/* boni.c generated by valac 0.56.3, the Vala compiler
 * generated from boni.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>

#define BONI_MAX_BONUSES ((guint8) 100)
#define BONI_MAX_MISSED ((guint8) 2)
#define NIBBLES_GAME_EMPTYCHAR 'a'
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef struct _BonusPrivate BonusPrivate;
enum  {
	BONUS_0_PROPERTY,
	BONUS_X_PROPERTY,
	BONUS_Y_PROPERTY,
	BONUS_BONUS_TYPE_PROPERTY,
	BONUS_FAKE_PROPERTY,
	BONUS_COUNTDOWN_PROPERTY,
	BONUS_NUM_PROPERTIES
};
static GParamSpec* bonus_properties[BONUS_NUM_PROPERTIES];

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;
typedef struct _BoniPrivate BoniPrivate;
enum  {
	BONI_0_PROPERTY,
	BONI_NUM_PROPERTIES
};
static GParamSpec* boni_properties[BONI_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BONI_BONUS_REMOVED_SIGNAL,
	BONI_NUM_SIGNALS
};
static guint boni_signals[BONI_NUM_SIGNALS] = {0};

struct _Bonus {
	GObject parent_instance;
	BonusPrivate * priv;
};

struct _BonusClass {
	GObjectClass parent_class;
};

struct _BonusPrivate {
	guint8 _x;
	guint8 _y;
	BonusType _bonus_type;
	gboolean _fake;
	guint16 _countdown;
};

struct _Boni {
	GObject parent_instance;
	BoniPrivate * priv;
};

struct _BoniClass {
	GObjectClass parent_class;
};

struct _BoniPrivate {
	GeeLinkedList* bonuses;
	guint8 regular_bonus_left;
	guint8 regular_bonus_maxi;
	guint8 total_bonus_number;
	guint8 missed;
};

static gint Bonus_private_offset;
static gpointer bonus_parent_class = NULL;
static gint Boni_private_offset;
static gpointer boni_parent_class = NULL;

VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
static void bonus_set_x (Bonus* self,
                  guint8 value);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
static void bonus_set_y (Bonus* self,
                  guint8 value);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
static void bonus_set_bonus_type (Bonus* self,
                           BonusType value);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
static void bonus_set_fake (Bonus* self,
                     gboolean value);
VALA_EXTERN guint16 bonus_get_countdown (Bonus* self);
VALA_EXTERN void bonus_set_countdown (Bonus* self,
                          guint16 value);
static void bonus_finalize (GObject * obj);
static GType bonus_get_type_once (void);
static void _vala_bonus_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_bonus_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         Bonus* bonus);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        gint* board,
                        gint board_length1,
                        gint board_length2,
                        Bonus* bonus);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
static inline void boni_reset_missed (Boni* self);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       guint8 x,
                       guint8 y);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         guint8* missed_bonuses_to_replace);
static inline void boni_increase_missed (Boni* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
static void boni_finalize (GObject * obj);
static GType boni_get_type_once (void);

static GType
bonus_type_get_type_once (void)
{
	static const GEnumValue values[] = {{BONUS_TYPE_REGULAR, "BONUS_TYPE_REGULAR", "regular"}, {BONUS_TYPE_HALF, "BONUS_TYPE_HALF", "half"}, {BONUS_TYPE_DOUBLE, "BONUS_TYPE_DOUBLE", "double"}, {BONUS_TYPE_LIFE, "BONUS_TYPE_LIFE", "life"}, {BONUS_TYPE_REVERSE, "BONUS_TYPE_REVERSE", "reverse"}, {BONUS_TYPE_WARP, "BONUS_TYPE_WARP", "warp"}, {0, NULL, NULL}};
	GType bonus_type_type_id;
	bonus_type_type_id = g_enum_register_static ("BonusType", values);
	return bonus_type_type_id;
}

GType
bonus_type_get_type (void)
{
	static volatile gsize bonus_type_type_id__once = 0;
	if (g_once_init_enter (&bonus_type_type_id__once)) {
		GType bonus_type_type_id;
		bonus_type_type_id = bonus_type_get_type_once ();
		g_once_init_leave (&bonus_type_type_id__once, bonus_type_type_id);
	}
	return bonus_type_type_id__once;
}

static inline gpointer
bonus_get_instance_private (Bonus* self)
{
	return G_STRUCT_MEMBER_P (self, Bonus_private_offset);
}

Bonus*
bonus_construct (GType object_type,
                 guint8 x,
                 guint8 y,
                 BonusType bonus_type,
                 gboolean fake,
                 guint16 countdown)
{
	Bonus * self = NULL;
#line 43 "../src/boni.vala"
	self = (Bonus*) g_object_new (object_type, "x", x, "y", y, "bonus-type", bonus_type, "fake", fake, "countdown", countdown, NULL);
#line 41 "../src/boni.vala"
	return self;
#line 249 "boni.c"
}

Bonus*
bonus_new (guint8 x,
           guint8 y,
           BonusType bonus_type,
           gboolean fake,
           guint16 countdown)
{
#line 41 "../src/boni.vala"
	return bonus_construct (TYPE_BONUS, x, y, bonus_type, fake, countdown);
#line 261 "boni.c"
}

guint8
bonus_get_x (Bonus* self)
{
	guint8 result;
#line 34 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 34 "../src/boni.vala"
	result = self->priv->_x;
#line 34 "../src/boni.vala"
	return result;
#line 274 "boni.c"
}

static void
bonus_set_x (Bonus* self,
             guint8 value)
{
	guint8 old_value;
#line 34 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/boni.vala"
	old_value = bonus_get_x (self);
#line 34 "../src/boni.vala"
	if (old_value != value) {
#line 34 "../src/boni.vala"
		self->priv->_x = value;
#line 34 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_X_PROPERTY]);
#line 292 "boni.c"
	}
}

guint8
bonus_get_y (Bonus* self)
{
	guint8 result;
#line 35 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 35 "../src/boni.vala"
	result = self->priv->_y;
#line 35 "../src/boni.vala"
	return result;
#line 306 "boni.c"
}

static void
bonus_set_y (Bonus* self,
             guint8 value)
{
	guint8 old_value;
#line 35 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/boni.vala"
	old_value = bonus_get_y (self);
#line 35 "../src/boni.vala"
	if (old_value != value) {
#line 35 "../src/boni.vala"
		self->priv->_y = value;
#line 35 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_Y_PROPERTY]);
#line 324 "boni.c"
	}
}

BonusType
bonus_get_bonus_type (Bonus* self)
{
	BonusType result;
#line 36 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/boni.vala"
	result = self->priv->_bonus_type;
#line 36 "../src/boni.vala"
	return result;
#line 338 "boni.c"
}

static void
bonus_set_bonus_type (Bonus* self,
                      BonusType value)
{
	BonusType old_value;
#line 36 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/boni.vala"
	old_value = bonus_get_bonus_type (self);
#line 36 "../src/boni.vala"
	if (old_value != value) {
#line 36 "../src/boni.vala"
		self->priv->_bonus_type = value;
#line 36 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_BONUS_TYPE_PROPERTY]);
#line 356 "boni.c"
	}
}

gboolean
bonus_get_fake (Bonus* self)
{
	gboolean result;
#line 37 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/boni.vala"
	result = self->priv->_fake;
#line 37 "../src/boni.vala"
	return result;
#line 370 "boni.c"
}

static void
bonus_set_fake (Bonus* self,
                gboolean value)
{
	gboolean old_value;
#line 37 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/boni.vala"
	old_value = bonus_get_fake (self);
#line 37 "../src/boni.vala"
	if (old_value != value) {
#line 37 "../src/boni.vala"
		self->priv->_fake = value;
#line 37 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_FAKE_PROPERTY]);
#line 388 "boni.c"
	}
}

guint16
bonus_get_countdown (Bonus* self)
{
	guint16 result;
#line 39 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 39 "../src/boni.vala"
	result = self->priv->_countdown;
#line 39 "../src/boni.vala"
	return result;
#line 402 "boni.c"
}

void
bonus_set_countdown (Bonus* self,
                     guint16 value)
{
	guint16 old_value;
#line 39 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/boni.vala"
	old_value = bonus_get_countdown (self);
#line 39 "../src/boni.vala"
	if (old_value != value) {
#line 39 "../src/boni.vala"
		self->priv->_countdown = value;
#line 39 "../src/boni.vala"
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_COUNTDOWN_PROPERTY]);
#line 420 "boni.c"
	}
}

static void
bonus_class_init (BonusClass * klass,
                  gpointer klass_data)
{
#line 32 "../src/boni.vala"
	bonus_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/boni.vala"
	g_type_class_adjust_private_offset (klass, &Bonus_private_offset);
#line 32 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bonus_get_property;
#line 32 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bonus_set_property;
#line 32 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = bonus_finalize;
#line 32 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_X_PROPERTY, bonus_properties[BONUS_X_PROPERTY] = g_param_spec_uchar ("x", "x", "x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_Y_PROPERTY, bonus_properties[BONUS_Y_PROPERTY] = g_param_spec_uchar ("y", "y", "y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_BONUS_TYPE_PROPERTY, bonus_properties[BONUS_BONUS_TYPE_PROPERTY] = g_param_spec_enum ("bonus-type", "bonus-type", "bonus-type", TYPE_BONUS_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_FAKE_PROPERTY, bonus_properties[BONUS_FAKE_PROPERTY] = g_param_spec_boolean ("fake", "fake", "fake", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../src/boni.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_COUNTDOWN_PROPERTY, bonus_properties[BONUS_COUNTDOWN_PROPERTY] = g_param_spec_uint ("countdown", "countdown", "countdown", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 448 "boni.c"
}

static void
bonus_instance_init (Bonus * self,
                     gpointer klass)
{
#line 32 "../src/boni.vala"
	self->priv = bonus_get_instance_private (self);
#line 457 "boni.c"
}

static void
bonus_finalize (GObject * obj)
{
	Bonus * self;
#line 32 "../src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONUS, Bonus);
#line 32 "../src/boni.vala"
	G_OBJECT_CLASS (bonus_parent_class)->finalize (obj);
#line 468 "boni.c"
}

static GType
bonus_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BonusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bonus_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bonus), 0, (GInstanceInitFunc) bonus_instance_init, NULL };
	GType bonus_type_id;
	bonus_type_id = g_type_register_static (G_TYPE_OBJECT, "Bonus", &g_define_type_info, 0);
	Bonus_private_offset = g_type_add_instance_private (bonus_type_id, sizeof (BonusPrivate));
	return bonus_type_id;
}

GType
bonus_get_type (void)
{
	static volatile gsize bonus_type_id__once = 0;
	if (g_once_init_enter (&bonus_type_id__once)) {
		GType bonus_type_id;
		bonus_type_id = bonus_get_type_once ();
		g_once_init_leave (&bonus_type_id__once, bonus_type_id);
	}
	return bonus_type_id__once;
}

static void
_vala_bonus_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
#line 32 "../src/boni.vala"
	switch (property_id) {
#line 32 "../src/boni.vala"
		case BONUS_X_PROPERTY:
#line 32 "../src/boni.vala"
		g_value_set_uchar (value, bonus_get_x (self));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_Y_PROPERTY:
#line 32 "../src/boni.vala"
		g_value_set_uchar (value, bonus_get_y (self));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_BONUS_TYPE_PROPERTY:
#line 32 "../src/boni.vala"
		g_value_set_enum (value, bonus_get_bonus_type (self));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_FAKE_PROPERTY:
#line 32 "../src/boni.vala"
		g_value_set_boolean (value, bonus_get_fake (self));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_COUNTDOWN_PROPERTY:
#line 32 "../src/boni.vala"
		g_value_set_uint (value, bonus_get_countdown (self));
#line 32 "../src/boni.vala"
		break;
#line 533 "boni.c"
		default:
#line 32 "../src/boni.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/boni.vala"
		break;
#line 539 "boni.c"
	}
}

static void
_vala_bonus_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
#line 32 "../src/boni.vala"
	switch (property_id) {
#line 32 "../src/boni.vala"
		case BONUS_X_PROPERTY:
#line 32 "../src/boni.vala"
		bonus_set_x (self, g_value_get_uchar (value));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_Y_PROPERTY:
#line 32 "../src/boni.vala"
		bonus_set_y (self, g_value_get_uchar (value));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_BONUS_TYPE_PROPERTY:
#line 32 "../src/boni.vala"
		bonus_set_bonus_type (self, g_value_get_enum (value));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_FAKE_PROPERTY:
#line 32 "../src/boni.vala"
		bonus_set_fake (self, g_value_get_boolean (value));
#line 32 "../src/boni.vala"
		break;
#line 32 "../src/boni.vala"
		case BONUS_COUNTDOWN_PROPERTY:
#line 32 "../src/boni.vala"
		bonus_set_countdown (self, g_value_get_uint (value));
#line 32 "../src/boni.vala"
		break;
#line 583 "boni.c"
		default:
#line 32 "../src/boni.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/boni.vala"
		break;
#line 589 "boni.c"
	}
}

static inline gpointer
boni_get_instance_private (Boni* self)
{
	return G_STRUCT_MEMBER_P (self, Boni_private_offset);
}

gboolean
boni_add_bonus (Boni* self,
                gint* board,
                gint board_length1,
                gint board_length2,
                Bonus* bonus)
{
	GeeLinkedList* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	BonusType _tmp5_;
	BonusType _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	BonusType _tmp11_;
	BonusType _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	guint8 _tmp16_;
	BonusType _tmp17_;
	BonusType _tmp18_;
	guint8 _tmp19_;
	guint8 _tmp20_;
	guint8 _tmp21_;
	guint8 _tmp22_;
	BonusType _tmp23_;
	BonusType _tmp24_;
	guint8 _tmp25_;
	gboolean result;
#line 59 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../src/boni.vala"
	g_return_val_if_fail (bonus != NULL, FALSE);
#line 61 "../src/boni.vala"
	if (self->priv->total_bonus_number >= BONI_MAX_BONUSES) {
#line 62 "../src/boni.vala"
		result = FALSE;
#line 62 "../src/boni.vala"
		_g_object_unref0 (bonus);
#line 62 "../src/boni.vala"
		return result;
#line 645 "boni.c"
	}
#line 64 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 64 "../src/boni.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, bonus);
#line 65 "../src/boni.vala"
	_tmp1_ = bonus_get_x (bonus);
#line 65 "../src/boni.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/boni.vala"
	_tmp3_ = bonus_get_y (bonus);
#line 65 "../src/boni.vala"
	_tmp4_ = _tmp3_;
#line 65 "../src/boni.vala"
	_tmp5_ = bonus_get_bonus_type (bonus);
#line 65 "../src/boni.vala"
	_tmp6_ = _tmp5_;
#line 65 "../src/boni.vala"
	board[(_tmp2_ * board_length2) + _tmp4_] = (gint) (_tmp6_ + 'A');
#line 66 "../src/boni.vala"
	_tmp7_ = bonus_get_x (bonus);
#line 66 "../src/boni.vala"
	_tmp8_ = _tmp7_;
#line 66 "../src/boni.vala"
	_tmp9_ = bonus_get_y (bonus);
#line 66 "../src/boni.vala"
	_tmp10_ = _tmp9_;
#line 66 "../src/boni.vala"
	_tmp11_ = bonus_get_bonus_type (bonus);
#line 66 "../src/boni.vala"
	_tmp12_ = _tmp11_;
#line 66 "../src/boni.vala"
	board[((_tmp8_ + 1) * board_length2) + _tmp10_] = (gint) (_tmp12_ + 'A');
#line 67 "../src/boni.vala"
	_tmp13_ = bonus_get_x (bonus);
#line 67 "../src/boni.vala"
	_tmp14_ = _tmp13_;
#line 67 "../src/boni.vala"
	_tmp15_ = bonus_get_y (bonus);
#line 67 "../src/boni.vala"
	_tmp16_ = _tmp15_;
#line 67 "../src/boni.vala"
	_tmp17_ = bonus_get_bonus_type (bonus);
#line 67 "../src/boni.vala"
	_tmp18_ = _tmp17_;
#line 67 "../src/boni.vala"
	board[(_tmp14_ * board_length2) + (_tmp16_ + 1)] = (gint) (_tmp18_ + 'A');
#line 68 "../src/boni.vala"
	_tmp19_ = bonus_get_x (bonus);
#line 68 "../src/boni.vala"
	_tmp20_ = _tmp19_;
#line 68 "../src/boni.vala"
	_tmp21_ = bonus_get_y (bonus);
#line 68 "../src/boni.vala"
	_tmp22_ = _tmp21_;
#line 68 "../src/boni.vala"
	_tmp23_ = bonus_get_bonus_type (bonus);
#line 68 "../src/boni.vala"
	_tmp24_ = _tmp23_;
#line 68 "../src/boni.vala"
	board[((_tmp20_ + 1) * board_length2) + (_tmp22_ + 1)] = (gint) (_tmp24_ + 'A');
#line 69 "../src/boni.vala"
	_tmp25_ = self->priv->total_bonus_number;
#line 69 "../src/boni.vala"
	self->priv->total_bonus_number = _tmp25_ + 1;
#line 70 "../src/boni.vala"
	result = TRUE;
#line 70 "../src/boni.vala"
	_g_object_unref0 (bonus);
#line 70 "../src/boni.vala"
	return result;
#line 717 "boni.c"
}

void
boni_remove_bonus (Boni* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   Bonus* bonus)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	guint8 _tmp11_;
	guint8 _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	GeeLinkedList* _tmp16_;
#line 73 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/boni.vala"
	g_return_if_fail (bonus != NULL);
#line 75 "../src/boni.vala"
	_tmp0_ = bonus_get_x (bonus);
#line 75 "../src/boni.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/boni.vala"
	_tmp2_ = bonus_get_y (bonus);
#line 75 "../src/boni.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/boni.vala"
	board[(_tmp1_ * board_length2) + _tmp3_] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 76 "../src/boni.vala"
	_tmp4_ = bonus_get_x (bonus);
#line 76 "../src/boni.vala"
	_tmp5_ = _tmp4_;
#line 76 "../src/boni.vala"
	_tmp6_ = bonus_get_y (bonus);
#line 76 "../src/boni.vala"
	_tmp7_ = _tmp6_;
#line 76 "../src/boni.vala"
	board[((_tmp5_ + 1) * board_length2) + _tmp7_] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 77 "../src/boni.vala"
	_tmp8_ = bonus_get_x (bonus);
#line 77 "../src/boni.vala"
	_tmp9_ = _tmp8_;
#line 77 "../src/boni.vala"
	_tmp10_ = bonus_get_y (bonus);
#line 77 "../src/boni.vala"
	_tmp11_ = _tmp10_;
#line 77 "../src/boni.vala"
	board[(_tmp9_ * board_length2) + (_tmp11_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 78 "../src/boni.vala"
	_tmp12_ = bonus_get_x (bonus);
#line 78 "../src/boni.vala"
	_tmp13_ = _tmp12_;
#line 78 "../src/boni.vala"
	_tmp14_ = bonus_get_y (bonus);
#line 78 "../src/boni.vala"
	_tmp15_ = _tmp14_;
#line 78 "../src/boni.vala"
	board[((_tmp13_ + 1) * board_length2) + (_tmp15_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 80 "../src/boni.vala"
	g_signal_emit (self, boni_signals[BONI_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 81 "../src/boni.vala"
	_tmp16_ = self->priv->bonuses;
#line 81 "../src/boni.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp16_, bonus);
#line 794 "boni.c"
}

void
boni_reset (Boni* self,
            guint8 regular_bonus)
{
	GeeLinkedList* _tmp0_;
#line 84 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/boni.vala"
	_tmp0_ = self->priv->bonuses;
#line 86 "../src/boni.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 87 "../src/boni.vala"
	boni_reset_missed (self);
#line 88 "../src/boni.vala"
	self->priv->regular_bonus_maxi = regular_bonus;
#line 89 "../src/boni.vala"
	self->priv->regular_bonus_left = regular_bonus;
#line 90 "../src/boni.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 816 "boni.c"
}

Bonus*
boni_get_bonus (Boni* self,
                gint* board,
                gint board_length1,
                gint board_length2,
                guint8 x,
                guint8 y)
{
	Bonus* result;
#line 93 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 830 "boni.c"
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bonus_index = 0;
#line 95 "../src/boni.vala"
		_tmp0_ = self->priv->bonuses;
#line 95 "../src/boni.vala"
		_bonus_list = _tmp0_;
#line 95 "../src/boni.vala"
		_tmp1_ = _bonus_list;
#line 95 "../src/boni.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 95 "../src/boni.vala"
		_tmp3_ = _tmp2_;
#line 95 "../src/boni.vala"
		_bonus_size = _tmp3_;
#line 95 "../src/boni.vala"
		_bonus_index = -1;
#line 95 "../src/boni.vala"
		while (TRUE) {
#line 855 "boni.c"
			gint _tmp4_;
			gint _tmp5_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			Bonus* _tmp12_;
			guint8 _tmp13_;
			guint8 _tmp14_;
#line 95 "../src/boni.vala"
			_bonus_index = _bonus_index + 1;
#line 95 "../src/boni.vala"
			_tmp4_ = _bonus_index;
#line 95 "../src/boni.vala"
			_tmp5_ = _bonus_size;
#line 95 "../src/boni.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 95 "../src/boni.vala"
				break;
#line 878 "boni.c"
			}
#line 95 "../src/boni.vala"
			_tmp6_ = _bonus_list;
#line 95 "../src/boni.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bonus_index);
#line 95 "../src/boni.vala"
			bonus = (Bonus*) _tmp7_;
#line 97 "../src/boni.vala"
			_tmp12_ = bonus;
#line 97 "../src/boni.vala"
			_tmp13_ = bonus_get_x (_tmp12_);
#line 97 "../src/boni.vala"
			_tmp14_ = _tmp13_;
#line 97 "../src/boni.vala"
			if (x == _tmp14_) {
#line 894 "boni.c"
				Bonus* _tmp15_;
				guint8 _tmp16_;
				guint8 _tmp17_;
#line 97 "../src/boni.vala"
				_tmp15_ = bonus;
#line 97 "../src/boni.vala"
				_tmp16_ = bonus_get_y (_tmp15_);
#line 97 "../src/boni.vala"
				_tmp17_ = _tmp16_;
#line 97 "../src/boni.vala"
				_tmp11_ = y == _tmp17_;
#line 906 "boni.c"
			} else {
#line 97 "../src/boni.vala"
				_tmp11_ = FALSE;
#line 910 "boni.c"
			}
#line 97 "../src/boni.vala"
			if (_tmp11_) {
#line 97 "../src/boni.vala"
				_tmp10_ = TRUE;
#line 916 "boni.c"
			} else {
				gboolean _tmp18_ = FALSE;
				Bonus* _tmp19_;
				guint8 _tmp20_;
				guint8 _tmp21_;
#line 98 "../src/boni.vala"
				_tmp19_ = bonus;
#line 98 "../src/boni.vala"
				_tmp20_ = bonus_get_x (_tmp19_);
#line 98 "../src/boni.vala"
				_tmp21_ = _tmp20_;
#line 98 "../src/boni.vala"
				if (((gint) x) == (_tmp21_ + 1)) {
#line 930 "boni.c"
					Bonus* _tmp22_;
					guint8 _tmp23_;
					guint8 _tmp24_;
#line 98 "../src/boni.vala"
					_tmp22_ = bonus;
#line 98 "../src/boni.vala"
					_tmp23_ = bonus_get_y (_tmp22_);
#line 98 "../src/boni.vala"
					_tmp24_ = _tmp23_;
#line 98 "../src/boni.vala"
					_tmp18_ = y == _tmp24_;
#line 942 "boni.c"
				} else {
#line 98 "../src/boni.vala"
					_tmp18_ = FALSE;
#line 946 "boni.c"
				}
#line 98 "../src/boni.vala"
				_tmp10_ = _tmp18_;
#line 950 "boni.c"
			}
#line 97 "../src/boni.vala"
			if (_tmp10_) {
#line 97 "../src/boni.vala"
				_tmp9_ = TRUE;
#line 956 "boni.c"
			} else {
				gboolean _tmp25_ = FALSE;
				Bonus* _tmp26_;
				guint8 _tmp27_;
				guint8 _tmp28_;
#line 99 "../src/boni.vala"
				_tmp26_ = bonus;
#line 99 "../src/boni.vala"
				_tmp27_ = bonus_get_x (_tmp26_);
#line 99 "../src/boni.vala"
				_tmp28_ = _tmp27_;
#line 99 "../src/boni.vala"
				if (x == _tmp28_) {
#line 970 "boni.c"
					Bonus* _tmp29_;
					guint8 _tmp30_;
					guint8 _tmp31_;
#line 99 "../src/boni.vala"
					_tmp29_ = bonus;
#line 99 "../src/boni.vala"
					_tmp30_ = bonus_get_y (_tmp29_);
#line 99 "../src/boni.vala"
					_tmp31_ = _tmp30_;
#line 99 "../src/boni.vala"
					_tmp25_ = ((gint) y) == (_tmp31_ + 1);
#line 982 "boni.c"
				} else {
#line 99 "../src/boni.vala"
					_tmp25_ = FALSE;
#line 986 "boni.c"
				}
#line 99 "../src/boni.vala"
				_tmp9_ = _tmp25_;
#line 990 "boni.c"
			}
#line 97 "../src/boni.vala"
			if (_tmp9_) {
#line 97 "../src/boni.vala"
				_tmp8_ = TRUE;
#line 996 "boni.c"
			} else {
				gboolean _tmp32_ = FALSE;
				Bonus* _tmp33_;
				guint8 _tmp34_;
				guint8 _tmp35_;
#line 100 "../src/boni.vala"
				_tmp33_ = bonus;
#line 100 "../src/boni.vala"
				_tmp34_ = bonus_get_x (_tmp33_);
#line 100 "../src/boni.vala"
				_tmp35_ = _tmp34_;
#line 100 "../src/boni.vala"
				if (((gint) x) == (_tmp35_ + 1)) {
#line 1010 "boni.c"
					Bonus* _tmp36_;
					guint8 _tmp37_;
					guint8 _tmp38_;
#line 100 "../src/boni.vala"
					_tmp36_ = bonus;
#line 100 "../src/boni.vala"
					_tmp37_ = bonus_get_y (_tmp36_);
#line 100 "../src/boni.vala"
					_tmp38_ = _tmp37_;
#line 100 "../src/boni.vala"
					_tmp32_ = ((gint) y) == (_tmp38_ + 1);
#line 1022 "boni.c"
				} else {
#line 100 "../src/boni.vala"
					_tmp32_ = FALSE;
#line 1026 "boni.c"
				}
#line 100 "../src/boni.vala"
				_tmp8_ = _tmp32_;
#line 1030 "boni.c"
			}
#line 97 "../src/boni.vala"
			if (_tmp8_) {
#line 102 "../src/boni.vala"
				result = bonus;
#line 102 "../src/boni.vala"
				return result;
#line 1038 "boni.c"
			}
#line 95 "../src/boni.vala"
			_g_object_unref0 (bonus);
#line 1042 "boni.c"
		}
	}
#line 106 "../src/boni.vala"
	result = NULL;
#line 106 "../src/boni.vala"
	return result;
#line 1049 "boni.c"
}

void
boni_on_worms_move (Boni* self,
                    gint* board,
                    gint board_length1,
                    gint board_length2,
                    guint8* missed_bonuses_to_replace)
{
	guint8 _vala_missed_bonuses_to_replace = 0U;
	GeeLinkedList* found = NULL;
	GeeLinkedList* _tmp0_;
#line 109 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/boni.vala"
	_vala_missed_bonuses_to_replace = (guint8) 0;
#line 114 "../src/boni.vala"
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 114 "../src/boni.vala"
	found = _tmp0_;
#line 1070 "boni.c"
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _bonus_index = 0;
#line 115 "../src/boni.vala"
		_tmp1_ = self->priv->bonuses;
#line 115 "../src/boni.vala"
		_bonus_list = _tmp1_;
#line 115 "../src/boni.vala"
		_tmp2_ = _bonus_list;
#line 115 "../src/boni.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 115 "../src/boni.vala"
		_tmp4_ = _tmp3_;
#line 115 "../src/boni.vala"
		_bonus_size = _tmp4_;
#line 115 "../src/boni.vala"
		_bonus_index = -1;
#line 115 "../src/boni.vala"
		while (TRUE) {
#line 1095 "boni.c"
			gint _tmp5_;
			gint _tmp6_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Bonus* _tmp9_;
			guint16 _tmp10_;
			guint16 _tmp11_;
#line 115 "../src/boni.vala"
			_bonus_index = _bonus_index + 1;
#line 115 "../src/boni.vala"
			_tmp5_ = _bonus_index;
#line 115 "../src/boni.vala"
			_tmp6_ = _bonus_size;
#line 115 "../src/boni.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 115 "../src/boni.vala"
				break;
#line 1114 "boni.c"
			}
#line 115 "../src/boni.vala"
			_tmp7_ = _bonus_list;
#line 115 "../src/boni.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _bonus_index);
#line 115 "../src/boni.vala"
			bonus = (Bonus*) _tmp8_;
#line 117 "../src/boni.vala"
			_tmp9_ = bonus;
#line 117 "../src/boni.vala"
			_tmp10_ = bonus_get_countdown (_tmp9_);
#line 117 "../src/boni.vala"
			_tmp11_ = _tmp10_;
#line 117 "../src/boni.vala"
			if (((gint) _tmp11_) == 0) {
#line 1130 "boni.c"
				GeeLinkedList* _tmp12_;
				Bonus* _tmp13_;
#line 118 "../src/boni.vala"
				_tmp12_ = found;
#line 118 "../src/boni.vala"
				_tmp13_ = bonus;
#line 118 "../src/boni.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 1139 "boni.c"
			} else {
				Bonus* _tmp14_;
				guint16 _tmp15_;
				guint16 _tmp16_;
#line 120 "../src/boni.vala"
				_tmp14_ = bonus;
#line 120 "../src/boni.vala"
				_tmp15_ = bonus_get_countdown (_tmp14_);
#line 120 "../src/boni.vala"
				_tmp16_ = _tmp15_;
#line 120 "../src/boni.vala"
				bonus_set_countdown (_tmp14_, _tmp16_ - 1);
#line 1152 "boni.c"
			}
#line 115 "../src/boni.vala"
			_g_object_unref0 (bonus);
#line 1156 "boni.c"
		}
	}
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp17_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _bonus_index = 0;
#line 123 "../src/boni.vala"
		_tmp17_ = found;
#line 123 "../src/boni.vala"
		_bonus_list = _tmp17_;
#line 123 "../src/boni.vala"
		_tmp18_ = _bonus_list;
#line 123 "../src/boni.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 123 "../src/boni.vala"
		_tmp20_ = _tmp19_;
#line 123 "../src/boni.vala"
		_bonus_size = _tmp20_;
#line 123 "../src/boni.vala"
		_bonus_index = -1;
#line 123 "../src/boni.vala"
		while (TRUE) {
#line 1183 "boni.c"
			gint _tmp21_;
			gint _tmp22_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp23_;
			gpointer _tmp24_;
			gboolean _tmp25_ = FALSE;
			Bonus* _tmp26_;
			BonusType _tmp27_;
			BonusType _tmp28_;
			gboolean real_bonus = FALSE;
			Bonus* _tmp32_;
#line 123 "../src/boni.vala"
			_bonus_index = _bonus_index + 1;
#line 123 "../src/boni.vala"
			_tmp21_ = _bonus_index;
#line 123 "../src/boni.vala"
			_tmp22_ = _bonus_size;
#line 123 "../src/boni.vala"
			if (!(_tmp21_ < _tmp22_)) {
#line 123 "../src/boni.vala"
				break;
#line 1205 "boni.c"
			}
#line 123 "../src/boni.vala"
			_tmp23_ = _bonus_list;
#line 123 "../src/boni.vala"
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _bonus_index);
#line 123 "../src/boni.vala"
			bonus = (Bonus*) _tmp24_;
#line 125 "../src/boni.vala"
			_tmp26_ = bonus;
#line 125 "../src/boni.vala"
			_tmp27_ = bonus_get_bonus_type (_tmp26_);
#line 125 "../src/boni.vala"
			_tmp28_ = _tmp27_;
#line 125 "../src/boni.vala"
			if (_tmp28_ == BONUS_TYPE_REGULAR) {
#line 1221 "boni.c"
				Bonus* _tmp29_;
				gboolean _tmp30_;
				gboolean _tmp31_;
#line 125 "../src/boni.vala"
				_tmp29_ = bonus;
#line 125 "../src/boni.vala"
				_tmp30_ = bonus_get_fake (_tmp29_);
#line 125 "../src/boni.vala"
				_tmp31_ = _tmp30_;
#line 125 "../src/boni.vala"
				_tmp25_ = !_tmp31_;
#line 1233 "boni.c"
			} else {
#line 125 "../src/boni.vala"
				_tmp25_ = FALSE;
#line 1237 "boni.c"
			}
#line 125 "../src/boni.vala"
			real_bonus = _tmp25_;
#line 127 "../src/boni.vala"
			_tmp32_ = bonus;
#line 127 "../src/boni.vala"
			boni_remove_bonus (self, board, (gint) board_length1, (gint) board_length2, _tmp32_);
#line 129 "../src/boni.vala"
			if (real_bonus) {
#line 1247 "boni.c"
				guint8 _tmp33_;
#line 131 "../src/boni.vala"
				boni_increase_missed (self);
#line 132 "../src/boni.vala"
				_tmp33_ = _vala_missed_bonuses_to_replace;
#line 132 "../src/boni.vala"
				_vala_missed_bonuses_to_replace = _tmp33_ + 1;
#line 1255 "boni.c"
			}
#line 123 "../src/boni.vala"
			_g_object_unref0 (bonus);
#line 1259 "boni.c"
		}
	}
#line 109 "../src/boni.vala"
	_g_object_unref0 (found);
#line 109 "../src/boni.vala"
	if (missed_bonuses_to_replace) {
#line 109 "../src/boni.vala"
		*missed_bonuses_to_replace = _vala_missed_bonuses_to_replace;
#line 1268 "boni.c"
	}
}

inline guint8
boni_new_regular_bonus_eaten (Boni* self)
{
	guint8 _tmp0_;
	guint8 result;
#line 137 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 139 "../src/boni.vala"
	if (((gint) self->priv->regular_bonus_left) == 0) {
#line 140 "../src/boni.vala"
		g_assert_not_reached ();
#line 1283 "boni.c"
	}
#line 141 "../src/boni.vala"
	_tmp0_ = self->priv->regular_bonus_left;
#line 141 "../src/boni.vala"
	self->priv->regular_bonus_left = _tmp0_ - 1;
#line 142 "../src/boni.vala"
	result = self->priv->regular_bonus_maxi - self->priv->regular_bonus_left;
#line 142 "../src/boni.vala"
	return result;
#line 1293 "boni.c"
}

inline gboolean
boni_last_regular_bonus (Boni* self)
{
	gboolean result;
#line 145 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/boni.vala"
	result = ((gint) self->priv->regular_bonus_left) == 0;
#line 147 "../src/boni.vala"
	return result;
#line 1306 "boni.c"
}

inline gboolean
boni_too_many_missed (Boni* self)
{
	gboolean result;
#line 157 "../src/boni.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/boni.vala"
	result = self->priv->missed > BONI_MAX_MISSED;
#line 159 "../src/boni.vala"
	return result;
#line 1319 "boni.c"
}

static inline void
boni_increase_missed (Boni* self)
{
	guint8 _tmp0_;
#line 162 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/boni.vala"
	_tmp0_ = self->priv->missed;
#line 164 "../src/boni.vala"
	self->priv->missed = _tmp0_ + 1;
#line 1332 "boni.c"
}

static inline void
boni_reset_missed (Boni* self)
{
#line 167 "../src/boni.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/boni.vala"
	self->priv->missed = (guint8) 0;
#line 1342 "boni.c"
}

Boni*
boni_construct (GType object_type)
{
	Boni * self = NULL;
#line 47 "../src/boni.vala"
	self = (Boni*) g_object_new (object_type, NULL);
#line 47 "../src/boni.vala"
	return self;
#line 1353 "boni.c"
}

Boni*
boni_new (void)
{
#line 47 "../src/boni.vala"
	return boni_construct (TYPE_BONI);
#line 1361 "boni.c"
}

static void
boni_class_init (BoniClass * klass,
                 gpointer klass_data)
{
#line 47 "../src/boni.vala"
	boni_parent_class = g_type_class_peek_parent (klass);
#line 47 "../src/boni.vala"
	g_type_class_adjust_private_offset (klass, &Boni_private_offset);
#line 47 "../src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = boni_finalize;
#line 47 "../src/boni.vala"
	boni_signals[BONI_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_BONI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 1376 "boni.c"
}

static void
boni_instance_init (Boni * self,
                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 47 "../src/boni.vala"
	self->priv = boni_get_instance_private (self);
#line 49 "../src/boni.vala"
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 49 "../src/boni.vala"
	self->priv->bonuses = _tmp0_;
#line 51 "../src/boni.vala"
	self->priv->regular_bonus_left = (guint8) 0;
#line 52 "../src/boni.vala"
	self->priv->regular_bonus_maxi = (guint8) 0;
#line 53 "../src/boni.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 154 "../src/boni.vala"
	self->priv->missed = (guint8) 0;
#line 1398 "boni.c"
}

static void
boni_finalize (GObject * obj)
{
	Boni * self;
#line 47 "../src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONI, Boni);
#line 49 "../src/boni.vala"
	_g_object_unref0 (self->priv->bonuses);
#line 47 "../src/boni.vala"
	G_OBJECT_CLASS (boni_parent_class)->finalize (obj);
#line 1411 "boni.c"
}

static GType
boni_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoniClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boni_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Boni), 0, (GInstanceInitFunc) boni_instance_init, NULL };
	GType boni_type_id;
	boni_type_id = g_type_register_static (G_TYPE_OBJECT, "Boni", &g_define_type_info, 0);
	Boni_private_offset = g_type_add_instance_private (boni_type_id, sizeof (BoniPrivate));
	return boni_type_id;
}

GType
boni_get_type (void)
{
	static volatile gsize boni_type_id__once = 0;
	if (g_once_init_enter (&boni_type_id__once)) {
		GType boni_type_id;
		boni_type_id = boni_get_type_once ();
		g_once_init_leave (&boni_type_id__once, boni_type_id);
	}
	return boni_type_id__once;
}

