/* preferences-dialog.c generated by valac 0.56.3, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Gabriel Ivascu <ivascu.gabriel59@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define NIBBLES_VIEW_NUM_COLORS 6
#define NIBBLES_GAME_MAX_WORMS 6
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_N_WORMS_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PreferencesDialog {
	GtkWindow parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkWindowClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	GeeArrayList* worm_settings;
	GtkStack* stack;
	GtkStack* headerbar_stack;
	GtkComboBoxText* worm_combobox;
	GtkListStore* list_store_1;
	GtkListStore* list_store_2;
	GtkListStore* list_store_3;
	GtkListStore* list_store_4;
	GtkTreeView* tree_view_1;
	GtkTreeView* tree_view_2;
	GtkTreeView* tree_view_3;
	GtkTreeView* tree_view_4;
	GtkComboBoxText* combo_box_1;
	GtkComboBoxText* combo_box_2;
	GtkComboBoxText* combo_box_3;
	GtkComboBoxText* combo_box_4;
	GeeArrayList* list_stores;
	GeeArrayList* tree_views;
	GeeArrayList* combo_boxes;
	GtkEventControllerKey* key_controller;
	gint _n_worms;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

VALA_EXTERN GType preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
VALA_EXTERN PreferencesDialog* preferences_dialog_new (GtkApplicationWindow* window,
                                           GSettings* settings,
                                           GeeArrayList* worm_settings,
                                           gint worm_id,
                                           gint n_worms);
VALA_EXTERN PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GtkApplicationWindow* window,
                                                 GSettings* settings,
                                                 GeeArrayList* worm_settings,
                                                 gint worm_id,
                                                 gint n_worms);
static void preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                         GtkCellRendererAccel* cell,
                                         const gchar* path_string,
                                         guint keyval,
                                         GdkModifierType mask,
                                         guint hardware_keycode);
static void _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                               const gchar* path_string,
                                                                               guint accel_key,
                                                                               GdkModifierType accel_mods,
                                                                               guint hardware_keycode,
                                                                               gpointer self);
static void preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                          GtkCellRendererAccel* cell,
                                          const gchar* path_string);
static void _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                                 const gchar* path_string,
                                                                                 gpointer self);
VALA_EXTERN gchar* nibbles_view_colorval_name_translated (gint colorval);
static void preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                              GtkComboBox* combo_box);
static void _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static inline gboolean preferences_dialog_on_key_pressed (PreferencesDialog* self,
                                            GtkEventControllerKey* _key_controller,
                                            guint keyval,
                                            guint keycode,
                                            GdkModifierType state);
static inline void preferences_dialog_on_worm_change (PreferencesDialog* self,
                                        GtkComboBox* _worm_combobox);
static void _preferences_dialog_on_worm_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gint preferences_dialog_get_n_worms (PreferencesDialog* self);
static void preferences_dialog_set_n_worms (PreferencesDialog* self,
                                     gint value);
static GObject * preferences_dialog_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static gboolean _preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                  guint keyval,
                                                                                  guint keycode,
                                                                                  GdkModifierType state,
                                                                                  gpointer self);
static void preferences_dialog_finalize (GObject * obj);
static GType preferences_dialog_get_type_once (void);
static void _vala_preferences_dialog_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_preferences_dialog_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 181 "preferences-dialog.c"
}

static void
_preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                          const gchar* path_string,
                                                                          guint accel_key,
                                                                          GdkModifierType accel_mods,
                                                                          guint hardware_keycode,
                                                                          gpointer self)
{
#line 119 "../src/preferences-dialog.vala"
	preferences_dialog_accel_edited_cb ((PreferencesDialog*) self, _sender, path_string, accel_key, accel_mods, hardware_keycode);
#line 194 "preferences-dialog.c"
}

static void
_preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                            const gchar* path_string,
                                                                            gpointer self)
{
#line 120 "../src/preferences-dialog.vala"
	preferences_dialog_accel_cleared_cb ((PreferencesDialog*) self, _sender, path_string);
#line 204 "preferences-dialog.c"
}

static void
_preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 135 "../src/preferences-dialog.vala"
	preferences_dialog_combo_box_changed_cb ((PreferencesDialog*) self, _sender);
#line 213 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GtkApplicationWindow* window,
                              GSettings* settings,
                              GeeArrayList* worm_settings,
                              gint worm_id,
                              gint n_worms)
{
	PreferencesDialog * self = NULL;
	GSettings* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkComboBoxText* _tmp73_;
#line 75 "../src/preferences-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 75 "../src/preferences-dialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 75 "../src/preferences-dialog.vala"
	g_return_val_if_fail (worm_settings != NULL, NULL);
#line 77 "../src/preferences-dialog.vala"
	self = (PreferencesDialog*) g_object_new (object_type, "transient-for", window, "n-worms", n_worms, NULL);
#line 79 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 79 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 79 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp0_;
#line 80 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (worm_settings);
#line 80 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->worm_settings);
#line 80 "../src/preferences-dialog.vala"
	self->priv->worm_settings = _tmp1_;
#line 82 "../src/preferences-dialog.vala"
	if (n_worms == 1) {
#line 250 "preferences-dialog.c"
		GtkStack* _tmp2_;
#line 83 "../src/preferences-dialog.vala"
		_tmp2_ = self->priv->headerbar_stack;
#line 83 "../src/preferences-dialog.vala"
		gtk_stack_set_visible_child_name (_tmp2_, "preferences-label");
#line 256 "preferences-dialog.c"
	} else {
#line 84 "../src/preferences-dialog.vala"
		if (n_worms != 4) {
#line 260 "preferences-dialog.c"
			{
				gint i = 0;
#line 85 "../src/preferences-dialog.vala"
				i = 3;
#line 265 "preferences-dialog.c"
				{
					gboolean _tmp3_ = FALSE;
#line 85 "../src/preferences-dialog.vala"
					_tmp3_ = TRUE;
#line 85 "../src/preferences-dialog.vala"
					while (TRUE) {
#line 272 "preferences-dialog.c"
						GtkComboBoxText* _tmp5_;
#line 85 "../src/preferences-dialog.vala"
						if (!_tmp3_) {
#line 276 "preferences-dialog.c"
							gint _tmp4_;
#line 85 "../src/preferences-dialog.vala"
							_tmp4_ = i;
#line 85 "../src/preferences-dialog.vala"
							i = _tmp4_ - 1;
#line 282 "preferences-dialog.c"
						}
#line 85 "../src/preferences-dialog.vala"
						_tmp3_ = FALSE;
#line 85 "../src/preferences-dialog.vala"
						if (!(i > (n_worms - 1))) {
#line 85 "../src/preferences-dialog.vala"
							break;
#line 290 "preferences-dialog.c"
						}
#line 86 "../src/preferences-dialog.vala"
						_tmp5_ = self->priv->worm_combobox;
#line 86 "../src/preferences-dialog.vala"
						gtk_combo_box_text_remove (_tmp5_, i);
#line 296 "preferences-dialog.c"
					}
				}
			}
		}
	}
	{
		GeeArrayList* _list_store_list = NULL;
		GeeArrayList* _tmp6_;
		gint _list_store_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _list_store_index = 0;
#line 89 "../src/preferences-dialog.vala"
		_tmp6_ = self->priv->list_stores;
#line 89 "../src/preferences-dialog.vala"
		_list_store_list = _tmp6_;
#line 89 "../src/preferences-dialog.vala"
		_tmp7_ = _list_store_list;
#line 89 "../src/preferences-dialog.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 89 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 89 "../src/preferences-dialog.vala"
		_list_store_size = _tmp9_;
#line 89 "../src/preferences-dialog.vala"
		_list_store_index = -1;
#line 89 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 326 "preferences-dialog.c"
			gint _tmp10_;
			gint _tmp11_;
			GtkListStore* list_store = NULL;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			gint id = 0;
			GeeArrayList* _tmp14_;
			GtkListStore* _tmp15_;
			GtkTreeView* tree_view = NULL;
			GeeArrayList* _tmp16_;
			gpointer _tmp17_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp18_;
			GtkTreeIter _tmp19_ = {0};
			gint keyval = 0;
			gpointer _tmp20_;
			GSettings* _tmp21_;
			gint _tmp22_;
			GtkListStore* _tmp23_;
			GtkTreeIter _tmp24_;
			GtkListStore* _tmp25_;
			GtkTreeIter _tmp26_ = {0};
			gpointer _tmp27_;
			GSettings* _tmp28_;
			GtkListStore* _tmp29_;
			GtkTreeIter _tmp30_;
			GtkListStore* _tmp31_;
			GtkTreeIter _tmp32_ = {0};
			gpointer _tmp33_;
			GSettings* _tmp34_;
			GtkListStore* _tmp35_;
			GtkTreeIter _tmp36_;
			GtkListStore* _tmp37_;
			GtkTreeIter _tmp38_ = {0};
			gpointer _tmp39_;
			GSettings* _tmp40_;
			GtkListStore* _tmp41_;
			GtkTreeIter _tmp42_;
			GtkCellRendererText* label_renderer = NULL;
			GtkCellRendererText* _tmp43_;
			GtkTreeView* _tmp44_;
			GtkCellRendererText* _tmp45_;
			GtkCellRendererAccel* key_renderer = NULL;
			GtkCellRendererAccel* _tmp46_;
			GtkCellRendererAccel* _tmp47_;
			GtkCellRendererAccel* _tmp48_;
			GtkCellRendererAccel* _tmp49_;
			GtkCellRendererAccel* _tmp50_;
			GtkTreeView* _tmp51_;
			GtkCellRendererAccel* _tmp52_;
#line 89 "../src/preferences-dialog.vala"
			_list_store_index = _list_store_index + 1;
#line 89 "../src/preferences-dialog.vala"
			_tmp10_ = _list_store_index;
#line 89 "../src/preferences-dialog.vala"
			_tmp11_ = _list_store_size;
#line 89 "../src/preferences-dialog.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 89 "../src/preferences-dialog.vala"
				break;
#line 387 "preferences-dialog.c"
			}
#line 89 "../src/preferences-dialog.vala"
			_tmp12_ = _list_store_list;
#line 89 "../src/preferences-dialog.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _list_store_index);
#line 89 "../src/preferences-dialog.vala"
			list_store = (GtkListStore*) _tmp13_;
#line 91 "../src/preferences-dialog.vala"
			_tmp14_ = self->priv->list_stores;
#line 91 "../src/preferences-dialog.vala"
			_tmp15_ = list_store;
#line 91 "../src/preferences-dialog.vala"
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp14_, _tmp15_);
#line 92 "../src/preferences-dialog.vala"
			_tmp16_ = self->priv->tree_views;
#line 92 "../src/preferences-dialog.vala"
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, id);
#line 92 "../src/preferences-dialog.vala"
			tree_view = (GtkTreeView*) _tmp17_;
#line 95 "../src/preferences-dialog.vala"
			_tmp18_ = list_store;
#line 95 "../src/preferences-dialog.vala"
			gtk_list_store_append (_tmp18_, &_tmp19_);
#line 95 "../src/preferences-dialog.vala"
			iter = _tmp19_;
#line 96 "../src/preferences-dialog.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
#line 96 "../src/preferences-dialog.vala"
			_tmp21_ = (GSettings*) _tmp20_;
#line 96 "../src/preferences-dialog.vala"
			_tmp22_ = g_settings_get_int (_tmp21_, "key-up");
#line 96 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp21_);
#line 96 "../src/preferences-dialog.vala"
			keyval = _tmp22_;
#line 98 "../src/preferences-dialog.vala"
			_tmp23_ = list_store;
#line 98 "../src/preferences-dialog.vala"
			_tmp24_ = iter;
#line 98 "../src/preferences-dialog.vala"
			gtk_list_store_set (_tmp23_, &_tmp24_, 0, "key-up", 1, _ ("Move up"), 2, keyval, -1);
#line 99 "../src/preferences-dialog.vala"
			_tmp25_ = list_store;
#line 99 "../src/preferences-dialog.vala"
			gtk_list_store_append (_tmp25_, &_tmp26_);
#line 99 "../src/preferences-dialog.vala"
			iter = _tmp26_;
#line 100 "../src/preferences-dialog.vala"
			_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
#line 100 "../src/preferences-dialog.vala"
			_tmp28_ = (GSettings*) _tmp27_;
#line 100 "../src/preferences-dialog.vala"
			keyval = g_settings_get_int (_tmp28_, "key-down");
#line 100 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp28_);
#line 102 "../src/preferences-dialog.vala"
			_tmp29_ = list_store;
#line 102 "../src/preferences-dialog.vala"
			_tmp30_ = iter;
#line 102 "../src/preferences-dialog.vala"
			gtk_list_store_set (_tmp29_, &_tmp30_, 0, "key-down", 1, _ ("Move down"), 2, keyval, -1);
#line 103 "../src/preferences-dialog.vala"
			_tmp31_ = list_store;
#line 103 "../src/preferences-dialog.vala"
			gtk_list_store_append (_tmp31_, &_tmp32_);
#line 103 "../src/preferences-dialog.vala"
			iter = _tmp32_;
#line 104 "../src/preferences-dialog.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
#line 104 "../src/preferences-dialog.vala"
			_tmp34_ = (GSettings*) _tmp33_;
#line 104 "../src/preferences-dialog.vala"
			keyval = g_settings_get_int (_tmp34_, "key-left");
#line 104 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp34_);
#line 106 "../src/preferences-dialog.vala"
			_tmp35_ = list_store;
#line 106 "../src/preferences-dialog.vala"
			_tmp36_ = iter;
#line 106 "../src/preferences-dialog.vala"
			gtk_list_store_set (_tmp35_, &_tmp36_, 0, "key-left", 1, _ ("Move left"), 2, keyval, -1);
#line 107 "../src/preferences-dialog.vala"
			_tmp37_ = list_store;
#line 107 "../src/preferences-dialog.vala"
			gtk_list_store_append (_tmp37_, &_tmp38_);
#line 107 "../src/preferences-dialog.vala"
			iter = _tmp38_;
#line 108 "../src/preferences-dialog.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
#line 108 "../src/preferences-dialog.vala"
			_tmp40_ = (GSettings*) _tmp39_;
#line 108 "../src/preferences-dialog.vala"
			keyval = g_settings_get_int (_tmp40_, "key-right");
#line 108 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp40_);
#line 110 "../src/preferences-dialog.vala"
			_tmp41_ = list_store;
#line 110 "../src/preferences-dialog.vala"
			_tmp42_ = iter;
#line 110 "../src/preferences-dialog.vala"
			gtk_list_store_set (_tmp41_, &_tmp42_, 0, "key-right", 1, _ ("Move right"), 2, keyval, -1);
#line 112 "../src/preferences-dialog.vala"
			_tmp43_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 112 "../src/preferences-dialog.vala"
			g_object_ref_sink (_tmp43_);
#line 112 "../src/preferences-dialog.vala"
			label_renderer = _tmp43_;
#line 114 "../src/preferences-dialog.vala"
			_tmp44_ = tree_view;
#line 114 "../src/preferences-dialog.vala"
			_tmp45_ = label_renderer;
#line 114 "../src/preferences-dialog.vala"
			gtk_tree_view_insert_column_with_attributes (_tmp44_, -1, _ ("Action"), (GtkCellRenderer*) _tmp45_, "text", 1, NULL);
#line 116 "../src/preferences-dialog.vala"
			_tmp46_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
#line 116 "../src/preferences-dialog.vala"
			g_object_ref_sink (_tmp46_);
#line 116 "../src/preferences-dialog.vala"
			key_renderer = _tmp46_;
#line 117 "../src/preferences-dialog.vala"
			_tmp47_ = key_renderer;
#line 117 "../src/preferences-dialog.vala"
			g_object_set ((GtkCellRendererText*) _tmp47_, "editable", TRUE, NULL);
#line 118 "../src/preferences-dialog.vala"
			_tmp48_ = key_renderer;
#line 118 "../src/preferences-dialog.vala"
			g_object_set (_tmp48_, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER, NULL);
#line 119 "../src/preferences-dialog.vala"
			_tmp49_ = key_renderer;
#line 119 "../src/preferences-dialog.vala"
			g_signal_connect_object (_tmp49_, "accel-edited", (GCallback) _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited, self, 0);
#line 120 "../src/preferences-dialog.vala"
			_tmp50_ = key_renderer;
#line 120 "../src/preferences-dialog.vala"
			g_signal_connect_object (_tmp50_, "accel-cleared", (GCallback) _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared, self, 0);
#line 122 "../src/preferences-dialog.vala"
			_tmp51_ = tree_view;
#line 122 "../src/preferences-dialog.vala"
			_tmp52_ = key_renderer;
#line 122 "../src/preferences-dialog.vala"
			gtk_tree_view_insert_column_with_attributes (_tmp51_, -1, _ ("Key"), (GtkCellRenderer*) _tmp52_, "accel-key", 2, NULL);
#line 89 "../src/preferences-dialog.vala"
			_g_object_unref0 (key_renderer);
#line 89 "../src/preferences-dialog.vala"
			_g_object_unref0 (label_renderer);
#line 89 "../src/preferences-dialog.vala"
			_g_object_unref0 (tree_view);
#line 89 "../src/preferences-dialog.vala"
			_g_object_unref0 (list_store);
#line 537 "preferences-dialog.c"
		}
	}
	{
		GeeArrayList* _combo_box_list = NULL;
		GeeArrayList* _tmp53_;
		gint _combo_box_size = 0;
		GeeArrayList* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		gint _combo_box_index = 0;
#line 126 "../src/preferences-dialog.vala"
		_tmp53_ = self->priv->combo_boxes;
#line 126 "../src/preferences-dialog.vala"
		_combo_box_list = _tmp53_;
#line 126 "../src/preferences-dialog.vala"
		_tmp54_ = _combo_box_list;
#line 126 "../src/preferences-dialog.vala"
		_tmp55_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp54_);
#line 126 "../src/preferences-dialog.vala"
		_tmp56_ = _tmp55_;
#line 126 "../src/preferences-dialog.vala"
		_combo_box_size = _tmp56_;
#line 126 "../src/preferences-dialog.vala"
		_combo_box_index = -1;
#line 126 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 564 "preferences-dialog.c"
			gint _tmp57_;
			gint _tmp58_;
			GtkComboBoxText* combo_box = NULL;
			GeeArrayList* _tmp59_;
			gpointer _tmp60_;
			gint id = 0;
			GeeArrayList* _tmp66_;
			GtkComboBoxText* _tmp67_;
			gint color = 0;
			gpointer _tmp68_;
			GSettings* _tmp69_;
			gint _tmp70_;
			GtkComboBoxText* _tmp71_;
			GtkComboBoxText* _tmp72_;
#line 126 "../src/preferences-dialog.vala"
			_combo_box_index = _combo_box_index + 1;
#line 126 "../src/preferences-dialog.vala"
			_tmp57_ = _combo_box_index;
#line 126 "../src/preferences-dialog.vala"
			_tmp58_ = _combo_box_size;
#line 126 "../src/preferences-dialog.vala"
			if (!(_tmp57_ < _tmp58_)) {
#line 126 "../src/preferences-dialog.vala"
				break;
#line 589 "preferences-dialog.c"
			}
#line 126 "../src/preferences-dialog.vala"
			_tmp59_ = _combo_box_list;
#line 126 "../src/preferences-dialog.vala"
			_tmp60_ = gee_abstract_list_get ((GeeAbstractList*) _tmp59_, _combo_box_index);
#line 126 "../src/preferences-dialog.vala"
			combo_box = (GtkComboBoxText*) _tmp60_;
#line 597 "preferences-dialog.c"
			{
				gint i = 0;
#line 128 "../src/preferences-dialog.vala"
				i = 0;
#line 602 "preferences-dialog.c"
				{
					gboolean _tmp61_ = FALSE;
#line 128 "../src/preferences-dialog.vala"
					_tmp61_ = TRUE;
#line 128 "../src/preferences-dialog.vala"
					while (TRUE) {
#line 609 "preferences-dialog.c"
						GtkComboBoxText* _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
#line 128 "../src/preferences-dialog.vala"
						if (!_tmp61_) {
#line 615 "preferences-dialog.c"
							gint _tmp62_;
#line 128 "../src/preferences-dialog.vala"
							_tmp62_ = i;
#line 128 "../src/preferences-dialog.vala"
							i = _tmp62_ + 1;
#line 621 "preferences-dialog.c"
						}
#line 128 "../src/preferences-dialog.vala"
						_tmp61_ = FALSE;
#line 128 "../src/preferences-dialog.vala"
						if (!(i < NIBBLES_VIEW_NUM_COLORS)) {
#line 128 "../src/preferences-dialog.vala"
							break;
#line 629 "preferences-dialog.c"
						}
#line 129 "../src/preferences-dialog.vala"
						_tmp63_ = combo_box;
#line 129 "../src/preferences-dialog.vala"
						_tmp64_ = nibbles_view_colorval_name_translated (i);
#line 129 "../src/preferences-dialog.vala"
						_tmp65_ = _tmp64_;
#line 129 "../src/preferences-dialog.vala"
						gtk_combo_box_text_append_text (_tmp63_, _tmp65_);
#line 129 "../src/preferences-dialog.vala"
						_g_free0 (_tmp65_);
#line 641 "preferences-dialog.c"
					}
				}
			}
#line 131 "../src/preferences-dialog.vala"
			_tmp66_ = self->priv->combo_boxes;
#line 131 "../src/preferences-dialog.vala"
			_tmp67_ = combo_box;
#line 131 "../src/preferences-dialog.vala"
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp66_, _tmp67_);
#line 133 "../src/preferences-dialog.vala"
			_tmp68_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
#line 133 "../src/preferences-dialog.vala"
			_tmp69_ = (GSettings*) _tmp68_;
#line 133 "../src/preferences-dialog.vala"
			_tmp70_ = g_settings_get_enum (_tmp69_, "color");
#line 133 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp69_);
#line 133 "../src/preferences-dialog.vala"
			color = _tmp70_;
#line 134 "../src/preferences-dialog.vala"
			_tmp71_ = combo_box;
#line 134 "../src/preferences-dialog.vala"
			gtk_combo_box_set_active ((GtkComboBox*) _tmp71_, color);
#line 135 "../src/preferences-dialog.vala"
			_tmp72_ = combo_box;
#line 135 "../src/preferences-dialog.vala"
			g_signal_connect_object ((GtkComboBox*) _tmp72_, "changed", (GCallback) _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed, self, 0);
#line 126 "../src/preferences-dialog.vala"
			_g_object_unref0 (combo_box);
#line 671 "preferences-dialog.c"
		}
	}
#line 139 "../src/preferences-dialog.vala"
	_tmp73_ = self->priv->worm_combobox;
#line 139 "../src/preferences-dialog.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp73_, worm_id - 1);
#line 75 "../src/preferences-dialog.vala"
	return self;
#line 680 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_new (GtkApplicationWindow* window,
                        GSettings* settings,
                        GeeArrayList* worm_settings,
                        gint worm_id,
                        gint n_worms)
{
#line 75 "../src/preferences-dialog.vala"
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, window, settings, worm_settings, worm_id, n_worms);
#line 692 "preferences-dialog.c"
}

static inline gboolean
preferences_dialog_on_key_pressed (PreferencesDialog* self,
                                   GtkEventControllerKey* _key_controller,
                                   guint keyval,
                                   guint keycode,
                                   GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result;
#line 142 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/preferences-dialog.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 144 "../src/preferences-dialog.vala"
	_tmp1_ = gdk_keyval_name (keyval);
#line 144 "../src/preferences-dialog.vala"
	_tmp0_ = _tmp1_;
#line 144 "../src/preferences-dialog.vala"
	if (_tmp0_ == NULL) {
#line 144 "../src/preferences-dialog.vala"
		_tmp0_ = "";
#line 720 "preferences-dialog.c"
	}
#line 144 "../src/preferences-dialog.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 144 "../src/preferences-dialog.vala"
	name = _tmp2_;
#line 145 "../src/preferences-dialog.vala"
	_tmp3_ = name;
#line 145 "../src/preferences-dialog.vala"
	if (g_strcmp0 (_tmp3_, "Escape") == 0) {
#line 146 "../src/preferences-dialog.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 732 "preferences-dialog.c"
	}
#line 147 "../src/preferences-dialog.vala"
	result = FALSE;
#line 147 "../src/preferences-dialog.vala"
	_g_free0 (name);
#line 147 "../src/preferences-dialog.vala"
	return result;
#line 740 "preferences-dialog.c"
}

static inline void
preferences_dialog_on_worm_change (PreferencesDialog* self,
                                   GtkComboBox* _worm_combobox)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
#line 151 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/preferences-dialog.vala"
	g_return_if_fail (_worm_combobox != NULL);
#line 153 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->stack;
#line 153 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) G_TYPE_CHECK_INSTANCE_CAST (_worm_combobox, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 153 "../src/preferences-dialog.vala"
	gtk_stack_set_visible_child_name (_tmp0_, _tmp1_);
#line 759 "preferences-dialog.c"
}

static void
_preferences_dialog_on_worm_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                          gpointer self)
{
#line 22 "../src/preferences-dialog.vala"
	preferences_dialog_on_worm_change ((PreferencesDialog*) self, _sender);
#line 768 "preferences-dialog.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 161 "../src/preferences-dialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 776 "preferences-dialog.c"
}

static void
preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                    GtkCellRendererAccel* cell,
                                    const gchar* path_string,
                                    guint keyval,
                                    GdkModifierType mask,
                                    guint hardware_keycode)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkComboBoxText* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GeeArrayList* _tmp13_;
	gpointer _tmp14_;
	GSettings* _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp17_;
	gboolean valid = FALSE;
#line 156 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/preferences-dialog.vala"
	g_return_if_fail (cell != NULL);
#line 156 "../src/preferences-dialog.vala"
	g_return_if_fail (path_string != NULL);
#line 159 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
#line 159 "../src/preferences-dialog.vala"
	path = _tmp0_;
#line 160 "../src/preferences-dialog.vala"
	_tmp1_ = path;
#line 160 "../src/preferences-dialog.vala"
	if (_tmp1_ == NULL) {
#line 161 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 161 "../src/preferences-dialog.vala"
		return;
#line 829 "preferences-dialog.c"
	}
#line 163 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->worm_combobox;
#line 163 "../src/preferences-dialog.vala"
	id = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
#line 164 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->list_stores;
#line 164 "../src/preferences-dialog.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
#line 164 "../src/preferences-dialog.vala"
	list_store = (GtkListStore*) _tmp4_;
#line 167 "../src/preferences-dialog.vala"
	_tmp5_ = list_store;
#line 167 "../src/preferences-dialog.vala"
	_tmp6_ = path;
#line 167 "../src/preferences-dialog.vala"
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
#line 167 "../src/preferences-dialog.vala"
	it = _tmp7_;
#line 167 "../src/preferences-dialog.vala"
	if (!_tmp8_) {
#line 168 "../src/preferences-dialog.vala"
		_g_object_unref0 (list_store);
#line 168 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 168 "../src/preferences-dialog.vala"
		return;
#line 857 "preferences-dialog.c"
	}
#line 170 "../src/preferences-dialog.vala"
	key = NULL;
#line 171 "../src/preferences-dialog.vala"
	_tmp9_ = list_store;
#line 171 "../src/preferences-dialog.vala"
	_tmp10_ = it;
#line 171 "../src/preferences-dialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
#line 171 "../src/preferences-dialog.vala"
	_g_free0 (key);
#line 171 "../src/preferences-dialog.vala"
	key = _tmp11_;
#line 172 "../src/preferences-dialog.vala"
	_tmp12_ = key;
#line 172 "../src/preferences-dialog.vala"
	if (_tmp12_ == NULL) {
#line 173 "../src/preferences-dialog.vala"
		_g_free0 (key);
#line 173 "../src/preferences-dialog.vala"
		_g_object_unref0 (list_store);
#line 173 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 173 "../src/preferences-dialog.vala"
		return;
#line 883 "preferences-dialog.c"
	}
#line 175 "../src/preferences-dialog.vala"
	_tmp13_ = self->priv->worm_settings;
#line 175 "../src/preferences-dialog.vala"
	_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, id);
#line 175 "../src/preferences-dialog.vala"
	_tmp15_ = (GSettings*) _tmp14_;
#line 175 "../src/preferences-dialog.vala"
	_tmp16_ = key;
#line 175 "../src/preferences-dialog.vala"
	_tmp17_ = keyval == ((guint) g_settings_get_int (_tmp15_, _tmp16_));
#line 175 "../src/preferences-dialog.vala"
	_g_object_unref0 (_tmp15_);
#line 175 "../src/preferences-dialog.vala"
	if (_tmp17_) {
#line 176 "../src/preferences-dialog.vala"
		_g_free0 (key);
#line 176 "../src/preferences-dialog.vala"
		_g_object_unref0 (list_store);
#line 176 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 176 "../src/preferences-dialog.vala"
		return;
#line 907 "preferences-dialog.c"
	}
#line 179 "../src/preferences-dialog.vala"
	valid = TRUE;
#line 911 "preferences-dialog.c"
	{
		gint i = 0;
#line 180 "../src/preferences-dialog.vala"
		i = 0;
#line 916 "preferences-dialog.c"
		{
			gboolean _tmp18_ = FALSE;
#line 180 "../src/preferences-dialog.vala"
			_tmp18_ = TRUE;
#line 180 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 923 "preferences-dialog.c"
				gint _tmp20_;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				GeeArrayList* _tmp24_;
				gpointer _tmp25_;
				GSettings* _tmp26_;
				gboolean _tmp27_;
#line 180 "../src/preferences-dialog.vala"
				if (!_tmp18_) {
#line 934 "preferences-dialog.c"
					gint _tmp19_;
#line 180 "../src/preferences-dialog.vala"
					_tmp19_ = i;
#line 180 "../src/preferences-dialog.vala"
					i = _tmp19_ + 1;
#line 940 "preferences-dialog.c"
				}
#line 180 "../src/preferences-dialog.vala"
				_tmp18_ = FALSE;
#line 180 "../src/preferences-dialog.vala"
				_tmp20_ = self->priv->_n_worms;
#line 180 "../src/preferences-dialog.vala"
				if (!(i < _tmp20_)) {
#line 180 "../src/preferences-dialog.vala"
					break;
#line 950 "preferences-dialog.c"
				}
#line 182 "../src/preferences-dialog.vala"
				_tmp24_ = self->priv->worm_settings;
#line 182 "../src/preferences-dialog.vala"
				_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, i);
#line 182 "../src/preferences-dialog.vala"
				_tmp26_ = (GSettings*) _tmp25_;
#line 182 "../src/preferences-dialog.vala"
				_tmp27_ = keyval == ((guint) g_settings_get_int (_tmp26_, "key-up"));
#line 182 "../src/preferences-dialog.vala"
				_g_object_unref0 (_tmp26_);
#line 182 "../src/preferences-dialog.vala"
				if (_tmp27_) {
#line 182 "../src/preferences-dialog.vala"
					_tmp23_ = TRUE;
#line 966 "preferences-dialog.c"
				} else {
					GeeArrayList* _tmp28_;
					gpointer _tmp29_;
					GSettings* _tmp30_;
#line 183 "../src/preferences-dialog.vala"
					_tmp28_ = self->priv->worm_settings;
#line 183 "../src/preferences-dialog.vala"
					_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, i);
#line 183 "../src/preferences-dialog.vala"
					_tmp30_ = (GSettings*) _tmp29_;
#line 183 "../src/preferences-dialog.vala"
					_tmp23_ = keyval == ((guint) g_settings_get_int (_tmp30_, "key-down"));
#line 183 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp30_);
#line 981 "preferences-dialog.c"
				}
#line 182 "../src/preferences-dialog.vala"
				if (_tmp23_) {
#line 182 "../src/preferences-dialog.vala"
					_tmp22_ = TRUE;
#line 987 "preferences-dialog.c"
				} else {
					GeeArrayList* _tmp31_;
					gpointer _tmp32_;
					GSettings* _tmp33_;
#line 184 "../src/preferences-dialog.vala"
					_tmp31_ = self->priv->worm_settings;
#line 184 "../src/preferences-dialog.vala"
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, i);
#line 184 "../src/preferences-dialog.vala"
					_tmp33_ = (GSettings*) _tmp32_;
#line 184 "../src/preferences-dialog.vala"
					_tmp22_ = keyval == ((guint) g_settings_get_int (_tmp33_, "key-left"));
#line 184 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp33_);
#line 1002 "preferences-dialog.c"
				}
#line 182 "../src/preferences-dialog.vala"
				if (_tmp22_) {
#line 182 "../src/preferences-dialog.vala"
					_tmp21_ = TRUE;
#line 1008 "preferences-dialog.c"
				} else {
					GeeArrayList* _tmp34_;
					gpointer _tmp35_;
					GSettings* _tmp36_;
#line 185 "../src/preferences-dialog.vala"
					_tmp34_ = self->priv->worm_settings;
#line 185 "../src/preferences-dialog.vala"
					_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, i);
#line 185 "../src/preferences-dialog.vala"
					_tmp36_ = (GSettings*) _tmp35_;
#line 185 "../src/preferences-dialog.vala"
					_tmp21_ = keyval == ((guint) g_settings_get_int (_tmp36_, "key-right"));
#line 185 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp36_);
#line 1023 "preferences-dialog.c"
				}
#line 182 "../src/preferences-dialog.vala"
				if (_tmp21_) {
#line 1027 "preferences-dialog.c"
					GtkMessageDialog* dialog = NULL;
					GtkMessageDialog* _tmp37_;
					GtkMessageDialog* _tmp38_;
					gint response = 0;
					GtkMessageDialog* _tmp39_;
					GtkMessageDialog* _tmp40_;
#line 187 "../src/preferences-dialog.vala"
					_tmp37_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_CANCEL, "%s", _ ("The key you selected is already assigned!"));
#line 187 "../src/preferences-dialog.vala"
					g_object_ref_sink (_tmp37_);
#line 187 "../src/preferences-dialog.vala"
					dialog = _tmp37_;
#line 195 "../src/preferences-dialog.vala"
					_tmp38_ = dialog;
#line 195 "../src/preferences-dialog.vala"
					gtk_dialog_add_button ((GtkDialog*) _tmp38_, _ ("_Set anyway"), 42);
#line 197 "../src/preferences-dialog.vala"
					_tmp39_ = dialog;
#line 197 "../src/preferences-dialog.vala"
					response = gtk_dialog_run ((GtkDialog*) _tmp39_);
#line 198 "../src/preferences-dialog.vala"
					_tmp40_ = dialog;
#line 198 "../src/preferences-dialog.vala"
					gtk_widget_destroy ((GtkWidget*) _tmp40_);
#line 199 "../src/preferences-dialog.vala"
					if (response != 42) {
#line 200 "../src/preferences-dialog.vala"
						valid = FALSE;
#line 1056 "preferences-dialog.c"
					}
#line 201 "../src/preferences-dialog.vala"
					_g_object_unref0 (dialog);
#line 201 "../src/preferences-dialog.vala"
					break;
#line 1062 "preferences-dialog.c"
				}
			}
		}
	}
#line 205 "../src/preferences-dialog.vala"
	if (valid) {
#line 1069 "preferences-dialog.c"
		GtkListStore* _tmp41_;
		GtkTreeIter _tmp42_;
		GeeArrayList* _tmp43_;
		gpointer _tmp44_;
		GSettings* _tmp45_;
		const gchar* _tmp46_;
#line 207 "../src/preferences-dialog.vala"
		_tmp41_ = list_store;
#line 207 "../src/preferences-dialog.vala"
		_tmp42_ = it;
#line 207 "../src/preferences-dialog.vala"
		gtk_list_store_set (_tmp41_, &_tmp42_, 2, keyval, -1);
#line 208 "../src/preferences-dialog.vala"
		_tmp43_ = self->priv->worm_settings;
#line 208 "../src/preferences-dialog.vala"
		_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, id);
#line 208 "../src/preferences-dialog.vala"
		_tmp45_ = (GSettings*) _tmp44_;
#line 208 "../src/preferences-dialog.vala"
		_tmp46_ = key;
#line 208 "../src/preferences-dialog.vala"
		g_settings_set_int (_tmp45_, _tmp46_, (gint) keyval);
#line 208 "../src/preferences-dialog.vala"
		_g_object_unref0 (_tmp45_);
#line 1094 "preferences-dialog.c"
	}
#line 156 "../src/preferences-dialog.vala"
	_g_free0 (key);
#line 156 "../src/preferences-dialog.vala"
	_g_object_unref0 (list_store);
#line 156 "../src/preferences-dialog.vala"
	__vala_GtkTreePath_free0 (path);
#line 1102 "preferences-dialog.c"
}

static void
preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                     GtkCellRendererAccel* cell,
                                     const gchar* path_string)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkComboBoxText* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	GSettings* _tmp17_;
	const gchar* _tmp18_;
#line 212 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/preferences-dialog.vala"
	g_return_if_fail (cell != NULL);
#line 212 "../src/preferences-dialog.vala"
	g_return_if_fail (path_string != NULL);
#line 214 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
#line 214 "../src/preferences-dialog.vala"
	path = _tmp0_;
#line 215 "../src/preferences-dialog.vala"
	_tmp1_ = path;
#line 215 "../src/preferences-dialog.vala"
	if (_tmp1_ == NULL) {
#line 216 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 216 "../src/preferences-dialog.vala"
		return;
#line 1152 "preferences-dialog.c"
	}
#line 218 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->worm_combobox;
#line 218 "../src/preferences-dialog.vala"
	id = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
#line 219 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->list_stores;
#line 219 "../src/preferences-dialog.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
#line 219 "../src/preferences-dialog.vala"
	list_store = (GtkListStore*) _tmp4_;
#line 222 "../src/preferences-dialog.vala"
	_tmp5_ = list_store;
#line 222 "../src/preferences-dialog.vala"
	_tmp6_ = path;
#line 222 "../src/preferences-dialog.vala"
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
#line 222 "../src/preferences-dialog.vala"
	it = _tmp7_;
#line 222 "../src/preferences-dialog.vala"
	if (!_tmp8_) {
#line 223 "../src/preferences-dialog.vala"
		_g_object_unref0 (list_store);
#line 223 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 223 "../src/preferences-dialog.vala"
		return;
#line 1180 "preferences-dialog.c"
	}
#line 225 "../src/preferences-dialog.vala"
	key = NULL;
#line 226 "../src/preferences-dialog.vala"
	_tmp9_ = list_store;
#line 226 "../src/preferences-dialog.vala"
	_tmp10_ = it;
#line 226 "../src/preferences-dialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
#line 226 "../src/preferences-dialog.vala"
	_g_free0 (key);
#line 226 "../src/preferences-dialog.vala"
	key = _tmp11_;
#line 227 "../src/preferences-dialog.vala"
	_tmp12_ = key;
#line 227 "../src/preferences-dialog.vala"
	if (_tmp12_ == NULL) {
#line 228 "../src/preferences-dialog.vala"
		_g_free0 (key);
#line 228 "../src/preferences-dialog.vala"
		_g_object_unref0 (list_store);
#line 228 "../src/preferences-dialog.vala"
		__vala_GtkTreePath_free0 (path);
#line 228 "../src/preferences-dialog.vala"
		return;
#line 1206 "preferences-dialog.c"
	}
#line 230 "../src/preferences-dialog.vala"
	_tmp13_ = list_store;
#line 230 "../src/preferences-dialog.vala"
	_tmp14_ = it;
#line 230 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp13_, &_tmp14_, 2, 0, -1);
#line 231 "../src/preferences-dialog.vala"
	_tmp15_ = self->priv->worm_settings;
#line 231 "../src/preferences-dialog.vala"
	_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, id);
#line 231 "../src/preferences-dialog.vala"
	_tmp17_ = (GSettings*) _tmp16_;
#line 231 "../src/preferences-dialog.vala"
	_tmp18_ = key;
#line 231 "../src/preferences-dialog.vala"
	g_settings_set_int (_tmp17_, _tmp18_, 0);
#line 231 "../src/preferences-dialog.vala"
	_g_object_unref0 (_tmp17_);
#line 212 "../src/preferences-dialog.vala"
	_g_free0 (key);
#line 212 "../src/preferences-dialog.vala"
	_g_object_unref0 (list_store);
#line 212 "../src/preferences-dialog.vala"
	__vala_GtkTreePath_free0 (path);
#line 1232 "preferences-dialog.c"
}

static void
preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                         GtkComboBox* combo_box)
{
	gint id = 0;
	GeeArrayList* _tmp0_;
	gint color_new = 0;
	gint color_old = 0;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	GSettings* _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp26_;
	gpointer _tmp27_;
	GSettings* _tmp28_;
#line 234 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/preferences-dialog.vala"
	g_return_if_fail (combo_box != NULL);
#line 236 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->combo_boxes;
#line 236 "../src/preferences-dialog.vala"
	id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (combo_box, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 237 "../src/preferences-dialog.vala"
	color_new = gtk_combo_box_get_active (combo_box);
#line 238 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->worm_settings;
#line 238 "../src/preferences-dialog.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, id);
#line 238 "../src/preferences-dialog.vala"
	_tmp3_ = (GSettings*) _tmp2_;
#line 238 "../src/preferences-dialog.vala"
	_tmp4_ = g_settings_get_enum (_tmp3_, "color");
#line 238 "../src/preferences-dialog.vala"
	_g_object_unref0 (_tmp3_);
#line 238 "../src/preferences-dialog.vala"
	color_old = _tmp4_;
#line 240 "../src/preferences-dialog.vala"
	if (color_new == color_old) {
#line 241 "../src/preferences-dialog.vala"
		return;
#line 1276 "preferences-dialog.c"
	}
	{
		gint i = 0;
#line 244 "../src/preferences-dialog.vala"
		i = 0;
#line 1282 "preferences-dialog.c"
		{
			gboolean _tmp5_ = FALSE;
#line 244 "../src/preferences-dialog.vala"
			_tmp5_ = TRUE;
#line 244 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 1289 "preferences-dialog.c"
				gboolean _tmp7_ = FALSE;
#line 244 "../src/preferences-dialog.vala"
				if (!_tmp5_) {
#line 1293 "preferences-dialog.c"
					gint _tmp6_;
#line 244 "../src/preferences-dialog.vala"
					_tmp6_ = i;
#line 244 "../src/preferences-dialog.vala"
					i = _tmp6_ + 1;
#line 1299 "preferences-dialog.c"
				}
#line 244 "../src/preferences-dialog.vala"
				_tmp5_ = FALSE;
#line 244 "../src/preferences-dialog.vala"
				if (!(i < NIBBLES_GAME_MAX_WORMS)) {
#line 244 "../src/preferences-dialog.vala"
					break;
#line 1307 "preferences-dialog.c"
				}
#line 246 "../src/preferences-dialog.vala"
				if (i != id) {
#line 1311 "preferences-dialog.c"
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					GSettings* _tmp10_;
#line 246 "../src/preferences-dialog.vala"
					_tmp8_ = self->priv->worm_settings;
#line 246 "../src/preferences-dialog.vala"
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
#line 246 "../src/preferences-dialog.vala"
					_tmp10_ = (GSettings*) _tmp9_;
#line 246 "../src/preferences-dialog.vala"
					_tmp7_ = g_settings_get_enum (_tmp10_, "color") == color_new;
#line 246 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp10_);
#line 1325 "preferences-dialog.c"
				} else {
#line 246 "../src/preferences-dialog.vala"
					_tmp7_ = FALSE;
#line 1329 "preferences-dialog.c"
				}
#line 246 "../src/preferences-dialog.vala"
				if (_tmp7_) {
#line 1333 "preferences-dialog.c"
					GeeArrayList* _tmp11_;
					gpointer _tmp12_;
					GSettings* _tmp13_;
					gint _tmp14_;
#line 248 "../src/preferences-dialog.vala"
					_tmp11_ = self->priv->worm_settings;
#line 248 "../src/preferences-dialog.vala"
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, i);
#line 248 "../src/preferences-dialog.vala"
					_tmp13_ = (GSettings*) _tmp12_;
#line 248 "../src/preferences-dialog.vala"
					g_settings_set_enum (_tmp13_, "color", color_old);
#line 248 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp13_);
#line 251 "../src/preferences-dialog.vala"
					_tmp14_ = self->priv->_n_worms;
#line 251 "../src/preferences-dialog.vala"
					if (i < _tmp14_) {
#line 1352 "preferences-dialog.c"
						{
							GeeArrayList* _cbox_list = NULL;
							GeeArrayList* _tmp15_;
							gint _cbox_size = 0;
							GeeArrayList* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							gint _cbox_index = 0;
#line 253 "../src/preferences-dialog.vala"
							_tmp15_ = self->priv->combo_boxes;
#line 253 "../src/preferences-dialog.vala"
							_cbox_list = _tmp15_;
#line 253 "../src/preferences-dialog.vala"
							_tmp16_ = _cbox_list;
#line 253 "../src/preferences-dialog.vala"
							_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 253 "../src/preferences-dialog.vala"
							_tmp18_ = _tmp17_;
#line 253 "../src/preferences-dialog.vala"
							_cbox_size = _tmp18_;
#line 253 "../src/preferences-dialog.vala"
							_cbox_index = -1;
#line 253 "../src/preferences-dialog.vala"
							while (TRUE) {
#line 1377 "preferences-dialog.c"
								gint _tmp19_;
								gint _tmp20_;
								GtkComboBoxText* cbox = NULL;
								GeeArrayList* _tmp21_;
								gpointer _tmp22_;
								gint index = 0;
								GeeArrayList* _tmp23_;
								GtkComboBoxText* _tmp24_;
#line 253 "../src/preferences-dialog.vala"
								_cbox_index = _cbox_index + 1;
#line 253 "../src/preferences-dialog.vala"
								_tmp19_ = _cbox_index;
#line 253 "../src/preferences-dialog.vala"
								_tmp20_ = _cbox_size;
#line 253 "../src/preferences-dialog.vala"
								if (!(_tmp19_ < _tmp20_)) {
#line 253 "../src/preferences-dialog.vala"
									break;
#line 1396 "preferences-dialog.c"
								}
#line 253 "../src/preferences-dialog.vala"
								_tmp21_ = _cbox_list;
#line 253 "../src/preferences-dialog.vala"
								_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _cbox_index);
#line 253 "../src/preferences-dialog.vala"
								cbox = (GtkComboBoxText*) _tmp22_;
#line 255 "../src/preferences-dialog.vala"
								_tmp23_ = self->priv->combo_boxes;
#line 255 "../src/preferences-dialog.vala"
								_tmp24_ = cbox;
#line 255 "../src/preferences-dialog.vala"
								index = gee_abstract_list_index_of ((GeeAbstractList*) _tmp23_, _tmp24_);
#line 256 "../src/preferences-dialog.vala"
								if (index == i) {
#line 1412 "preferences-dialog.c"
									GtkComboBoxText* _tmp25_;
#line 258 "../src/preferences-dialog.vala"
									_tmp25_ = cbox;
#line 258 "../src/preferences-dialog.vala"
									gtk_combo_box_set_active ((GtkComboBox*) _tmp25_, color_old);
#line 259 "../src/preferences-dialog.vala"
									_g_object_unref0 (cbox);
#line 259 "../src/preferences-dialog.vala"
									break;
#line 1422 "preferences-dialog.c"
								}
#line 253 "../src/preferences-dialog.vala"
								_g_object_unref0 (cbox);
#line 1426 "preferences-dialog.c"
							}
						}
					}
#line 264 "../src/preferences-dialog.vala"
					break;
#line 1432 "preferences-dialog.c"
				}
			}
		}
	}
#line 268 "../src/preferences-dialog.vala"
	_tmp26_ = self->priv->worm_settings;
#line 268 "../src/preferences-dialog.vala"
	_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, id);
#line 268 "../src/preferences-dialog.vala"
	_tmp28_ = (GSettings*) _tmp27_;
#line 268 "../src/preferences-dialog.vala"
	g_settings_set_enum (_tmp28_, "color", color_new);
#line 268 "../src/preferences-dialog.vala"
	_g_object_unref0 (_tmp28_);
#line 1447 "preferences-dialog.c"
}

static gint
preferences_dialog_get_n_worms (PreferencesDialog* self)
{
	gint result;
#line 49 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../src/preferences-dialog.vala"
	result = self->priv->_n_worms;
#line 49 "../src/preferences-dialog.vala"
	return result;
#line 1460 "preferences-dialog.c"
}

static void
preferences_dialog_set_n_worms (PreferencesDialog* self,
                                gint value)
{
	gint old_value;
#line 49 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/preferences-dialog.vala"
	old_value = preferences_dialog_get_n_worms (self);
#line 49 "../src/preferences-dialog.vala"
	if (old_value != value) {
#line 49 "../src/preferences-dialog.vala"
		self->priv->_n_worms = value;
#line 49 "../src/preferences-dialog.vala"
		g_object_notify_by_pspec ((GObject *) self, preferences_dialog_properties[PREFERENCES_DIALOG_N_WORMS_PROPERTY]);
#line 1478 "preferences-dialog.c"
	}
}

static gboolean
_preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self)
{
	gboolean result;
	result = preferences_dialog_on_key_pressed ((PreferencesDialog*) self, _sender, keyval, keycode, state);
#line 54 "../src/preferences-dialog.vala"
	return result;
#line 1493 "preferences-dialog.c"
}

static GObject *
preferences_dialog_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PreferencesDialog * self;
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GtkTreeView* _tmp4_;
	GeeArrayList* _tmp5_;
	GtkTreeView* _tmp6_;
	GeeArrayList* _tmp7_;
	GtkTreeView* _tmp8_;
	GeeArrayList* _tmp9_;
	GtkTreeView* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GtkListStore* _tmp13_;
	GeeArrayList* _tmp14_;
	GtkListStore* _tmp15_;
	GeeArrayList* _tmp16_;
	GtkListStore* _tmp17_;
	GeeArrayList* _tmp18_;
	GtkListStore* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GeeArrayList* _tmp23_;
	GtkComboBoxText* _tmp24_;
	GeeArrayList* _tmp25_;
	GtkComboBoxText* _tmp26_;
	GeeArrayList* _tmp27_;
	GtkComboBoxText* _tmp28_;
#line 51 "../src/preferences-dialog.vala"
	parent_class = G_OBJECT_CLASS (preferences_dialog_parent_class);
#line 51 "../src/preferences-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 53 "../src/preferences-dialog.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 53 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 53 "../src/preferences-dialog.vala"
	self->priv->key_controller = _tmp0_;
#line 54 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->key_controller;
#line 54 "../src/preferences-dialog.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 56 "../src/preferences-dialog.vala"
	_tmp2_ = gee_array_list_new (gtk_tree_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 56 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->tree_views);
#line 56 "../src/preferences-dialog.vala"
	self->priv->tree_views = _tmp2_;
#line 57 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->tree_views;
#line 57 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->tree_view_1;
#line 57 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 58 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->tree_views;
#line 58 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->tree_view_2;
#line 58 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 59 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->tree_views;
#line 59 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->tree_view_3;
#line 59 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 60 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->tree_views;
#line 60 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->tree_view_4;
#line 60 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
#line 62 "../src/preferences-dialog.vala"
	_tmp11_ = gee_array_list_new (gtk_list_store_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->list_stores);
#line 62 "../src/preferences-dialog.vala"
	self->priv->list_stores = _tmp11_;
#line 63 "../src/preferences-dialog.vala"
	_tmp12_ = self->priv->list_stores;
#line 63 "../src/preferences-dialog.vala"
	_tmp13_ = self->priv->list_store_1;
#line 63 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 64 "../src/preferences-dialog.vala"
	_tmp14_ = self->priv->list_stores;
#line 64 "../src/preferences-dialog.vala"
	_tmp15_ = self->priv->list_store_2;
#line 64 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 65 "../src/preferences-dialog.vala"
	_tmp16_ = self->priv->list_stores;
#line 65 "../src/preferences-dialog.vala"
	_tmp17_ = self->priv->list_store_3;
#line 65 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 66 "../src/preferences-dialog.vala"
	_tmp18_ = self->priv->list_stores;
#line 66 "../src/preferences-dialog.vala"
	_tmp19_ = self->priv->list_store_4;
#line 66 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 68 "../src/preferences-dialog.vala"
	_tmp20_ = gee_array_list_new (gtk_combo_box_text_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 68 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->combo_boxes);
#line 68 "../src/preferences-dialog.vala"
	self->priv->combo_boxes = _tmp20_;
#line 69 "../src/preferences-dialog.vala"
	_tmp21_ = self->priv->combo_boxes;
#line 69 "../src/preferences-dialog.vala"
	_tmp22_ = self->priv->combo_box_1;
#line 69 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 70 "../src/preferences-dialog.vala"
	_tmp23_ = self->priv->combo_boxes;
#line 70 "../src/preferences-dialog.vala"
	_tmp24_ = self->priv->combo_box_2;
#line 70 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 71 "../src/preferences-dialog.vala"
	_tmp25_ = self->priv->combo_boxes;
#line 71 "../src/preferences-dialog.vala"
	_tmp26_ = self->priv->combo_box_3;
#line 71 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 72 "../src/preferences-dialog.vala"
	_tmp27_ = self->priv->combo_boxes;
#line 72 "../src/preferences-dialog.vala"
	_tmp28_ = self->priv->combo_box_4;
#line 72 "../src/preferences-dialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 51 "../src/preferences-dialog.vala"
	return obj;
#line 1641 "preferences-dialog.c"
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
#line 22 "../src/preferences-dialog.vala"
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
#line 22 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_preferences_dialog_get_property;
#line 22 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_preferences_dialog_set_property;
#line 22 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = preferences_dialog_constructor;
#line 22 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
#line 22 "../src/preferences-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_DIALOG_N_WORMS_PROPERTY, preferences_dialog_properties[PREFERENCES_DIALOG_N_WORMS_PROPERTY] = g_param_spec_int ("n-worms", "n-worms", "n-worms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/preferences-dialog.ui");
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, stack));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar_stack", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, headerbar_stack));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "worm_combobox", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, worm_combobox));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_1));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_2));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_3));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_4));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_1));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_2));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_3));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_4));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_1));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_2));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_3));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_4));
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_worm_change", G_CALLBACK(_preferences_dialog_on_worm_change_gtk_combo_box_changed));
#line 1696 "preferences-dialog.c"
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
#line 22 "../src/preferences-dialog.vala"
	self->priv = preferences_dialog_get_instance_private (self);
#line 22 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1707 "preferences-dialog.c"
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
#line 22 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 24 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 25 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->worm_settings);
#line 43 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->list_stores);
#line 44 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->tree_views);
#line 45 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->combo_boxes);
#line 47 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 22 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
#line 1730 "preferences-dialog.c"
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_static (gtk_window_get_type (), "PreferencesDialog", &g_define_type_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__once)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__once, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__once;
}

static void
_vala_preferences_dialog_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 22 "../src/preferences-dialog.vala"
	switch (property_id) {
#line 22 "../src/preferences-dialog.vala"
		case PREFERENCES_DIALOG_N_WORMS_PROPERTY:
#line 22 "../src/preferences-dialog.vala"
		g_value_set_int (value, preferences_dialog_get_n_worms (self));
#line 22 "../src/preferences-dialog.vala"
		break;
#line 1771 "preferences-dialog.c"
		default:
#line 22 "../src/preferences-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/preferences-dialog.vala"
		break;
#line 1777 "preferences-dialog.c"
	}
}

static void
_vala_preferences_dialog_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 22 "../src/preferences-dialog.vala"
	switch (property_id) {
#line 22 "../src/preferences-dialog.vala"
		case PREFERENCES_DIALOG_N_WORMS_PROPERTY:
#line 22 "../src/preferences-dialog.vala"
		preferences_dialog_set_n_worms (self, g_value_get_int (value));
#line 22 "../src/preferences-dialog.vala"
		break;
#line 1797 "preferences-dialog.c"
		default:
#line 22 "../src/preferences-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/preferences-dialog.vala"
		break;
#line 1803 "preferences-dialog.c"
	}
}

