/* scoreboard.c generated by valac 0.56.3, the Vala compiler
 * generated from scoreboard.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define WORM_MAX_LIVES ((guint8) 12)
#define WORM_STARTING_LIVES ((guint8) 6)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SCOREBOARD (scoreboard_get_type ())
#define SCOREBOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCOREBOARD, Scoreboard))
#define SCOREBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCOREBOARD, ScoreboardClass))
#define IS_SCOREBOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCOREBOARD))
#define IS_SCOREBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCOREBOARD))
#define SCOREBOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCOREBOARD, ScoreboardClass))

typedef struct _Scoreboard Scoreboard;
typedef struct _ScoreboardClass ScoreboardClass;
typedef struct _ScoreboardPrivate ScoreboardPrivate;

#define TYPE_PLAYER_SCORE_BOX (player_score_box_get_type ())
#define PLAYER_SCORE_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PLAYER_SCORE_BOX, PlayerScoreBox))
#define PLAYER_SCORE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PLAYER_SCORE_BOX, PlayerScoreBoxClass))
#define IS_PLAYER_SCORE_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PLAYER_SCORE_BOX))
#define IS_PLAYER_SCORE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PLAYER_SCORE_BOX))
#define PLAYER_SCORE_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PLAYER_SCORE_BOX, PlayerScoreBoxClass))

typedef struct _PlayerScoreBox PlayerScoreBox;
typedef struct _PlayerScoreBoxClass PlayerScoreBoxClass;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;
enum  {
	SCOREBOARD_0_PROPERTY,
	SCOREBOARD_NUM_PROPERTIES
};
static GParamSpec* scoreboard_properties[SCOREBOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PlayerScoreBoxPrivate PlayerScoreBoxPrivate;
enum  {
	PLAYER_SCORE_BOX_0_PROPERTY,
	PLAYER_SCORE_BOX_NUM_PROPERTIES
};
static GParamSpec* player_score_box_properties[PLAYER_SCORE_BOX_NUM_PROPERTIES];

struct _Scoreboard {
	GtkBox parent_instance;
	ScoreboardPrivate * priv;
};

struct _ScoreboardClass {
	GtkBoxClass parent_class;
};

struct _ScoreboardPrivate {
	GeeHashMap* boxes;
};

struct _PlayerScoreBox {
	GtkBox parent_instance;
	PlayerScoreBoxPrivate * priv;
};

struct _PlayerScoreBoxClass {
	GtkBoxClass parent_class;
};

struct _PlayerScoreBoxPrivate {
	GtkLabel* name_label;
	GtkLabel* score_label;
	GtkGrid* lives_grid;
	GeeLinkedList* life_images;
};

static gint Scoreboard_private_offset;
static gpointer scoreboard_parent_class = NULL;
static gint PlayerScoreBox_private_offset;
static gpointer player_score_box_parent_class = NULL;

VALA_EXTERN GType scoreboard_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Scoreboard, g_object_unref)
VALA_EXTERN GType player_score_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PlayerScoreBox, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN void scoreboard_register (Scoreboard* self,
                          Worm* worm,
                          const gchar* color_name,
                          GdkPixbuf* life_pixbuf);
VALA_EXTERN gint worm_get_id (Worm* self);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN PlayerScoreBox* player_score_box_new (const gchar* name,
                                      PangoColor* color,
                                      gint score,
                                      guint8 lives_left,
                                      GdkPixbuf* life_pixbuf);
VALA_EXTERN PlayerScoreBox* player_score_box_construct (GType object_type,
                                            const gchar* name,
                                            PangoColor* color,
                                            gint score,
                                            guint8 lives_left,
                                            GdkPixbuf* life_pixbuf);
VALA_EXTERN void scoreboard_update (Scoreboard* self);
VALA_EXTERN void player_score_box_update (PlayerScoreBox* self,
                              gint score,
                              guint8 lives_left);
VALA_EXTERN void scoreboard_clear (Scoreboard* self);
VALA_EXTERN Scoreboard* scoreboard_new (void);
VALA_EXTERN Scoreboard* scoreboard_construct (GType object_type);
static void scoreboard_finalize (GObject * obj);
static GType scoreboard_get_type_once (void);
VALA_EXTERN void player_score_box_update_score (PlayerScoreBox* self,
                                    gint score);
VALA_EXTERN void player_score_box_update_lives (PlayerScoreBox* self,
                                    guint8 lives_left);
static void player_score_box_finalize (GObject * obj);
static GType player_score_box_get_type_once (void);

static inline gpointer
scoreboard_get_instance_private (Scoreboard* self)
{
	return G_STRUCT_MEMBER_P (self, Scoreboard_private_offset);
}

void
scoreboard_register (Scoreboard* self,
                     Worm* worm,
                     const gchar* color_name,
                     GdkPixbuf* life_pixbuf)
{
	PangoColor color = {0};
	PlayerScoreBox* box = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PangoColor _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	PlayerScoreBox* _tmp9_;
	PlayerScoreBox* _tmp10_;
	GeeHashMap* _tmp11_;
#line 26 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/scoreboard.vala"
	g_return_if_fail (worm != NULL);
#line 26 "../src/scoreboard.vala"
	g_return_if_fail (color_name != NULL);
#line 26 "../src/scoreboard.vala"
	g_return_if_fail (life_pixbuf != NULL);
#line 28 "../src/scoreboard.vala"
	memset (&color, 0, sizeof (PangoColor));
#line 29 "../src/scoreboard.vala"
	pango_color_parse (&color, color_name);
#line 32 "../src/scoreboard.vala"
	_tmp0_ = worm_get_id (worm);
#line 32 "../src/scoreboard.vala"
	_tmp1_ = _tmp0_;
#line 32 "../src/scoreboard.vala"
	_tmp2_ = g_strdup_printf (_ ("Player %d"), _tmp1_ + 1);
#line 32 "../src/scoreboard.vala"
	_tmp3_ = _tmp2_;
#line 32 "../src/scoreboard.vala"
	_tmp4_ = color;
#line 32 "../src/scoreboard.vala"
	_tmp5_ = worm_get_score (worm);
#line 32 "../src/scoreboard.vala"
	_tmp6_ = _tmp5_;
#line 32 "../src/scoreboard.vala"
	_tmp7_ = worm_get_lives (worm);
#line 32 "../src/scoreboard.vala"
	_tmp8_ = _tmp7_;
#line 32 "../src/scoreboard.vala"
	_tmp9_ = player_score_box_new (_tmp3_, &_tmp4_, _tmp6_, _tmp8_, life_pixbuf);
#line 32 "../src/scoreboard.vala"
	g_object_ref_sink (_tmp9_);
#line 32 "../src/scoreboard.vala"
	_tmp10_ = _tmp9_;
#line 32 "../src/scoreboard.vala"
	_g_free0 (_tmp3_);
#line 32 "../src/scoreboard.vala"
	box = _tmp10_;
#line 33 "../src/scoreboard.vala"
	_tmp11_ = self->priv->boxes;
#line 33 "../src/scoreboard.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, box, worm);
#line 34 "../src/scoreboard.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
#line 26 "../src/scoreboard.vala"
	_g_object_unref0 (box);
#line 239 "scoreboard.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/scoreboard.vala"
	return self ? g_object_ref (self) : NULL;
#line 247 "scoreboard.c"
}

void
scoreboard_update (Scoreboard* self)
{
#line 37 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 255 "scoreboard.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 39 "../src/scoreboard.vala"
		_tmp0_ = self->priv->boxes;
#line 39 "../src/scoreboard.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 39 "../src/scoreboard.vala"
		_tmp2_ = _tmp1_;
#line 39 "../src/scoreboard.vala"
		_tmp3_ = _tmp2_;
#line 39 "../src/scoreboard.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 39 "../src/scoreboard.vala"
		_tmp5_ = _tmp4_;
#line 39 "../src/scoreboard.vala"
		_g_object_unref0 (_tmp3_);
#line 39 "../src/scoreboard.vala"
		_entry_it = _tmp5_;
#line 39 "../src/scoreboard.vala"
		while (TRUE) {
#line 282 "scoreboard.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			PlayerScoreBox* box = NULL;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			PlayerScoreBox* _tmp12_;
			Worm* worm = NULL;
			GeeMapEntry* _tmp13_;
			gconstpointer _tmp14_;
			gconstpointer _tmp15_;
			Worm* _tmp16_;
			PlayerScoreBox* _tmp17_;
			Worm* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			Worm* _tmp21_;
			guint8 _tmp22_;
			guint8 _tmp23_;
#line 39 "../src/scoreboard.vala"
			_tmp6_ = _entry_it;
#line 39 "../src/scoreboard.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 39 "../src/scoreboard.vala"
				break;
#line 310 "scoreboard.c"
			}
#line 39 "../src/scoreboard.vala"
			_tmp7_ = _entry_it;
#line 39 "../src/scoreboard.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 39 "../src/scoreboard.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 41 "../src/scoreboard.vala"
			_tmp9_ = entry;
#line 41 "../src/scoreboard.vala"
			_tmp10_ = gee_map_entry_get_key (_tmp9_);
#line 41 "../src/scoreboard.vala"
			_tmp11_ = _tmp10_;
#line 41 "../src/scoreboard.vala"
			_tmp12_ = _g_object_ref0 ((PlayerScoreBox*) _tmp11_);
#line 41 "../src/scoreboard.vala"
			box = _tmp12_;
#line 42 "../src/scoreboard.vala"
			_tmp13_ = entry;
#line 42 "../src/scoreboard.vala"
			_tmp14_ = gee_map_entry_get_value (_tmp13_);
#line 42 "../src/scoreboard.vala"
			_tmp15_ = _tmp14_;
#line 42 "../src/scoreboard.vala"
			_tmp16_ = _g_object_ref0 ((Worm*) _tmp15_);
#line 42 "../src/scoreboard.vala"
			worm = _tmp16_;
#line 44 "../src/scoreboard.vala"
			_tmp17_ = box;
#line 44 "../src/scoreboard.vala"
			_tmp18_ = worm;
#line 44 "../src/scoreboard.vala"
			_tmp19_ = worm_get_score (_tmp18_);
#line 44 "../src/scoreboard.vala"
			_tmp20_ = _tmp19_;
#line 44 "../src/scoreboard.vala"
			_tmp21_ = worm;
#line 44 "../src/scoreboard.vala"
			_tmp22_ = worm_get_lives (_tmp21_);
#line 44 "../src/scoreboard.vala"
			_tmp23_ = _tmp22_;
#line 44 "../src/scoreboard.vala"
			player_score_box_update (_tmp17_, _tmp20_, _tmp23_);
#line 39 "../src/scoreboard.vala"
			_g_object_unref0 (worm);
#line 39 "../src/scoreboard.vala"
			_g_object_unref0 (box);
#line 39 "../src/scoreboard.vala"
			_g_object_unref0 (entry);
#line 360 "scoreboard.c"
		}
#line 39 "../src/scoreboard.vala"
		_g_object_unref0 (_entry_it);
#line 364 "scoreboard.c"
	}
}

void
scoreboard_clear (Scoreboard* self)
{
	GeeHashMap* _tmp14_;
#line 48 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 374 "scoreboard.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 50 "../src/scoreboard.vala"
		_tmp0_ = self->priv->boxes;
#line 50 "../src/scoreboard.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 50 "../src/scoreboard.vala"
		_tmp2_ = _tmp1_;
#line 50 "../src/scoreboard.vala"
		_tmp3_ = _tmp2_;
#line 50 "../src/scoreboard.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 50 "../src/scoreboard.vala"
		_tmp5_ = _tmp4_;
#line 50 "../src/scoreboard.vala"
		_g_object_unref0 (_tmp3_);
#line 50 "../src/scoreboard.vala"
		_entry_it = _tmp5_;
#line 50 "../src/scoreboard.vala"
		while (TRUE) {
#line 401 "scoreboard.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			PlayerScoreBox* box = NULL;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			PlayerScoreBox* _tmp12_;
			PlayerScoreBox* _tmp13_;
#line 50 "../src/scoreboard.vala"
			_tmp6_ = _entry_it;
#line 50 "../src/scoreboard.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 50 "../src/scoreboard.vala"
				break;
#line 418 "scoreboard.c"
			}
#line 50 "../src/scoreboard.vala"
			_tmp7_ = _entry_it;
#line 50 "../src/scoreboard.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 50 "../src/scoreboard.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 52 "../src/scoreboard.vala"
			_tmp9_ = entry;
#line 52 "../src/scoreboard.vala"
			_tmp10_ = gee_map_entry_get_key (_tmp9_);
#line 52 "../src/scoreboard.vala"
			_tmp11_ = _tmp10_;
#line 52 "../src/scoreboard.vala"
			_tmp12_ = _g_object_ref0 ((PlayerScoreBox*) _tmp11_);
#line 52 "../src/scoreboard.vala"
			box = _tmp12_;
#line 53 "../src/scoreboard.vala"
			_tmp13_ = box;
#line 53 "../src/scoreboard.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp13_);
#line 50 "../src/scoreboard.vala"
			_g_object_unref0 (box);
#line 50 "../src/scoreboard.vala"
			_g_object_unref0 (entry);
#line 444 "scoreboard.c"
		}
#line 50 "../src/scoreboard.vala"
		_g_object_unref0 (_entry_it);
#line 448 "scoreboard.c"
	}
#line 55 "../src/scoreboard.vala"
	_tmp14_ = self->priv->boxes;
#line 55 "../src/scoreboard.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp14_);
#line 454 "scoreboard.c"
}

Scoreboard*
scoreboard_construct (GType object_type)
{
	Scoreboard * self = NULL;
#line 22 "../src/scoreboard.vala"
	self = (Scoreboard*) g_object_new (object_type, NULL);
#line 22 "../src/scoreboard.vala"
	return self;
#line 465 "scoreboard.c"
}

Scoreboard*
scoreboard_new (void)
{
#line 22 "../src/scoreboard.vala"
	return scoreboard_construct (TYPE_SCOREBOARD);
#line 473 "scoreboard.c"
}

static void
scoreboard_class_init (ScoreboardClass * klass,
                       gpointer klass_data)
{
#line 22 "../src/scoreboard.vala"
	scoreboard_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/scoreboard.vala"
	g_type_class_adjust_private_offset (klass, &Scoreboard_private_offset);
#line 22 "../src/scoreboard.vala"
	G_OBJECT_CLASS (klass)->finalize = scoreboard_finalize;
#line 22 "../src/scoreboard.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/scoreboard.ui");
#line 488 "scoreboard.c"
}

static void
scoreboard_instance_init (Scoreboard * self,
                          gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 22 "../src/scoreboard.vala"
	self->priv = scoreboard_get_instance_private (self);
#line 24 "../src/scoreboard.vala"
	_tmp0_ = gee_hash_map_new (TYPE_PLAYER_SCORE_BOX, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 24 "../src/scoreboard.vala"
	self->priv->boxes = _tmp0_;
#line 22 "../src/scoreboard.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 504 "scoreboard.c"
}

static void
scoreboard_finalize (GObject * obj)
{
	Scoreboard * self;
#line 22 "../src/scoreboard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCOREBOARD, Scoreboard);
#line 24 "../src/scoreboard.vala"
	_g_object_unref0 (self->priv->boxes);
#line 22 "../src/scoreboard.vala"
	G_OBJECT_CLASS (scoreboard_parent_class)->finalize (obj);
#line 517 "scoreboard.c"
}

static GType
scoreboard_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScoreboardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scoreboard_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Scoreboard), 0, (GInstanceInitFunc) scoreboard_instance_init, NULL };
	GType scoreboard_type_id;
	scoreboard_type_id = g_type_register_static (gtk_box_get_type (), "Scoreboard", &g_define_type_info, 0);
	Scoreboard_private_offset = g_type_add_instance_private (scoreboard_type_id, sizeof (ScoreboardPrivate));
	return scoreboard_type_id;
}

GType
scoreboard_get_type (void)
{
	static volatile gsize scoreboard_type_id__once = 0;
	if (g_once_init_enter (&scoreboard_type_id__once)) {
		GType scoreboard_type_id;
		scoreboard_type_id = scoreboard_get_type_once ();
		g_once_init_leave (&scoreboard_type_id__once, scoreboard_type_id);
	}
	return scoreboard_type_id__once;
}

static inline gpointer
player_score_box_get_instance_private (PlayerScoreBox* self)
{
	return G_STRUCT_MEMBER_P (self, PlayerScoreBox_private_offset);
}

PlayerScoreBox*
player_score_box_construct (GType object_type,
                            const gchar* name,
                            PangoColor* color,
                            gint score,
                            guint8 lives_left,
                            GdkPixbuf* life_pixbuf)
{
	PlayerScoreBox * self = NULL;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkLabel* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 68 "../src/scoreboard.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 68 "../src/scoreboard.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 68 "../src/scoreboard.vala"
	g_return_val_if_fail (life_pixbuf != NULL, NULL);
#line 68 "../src/scoreboard.vala"
	self = (PlayerScoreBox*) g_object_new (object_type, NULL);
#line 70 "../src/scoreboard.vala"
	_tmp0_ = self->priv->name_label;
#line 70 "../src/scoreboard.vala"
	_tmp1_ = pango_color_to_string (color);
#line 70 "../src/scoreboard.vala"
	_tmp2_ = _tmp1_;
#line 70 "../src/scoreboard.vala"
	_tmp3_ = g_strconcat ("<span color=\"", _tmp2_, NULL);
#line 70 "../src/scoreboard.vala"
	_tmp4_ = _tmp3_;
#line 70 "../src/scoreboard.vala"
	_tmp5_ = g_strconcat (_tmp4_, "\">", NULL);
#line 70 "../src/scoreboard.vala"
	_tmp6_ = _tmp5_;
#line 70 "../src/scoreboard.vala"
	_tmp7_ = g_strconcat (_tmp6_, name, NULL);
#line 70 "../src/scoreboard.vala"
	_tmp8_ = _tmp7_;
#line 70 "../src/scoreboard.vala"
	_tmp9_ = g_strconcat (_tmp8_, "</span>", NULL);
#line 70 "../src/scoreboard.vala"
	_tmp10_ = _tmp9_;
#line 70 "../src/scoreboard.vala"
	gtk_label_set_markup (_tmp0_, _tmp10_);
#line 70 "../src/scoreboard.vala"
	_g_free0 (_tmp10_);
#line 70 "../src/scoreboard.vala"
	_g_free0 (_tmp8_);
#line 70 "../src/scoreboard.vala"
	_g_free0 (_tmp6_);
#line 70 "../src/scoreboard.vala"
	_g_free0 (_tmp4_);
#line 70 "../src/scoreboard.vala"
	_g_free0 (_tmp2_);
#line 71 "../src/scoreboard.vala"
	_tmp11_ = self->priv->score_label;
#line 71 "../src/scoreboard.vala"
	_tmp12_ = g_strdup_printf ("%i", score);
#line 71 "../src/scoreboard.vala"
	_tmp13_ = _tmp12_;
#line 71 "../src/scoreboard.vala"
	gtk_label_set_label (_tmp11_, _tmp13_);
#line 71 "../src/scoreboard.vala"
	_g_free0 (_tmp13_);
#line 623 "scoreboard.c"
	{
		guint8 i = 0U;
#line 73 "../src/scoreboard.vala"
		i = (guint8) 0;
#line 628 "scoreboard.c"
		{
			gboolean _tmp14_ = FALSE;
#line 73 "../src/scoreboard.vala"
			_tmp14_ = TRUE;
#line 73 "../src/scoreboard.vala"
			while (TRUE) {
#line 635 "scoreboard.c"
				GtkImage* life = NULL;
				GtkImage* _tmp16_;
				GtkImage* _tmp17_;
				GeeLinkedList* _tmp19_;
				GtkImage* _tmp20_;
				GtkGrid* _tmp21_;
				GtkImage* _tmp22_;
#line 73 "../src/scoreboard.vala"
				if (!_tmp14_) {
#line 645 "scoreboard.c"
					guint8 _tmp15_;
#line 73 "../src/scoreboard.vala"
					_tmp15_ = i;
#line 73 "../src/scoreboard.vala"
					i = _tmp15_ + 1;
#line 651 "scoreboard.c"
				}
#line 73 "../src/scoreboard.vala"
				_tmp14_ = FALSE;
#line 73 "../src/scoreboard.vala"
				if (!(i < WORM_MAX_LIVES)) {
#line 73 "../src/scoreboard.vala"
					break;
#line 659 "scoreboard.c"
				}
#line 75 "../src/scoreboard.vala"
				_tmp16_ = (GtkImage*) gtk_image_new_from_pixbuf (life_pixbuf);
#line 75 "../src/scoreboard.vala"
				g_object_ref_sink (_tmp16_);
#line 75 "../src/scoreboard.vala"
				life = _tmp16_;
#line 76 "../src/scoreboard.vala"
				_tmp17_ = life;
#line 76 "../src/scoreboard.vala"
				gtk_widget_show ((GtkWidget*) _tmp17_);
#line 78 "../src/scoreboard.vala"
				if (i >= WORM_STARTING_LIVES) {
#line 673 "scoreboard.c"
					GtkImage* _tmp18_;
#line 79 "../src/scoreboard.vala"
					_tmp18_ = life;
#line 79 "../src/scoreboard.vala"
					gtk_widget_set_opacity ((GtkWidget*) _tmp18_, (gdouble) 0);
#line 679 "scoreboard.c"
				}
#line 81 "../src/scoreboard.vala"
				_tmp19_ = self->priv->life_images;
#line 81 "../src/scoreboard.vala"
				_tmp20_ = life;
#line 81 "../src/scoreboard.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 82 "../src/scoreboard.vala"
				_tmp21_ = self->priv->lives_grid;
#line 82 "../src/scoreboard.vala"
				_tmp22_ = life;
#line 82 "../src/scoreboard.vala"
				gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, i % 6, i / 6, 1, 1);
#line 73 "../src/scoreboard.vala"
				_g_object_unref0 (life);
#line 695 "scoreboard.c"
			}
		}
	}
#line 68 "../src/scoreboard.vala"
	return self;
#line 701 "scoreboard.c"
}

PlayerScoreBox*
player_score_box_new (const gchar* name,
                      PangoColor* color,
                      gint score,
                      guint8 lives_left,
                      GdkPixbuf* life_pixbuf)
{
#line 68 "../src/scoreboard.vala"
	return player_score_box_construct (TYPE_PLAYER_SCORE_BOX, name, color, score, lives_left, life_pixbuf);
#line 713 "scoreboard.c"
}

void
player_score_box_update (PlayerScoreBox* self,
                         gint score,
                         guint8 lives_left)
{
#line 86 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/scoreboard.vala"
	player_score_box_update_score (self, score);
#line 89 "../src/scoreboard.vala"
	player_score_box_update_lives (self, lives_left);
#line 727 "scoreboard.c"
}

inline void
player_score_box_update_score (PlayerScoreBox* self,
                               gint score)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 92 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/scoreboard.vala"
	_tmp0_ = self->priv->score_label;
#line 94 "../src/scoreboard.vala"
	_tmp1_ = g_strdup_printf ("%i", score);
#line 94 "../src/scoreboard.vala"
	_tmp2_ = _tmp1_;
#line 94 "../src/scoreboard.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 94 "../src/scoreboard.vala"
	_g_free0 (_tmp2_);
#line 749 "scoreboard.c"
}

void
player_score_box_update_lives (PlayerScoreBox* self,
                               guint8 lives_left)
{
#line 97 "../src/scoreboard.vala"
	g_return_if_fail (self != NULL);
#line 758 "scoreboard.c"
	{
		guint8 i = 0U;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 100 "../src/scoreboard.vala"
		_tmp0_ = self->priv->life_images;
#line 100 "../src/scoreboard.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 100 "../src/scoreboard.vala"
		_tmp2_ = _tmp1_;
#line 100 "../src/scoreboard.vala"
		i = (guint8) _tmp2_;
#line 772 "scoreboard.c"
		{
			gboolean _tmp3_ = FALSE;
#line 100 "../src/scoreboard.vala"
			_tmp3_ = TRUE;
#line 100 "../src/scoreboard.vala"
			while (TRUE) {
#line 779 "scoreboard.c"
				GeeLinkedList* _tmp5_;
				gpointer _tmp6_;
				GtkImage* _tmp7_;
#line 100 "../src/scoreboard.vala"
				if (!_tmp3_) {
#line 785 "scoreboard.c"
					guint8 _tmp4_;
#line 100 "../src/scoreboard.vala"
					_tmp4_ = i;
#line 100 "../src/scoreboard.vala"
					i = _tmp4_ - 1;
#line 791 "scoreboard.c"
				}
#line 100 "../src/scoreboard.vala"
				_tmp3_ = FALSE;
#line 100 "../src/scoreboard.vala"
				if (!(i > lives_left)) {
#line 100 "../src/scoreboard.vala"
					break;
#line 799 "scoreboard.c"
				}
#line 101 "../src/scoreboard.vala"
				_tmp5_ = self->priv->life_images;
#line 101 "../src/scoreboard.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, i - 1);
#line 101 "../src/scoreboard.vala"
				_tmp7_ = (GtkImage*) _tmp6_;
#line 101 "../src/scoreboard.vala"
				gtk_widget_set_opacity ((GtkWidget*) _tmp7_, (gdouble) 0);
#line 101 "../src/scoreboard.vala"
				_g_object_unref0 (_tmp7_);
#line 811 "scoreboard.c"
			}
		}
	}
	{
		guint8 i = 0U;
#line 104 "../src/scoreboard.vala"
		i = (guint8) 0;
#line 819 "scoreboard.c"
		{
			gboolean _tmp8_ = FALSE;
#line 104 "../src/scoreboard.vala"
			_tmp8_ = TRUE;
#line 104 "../src/scoreboard.vala"
			while (TRUE) {
#line 826 "scoreboard.c"
				GeeLinkedList* _tmp10_;
				gpointer _tmp11_;
				GtkImage* _tmp12_;
#line 104 "../src/scoreboard.vala"
				if (!_tmp8_) {
#line 832 "scoreboard.c"
					guint8 _tmp9_;
#line 104 "../src/scoreboard.vala"
					_tmp9_ = i;
#line 104 "../src/scoreboard.vala"
					i = _tmp9_ + 1;
#line 838 "scoreboard.c"
				}
#line 104 "../src/scoreboard.vala"
				_tmp8_ = FALSE;
#line 104 "../src/scoreboard.vala"
				if (!(i < lives_left)) {
#line 104 "../src/scoreboard.vala"
					break;
#line 846 "scoreboard.c"
				}
#line 105 "../src/scoreboard.vala"
				_tmp10_ = self->priv->life_images;
#line 105 "../src/scoreboard.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, (gint) i);
#line 105 "../src/scoreboard.vala"
				_tmp12_ = (GtkImage*) _tmp11_;
#line 105 "../src/scoreboard.vala"
				gtk_widget_set_opacity ((GtkWidget*) _tmp12_, (gdouble) 1);
#line 105 "../src/scoreboard.vala"
				_g_object_unref0 (_tmp12_);
#line 858 "scoreboard.c"
			}
		}
	}
}

static void
player_score_box_class_init (PlayerScoreBoxClass * klass,
                             gpointer klass_data)
{
#line 60 "../src/scoreboard.vala"
	player_score_box_parent_class = g_type_class_peek_parent (klass);
#line 60 "../src/scoreboard.vala"
	g_type_class_adjust_private_offset (klass, &PlayerScoreBox_private_offset);
#line 60 "../src/scoreboard.vala"
	G_OBJECT_CLASS (klass)->finalize = player_score_box_finalize;
#line 60 "../src/scoreboard.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/player-score-box.ui");
#line 60 "../src/scoreboard.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, PlayerScoreBox_private_offset + G_STRUCT_OFFSET (PlayerScoreBoxPrivate, name_label));
#line 60 "../src/scoreboard.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "score_label", FALSE, PlayerScoreBox_private_offset + G_STRUCT_OFFSET (PlayerScoreBoxPrivate, score_label));
#line 60 "../src/scoreboard.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "lives_grid", FALSE, PlayerScoreBox_private_offset + G_STRUCT_OFFSET (PlayerScoreBoxPrivate, lives_grid));
#line 882 "scoreboard.c"
}

static void
player_score_box_instance_init (PlayerScoreBox * self,
                                gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 60 "../src/scoreboard.vala"
	self->priv = player_score_box_get_instance_private (self);
#line 66 "../src/scoreboard.vala"
	_tmp0_ = gee_linked_list_new (gtk_image_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 66 "../src/scoreboard.vala"
	self->priv->life_images = _tmp0_;
#line 60 "../src/scoreboard.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 898 "scoreboard.c"
}

static void
player_score_box_finalize (GObject * obj)
{
	PlayerScoreBox * self;
#line 60 "../src/scoreboard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PLAYER_SCORE_BOX, PlayerScoreBox);
#line 66 "../src/scoreboard.vala"
	_g_object_unref0 (self->priv->life_images);
#line 60 "../src/scoreboard.vala"
	G_OBJECT_CLASS (player_score_box_parent_class)->finalize (obj);
#line 911 "scoreboard.c"
}

static GType
player_score_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlayerScoreBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) player_score_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlayerScoreBox), 0, (GInstanceInitFunc) player_score_box_instance_init, NULL };
	GType player_score_box_type_id;
	player_score_box_type_id = g_type_register_static (gtk_box_get_type (), "PlayerScoreBox", &g_define_type_info, 0);
	PlayerScoreBox_private_offset = g_type_add_instance_private (player_score_box_type_id, sizeof (PlayerScoreBoxPrivate));
	return player_score_box_type_id;
}

GType
player_score_box_get_type (void)
{
	static volatile gsize player_score_box_type_id__once = 0;
	if (g_once_init_enter (&player_score_box_type_id__once)) {
		GType player_score_box_type_id;
		player_score_box_type_id = player_score_box_get_type_once ();
		g_once_init_leave (&player_score_box_type_id__once, player_score_box_type_id);
	}
	return player_score_box_type_id__once;
}

