/* warp.c generated by valac 0.56.3, the Vala compiler
 * generated from warp.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 *
 * Rewrite of the original by Sean MacIsaac, Ian Peters, Guillaume Béland
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2020 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#define WARP_MANAGER_MAX_WARPS ((guint8) 200)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
typedef struct _WarpManagerPrivate WarpManagerPrivate;

#define WARP_MANAGER_TYPE_WARP (warp_manager_warp_get_type ())
#define WARP_MANAGER_WARP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARP_MANAGER_TYPE_WARP, WarpManagerWarp))
#define WARP_MANAGER_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARP_MANAGER_TYPE_WARP, WarpManagerWarpClass))
#define WARP_MANAGER_IS_WARP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARP_MANAGER_TYPE_WARP))
#define WARP_MANAGER_IS_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARP_MANAGER_TYPE_WARP))
#define WARP_MANAGER_WARP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARP_MANAGER_TYPE_WARP, WarpManagerWarpClass))

typedef struct _WarpManagerWarp WarpManagerWarp;
typedef struct _WarpManagerWarpClass WarpManagerWarpClass;
enum  {
	WARP_MANAGER_0_PROPERTY,
	WARP_MANAGER_NUM_PROPERTIES
};
static GParamSpec* warp_manager_properties[WARP_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _WarpManagerWarpPrivate WarpManagerWarpPrivate;
enum  {
	WARP_MANAGER_WARP_0_PROPERTY,
	WARP_MANAGER_WARP_ID_PROPERTY,
	WARP_MANAGER_WARP_SOURCE_X_PROPERTY,
	WARP_MANAGER_WARP_SOURCE_Y_PROPERTY,
	WARP_MANAGER_WARP_TARGET_X_PROPERTY,
	WARP_MANAGER_WARP_TARGET_Y_PROPERTY,
	WARP_MANAGER_WARP_BIDI_PROPERTY,
	WARP_MANAGER_WARP_NUM_PROPERTIES
};
static GParamSpec* warp_manager_warp_properties[WARP_MANAGER_WARP_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _WarpManager {
	GObject parent_instance;
	WarpManagerPrivate * priv;
};

struct _WarpManagerClass {
	GObjectClass parent_class;
};

struct _WarpManagerPrivate {
	GeeLinkedList* warps;
};

struct _WarpManagerWarp {
	GObject parent_instance;
	WarpManagerWarpPrivate * priv;
};

struct _WarpManagerWarpClass {
	GObjectClass parent_class;
};

struct _WarpManagerWarpPrivate {
	gboolean init_finished;
	gint _id;
	guint8 _source_x;
	guint8 _source_y;
	guint8 _target_x;
	guint8 _target_y;
	gboolean _bidi;
};

static gint WarpManager_private_offset;
static gpointer warp_manager_parent_class = NULL;
static gint WarpManagerWarp_private_offset;
static gpointer warp_manager_warp_parent_class = NULL;

VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
static GType warp_manager_warp_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManagerWarp, g_object_unref)
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
static gint warp_manager_warp_get_id (WarpManagerWarp* self);
static void warp_manager_warp_set_source (WarpManagerWarp* self,
                                   guint8 x,
                                   guint8 y);
static gboolean warp_manager_warp_get_bidi (WarpManagerWarp* self);
static WarpManagerWarp* warp_manager_warp_new_from_source (gint id,
                                                    guint8 source_x,
                                                    guint8 source_y);
static WarpManagerWarp* warp_manager_warp_construct_from_source (GType object_type,
                                                          gint id,
                                                          guint8 source_x,
                                                          guint8 source_y);
static guint8 warp_manager_warp_get_source_x (WarpManagerWarp* self);
static guint8 warp_manager_warp_get_source_y (WarpManagerWarp* self);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
static void warp_manager_warp_set_target (WarpManagerWarp* self,
                                   guint8 x,
                                   guint8 y);
static WarpManagerWarp* warp_manager_warp_new_from_target (gint id,
                                                    guint8 target_x,
                                                    guint8 target_y);
static WarpManagerWarp* warp_manager_warp_construct_from_target (GType object_type,
                                                          gint id,
                                                          guint8 target_x,
                                                          guint8 target_y);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
static gboolean warp_manager_warp_get_target (WarpManagerWarp* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
static void warp_manager_warp_set_target_x (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_target_y (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_source_x (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_source_y (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_bidi (WarpManagerWarp* self,
                                 gboolean value);
static guint8 warp_manager_warp_get_target_x (WarpManagerWarp* self);
static guint8 warp_manager_warp_get_target_y (WarpManagerWarp* self);
static WarpManagerWarp* warp_manager_warp_new (void);
static WarpManagerWarp* warp_manager_warp_construct (GType object_type);
static void warp_manager_warp_set_id (WarpManagerWarp* self,
                               gint value);
static void warp_manager_warp_finalize (GObject * obj);
static GType warp_manager_warp_get_type_once (void);
static void _vala_warp_manager_warp_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_warp_manager_warp_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void warp_manager_finalize (GObject * obj);
static GType warp_manager_get_type_once (void);

static inline gpointer
warp_manager_get_instance_private (WarpManager* self)
{
	return G_STRUCT_MEMBER_P (self, WarpManager_private_offset);
}

void
warp_manager_add_warp_source (WarpManager* self,
                              gint id,
                              guint8 x,
                              guint8 y)
{
	GeeLinkedList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GeeLinkedList* _tmp28_;
	WarpManagerWarp* _tmp29_;
	WarpManagerWarp* _tmp30_;
#line 126 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 221 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 128 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 128 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 128 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 128 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 128 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 128 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 128 "../src/warp.vala"
		_warp_index = -1;
#line 128 "../src/warp.vala"
		while (TRUE) {
#line 246 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			WarpManagerWarp* _tmp11_;
			WarpManagerWarp* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 128 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 128 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 128 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 128 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 128 "../src/warp.vala"
				break;
#line 269 "warp.c"
			}
#line 128 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 128 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 128 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 130 "../src/warp.vala"
			_tmp8_ = warp;
#line 130 "../src/warp.vala"
			_tmp9_ = warp_manager_warp_get_id (_tmp8_);
#line 130 "../src/warp.vala"
			_tmp10_ = _tmp9_;
#line 130 "../src/warp.vala"
			if (_tmp10_ != id) {
#line 131 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 131 "../src/warp.vala"
				continue;
#line 289 "warp.c"
			}
#line 133 "../src/warp.vala"
			_tmp11_ = warp;
#line 133 "../src/warp.vala"
			warp_manager_warp_set_source (_tmp11_, x, y);
#line 134 "../src/warp.vala"
			_tmp12_ = warp;
#line 134 "../src/warp.vala"
			_tmp13_ = warp_manager_warp_get_bidi (_tmp12_);
#line 134 "../src/warp.vala"
			_tmp14_ = _tmp13_;
#line 134 "../src/warp.vala"
			if (_tmp14_) {
#line 303 "warp.c"
				WarpManagerWarp* bidi_warp = NULL;
				WarpManagerWarp* _tmp15_;
				WarpManagerWarp* _tmp16_;
				WarpManagerWarp* _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				WarpManagerWarp* _tmp20_;
				guint8 _tmp21_;
				guint8 _tmp22_;
				GeeLinkedList* _tmp23_;
				WarpManagerWarp* _tmp24_;
#line 136 "../src/warp.vala"
				_tmp15_ = warp_manager_warp_new_from_source (id, x, y);
#line 136 "../src/warp.vala"
				bidi_warp = _tmp15_;
#line 137 "../src/warp.vala"
				_tmp16_ = bidi_warp;
#line 137 "../src/warp.vala"
				_tmp17_ = warp;
#line 137 "../src/warp.vala"
				_tmp18_ = warp_manager_warp_get_source_x (_tmp17_);
#line 137 "../src/warp.vala"
				_tmp19_ = _tmp18_;
#line 137 "../src/warp.vala"
				_tmp20_ = warp;
#line 137 "../src/warp.vala"
				_tmp21_ = warp_manager_warp_get_source_y (_tmp20_);
#line 137 "../src/warp.vala"
				_tmp22_ = _tmp21_;
#line 137 "../src/warp.vala"
				warp_manager_warp_set_source (_tmp16_, _tmp19_, _tmp22_);
#line 138 "../src/warp.vala"
				_tmp23_ = self->priv->warps;
#line 138 "../src/warp.vala"
				_tmp24_ = bidi_warp;
#line 138 "../src/warp.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 134 "../src/warp.vala"
				_g_object_unref0 (bidi_warp);
#line 343 "warp.c"
			}
#line 140 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 140 "../src/warp.vala"
			return;
#line 349 "warp.c"
		}
	}
#line 143 "../src/warp.vala"
	_tmp25_ = self->priv->warps;
#line 143 "../src/warp.vala"
	_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 143 "../src/warp.vala"
	_tmp27_ = _tmp26_;
#line 143 "../src/warp.vala"
	if (_tmp27_ >= ((gint) WARP_MANAGER_MAX_WARPS)) {
#line 144 "../src/warp.vala"
		return;
#line 362 "warp.c"
	}
#line 146 "../src/warp.vala"
	_tmp28_ = self->priv->warps;
#line 146 "../src/warp.vala"
	_tmp29_ = warp_manager_warp_new_from_source (id, x, y);
#line 146 "../src/warp.vala"
	_tmp30_ = _tmp29_;
#line 146 "../src/warp.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp30_);
#line 146 "../src/warp.vala"
	_g_object_unref0 (_tmp30_);
#line 374 "warp.c"
}

void
warp_manager_add_warp_target (WarpManager* self,
                              gint id,
                              guint8 x,
                              guint8 y)
{
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GeeLinkedList* _tmp15_;
	WarpManagerWarp* _tmp16_;
	WarpManagerWarp* _tmp17_;
#line 149 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 391 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 151 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 151 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 151 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 151 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 151 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 151 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 151 "../src/warp.vala"
		_warp_index = -1;
#line 151 "../src/warp.vala"
		while (TRUE) {
#line 416 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			WarpManagerWarp* _tmp11_;
#line 151 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 151 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 151 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 151 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 151 "../src/warp.vala"
				break;
#line 436 "warp.c"
			}
#line 151 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 151 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 151 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 153 "../src/warp.vala"
			_tmp8_ = warp;
#line 153 "../src/warp.vala"
			_tmp9_ = warp_manager_warp_get_id (_tmp8_);
#line 153 "../src/warp.vala"
			_tmp10_ = _tmp9_;
#line 153 "../src/warp.vala"
			if (_tmp10_ != id) {
#line 154 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 154 "../src/warp.vala"
				continue;
#line 456 "warp.c"
			}
#line 156 "../src/warp.vala"
			_tmp11_ = warp;
#line 156 "../src/warp.vala"
			warp_manager_warp_set_target (_tmp11_, x, y);
#line 157 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 157 "../src/warp.vala"
			return;
#line 466 "warp.c"
		}
	}
#line 160 "../src/warp.vala"
	_tmp12_ = self->priv->warps;
#line 160 "../src/warp.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 160 "../src/warp.vala"
	_tmp14_ = _tmp13_;
#line 160 "../src/warp.vala"
	if (_tmp14_ >= ((gint) WARP_MANAGER_MAX_WARPS)) {
#line 161 "../src/warp.vala"
		return;
#line 479 "warp.c"
	}
#line 163 "../src/warp.vala"
	_tmp15_ = self->priv->warps;
#line 163 "../src/warp.vala"
	_tmp16_ = warp_manager_warp_new_from_target (id, x, y);
#line 163 "../src/warp.vala"
	_tmp17_ = _tmp16_;
#line 163 "../src/warp.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp17_);
#line 163 "../src/warp.vala"
	_g_object_unref0 (_tmp17_);
#line 491 "warp.c"
}

gboolean
warp_manager_get_warp_target (WarpManager* self,
                              guint8 x,
                              guint8 y,
                              gboolean horizontal,
                              guint8* target_x,
                              guint8* target_y)
{
	guint8 _vala_target_x = 0U;
	guint8 _vala_target_y = 0U;
	gboolean result;
#line 166 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../src/warp.vala"
	_vala_target_x = (guint8) 0;
#line 169 "../src/warp.vala"
	_vala_target_y = (guint8) 0;
#line 511 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 171 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 171 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 171 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 171 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 171 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 171 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 171 "../src/warp.vala"
		_warp_index = -1;
#line 171 "../src/warp.vala"
		while (TRUE) {
#line 536 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gboolean _tmp9_;
#line 171 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 171 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 171 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 171 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 171 "../src/warp.vala"
				break;
#line 554 "warp.c"
			}
#line 171 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 171 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 171 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 172 "../src/warp.vala"
			_tmp8_ = warp;
#line 172 "../src/warp.vala"
			_tmp9_ = warp_manager_warp_get_target (_tmp8_, x, y, horizontal, &_vala_target_x, &_vala_target_y);
#line 172 "../src/warp.vala"
			if (_tmp9_) {
#line 173 "../src/warp.vala"
				result = TRUE;
#line 173 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 173 "../src/warp.vala"
				if (target_x) {
#line 173 "../src/warp.vala"
					*target_x = _vala_target_x;
#line 576 "warp.c"
				}
#line 173 "../src/warp.vala"
				if (target_y) {
#line 173 "../src/warp.vala"
					*target_y = _vala_target_y;
#line 582 "warp.c"
				}
#line 173 "../src/warp.vala"
				return result;
#line 586 "warp.c"
			}
#line 171 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 590 "warp.c"
		}
	}
#line 175 "../src/warp.vala"
	result = FALSE;
#line 175 "../src/warp.vala"
	if (target_x) {
#line 175 "../src/warp.vala"
		*target_x = _vala_target_x;
#line 599 "warp.c"
	}
#line 175 "../src/warp.vala"
	if (target_y) {
#line 175 "../src/warp.vala"
		*target_y = _vala_target_y;
#line 605 "warp.c"
	}
#line 175 "../src/warp.vala"
	return result;
#line 609 "warp.c"
}

void
warp_manager_clear_warps (WarpManager* self)
{
	GeeLinkedList* _tmp0_;
#line 178 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/warp.vala"
	_tmp0_ = self->priv->warps;
#line 180 "../src/warp.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 622 "warp.c"
}

WarpManager*
warp_manager_construct (GType object_type)
{
	WarpManager * self = NULL;
#line 22 "../src/warp.vala"
	self = (WarpManager*) g_object_new (object_type, NULL);
#line 22 "../src/warp.vala"
	return self;
#line 633 "warp.c"
}

WarpManager*
warp_manager_new (void)
{
#line 22 "../src/warp.vala"
	return warp_manager_construct (TYPE_WARP_MANAGER);
#line 641 "warp.c"
}

static inline gpointer
warp_manager_warp_get_instance_private (WarpManagerWarp* self)
{
	return G_STRUCT_MEMBER_P (self, WarpManagerWarp_private_offset);
}

static WarpManagerWarp*
warp_manager_warp_construct_from_source (GType object_type,
                                         gint id,
                                         guint8 source_x,
                                         guint8 source_y)
{
	WarpManagerWarp * self = NULL;
#line 40 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, "id", id, "source-x", source_x, "source-y", source_y, "bidi", TRUE, NULL);
#line 38 "../src/warp.vala"
	return self;
#line 661 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new_from_source (gint id,
                                   guint8 source_x,
                                   guint8 source_y)
{
#line 38 "../src/warp.vala"
	return warp_manager_warp_construct_from_source (WARP_MANAGER_TYPE_WARP, id, source_x, source_y);
#line 671 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_construct_from_target (GType object_type,
                                         gint id,
                                         guint8 target_x,
                                         guint8 target_y)
{
	WarpManagerWarp * self = NULL;
#line 48 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, "id", id, "target-x", target_x, "target-y", target_y, "bidi", FALSE, NULL);
#line 46 "../src/warp.vala"
	return self;
#line 685 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new_from_target (gint id,
                                   guint8 target_x,
                                   guint8 target_y)
{
#line 46 "../src/warp.vala"
	return warp_manager_warp_construct_from_target (WARP_MANAGER_TYPE_WARP, id, target_x, target_y);
#line 695 "warp.c"
}

static void
warp_manager_warp_set_source (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y)
{
	gboolean _tmp0_;
#line 54 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/warp.vala"
	_vala_return_if_fail (self->priv->init_finished == FALSE, "init_finished == false");
#line 57 "../src/warp.vala"
	_tmp0_ = self->priv->_bidi;
#line 57 "../src/warp.vala"
	if (_tmp0_) {
#line 59 "../src/warp.vala"
		warp_manager_warp_set_target_x (self, x);
#line 60 "../src/warp.vala"
		warp_manager_warp_set_target_y (self, y);
#line 716 "warp.c"
	} else {
#line 64 "../src/warp.vala"
		warp_manager_warp_set_source_x (self, x);
#line 65 "../src/warp.vala"
		warp_manager_warp_set_source_y (self, y);
#line 722 "warp.c"
	}
#line 67 "../src/warp.vala"
	self->priv->init_finished = TRUE;
#line 726 "warp.c"
}

static void
warp_manager_warp_set_target (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y)
{
	gboolean _tmp0_;
#line 70 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/warp.vala"
	_vala_return_if_fail (self->priv->init_finished == FALSE, "init_finished == false");
#line 70 "../src/warp.vala"
	_tmp0_ = self->priv->_bidi;
#line 70 "../src/warp.vala"
	_vala_return_if_fail (_tmp0_ == TRUE, "bidi == true");
#line 74 "../src/warp.vala"
	warp_manager_warp_set_target_x (self, x);
#line 75 "../src/warp.vala"
	warp_manager_warp_set_target_y (self, y);
#line 76 "../src/warp.vala"
	warp_manager_warp_set_bidi (self, FALSE);
#line 77 "../src/warp.vala"
	self->priv->init_finished = TRUE;
#line 751 "warp.c"
}

static gboolean
warp_manager_warp_get_target (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y,
                              gboolean horizontal,
                              guint8* target_x,
                              guint8* target_y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint8 _tmp2_;
	gboolean _tmp7_;
	gboolean result;
#line 80 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/warp.vala"
	_vala_return_val_if_fail (self->priv->init_finished == TRUE, "init_finished == true", FALSE);
#line 83 "../src/warp.vala"
	_tmp2_ = self->priv->_source_x;
#line 83 "../src/warp.vala"
	if (x != _tmp2_) {
#line 775 "warp.c"
		guint8 _tmp3_;
#line 83 "../src/warp.vala"
		_tmp3_ = self->priv->_source_x;
#line 83 "../src/warp.vala"
		_tmp1_ = ((gint) x) != (_tmp3_ + 1);
#line 781 "warp.c"
	} else {
#line 83 "../src/warp.vala"
		_tmp1_ = FALSE;
#line 785 "warp.c"
	}
#line 83 "../src/warp.vala"
	if (_tmp1_) {
#line 83 "../src/warp.vala"
		_tmp0_ = TRUE;
#line 791 "warp.c"
	} else {
		gboolean _tmp4_ = FALSE;
		guint8 _tmp5_;
#line 84 "../src/warp.vala"
		_tmp5_ = self->priv->_source_y;
#line 84 "../src/warp.vala"
		if (y != _tmp5_) {
#line 799 "warp.c"
			guint8 _tmp6_;
#line 84 "../src/warp.vala"
			_tmp6_ = self->priv->_source_y;
#line 84 "../src/warp.vala"
			_tmp4_ = ((gint) y) != (_tmp6_ + 1);
#line 805 "warp.c"
		} else {
#line 84 "../src/warp.vala"
			_tmp4_ = FALSE;
#line 809 "warp.c"
		}
#line 84 "../src/warp.vala"
		_tmp0_ = _tmp4_;
#line 813 "warp.c"
	}
#line 83 "../src/warp.vala"
	if (_tmp0_) {
#line 85 "../src/warp.vala"
		result = FALSE;
#line 85 "../src/warp.vala"
		return result;
#line 821 "warp.c"
	}
#line 87 "../src/warp.vala"
	_tmp7_ = self->priv->_bidi;
#line 87 "../src/warp.vala"
	if (!_tmp7_) {
#line 827 "warp.c"
		guint8 _tmp8_;
		guint8 _tmp9_;
#line 89 "../src/warp.vala"
		_tmp8_ = self->priv->_target_x;
#line 89 "../src/warp.vala"
		*target_x = _tmp8_;
#line 90 "../src/warp.vala"
		_tmp9_ = self->priv->_target_y;
#line 90 "../src/warp.vala"
		*target_y = _tmp9_;
#line 838 "warp.c"
	} else {
#line 92 "../src/warp.vala"
		if (horizontal) {
#line 842 "warp.c"
			guint8 _tmp10_;
			guint8 _tmp14_;
#line 94 "../src/warp.vala"
			_tmp10_ = self->priv->_source_x;
#line 94 "../src/warp.vala"
			if (x == _tmp10_) {
#line 849 "warp.c"
				guint8 _tmp11_;
#line 95 "../src/warp.vala"
				_tmp11_ = self->priv->_target_x;
#line 95 "../src/warp.vala"
				*target_x = (guint8) (_tmp11_ + 2);
#line 855 "warp.c"
			} else {
				guint8 _tmp12_;
#line 96 "../src/warp.vala"
				_tmp12_ = self->priv->_target_x;
#line 96 "../src/warp.vala"
				if (((gint) _tmp12_) == 0) {
#line 97 "../src/warp.vala"
					g_assert_not_reached ();
#line 864 "warp.c"
				} else {
					guint8 _tmp13_;
#line 99 "../src/warp.vala"
					_tmp13_ = self->priv->_target_x;
#line 99 "../src/warp.vala"
					*target_x = (guint8) (_tmp13_ - 1);
#line 871 "warp.c"
				}
			}
#line 100 "../src/warp.vala"
			_tmp14_ = self->priv->_source_y;
#line 100 "../src/warp.vala"
			if (y == _tmp14_) {
#line 878 "warp.c"
				guint8 _tmp15_;
#line 101 "../src/warp.vala"
				_tmp15_ = self->priv->_target_y;
#line 101 "../src/warp.vala"
				*target_y = _tmp15_;
#line 884 "warp.c"
			} else {
				guint8 _tmp16_;
#line 103 "../src/warp.vala"
				_tmp16_ = self->priv->_target_y;
#line 103 "../src/warp.vala"
				*target_y = (guint8) (_tmp16_ + 1);
#line 891 "warp.c"
			}
		} else {
			guint8 _tmp17_;
			guint8 _tmp20_;
#line 107 "../src/warp.vala"
			_tmp17_ = self->priv->_source_x;
#line 107 "../src/warp.vala"
			if (x == _tmp17_) {
#line 900 "warp.c"
				guint8 _tmp18_;
#line 108 "../src/warp.vala"
				_tmp18_ = self->priv->_target_x;
#line 108 "../src/warp.vala"
				*target_x = _tmp18_;
#line 906 "warp.c"
			} else {
				guint8 _tmp19_;
#line 110 "../src/warp.vala"
				_tmp19_ = self->priv->_target_x;
#line 110 "../src/warp.vala"
				*target_x = (guint8) (_tmp19_ + 1);
#line 913 "warp.c"
			}
#line 111 "../src/warp.vala"
			_tmp20_ = self->priv->_source_y;
#line 111 "../src/warp.vala"
			if (y == _tmp20_) {
#line 919 "warp.c"
				guint8 _tmp21_;
#line 112 "../src/warp.vala"
				_tmp21_ = self->priv->_target_y;
#line 112 "../src/warp.vala"
				*target_y = (guint8) (_tmp21_ + 2);
#line 925 "warp.c"
			} else {
				guint8 _tmp22_;
#line 113 "../src/warp.vala"
				_tmp22_ = self->priv->_target_y;
#line 113 "../src/warp.vala"
				if (((gint) _tmp22_) == 0) {
#line 114 "../src/warp.vala"
					g_assert_not_reached ();
#line 934 "warp.c"
				} else {
					guint8 _tmp23_;
#line 116 "../src/warp.vala"
					_tmp23_ = self->priv->_target_y;
#line 116 "../src/warp.vala"
					*target_y = (guint8) (_tmp23_ - 1);
#line 941 "warp.c"
				}
			}
		}
	}
#line 118 "../src/warp.vala"
	result = TRUE;
#line 118 "../src/warp.vala"
	return result;
#line 950 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_construct (GType object_type)
{
	WarpManagerWarp * self = NULL;
#line 24 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, NULL);
#line 24 "../src/warp.vala"
	return self;
#line 961 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new (void)
{
#line 24 "../src/warp.vala"
	return warp_manager_warp_construct (WARP_MANAGER_TYPE_WARP);
#line 969 "warp.c"
}

static gint
warp_manager_warp_get_id (WarpManagerWarp* self)
{
	gint result;
#line 28 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/warp.vala"
	result = self->priv->_id;
#line 28 "../src/warp.vala"
	return result;
#line 982 "warp.c"
}

static void
warp_manager_warp_set_id (WarpManagerWarp* self,
                          gint value)
{
	gint old_value;
#line 28 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/warp.vala"
	old_value = warp_manager_warp_get_id (self);
#line 28 "../src/warp.vala"
	if (old_value != value) {
#line 28 "../src/warp.vala"
		self->priv->_id = value;
#line 28 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_ID_PROPERTY]);
#line 1000 "warp.c"
	}
}

static guint8
warp_manager_warp_get_source_x (WarpManagerWarp* self)
{
	guint8 result;
#line 30 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 30 "../src/warp.vala"
	result = self->priv->_source_x;
#line 30 "../src/warp.vala"
	return result;
#line 1014 "warp.c"
}

static void
warp_manager_warp_set_source_x (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 30 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/warp.vala"
	old_value = warp_manager_warp_get_source_x (self);
#line 30 "../src/warp.vala"
	if (old_value != value) {
#line 30 "../src/warp.vala"
		self->priv->_source_x = value;
#line 30 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_X_PROPERTY]);
#line 1032 "warp.c"
	}
}

static guint8
warp_manager_warp_get_source_y (WarpManagerWarp* self)
{
	guint8 result;
#line 31 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 31 "../src/warp.vala"
	result = self->priv->_source_y;
#line 31 "../src/warp.vala"
	return result;
#line 1046 "warp.c"
}

static void
warp_manager_warp_set_source_y (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 31 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/warp.vala"
	old_value = warp_manager_warp_get_source_y (self);
#line 31 "../src/warp.vala"
	if (old_value != value) {
#line 31 "../src/warp.vala"
		self->priv->_source_y = value;
#line 31 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_Y_PROPERTY]);
#line 1064 "warp.c"
	}
}

static guint8
warp_manager_warp_get_target_x (WarpManagerWarp* self)
{
	guint8 result;
#line 33 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../src/warp.vala"
	result = self->priv->_target_x;
#line 33 "../src/warp.vala"
	return result;
#line 1078 "warp.c"
}

static void
warp_manager_warp_set_target_x (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 33 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/warp.vala"
	old_value = warp_manager_warp_get_target_x (self);
#line 33 "../src/warp.vala"
	if (old_value != value) {
#line 33 "../src/warp.vala"
		self->priv->_target_x = value;
#line 33 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_X_PROPERTY]);
#line 1096 "warp.c"
	}
}

static guint8
warp_manager_warp_get_target_y (WarpManagerWarp* self)
{
	guint8 result;
#line 34 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 34 "../src/warp.vala"
	result = self->priv->_target_y;
#line 34 "../src/warp.vala"
	return result;
#line 1110 "warp.c"
}

static void
warp_manager_warp_set_target_y (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 34 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/warp.vala"
	old_value = warp_manager_warp_get_target_y (self);
#line 34 "../src/warp.vala"
	if (old_value != value) {
#line 34 "../src/warp.vala"
		self->priv->_target_y = value;
#line 34 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_Y_PROPERTY]);
#line 1128 "warp.c"
	}
}

static gboolean
warp_manager_warp_get_bidi (WarpManagerWarp* self)
{
	gboolean result;
#line 36 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/warp.vala"
	result = self->priv->_bidi;
#line 36 "../src/warp.vala"
	return result;
#line 1142 "warp.c"
}

static void
warp_manager_warp_set_bidi (WarpManagerWarp* self,
                            gboolean value)
{
	gboolean old_value;
#line 36 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/warp.vala"
	old_value = warp_manager_warp_get_bidi (self);
#line 36 "../src/warp.vala"
	if (old_value != value) {
#line 36 "../src/warp.vala"
		self->priv->_bidi = value;
#line 36 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_BIDI_PROPERTY]);
#line 1160 "warp.c"
	}
}

static void
warp_manager_warp_class_init (WarpManagerWarpClass * klass,
                              gpointer klass_data)
{
#line 24 "../src/warp.vala"
	warp_manager_warp_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/warp.vala"
	g_type_class_adjust_private_offset (klass, &WarpManagerWarp_private_offset);
#line 24 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warp_manager_warp_get_property;
#line 24 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warp_manager_warp_set_property;
#line 24 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_manager_warp_finalize;
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_ID_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_SOURCE_X_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_X_PROPERTY] = g_param_spec_uchar ("source-x", "source-x", "source-x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_SOURCE_Y_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_Y_PROPERTY] = g_param_spec_uchar ("source-y", "source-y", "source-y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_TARGET_X_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_X_PROPERTY] = g_param_spec_uchar ("target-x", "target-x", "target-x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_TARGET_Y_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_Y_PROPERTY] = g_param_spec_uchar ("target-y", "target-y", "target-y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_BIDI_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_BIDI_PROPERTY] = g_param_spec_boolean ("bidi", "bidi", "bidi", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1190 "warp.c"
}

static void
warp_manager_warp_instance_init (WarpManagerWarp * self,
                                 gpointer klass)
{
#line 24 "../src/warp.vala"
	self->priv = warp_manager_warp_get_instance_private (self);
#line 26 "../src/warp.vala"
	self->priv->init_finished = FALSE;
#line 1201 "warp.c"
}

static void
warp_manager_warp_finalize (GObject * obj)
{
	WarpManagerWarp * self;
#line 24 "../src/warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 24 "../src/warp.vala"
	G_OBJECT_CLASS (warp_manager_warp_parent_class)->finalize (obj);
#line 1212 "warp.c"
}

static GType
warp_manager_warp_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarpManagerWarpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_manager_warp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarpManagerWarp), 0, (GInstanceInitFunc) warp_manager_warp_instance_init, NULL };
	GType warp_manager_warp_type_id;
	warp_manager_warp_type_id = g_type_register_static (G_TYPE_OBJECT, "WarpManagerWarp", &g_define_type_info, 0);
	WarpManagerWarp_private_offset = g_type_add_instance_private (warp_manager_warp_type_id, sizeof (WarpManagerWarpPrivate));
	return warp_manager_warp_type_id;
}

static GType
warp_manager_warp_get_type (void)
{
	static volatile gsize warp_manager_warp_type_id__once = 0;
	if (g_once_init_enter (&warp_manager_warp_type_id__once)) {
		GType warp_manager_warp_type_id;
		warp_manager_warp_type_id = warp_manager_warp_get_type_once ();
		g_once_init_leave (&warp_manager_warp_type_id__once, warp_manager_warp_type_id);
	}
	return warp_manager_warp_type_id__once;
}

static void
_vala_warp_manager_warp_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WarpManagerWarp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 24 "../src/warp.vala"
	switch (property_id) {
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_ID_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_int (value, warp_manager_warp_get_id (self));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_X_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_source_x (self));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_Y_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_source_y (self));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_X_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_target_x (self));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_Y_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_target_y (self));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_BIDI_PROPERTY:
#line 24 "../src/warp.vala"
		g_value_set_boolean (value, warp_manager_warp_get_bidi (self));
#line 24 "../src/warp.vala"
		break;
#line 1283 "warp.c"
		default:
#line 24 "../src/warp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/warp.vala"
		break;
#line 1289 "warp.c"
	}
}

static void
_vala_warp_manager_warp_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WarpManagerWarp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 24 "../src/warp.vala"
	switch (property_id) {
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_ID_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_id (self, g_value_get_int (value));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_X_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_source_x (self, g_value_get_uchar (value));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_Y_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_source_y (self, g_value_get_uchar (value));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_X_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_target_x (self, g_value_get_uchar (value));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_Y_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_target_y (self, g_value_get_uchar (value));
#line 24 "../src/warp.vala"
		break;
#line 24 "../src/warp.vala"
		case WARP_MANAGER_WARP_BIDI_PROPERTY:
#line 24 "../src/warp.vala"
		warp_manager_warp_set_bidi (self, g_value_get_boolean (value));
#line 24 "../src/warp.vala"
		break;
#line 1339 "warp.c"
		default:
#line 24 "../src/warp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/warp.vala"
		break;
#line 1345 "warp.c"
	}
}

static void
warp_manager_class_init (WarpManagerClass * klass,
                         gpointer klass_data)
{
#line 22 "../src/warp.vala"
	warp_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/warp.vala"
	g_type_class_adjust_private_offset (klass, &WarpManager_private_offset);
#line 22 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_manager_finalize;
#line 1359 "warp.c"
}

static void
warp_manager_instance_init (WarpManager * self,
                            gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 22 "../src/warp.vala"
	self->priv = warp_manager_get_instance_private (self);
#line 124 "../src/warp.vala"
	_tmp0_ = gee_linked_list_new (WARP_MANAGER_TYPE_WARP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 124 "../src/warp.vala"
	self->priv->warps = _tmp0_;
#line 1373 "warp.c"
}

static void
warp_manager_finalize (GObject * obj)
{
	WarpManager * self;
#line 22 "../src/warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WARP_MANAGER, WarpManager);
#line 124 "../src/warp.vala"
	_g_object_unref0 (self->priv->warps);
#line 22 "../src/warp.vala"
	G_OBJECT_CLASS (warp_manager_parent_class)->finalize (obj);
#line 1386 "warp.c"
}

static GType
warp_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarpManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarpManager), 0, (GInstanceInitFunc) warp_manager_instance_init, NULL };
	GType warp_manager_type_id;
	warp_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "WarpManager", &g_define_type_info, 0);
	WarpManager_private_offset = g_type_add_instance_private (warp_manager_type_id, sizeof (WarpManagerPrivate));
	return warp_manager_type_id;
}

GType
warp_manager_get_type (void)
{
	static volatile gsize warp_manager_type_id__once = 0;
	if (g_once_init_enter (&warp_manager_type_id__once)) {
		GType warp_manager_type_id;
		warp_manager_type_id = warp_manager_get_type_once ();
		g_once_init_leave (&warp_manager_type_id__once, warp_manager_type_id);
	}
	return warp_manager_type_id__once;
}

