/* worm.c generated by valac 0.56.3, the Vala compiler
 * generated from worm.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <gee.h>

#define WORM_STARTING_LIVES ((guint8) 6)
#define WORM_STARTING_LENGTH 5
#define WORM_MAX_LIVES ((guint8) 12)
#define WORM_GROW_FACTOR 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WORMCHAR 'w'
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;
typedef struct _WormPropertiesPrivate WormPropertiesPrivate;
enum  {
	WORM_PROPERTIES_0_PROPERTY,
	WORM_PROPERTIES_COLOR_PROPERTY,
	WORM_PROPERTIES_UP_PROPERTY,
	WORM_PROPERTIES_DOWN_PROPERTY,
	WORM_PROPERTIES_LEFT_PROPERTY,
	WORM_PROPERTIES_RIGHT_PROPERTY,
	WORM_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* worm_properties_properties[WORM_PROPERTIES_NUM_PROPERTIES];

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;
typedef struct _WormPrivate WormPrivate;
enum  {
	WORM_0_PROPERTY,
	WORM_STARTING_POSITION_PROPERTY,
	WORM_ID_PROPERTY,
	WORM_IS_MATERIALIZED_PROPERTY,
	WORM_LIVES_PROPERTY,
	WORM_CHANGE_PROPERTY,
	WORM_SCORE_PROPERTY,
	WORM_LENGTH_PROPERTY,
	WORM_HEAD_PROPERTY,
	WORM_DIRECTION_PROPERTY,
	WORM_LIST_PROPERTY,
	WORM_WIDTH_PROPERTY,
	WORM_HEIGHT_PROPERTY,
	WORM_CAPACITY_PROPERTY,
	WORM_NUM_PROPERTIES
};
static GParamSpec* worm_properties[WORM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _position_free0(var) ((var == NULL) ? NULL : (var = (position_free (var), NULL)))
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
enum  {
	WORM_ADDED_SIGNAL,
	WORM_FINISH_ADDED_SIGNAL,
	WORM_MOVED_SIGNAL,
	WORM_RESCALED_SIGNAL,
	WORM_DIED_SIGNAL,
	WORM_TAIL_REDUCED_SIGNAL,
	WORM_REVERSED_SIGNAL,
	WORM_BONUS_FOUND_SIGNAL,
	WORM_NUM_SIGNALS
};
static guint worm_signals[WORM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Position {
	guint8 x;
	guint8 y;
};

struct _WormProperties {
	GObject parent_instance;
	WormPropertiesPrivate * priv;
};

struct _WormPropertiesClass {
	GObjectClass parent_class;
};

struct _WormPropertiesPrivate {
	gint _color;
	guint _up;
	guint _down;
	guint _left;
	guint _right;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gboolean is_stopped;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _WormPrivate {
	Position _starting_position;
	gint _id;
	gboolean _is_materialized;
	gint rounds_dematerialized;
	guint8 _lives;
	gint _change;
	gint _score;
	WormDirection _direction;
	WormDirection starting_direction;
	GeeArrayQueue* key_queue;
	GeeLinkedList* _list;
	guint8 _width;
	guint8 _height;
	gint _capacity;
};

static gint WormProperties_private_offset;
static gpointer worm_properties_parent_class = NULL;
static gint Worm_private_offset;
static gpointer worm_parent_class = NULL;
static guint* worm_deadend_board;
static gint worm_deadend_board_length1;
static gint worm_deadend_board_length2;
static guint* worm_deadend_board = NULL;
static gint worm_deadend_board_length1 = 0;
static gint worm_deadend_board_length2 = 0;
static guint worm_deadend_runnumber;
static guint worm_deadend_runnumber = (guint) 0;

VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN WormDirection worm_direction_opposite (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_left (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_right (WormDirection self);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void position_move (Position *self,
                    WormDirection direction,
                    guint8 width,
                    guint8 height);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN void worm_properties_set_color (WormProperties* self,
                                gint value);
VALA_EXTERN guint worm_properties_get_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_up (WormProperties* self,
                             guint value);
VALA_EXTERN guint worm_properties_get_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_down (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_left (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_right (WormProperties* self,
                                guint value);
static void worm_properties_finalize (GObject * obj);
static GType worm_properties_get_type_once (void);
static void _vala_worm_properties_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_worm_properties_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height);
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN GeeLinkedList* worm_get_list (Worm* self);
static void worm_set_starting_position (Worm* self,
                                 Position * value);
VALA_EXTERN void worm_get_starting_position (Worm* self,
                                 Position * result);
static void worm_set_direction (Worm* self,
                         WormDirection value);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
static guint8 worm_get_width (Worm* self);
static guint8 worm_get_height (Worm* self);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
static void worm_set_head (Worm* self,
                    Position * value);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN gboolean worm_get_is_materialized (Worm* self);
VALA_EXTERN gint worm_get_id (Worm* self);
static void worm_dequeue_keypress (Worm* self);
static void worm_materialize (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       gint erase_size);
VALA_EXTERN void worm_reverse (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2);
static void worm_set_list (Worm* self,
                    GeeLinkedList* value);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           gint numworms,
                           Position* position);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void worm_set_is_materialized (Worm* self,
                               gboolean value);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint rounds,
                         gint gamedelay);
static gboolean __lambda4_ (Worm* self);
static gboolean ___lambda4__gsource_func (gpointer self);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_set_lives (Worm* self,
                     guint8 value);
static inline void worm_lose_life (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
static void worm_direction_set (Worm* self,
                         WormDirection dir);
static void worm_queue_keypress (Worm* self,
                          WormDirection dir);
static guint worm_upper_key (Worm* self,
                      guint keyval);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keyval,
                               GeeHashMap* worm_props);
static gint worm_ai_deadend (gint* board,
                      gint board_length1,
                      gint board_length2,
                      gint numworms,
                      Position* old_position,
                      gint length_left);
static gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            gint numworms,
                            Position* old_position,
                            WormDirection direction,
                            gint length);
static inline gboolean worm_ai_too_close (Worm* self,
                            GeeLinkedList* worms);
static gboolean worm_ai_wander (gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint numworms,
                         Position* updated_position,
                         WormDirection direction,
                         Position* initial_position);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   gint numworms,
                   GeeLinkedList* worms);
static gint worm_get_capacity (Worm* self);
VALA_EXTERN gint worm_get_length (Worm* self);
static gboolean _position_equal (const Position * s1,
                          const Position * s2);
static void worm_set_id (Worm* self,
                  gint value);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
static void worm_set_width (Worm* self,
                     guint8 value);
static void worm_set_height (Worm* self,
                      guint8 value);
static void worm_set_capacity (Worm* self,
                        gint value);
static GObject * worm_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void worm_finalize (GObject * obj);
static GType worm_get_type_once (void);
static void _vala_worm_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_worm_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

WormDirection
worm_direction_opposite (WormDirection self)
{
	WormDirection result;
#line 32 "../src/worm.vala"
	switch (self) {
#line 32 "../src/worm.vala"
		case WORM_DIRECTION_RIGHT:
#line 402 "worm.c"
		{
#line 34 "../src/worm.vala"
			result = WORM_DIRECTION_LEFT;
#line 34 "../src/worm.vala"
			return result;
#line 408 "worm.c"
		}
#line 32 "../src/worm.vala"
		case WORM_DIRECTION_LEFT:
#line 412 "worm.c"
		{
#line 35 "../src/worm.vala"
			result = WORM_DIRECTION_RIGHT;
#line 35 "../src/worm.vala"
			return result;
#line 418 "worm.c"
		}
#line 32 "../src/worm.vala"
		case WORM_DIRECTION_DOWN:
#line 422 "worm.c"
		{
#line 36 "../src/worm.vala"
			result = WORM_DIRECTION_UP;
#line 36 "../src/worm.vala"
			return result;
#line 428 "worm.c"
		}
#line 32 "../src/worm.vala"
		case WORM_DIRECTION_UP:
#line 432 "worm.c"
		{
#line 37 "../src/worm.vala"
			result = WORM_DIRECTION_DOWN;
#line 37 "../src/worm.vala"
			return result;
#line 438 "worm.c"
		}
		default:
		{
#line 38 "../src/worm.vala"
			g_assert_not_reached ();
#line 444 "worm.c"
		}
	}
}

WormDirection
worm_direction_turn_left (WormDirection self)
{
	WormDirection result;
#line 44 "../src/worm.vala"
	switch (self) {
#line 44 "../src/worm.vala"
		case WORM_DIRECTION_RIGHT:
#line 457 "worm.c"
		{
#line 46 "../src/worm.vala"
			result = WORM_DIRECTION_UP;
#line 46 "../src/worm.vala"
			return result;
#line 463 "worm.c"
		}
#line 44 "../src/worm.vala"
		case WORM_DIRECTION_UP:
#line 467 "worm.c"
		{
#line 47 "../src/worm.vala"
			result = WORM_DIRECTION_LEFT;
#line 47 "../src/worm.vala"
			return result;
#line 473 "worm.c"
		}
#line 44 "../src/worm.vala"
		case WORM_DIRECTION_LEFT:
#line 477 "worm.c"
		{
#line 48 "../src/worm.vala"
			result = WORM_DIRECTION_DOWN;
#line 48 "../src/worm.vala"
			return result;
#line 483 "worm.c"
		}
#line 44 "../src/worm.vala"
		case WORM_DIRECTION_DOWN:
#line 487 "worm.c"
		{
#line 49 "../src/worm.vala"
			result = WORM_DIRECTION_RIGHT;
#line 49 "../src/worm.vala"
			return result;
#line 493 "worm.c"
		}
		default:
		{
#line 50 "../src/worm.vala"
			g_assert_not_reached ();
#line 499 "worm.c"
		}
	}
}

WormDirection
worm_direction_turn_right (WormDirection self)
{
	WormDirection result;
#line 56 "../src/worm.vala"
	switch (self) {
#line 56 "../src/worm.vala"
		case WORM_DIRECTION_RIGHT:
#line 512 "worm.c"
		{
#line 58 "../src/worm.vala"
			result = WORM_DIRECTION_DOWN;
#line 58 "../src/worm.vala"
			return result;
#line 518 "worm.c"
		}
#line 56 "../src/worm.vala"
		case WORM_DIRECTION_DOWN:
#line 522 "worm.c"
		{
#line 59 "../src/worm.vala"
			result = WORM_DIRECTION_LEFT;
#line 59 "../src/worm.vala"
			return result;
#line 528 "worm.c"
		}
#line 56 "../src/worm.vala"
		case WORM_DIRECTION_LEFT:
#line 532 "worm.c"
		{
#line 60 "../src/worm.vala"
			result = WORM_DIRECTION_UP;
#line 60 "../src/worm.vala"
			return result;
#line 538 "worm.c"
		}
#line 56 "../src/worm.vala"
		case WORM_DIRECTION_UP:
#line 542 "worm.c"
		{
#line 61 "../src/worm.vala"
			result = WORM_DIRECTION_RIGHT;
#line 61 "../src/worm.vala"
			return result;
#line 548 "worm.c"
		}
		default:
		{
#line 62 "../src/worm.vala"
			g_assert_not_reached ();
#line 554 "worm.c"
		}
	}
}

static GType
worm_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{WORM_DIRECTION_NONE, "WORM_DIRECTION_NONE", "none"}, {WORM_DIRECTION_RIGHT, "WORM_DIRECTION_RIGHT", "right"}, {WORM_DIRECTION_DOWN, "WORM_DIRECTION_DOWN", "down"}, {WORM_DIRECTION_LEFT, "WORM_DIRECTION_LEFT", "left"}, {WORM_DIRECTION_UP, "WORM_DIRECTION_UP", "up"}, {0, NULL, NULL}};
	GType worm_direction_type_id;
	worm_direction_type_id = g_enum_register_static ("WormDirection", values);
	return worm_direction_type_id;
}

GType
worm_direction_get_type (void)
{
	static volatile gsize worm_direction_type_id__once = 0;
	if (g_once_init_enter (&worm_direction_type_id__once)) {
		GType worm_direction_type_id;
		worm_direction_type_id = worm_direction_get_type_once ();
		g_once_init_leave (&worm_direction_type_id__once, worm_direction_type_id);
	}
	return worm_direction_type_id__once;
}

void
position_move (Position *self,
               WormDirection direction,
               guint8 width,
               guint8 height)
{
#line 74 "../src/worm.vala"
	switch (direction) {
#line 74 "../src/worm.vala"
		case WORM_DIRECTION_UP:
#line 590 "worm.c"
		{
#line 77 "../src/worm.vala"
			if (((gint) (*self).y) == 0) {
#line 78 "../src/worm.vala"
				(*self).y = (guint8) (height - 1);
#line 596 "worm.c"
			} else {
				guint8 _tmp0_;
#line 80 "../src/worm.vala"
				_tmp0_ = (*self).y;
#line 80 "../src/worm.vala"
				(*self).y = _tmp0_ - 1;
#line 603 "worm.c"
			}
#line 81 "../src/worm.vala"
			break;
#line 607 "worm.c"
		}
#line 74 "../src/worm.vala"
		case WORM_DIRECTION_DOWN:
#line 611 "worm.c"
		{
#line 84 "../src/worm.vala"
			if (((gint) (*self).y) >= (height - 1)) {
#line 85 "../src/worm.vala"
				(*self).y = (guint8) 0;
#line 617 "worm.c"
			} else {
				guint8 _tmp1_;
#line 87 "../src/worm.vala"
				_tmp1_ = (*self).y;
#line 87 "../src/worm.vala"
				(*self).y = _tmp1_ + 1;
#line 624 "worm.c"
			}
#line 88 "../src/worm.vala"
			break;
#line 628 "worm.c"
		}
#line 74 "../src/worm.vala"
		case WORM_DIRECTION_LEFT:
#line 632 "worm.c"
		{
#line 91 "../src/worm.vala"
			if (((gint) (*self).x) == 0) {
#line 92 "../src/worm.vala"
				(*self).x = (guint8) (width - 1);
#line 638 "worm.c"
			} else {
				guint8 _tmp2_;
#line 94 "../src/worm.vala"
				_tmp2_ = (*self).x;
#line 94 "../src/worm.vala"
				(*self).x = _tmp2_ - 1;
#line 645 "worm.c"
			}
#line 95 "../src/worm.vala"
			break;
#line 649 "worm.c"
		}
#line 74 "../src/worm.vala"
		case WORM_DIRECTION_RIGHT:
#line 653 "worm.c"
		{
#line 98 "../src/worm.vala"
			if (((gint) (*self).x) >= (width - 1)) {
#line 99 "../src/worm.vala"
				(*self).x = (guint8) 0;
#line 659 "worm.c"
			} else {
				guint8 _tmp3_;
#line 101 "../src/worm.vala"
				_tmp3_ = (*self).x;
#line 101 "../src/worm.vala"
				(*self).x = _tmp3_ + 1;
#line 666 "worm.c"
			}
#line 102 "../src/worm.vala"
			break;
#line 670 "worm.c"
		}
		default:
		{
#line 105 "../src/worm.vala"
			g_assert_not_reached ();
#line 676 "worm.c"
		}
	}
}

Position*
position_dup (const Position* self)
{
	Position* dup;
#line 67 "../src/worm.vala"
	dup = g_new0 (Position, 1);
#line 67 "../src/worm.vala"
	memcpy (dup, self, sizeof (Position));
#line 67 "../src/worm.vala"
	return dup;
#line 691 "worm.c"
}

void
position_free (Position* self)
{
#line 67 "../src/worm.vala"
	g_free (self);
#line 699 "worm.c"
}

static GType
position_get_type_once (void)
{
	GType position_type_id;
	position_type_id = g_boxed_type_register_static ("Position", (GBoxedCopyFunc) position_dup, (GBoxedFreeFunc) position_free);
	return position_type_id;
}

GType
position_get_type (void)
{
	static volatile gsize position_type_id__once = 0;
	if (g_once_init_enter (&position_type_id__once)) {
		GType position_type_id;
		position_type_id = position_get_type_once ();
		g_once_init_leave (&position_type_id__once, position_type_id);
	}
	return position_type_id__once;
}

static inline gpointer
worm_properties_get_instance_private (WormProperties* self)
{
	return G_STRUCT_MEMBER_P (self, WormProperties_private_offset);
}

WormProperties*
worm_properties_construct (GType object_type)
{
	WormProperties * self = NULL;
#line 110 "../src/worm.vala"
	self = (WormProperties*) g_object_new (object_type, NULL);
#line 110 "../src/worm.vala"
	return self;
#line 736 "worm.c"
}

WormProperties*
worm_properties_new (void)
{
#line 110 "../src/worm.vala"
	return worm_properties_construct (TYPE_WORM_PROPERTIES);
#line 744 "worm.c"
}

gint
worm_properties_get_color (WormProperties* self)
{
	gint result;
#line 112 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 112 "../src/worm.vala"
	result = self->priv->_color;
#line 112 "../src/worm.vala"
	return result;
#line 757 "worm.c"
}

void
worm_properties_set_color (WormProperties* self,
                           gint value)
{
	gint old_value;
#line 112 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/worm.vala"
	old_value = worm_properties_get_color (self);
#line 112 "../src/worm.vala"
	if (old_value != value) {
#line 112 "../src/worm.vala"
		self->priv->_color = value;
#line 112 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY]);
#line 775 "worm.c"
	}
}

guint
worm_properties_get_up (WormProperties* self)
{
	guint result;
#line 113 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 113 "../src/worm.vala"
	result = self->priv->_up;
#line 113 "../src/worm.vala"
	return result;
#line 789 "worm.c"
}

void
worm_properties_set_up (WormProperties* self,
                        guint value)
{
	guint old_value;
#line 113 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/worm.vala"
	old_value = worm_properties_get_up (self);
#line 113 "../src/worm.vala"
	if (old_value != value) {
#line 113 "../src/worm.vala"
		self->priv->_up = value;
#line 113 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY]);
#line 807 "worm.c"
	}
}

guint
worm_properties_get_down (WormProperties* self)
{
	guint result;
#line 114 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 114 "../src/worm.vala"
	result = self->priv->_down;
#line 114 "../src/worm.vala"
	return result;
#line 821 "worm.c"
}

void
worm_properties_set_down (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 114 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/worm.vala"
	old_value = worm_properties_get_down (self);
#line 114 "../src/worm.vala"
	if (old_value != value) {
#line 114 "../src/worm.vala"
		self->priv->_down = value;
#line 114 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY]);
#line 839 "worm.c"
	}
}

guint
worm_properties_get_left (WormProperties* self)
{
	guint result;
#line 115 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 115 "../src/worm.vala"
	result = self->priv->_left;
#line 115 "../src/worm.vala"
	return result;
#line 853 "worm.c"
}

void
worm_properties_set_left (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 115 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/worm.vala"
	old_value = worm_properties_get_left (self);
#line 115 "../src/worm.vala"
	if (old_value != value) {
#line 115 "../src/worm.vala"
		self->priv->_left = value;
#line 115 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY]);
#line 871 "worm.c"
	}
}

guint
worm_properties_get_right (WormProperties* self)
{
	guint result;
#line 116 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 116 "../src/worm.vala"
	result = self->priv->_right;
#line 116 "../src/worm.vala"
	return result;
#line 885 "worm.c"
}

void
worm_properties_set_right (WormProperties* self,
                           guint value)
{
	guint old_value;
#line 116 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/worm.vala"
	old_value = worm_properties_get_right (self);
#line 116 "../src/worm.vala"
	if (old_value != value) {
#line 116 "../src/worm.vala"
		self->priv->_right = value;
#line 116 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY]);
#line 903 "worm.c"
	}
}

static void
worm_properties_class_init (WormPropertiesClass * klass,
                            gpointer klass_data)
{
#line 110 "../src/worm.vala"
	worm_properties_parent_class = g_type_class_peek_parent (klass);
#line 110 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &WormProperties_private_offset);
#line 110 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_properties_get_property;
#line 110 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_properties_set_property;
#line 110 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_properties_finalize;
#line 110 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_COLOR_PROPERTY, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 110 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY] = g_param_spec_uint ("up", "up", "up", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 110 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY] = g_param_spec_uint ("down", "down", "down", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 110 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY] = g_param_spec_uint ("left", "left", "left", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 110 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY] = g_param_spec_uint ("right", "right", "right", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 931 "worm.c"
}

static void
worm_properties_instance_init (WormProperties * self,
                               gpointer klass)
{
#line 110 "../src/worm.vala"
	self->priv = worm_properties_get_instance_private (self);
#line 940 "worm.c"
}

static void
worm_properties_finalize (GObject * obj)
{
	WormProperties * self;
#line 110 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_PROPERTIES, WormProperties);
#line 110 "../src/worm.vala"
	G_OBJECT_CLASS (worm_properties_parent_class)->finalize (obj);
#line 951 "worm.c"
}

static GType
worm_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormProperties), 0, (GInstanceInitFunc) worm_properties_instance_init, NULL };
	GType worm_properties_type_id;
	worm_properties_type_id = g_type_register_static (G_TYPE_OBJECT, "WormProperties", &g_define_type_info, 0);
	WormProperties_private_offset = g_type_add_instance_private (worm_properties_type_id, sizeof (WormPropertiesPrivate));
	return worm_properties_type_id;
}

GType
worm_properties_get_type (void)
{
	static volatile gsize worm_properties_type_id__once = 0;
	if (g_once_init_enter (&worm_properties_type_id__once)) {
		GType worm_properties_type_id;
		worm_properties_type_id = worm_properties_get_type_once ();
		g_once_init_leave (&worm_properties_type_id__once, worm_properties_type_id);
	}
	return worm_properties_type_id__once;
}

static void
_vala_worm_properties_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 110 "../src/worm.vala"
	switch (property_id) {
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 110 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_color (self));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 110 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_up (self));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 110 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_down (self));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 110 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_left (self));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 110 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_right (self));
#line 110 "../src/worm.vala"
		break;
#line 1016 "worm.c"
		default:
#line 110 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 110 "../src/worm.vala"
		break;
#line 1022 "worm.c"
	}
}

static void
_vala_worm_properties_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 110 "../src/worm.vala"
	switch (property_id) {
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 110 "../src/worm.vala"
		worm_properties_set_color (self, g_value_get_int (value));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 110 "../src/worm.vala"
		worm_properties_set_up (self, g_value_get_uint (value));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 110 "../src/worm.vala"
		worm_properties_set_down (self, g_value_get_uint (value));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 110 "../src/worm.vala"
		worm_properties_set_left (self, g_value_get_uint (value));
#line 110 "../src/worm.vala"
		break;
#line 110 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 110 "../src/worm.vala"
		worm_properties_set_right (self, g_value_get_uint (value));
#line 110 "../src/worm.vala"
		break;
#line 1066 "worm.c"
		default:
#line 110 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 110 "../src/worm.vala"
		break;
#line 1072 "worm.c"
	}
}

static inline gpointer
worm_get_instance_private (Worm* self)
{
	return G_STRUCT_MEMBER_P (self, Worm_private_offset);
}

Worm*
worm_construct (GType object_type,
                gint id,
                guint8 width,
                guint8 height)
{
	Worm * self = NULL;
	gint capacity = 0;
#line 188 "../src/worm.vala"
	capacity = (gint) (width * height);
#line 189 "../src/worm.vala"
	self = (Worm*) g_object_new (object_type, "id", id, "width", width, "height", height, "capacity", capacity, NULL);
#line 186 "../src/worm.vala"
	return self;
#line 1096 "worm.c"
}

Worm*
worm_new (gint id,
          guint8 width,
          guint8 height)
{
#line 186 "../src/worm.vala"
	return worm_construct (TYPE_WORM, id, width, height);
#line 1106 "worm.c"
}

void
worm_set_start (Worm* self,
                guint8 x,
                guint8 y,
                WormDirection direction)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_ = {0};
	GeeLinkedList* _tmp2_;
	Position _tmp3_;
	GeeArrayQueue* _tmp4_;
#line 192 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/worm.vala"
	_tmp0_ = self->priv->_list;
#line 194 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 196 "../src/worm.vala"
	memset (&_tmp1_, 0, sizeof (Position));
#line 196 "../src/worm.vala"
	_tmp1_.x = x;
#line 196 "../src/worm.vala"
	_tmp1_.y = y;
#line 196 "../src/worm.vala"
	worm_set_starting_position (self, &_tmp1_);
#line 198 "../src/worm.vala"
	_tmp2_ = self->priv->_list;
#line 198 "../src/worm.vala"
	_tmp3_ = self->priv->_starting_position;
#line 198 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, &_tmp3_);
#line 200 "../src/worm.vala"
	self->priv->starting_direction = direction;
#line 201 "../src/worm.vala"
	worm_set_direction (self, direction);
#line 202 "../src/worm.vala"
	worm_set_change (self, 0);
#line 203 "../src/worm.vala"
	_tmp4_ = self->priv->key_queue;
#line 203 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
#line 1150 "worm.c"
}

void
worm_move_part_1 (Worm* self)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	GeeLinkedList* _tmp5_;
	Position _tmp6_;
#line 206 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/worm.vala"
	if (self->is_human) {
#line 209 "../src/worm.vala"
		self->keypress = FALSE;
#line 1170 "worm.c"
	}
#line 211 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 211 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/worm.vala"
	position = _tmp1_;
#line 212 "../src/worm.vala"
	_tmp2_ = self->priv->_direction;
#line 212 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 212 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 212 "../src/worm.vala"
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
#line 215 "../src/worm.vala"
	_tmp5_ = self->priv->_list;
#line 215 "../src/worm.vala"
	_tmp6_ = position;
#line 215 "../src/worm.vala"
	gee_deque_offer_head ((GeeDeque*) _tmp5_, &_tmp6_);
#line 1192 "worm.c"
}

void
worm_move_part_2 (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  Position* head_position)
{
	gint _tmp1_;
	Position _tmp12_ = {0};
	Position _tmp13_;
	Position _tmp14_ = {0};
	Position _tmp15_;
	gint _tmp16_;
	gboolean _tmp17_;
	GeeArrayQueue* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
#line 218 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/worm.vala"
	if (head_position != NULL) {
#line 1216 "worm.c"
		Position _tmp0_ = {0};
#line 221 "../src/worm.vala"
		memset (&_tmp0_, 0, sizeof (Position));
#line 221 "../src/worm.vala"
		_tmp0_.x = (*head_position).x;
#line 221 "../src/worm.vala"
		_tmp0_.y = (*head_position).y;
#line 221 "../src/worm.vala"
		worm_set_head (self, &_tmp0_);
#line 1226 "worm.c"
	}
#line 223 "../src/worm.vala"
	_tmp1_ = self->priv->_change;
#line 223 "../src/worm.vala"
	if (_tmp1_ > 0) {
#line 1232 "worm.c"
		gint _tmp2_;
#line 225 "../src/worm.vala"
		_tmp2_ = self->priv->_change;
#line 225 "../src/worm.vala"
		worm_set_change (self, _tmp2_ - 1);
#line 226 "../src/worm.vala"
		g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
#line 1240 "worm.c"
	} else {
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Position* _tmp5_;
		GeeLinkedList* _tmp6_;
		gpointer _tmp7_;
		Position* _tmp8_;
		GeeLinkedList* _tmp9_;
		gpointer _tmp10_;
		Position* _tmp11_;
#line 230 "../src/worm.vala"
		_tmp3_ = self->priv->_list;
#line 230 "../src/worm.vala"
		_tmp4_ = gee_linked_list_last (_tmp3_);
#line 230 "../src/worm.vala"
		_tmp5_ = (Position*) _tmp4_;
#line 230 "../src/worm.vala"
		_tmp6_ = self->priv->_list;
#line 230 "../src/worm.vala"
		_tmp7_ = gee_linked_list_last (_tmp6_);
#line 230 "../src/worm.vala"
		_tmp8_ = (Position*) _tmp7_;
#line 230 "../src/worm.vala"
		board[((*_tmp5_).x * board_length2) + (*_tmp8_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 230 "../src/worm.vala"
		_position_free0 (_tmp8_);
#line 230 "../src/worm.vala"
		_position_free0 (_tmp5_);
#line 231 "../src/worm.vala"
		_tmp9_ = self->priv->_list;
#line 231 "../src/worm.vala"
		_tmp10_ = gee_deque_poll_tail ((GeeDeque*) _tmp9_);
#line 231 "../src/worm.vala"
		_tmp11_ = (Position*) _tmp10_;
#line 231 "../src/worm.vala"
		_position_free0 (_tmp11_);
#line 232 "../src/worm.vala"
		g_signal_emit (self, worm_signals[WORM_MOVED_SIGNAL], 0);
#line 1279 "worm.c"
	}
#line 236 "../src/worm.vala"
	worm_get_head (self, &_tmp12_);
#line 236 "../src/worm.vala"
	_tmp13_ = _tmp12_;
#line 236 "../src/worm.vala"
	worm_get_head (self, &_tmp14_);
#line 236 "../src/worm.vala"
	_tmp15_ = _tmp14_;
#line 236 "../src/worm.vala"
	_tmp16_ = board[(_tmp13_.x * board_length2) + _tmp15_.y];
#line 236 "../src/worm.vala"
	if (_tmp16_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 237 "../src/worm.vala"
		g_signal_emit (self, worm_signals[WORM_BONUS_FOUND_SIGNAL], 0);
#line 1295 "worm.c"
	}
#line 240 "../src/worm.vala"
	_tmp17_ = self->priv->_is_materialized;
#line 240 "../src/worm.vala"
	if (_tmp17_) {
#line 1301 "worm.c"
		Position _tmp18_ = {0};
		Position _tmp19_;
		Position _tmp20_ = {0};
		Position _tmp21_;
		gint _tmp22_;
#line 241 "../src/worm.vala"
		worm_get_head (self, &_tmp18_);
#line 241 "../src/worm.vala"
		_tmp19_ = _tmp18_;
#line 241 "../src/worm.vala"
		worm_get_head (self, &_tmp20_);
#line 241 "../src/worm.vala"
		_tmp21_ = _tmp20_;
#line 241 "../src/worm.vala"
		_tmp22_ = self->priv->_id;
#line 241 "../src/worm.vala"
		board[(_tmp19_.x * board_length2) + _tmp21_.y] = NIBBLES_GAME_WORMCHAR + _tmp22_;
#line 1319 "worm.c"
	} else {
#line 243 "../src/worm.vala"
		self->priv->rounds_dematerialized = self->priv->rounds_dematerialized - 1;
#line 1323 "worm.c"
	}
#line 245 "../src/worm.vala"
	_tmp23_ = self->priv->key_queue;
#line 245 "../src/worm.vala"
	_tmp24_ = gee_array_queue_get_is_empty (_tmp23_);
#line 245 "../src/worm.vala"
	_tmp25_ = _tmp24_;
#line 245 "../src/worm.vala"
	if (!_tmp25_) {
#line 246 "../src/worm.vala"
		worm_dequeue_keypress (self);
#line 1335 "worm.c"
	}
#line 248 "../src/worm.vala"
	if (self->priv->rounds_dematerialized == 1) {
#line 249 "../src/worm.vala"
		worm_materialize (self, board, (gint) board_length1, (gint) board_length2);
#line 1341 "worm.c"
	}
}

void
worm_reduce_tail (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint erase_size)
{
#line 252 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/worm.vala"
	if (erase_size <= 0) {
#line 255 "../src/worm.vala"
		return;
#line 1358 "worm.c"
	}
	{
		gint i = 0;
#line 257 "../src/worm.vala"
		i = 0;
#line 1364 "worm.c"
		{
			gboolean _tmp0_ = FALSE;
#line 257 "../src/worm.vala"
			_tmp0_ = TRUE;
#line 257 "../src/worm.vala"
			while (TRUE) {
#line 1371 "worm.c"
				GeeLinkedList* _tmp2_;
				gpointer _tmp3_;
				Position* _tmp4_;
				GeeLinkedList* _tmp5_;
				gpointer _tmp6_;
				Position* _tmp7_;
				GeeLinkedList* _tmp8_;
				gpointer _tmp9_;
				Position* _tmp10_;
#line 257 "../src/worm.vala"
				if (!_tmp0_) {
#line 1383 "worm.c"
					gint _tmp1_;
#line 257 "../src/worm.vala"
					_tmp1_ = i;
#line 257 "../src/worm.vala"
					i = _tmp1_ + 1;
#line 1389 "worm.c"
				}
#line 257 "../src/worm.vala"
				_tmp0_ = FALSE;
#line 257 "../src/worm.vala"
				if (!(i < erase_size)) {
#line 257 "../src/worm.vala"
					break;
#line 1397 "worm.c"
				}
#line 259 "../src/worm.vala"
				_tmp2_ = self->priv->_list;
#line 259 "../src/worm.vala"
				_tmp3_ = gee_linked_list_last (_tmp2_);
#line 259 "../src/worm.vala"
				_tmp4_ = (Position*) _tmp3_;
#line 259 "../src/worm.vala"
				_tmp5_ = self->priv->_list;
#line 259 "../src/worm.vala"
				_tmp6_ = gee_linked_list_last (_tmp5_);
#line 259 "../src/worm.vala"
				_tmp7_ = (Position*) _tmp6_;
#line 259 "../src/worm.vala"
				board[((*_tmp4_).x * board_length2) + (*_tmp7_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 259 "../src/worm.vala"
				_position_free0 (_tmp7_);
#line 259 "../src/worm.vala"
				_position_free0 (_tmp4_);
#line 260 "../src/worm.vala"
				_tmp8_ = self->priv->_list;
#line 260 "../src/worm.vala"
				_tmp9_ = gee_deque_poll_tail ((GeeDeque*) _tmp8_);
#line 260 "../src/worm.vala"
				_tmp10_ = (Position*) _tmp9_;
#line 260 "../src/worm.vala"
				_position_free0 (_tmp10_);
#line 1425 "worm.c"
			}
		}
	}
#line 262 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_TAIL_REDUCED_SIGNAL], 0, erase_size);
#line 1431 "worm.c"
}

void
worm_reverse (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2)
{
	GeeLinkedList* reversed_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* _tmp12_;
	gpointer _tmp13_;
	Position* _tmp14_;
	GeeLinkedList* _tmp15_;
	gpointer _tmp16_;
	Position* _tmp17_;
	gboolean _tmp18_;
#line 265 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/worm.vala"
	_tmp0_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
#line 267 "../src/worm.vala"
	reversed_list = _tmp0_;
#line 1456 "worm.c"
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
#line 268 "../src/worm.vala"
		_tmp1_ = self->priv->_list;
#line 268 "../src/worm.vala"
		_pos_list = _tmp1_;
#line 268 "../src/worm.vala"
		_tmp2_ = _pos_list;
#line 268 "../src/worm.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 268 "../src/worm.vala"
		_tmp4_ = _tmp3_;
#line 268 "../src/worm.vala"
		_pos_size = _tmp4_;
#line 268 "../src/worm.vala"
		_pos_index = -1;
#line 268 "../src/worm.vala"
		while (TRUE) {
#line 1481 "worm.c"
			gint _tmp5_;
			gint _tmp6_;
			Position* pos = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			GeeLinkedList* _tmp9_;
			Position* _tmp10_;
#line 268 "../src/worm.vala"
			_pos_index = _pos_index + 1;
#line 268 "../src/worm.vala"
			_tmp5_ = _pos_index;
#line 268 "../src/worm.vala"
			_tmp6_ = _pos_size;
#line 268 "../src/worm.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 268 "../src/worm.vala"
				break;
#line 1499 "worm.c"
			}
#line 268 "../src/worm.vala"
			_tmp7_ = _pos_list;
#line 268 "../src/worm.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _pos_index);
#line 268 "../src/worm.vala"
			pos = (Position*) _tmp8_;
#line 269 "../src/worm.vala"
			_tmp9_ = reversed_list;
#line 269 "../src/worm.vala"
			_tmp10_ = pos;
#line 269 "../src/worm.vala"
			gee_deque_offer_head ((GeeDeque*) _tmp9_, _tmp10_);
#line 268 "../src/worm.vala"
			_position_free0 (pos);
#line 1515 "worm.c"
		}
	}
#line 271 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_REVERSED_SIGNAL], 0);
#line 272 "../src/worm.vala"
	_tmp11_ = reversed_list;
#line 272 "../src/worm.vala"
	worm_set_list (self, _tmp11_);
#line 275 "../src/worm.vala"
	_tmp12_ = self->priv->_list;
#line 275 "../src/worm.vala"
	_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
#line 275 "../src/worm.vala"
	_tmp14_ = (Position*) _tmp13_;
#line 275 "../src/worm.vala"
	_tmp15_ = self->priv->_list;
#line 275 "../src/worm.vala"
	_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 1);
#line 275 "../src/worm.vala"
	_tmp17_ = (Position*) _tmp16_;
#line 275 "../src/worm.vala"
	_tmp18_ = (*_tmp14_).y == (*_tmp17_).y;
#line 275 "../src/worm.vala"
	_position_free0 (_tmp17_);
#line 275 "../src/worm.vala"
	_position_free0 (_tmp14_);
#line 275 "../src/worm.vala"
	if (_tmp18_) {
#line 1544 "worm.c"
		WormDirection _tmp19_ = 0;
		GeeLinkedList* _tmp20_;
		gpointer _tmp21_;
		Position* _tmp22_;
		GeeLinkedList* _tmp23_;
		gpointer _tmp24_;
		Position* _tmp25_;
		gboolean _tmp26_;
#line 276 "../src/worm.vala"
		_tmp20_ = self->priv->_list;
#line 276 "../src/worm.vala"
		_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, 0);
#line 276 "../src/worm.vala"
		_tmp22_ = (Position*) _tmp21_;
#line 276 "../src/worm.vala"
		_tmp23_ = self->priv->_list;
#line 276 "../src/worm.vala"
		_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, 1);
#line 276 "../src/worm.vala"
		_tmp25_ = (Position*) _tmp24_;
#line 276 "../src/worm.vala"
		_tmp26_ = (*_tmp22_).x > (*_tmp25_).x;
#line 276 "../src/worm.vala"
		_position_free0 (_tmp25_);
#line 276 "../src/worm.vala"
		_position_free0 (_tmp22_);
#line 276 "../src/worm.vala"
		if (_tmp26_) {
#line 276 "../src/worm.vala"
			_tmp19_ = WORM_DIRECTION_RIGHT;
#line 1575 "worm.c"
		} else {
#line 276 "../src/worm.vala"
			_tmp19_ = WORM_DIRECTION_LEFT;
#line 1579 "worm.c"
		}
#line 276 "../src/worm.vala"
		worm_set_direction (self, _tmp19_);
#line 1583 "worm.c"
	} else {
		WormDirection _tmp27_ = 0;
		GeeLinkedList* _tmp28_;
		gpointer _tmp29_;
		Position* _tmp30_;
		GeeLinkedList* _tmp31_;
		gpointer _tmp32_;
		Position* _tmp33_;
		gboolean _tmp34_;
#line 278 "../src/worm.vala"
		_tmp28_ = self->priv->_list;
#line 278 "../src/worm.vala"
		_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, 0);
#line 278 "../src/worm.vala"
		_tmp30_ = (Position*) _tmp29_;
#line 278 "../src/worm.vala"
		_tmp31_ = self->priv->_list;
#line 278 "../src/worm.vala"
		_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, 1);
#line 278 "../src/worm.vala"
		_tmp33_ = (Position*) _tmp32_;
#line 278 "../src/worm.vala"
		_tmp34_ = (*_tmp30_).y > (*_tmp33_).y;
#line 278 "../src/worm.vala"
		_position_free0 (_tmp33_);
#line 278 "../src/worm.vala"
		_position_free0 (_tmp30_);
#line 278 "../src/worm.vala"
		if (_tmp34_) {
#line 278 "../src/worm.vala"
			_tmp27_ = WORM_DIRECTION_DOWN;
#line 1615 "worm.c"
		} else {
#line 278 "../src/worm.vala"
			_tmp27_ = WORM_DIRECTION_UP;
#line 1619 "worm.c"
		}
#line 278 "../src/worm.vala"
		worm_set_direction (self, _tmp27_);
#line 1623 "worm.c"
	}
#line 265 "../src/worm.vala"
	_g_object_unref0 (reversed_list);
#line 1627 "worm.c"
}

gboolean
worm_can_move_to (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint numworms,
                  Position* position)
{
	gint next_position = 0;
	Position _tmp0_;
	Position _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 281 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 283 "../src/worm.vala"
	_tmp0_ = *position;
#line 283 "../src/worm.vala"
	_tmp1_ = *position;
#line 283 "../src/worm.vala"
	_tmp2_ = board[(_tmp0_.x * board_length2) + _tmp1_.y];
#line 283 "../src/worm.vala"
	next_position = _tmp2_;
#line 285 "../src/worm.vala"
	if (next_position > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 286 "../src/worm.vala"
		_tmp3_ = next_position < ((gint) NIBBLES_GAME_WORMCHAR);
#line 1661 "worm.c"
	} else {
#line 285 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 1665 "worm.c"
	}
#line 285 "../src/worm.vala"
	if (_tmp3_) {
#line 287 "../src/worm.vala"
		result = FALSE;
#line 287 "../src/worm.vala"
		return result;
#line 1673 "worm.c"
	}
#line 289 "../src/worm.vala"
	if (next_position >= ((gint) NIBBLES_GAME_WORMCHAR)) {
#line 290 "../src/worm.vala"
		_tmp4_ = next_position < (NIBBLES_GAME_WORMCHAR + numworms);
#line 1679 "worm.c"
	} else {
#line 289 "../src/worm.vala"
		_tmp4_ = FALSE;
#line 1683 "worm.c"
	}
#line 289 "../src/worm.vala"
	if (_tmp4_) {
#line 1687 "worm.c"
		gboolean _tmp5_;
#line 291 "../src/worm.vala"
		_tmp5_ = self->priv->_is_materialized;
#line 291 "../src/worm.vala"
		result = !_tmp5_;
#line 291 "../src/worm.vala"
		return result;
#line 1695 "worm.c"
	}
#line 293 "../src/worm.vala"
	result = TRUE;
#line 293 "../src/worm.vala"
	return result;
#line 1701 "worm.c"
}

void
worm_spawn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
#line 296 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/worm.vala"
	worm_set_change (self, WORM_STARTING_LENGTH - 1);
#line 1714 "worm.c"
	{
		gint i = 0;
#line 299 "../src/worm.vala"
		i = 0;
#line 1719 "worm.c"
		{
			gboolean _tmp0_ = FALSE;
#line 299 "../src/worm.vala"
			_tmp0_ = TRUE;
#line 299 "../src/worm.vala"
			while (TRUE) {
#line 299 "../src/worm.vala"
				if (!_tmp0_) {
#line 1728 "worm.c"
					gint _tmp1_;
#line 299 "../src/worm.vala"
					_tmp1_ = i;
#line 299 "../src/worm.vala"
					i = _tmp1_ + 1;
#line 1734 "worm.c"
				}
#line 299 "../src/worm.vala"
				_tmp0_ = FALSE;
#line 299 "../src/worm.vala"
				if (!(i < WORM_STARTING_LENGTH)) {
#line 299 "../src/worm.vala"
					break;
#line 1742 "worm.c"
				}
#line 301 "../src/worm.vala"
				worm_move_part_1 (self);
#line 302 "../src/worm.vala"
				worm_move_part_2 (self, board, (gint) board_length1, (gint) board_length2, NULL);
#line 1748 "worm.c"
			}
		}
	}
}

static void
worm_materialize (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2)
{
#line 306 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1762 "worm.c"
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _pos_index = 0;
#line 308 "../src/worm.vala"
		_tmp0_ = self->priv->_list;
#line 308 "../src/worm.vala"
		_pos_list = _tmp0_;
#line 308 "../src/worm.vala"
		_tmp1_ = _pos_list;
#line 308 "../src/worm.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 308 "../src/worm.vala"
		_tmp3_ = _tmp2_;
#line 308 "../src/worm.vala"
		_pos_size = _tmp3_;
#line 308 "../src/worm.vala"
		_pos_index = -1;
#line 308 "../src/worm.vala"
		while (TRUE) {
#line 1787 "worm.c"
			gint _tmp4_;
			gint _tmp5_;
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Position* _tmp8_;
			Position* _tmp9_;
			gint _tmp10_;
#line 308 "../src/worm.vala"
			_pos_index = _pos_index + 1;
#line 308 "../src/worm.vala"
			_tmp4_ = _pos_index;
#line 308 "../src/worm.vala"
			_tmp5_ = _pos_size;
#line 308 "../src/worm.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 308 "../src/worm.vala"
				break;
#line 1806 "worm.c"
			}
#line 308 "../src/worm.vala"
			_tmp6_ = _pos_list;
#line 308 "../src/worm.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
#line 308 "../src/worm.vala"
			pos = (Position*) _tmp7_;
#line 310 "../src/worm.vala"
			_tmp8_ = pos;
#line 310 "../src/worm.vala"
			_tmp9_ = pos;
#line 310 "../src/worm.vala"
			_tmp10_ = board[((*_tmp8_).x * board_length2) + (*_tmp9_).y];
#line 310 "../src/worm.vala"
			if (_tmp10_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 312 "../src/worm.vala"
				self->priv->rounds_dematerialized = self->priv->rounds_dematerialized + 1;
#line 313 "../src/worm.vala"
				_position_free0 (pos);
#line 313 "../src/worm.vala"
				return;
#line 1828 "worm.c"
			}
#line 308 "../src/worm.vala"
			_position_free0 (pos);
#line 1832 "worm.c"
		}
	}
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp11_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _pos_index = 0;
#line 316 "../src/worm.vala"
		_tmp11_ = self->priv->_list;
#line 316 "../src/worm.vala"
		_pos_list = _tmp11_;
#line 316 "../src/worm.vala"
		_tmp12_ = _pos_list;
#line 316 "../src/worm.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 316 "../src/worm.vala"
		_tmp14_ = _tmp13_;
#line 316 "../src/worm.vala"
		_pos_size = _tmp14_;
#line 316 "../src/worm.vala"
		_pos_index = -1;
#line 316 "../src/worm.vala"
		while (TRUE) {
#line 1859 "worm.c"
			gint _tmp15_;
			gint _tmp16_;
			Position* pos = NULL;
			GeeLinkedList* _tmp17_;
			gpointer _tmp18_;
			Position* _tmp19_;
			Position* _tmp20_;
			gint _tmp21_;
#line 316 "../src/worm.vala"
			_pos_index = _pos_index + 1;
#line 316 "../src/worm.vala"
			_tmp15_ = _pos_index;
#line 316 "../src/worm.vala"
			_tmp16_ = _pos_size;
#line 316 "../src/worm.vala"
			if (!(_tmp15_ < _tmp16_)) {
#line 316 "../src/worm.vala"
				break;
#line 1878 "worm.c"
			}
#line 316 "../src/worm.vala"
			_tmp17_ = _pos_list;
#line 316 "../src/worm.vala"
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _pos_index);
#line 316 "../src/worm.vala"
			pos = (Position*) _tmp18_;
#line 317 "../src/worm.vala"
			_tmp19_ = pos;
#line 317 "../src/worm.vala"
			_tmp20_ = pos;
#line 317 "../src/worm.vala"
			_tmp21_ = self->priv->_id;
#line 317 "../src/worm.vala"
			board[((*_tmp19_).x * board_length2) + (*_tmp20_).y] = NIBBLES_GAME_WORMCHAR + _tmp21_;
#line 316 "../src/worm.vala"
			_position_free0 (pos);
#line 1896 "worm.c"
		}
	}
#line 318 "../src/worm.vala"
	worm_set_is_materialized (self, TRUE);
#line 319 "../src/worm.vala"
	self->priv->rounds_dematerialized = 0;
#line 1903 "worm.c"
}

static gboolean
__lambda4_ (Worm* self)
{
	gboolean result;
#line 333 "../src/worm.vala"
	self->is_stopped = FALSE;
#line 334 "../src/worm.vala"
	result = G_SOURCE_REMOVE;
#line 334 "../src/worm.vala"
	return result;
#line 1916 "worm.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((Worm*) self);
#line 332 "../src/worm.vala"
	return result;
#line 1926 "worm.c"
}

void
worm_dematerialize (Worm* self,
                    gint* board,
                    gint board_length1,
                    gint board_length2,
                    gint rounds,
                    gint gamedelay)
{
#line 322 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/worm.vala"
	self->priv->rounds_dematerialized = rounds;
#line 325 "../src/worm.vala"
	worm_set_is_materialized (self, FALSE);
#line 1943 "worm.c"
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _pos_index = 0;
#line 326 "../src/worm.vala"
		_tmp0_ = self->priv->_list;
#line 326 "../src/worm.vala"
		_pos_list = _tmp0_;
#line 326 "../src/worm.vala"
		_tmp1_ = _pos_list;
#line 326 "../src/worm.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 326 "../src/worm.vala"
		_tmp3_ = _tmp2_;
#line 326 "../src/worm.vala"
		_pos_size = _tmp3_;
#line 326 "../src/worm.vala"
		_pos_index = -1;
#line 326 "../src/worm.vala"
		while (TRUE) {
#line 1968 "worm.c"
			gint _tmp4_;
			gint _tmp5_;
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Position* _tmp8_;
			Position* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 326 "../src/worm.vala"
			_pos_index = _pos_index + 1;
#line 326 "../src/worm.vala"
			_tmp4_ = _pos_index;
#line 326 "../src/worm.vala"
			_tmp5_ = _pos_size;
#line 326 "../src/worm.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 326 "../src/worm.vala"
				break;
#line 1988 "worm.c"
			}
#line 326 "../src/worm.vala"
			_tmp6_ = _pos_list;
#line 326 "../src/worm.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
#line 326 "../src/worm.vala"
			pos = (Position*) _tmp7_;
#line 328 "../src/worm.vala"
			_tmp8_ = pos;
#line 328 "../src/worm.vala"
			_tmp9_ = pos;
#line 328 "../src/worm.vala"
			_tmp10_ = board[((*_tmp8_).x * board_length2) + (*_tmp9_).y];
#line 328 "../src/worm.vala"
			_tmp11_ = self->priv->_id;
#line 328 "../src/worm.vala"
			if (_tmp10_ == (NIBBLES_GAME_WORMCHAR + _tmp11_)) {
#line 2006 "worm.c"
				Position* _tmp12_;
				Position* _tmp13_;
#line 329 "../src/worm.vala"
				_tmp12_ = pos;
#line 329 "../src/worm.vala"
				_tmp13_ = pos;
#line 329 "../src/worm.vala"
				board[((*_tmp12_).x * board_length2) + (*_tmp13_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 2015 "worm.c"
			}
#line 326 "../src/worm.vala"
			_position_free0 (pos);
#line 2019 "worm.c"
		}
	}
#line 332 "../src/worm.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (gamedelay * 27), ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 2024 "worm.c"
}

void
worm_add_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 338 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 340 "../src/worm.vala"
	if (_tmp0_ > WORM_MAX_LIVES) {
#line 341 "../src/worm.vala"
		return;
#line 2040 "worm.c"
	}
#line 343 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 343 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ + 1);
#line 2046 "worm.c"
}

static inline void
worm_lose_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 346 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 348 "../src/worm.vala"
	if (((gint) _tmp0_) == 0) {
#line 349 "../src/worm.vala"
		return;
#line 2062 "worm.c"
	}
#line 351 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 351 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ - 1);
#line 2068 "worm.c"
}

void
worm_reset (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	GeeArrayQueue* _tmp0_;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* _tmp12_;
	Position _tmp13_;
#line 354 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/worm.vala"
	self->is_stopped = TRUE;
#line 357 "../src/worm.vala"
	worm_set_is_materialized (self, FALSE);
#line 358 "../src/worm.vala"
	self->priv->rounds_dematerialized = 0;
#line 360 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 360 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 362 "../src/worm.vala"
	worm_lose_life (self);
#line 364 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_DIED_SIGNAL], 0);
#line 2097 "worm.c"
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
#line 365 "../src/worm.vala"
		_tmp1_ = self->priv->_list;
#line 365 "../src/worm.vala"
		_pos_list = _tmp1_;
#line 365 "../src/worm.vala"
		_tmp2_ = _pos_list;
#line 365 "../src/worm.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 365 "../src/worm.vala"
		_tmp4_ = _tmp3_;
#line 365 "../src/worm.vala"
		_pos_size = _tmp4_;
#line 365 "../src/worm.vala"
		_pos_index = -1;
#line 365 "../src/worm.vala"
		while (TRUE) {
#line 2122 "worm.c"
			gint _tmp5_;
			gint _tmp6_;
			Position* pos = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Position* _tmp9_;
			Position* _tmp10_;
#line 365 "../src/worm.vala"
			_pos_index = _pos_index + 1;
#line 365 "../src/worm.vala"
			_tmp5_ = _pos_index;
#line 365 "../src/worm.vala"
			_tmp6_ = _pos_size;
#line 365 "../src/worm.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 365 "../src/worm.vala"
				break;
#line 2140 "worm.c"
			}
#line 365 "../src/worm.vala"
			_tmp7_ = _pos_list;
#line 365 "../src/worm.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _pos_index);
#line 365 "../src/worm.vala"
			pos = (Position*) _tmp8_;
#line 366 "../src/worm.vala"
			_tmp9_ = pos;
#line 366 "../src/worm.vala"
			_tmp10_ = pos;
#line 366 "../src/worm.vala"
			board[((*_tmp9_).x * board_length2) + (*_tmp10_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 365 "../src/worm.vala"
			_position_free0 (pos);
#line 2156 "worm.c"
		}
	}
#line 368 "../src/worm.vala"
	_tmp11_ = self->priv->_list;
#line 368 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp11_);
#line 369 "../src/worm.vala"
	_tmp12_ = self->priv->_list;
#line 369 "../src/worm.vala"
	_tmp13_ = self->priv->_starting_position;
#line 369 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, &_tmp13_);
#line 370 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
#line 372 "../src/worm.vala"
	worm_set_direction (self, self->priv->starting_direction);
#line 373 "../src/worm.vala"
	worm_set_change (self, 0);
#line 374 "../src/worm.vala"
	worm_spawn (self, board, (gint) board_length1, (gint) board_length2);
#line 376 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_FINISH_ADDED_SIGNAL], 0);
#line 2179 "worm.c"
}

void
worm_position_move (Worm* self,
                    Position* result)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
#line 379 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 381 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 381 "../src/worm.vala"
	position = _tmp1_;
#line 382 "../src/worm.vala"
	_tmp2_ = self->priv->_direction;
#line 382 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 382 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 382 "../src/worm.vala"
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
#line 383 "../src/worm.vala"
	*result = position;
#line 383 "../src/worm.vala"
	return;
#line 2212 "worm.c"
}

static void
worm_direction_set (Worm* self,
                    WormDirection dir)
{
#line 386 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/worm.vala"
	_vala_return_if_fail (dir != WORM_DIRECTION_NONE, "dir != WormDirection.NONE");
#line 389 "../src/worm.vala"
	if (!self->is_human) {
#line 390 "../src/worm.vala"
		return;
#line 2227 "worm.c"
	}
#line 392 "../src/worm.vala"
	if (self->keypress) {
#line 394 "../src/worm.vala"
		worm_queue_keypress (self, dir);
#line 395 "../src/worm.vala"
		return;
#line 2235 "worm.c"
	}
#line 398 "../src/worm.vala"
	worm_set_direction (self, dir);
#line 399 "../src/worm.vala"
	self->keypress = TRUE;
#line 2241 "worm.c"
}

static guint
worm_upper_key (Worm* self,
                guint keyval)
{
	guint result;
#line 406 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 408 "../src/worm.vala"
	if (keyval > ((guint) 255)) {
#line 409 "../src/worm.vala"
		result = keyval;
#line 409 "../src/worm.vala"
		return result;
#line 2257 "worm.c"
	}
#line 410 "../src/worm.vala"
	result = (guint) g_ascii_toupper ((gchar) keyval);
#line 410 "../src/worm.vala"
	return result;
#line 2263 "worm.c"
}

gboolean
worm_handle_keypress (Worm* self,
                      guint keyval,
                      GeeHashMap* worm_props)
{
	gboolean _tmp0_ = FALSE;
	guint8 _tmp1_;
	WormProperties* properties = NULL;
	guint propsUp = 0U;
	guint propsDown = 0U;
	guint propsLeft = 0U;
	guint propsRight = 0U;
	guint keyvalUpper = 0U;
	gpointer _tmp2_;
	WormProperties* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	WormProperties* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	WormProperties* _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	WormProperties* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean result;
#line 413 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 413 "../src/worm.vala"
	g_return_val_if_fail (worm_props != NULL, FALSE);
#line 415 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 415 "../src/worm.vala"
	if (((gint) _tmp1_) == 0) {
#line 415 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 2307 "worm.c"
	} else {
#line 415 "../src/worm.vala"
		_tmp0_ = self->is_stopped;
#line 2311 "worm.c"
	}
#line 415 "../src/worm.vala"
	if (_tmp0_) {
#line 416 "../src/worm.vala"
		result = FALSE;
#line 416 "../src/worm.vala"
		return result;
#line 2319 "worm.c"
	}
#line 421 "../src/worm.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) worm_props, self);
#line 421 "../src/worm.vala"
	_g_object_unref0 (properties);
#line 421 "../src/worm.vala"
	properties = (WormProperties*) _tmp2_;
#line 422 "../src/worm.vala"
	_tmp3_ = properties;
#line 422 "../src/worm.vala"
	_tmp4_ = worm_properties_get_up (_tmp3_);
#line 422 "../src/worm.vala"
	_tmp5_ = _tmp4_;
#line 422 "../src/worm.vala"
	propsUp = worm_upper_key (self, _tmp5_);
#line 423 "../src/worm.vala"
	_tmp6_ = properties;
#line 423 "../src/worm.vala"
	_tmp7_ = worm_properties_get_left (_tmp6_);
#line 423 "../src/worm.vala"
	_tmp8_ = _tmp7_;
#line 423 "../src/worm.vala"
	propsLeft = worm_upper_key (self, _tmp8_);
#line 424 "../src/worm.vala"
	_tmp9_ = properties;
#line 424 "../src/worm.vala"
	_tmp10_ = worm_properties_get_down (_tmp9_);
#line 424 "../src/worm.vala"
	_tmp11_ = _tmp10_;
#line 424 "../src/worm.vala"
	propsDown = worm_upper_key (self, _tmp11_);
#line 425 "../src/worm.vala"
	_tmp12_ = properties;
#line 425 "../src/worm.vala"
	_tmp13_ = worm_properties_get_right (_tmp12_);
#line 425 "../src/worm.vala"
	_tmp14_ = _tmp13_;
#line 425 "../src/worm.vala"
	propsRight = worm_upper_key (self, _tmp14_);
#line 426 "../src/worm.vala"
	keyvalUpper = worm_upper_key (self, keyval);
#line 428 "../src/worm.vala"
	if (keyvalUpper == propsUp) {
#line 2363 "worm.c"
		WormDirection _tmp16_;
#line 428 "../src/worm.vala"
		_tmp16_ = self->priv->_direction;
#line 428 "../src/worm.vala"
		_tmp15_ = _tmp16_ != WORM_DIRECTION_DOWN;
#line 2369 "worm.c"
	} else {
#line 428 "../src/worm.vala"
		_tmp15_ = FALSE;
#line 2373 "worm.c"
	}
#line 428 "../src/worm.vala"
	if (_tmp15_) {
#line 430 "../src/worm.vala"
		worm_direction_set (self, WORM_DIRECTION_UP);
#line 431 "../src/worm.vala"
		result = TRUE;
#line 431 "../src/worm.vala"
		_g_object_unref0 (properties);
#line 431 "../src/worm.vala"
		return result;
#line 2385 "worm.c"
	}
#line 433 "../src/worm.vala"
	if (keyvalUpper == propsDown) {
#line 2389 "worm.c"
		WormDirection _tmp18_;
#line 433 "../src/worm.vala"
		_tmp18_ = self->priv->_direction;
#line 433 "../src/worm.vala"
		_tmp17_ = _tmp18_ != WORM_DIRECTION_UP;
#line 2395 "worm.c"
	} else {
#line 433 "../src/worm.vala"
		_tmp17_ = FALSE;
#line 2399 "worm.c"
	}
#line 433 "../src/worm.vala"
	if (_tmp17_) {
#line 435 "../src/worm.vala"
		worm_direction_set (self, WORM_DIRECTION_DOWN);
#line 436 "../src/worm.vala"
		result = TRUE;
#line 436 "../src/worm.vala"
		_g_object_unref0 (properties);
#line 436 "../src/worm.vala"
		return result;
#line 2411 "worm.c"
	}
#line 438 "../src/worm.vala"
	if (keyvalUpper == propsRight) {
#line 2415 "worm.c"
		WormDirection _tmp20_;
#line 438 "../src/worm.vala"
		_tmp20_ = self->priv->_direction;
#line 438 "../src/worm.vala"
		_tmp19_ = _tmp20_ != WORM_DIRECTION_LEFT;
#line 2421 "worm.c"
	} else {
#line 438 "../src/worm.vala"
		_tmp19_ = FALSE;
#line 2425 "worm.c"
	}
#line 438 "../src/worm.vala"
	if (_tmp19_) {
#line 440 "../src/worm.vala"
		worm_direction_set (self, WORM_DIRECTION_RIGHT);
#line 441 "../src/worm.vala"
		result = TRUE;
#line 441 "../src/worm.vala"
		_g_object_unref0 (properties);
#line 441 "../src/worm.vala"
		return result;
#line 2437 "worm.c"
	}
#line 443 "../src/worm.vala"
	if (keyvalUpper == propsLeft) {
#line 2441 "worm.c"
		WormDirection _tmp22_;
#line 443 "../src/worm.vala"
		_tmp22_ = self->priv->_direction;
#line 443 "../src/worm.vala"
		_tmp21_ = _tmp22_ != WORM_DIRECTION_RIGHT;
#line 2447 "worm.c"
	} else {
#line 443 "../src/worm.vala"
		_tmp21_ = FALSE;
#line 2451 "worm.c"
	}
#line 443 "../src/worm.vala"
	if (_tmp21_) {
#line 445 "../src/worm.vala"
		worm_direction_set (self, WORM_DIRECTION_LEFT);
#line 446 "../src/worm.vala"
		result = TRUE;
#line 446 "../src/worm.vala"
		_g_object_unref0 (properties);
#line 446 "../src/worm.vala"
		return result;
#line 2463 "worm.c"
	}
#line 449 "../src/worm.vala"
	result = FALSE;
#line 449 "../src/worm.vala"
	_g_object_unref0 (properties);
#line 449 "../src/worm.vala"
	return result;
#line 2471 "worm.c"
}

static void
worm_queue_keypress (Worm* self,
                     WormDirection dir)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayQueue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayQueue* _tmp6_;
#line 452 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/worm.vala"
	_tmp1_ = self->priv->key_queue;
#line 457 "../src/worm.vala"
	_tmp2_ = gee_array_queue_get_is_empty (_tmp1_);
#line 457 "../src/worm.vala"
	_tmp3_ = _tmp2_;
#line 457 "../src/worm.vala"
	if (!_tmp3_) {
#line 2493 "worm.c"
		GeeArrayQueue* _tmp4_;
		gpointer _tmp5_;
#line 457 "../src/worm.vala"
		_tmp4_ = self->priv->key_queue;
#line 457 "../src/worm.vala"
		_tmp5_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp4_);
#line 457 "../src/worm.vala"
		_tmp0_ = dir == ((WormDirection) ((gintptr) _tmp5_));
#line 2502 "worm.c"
	} else {
#line 457 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2506 "worm.c"
	}
#line 457 "../src/worm.vala"
	if (_tmp0_) {
#line 458 "../src/worm.vala"
		return;
#line 2512 "worm.c"
	}
#line 460 "../src/worm.vala"
	_tmp6_ = self->priv->key_queue;
#line 460 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, (gpointer) ((gintptr) dir));
#line 2518 "worm.c"
}

static void
worm_dequeue_keypress (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayQueue* _tmp3_;
	gpointer _tmp4_;
#line 463 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 463 "../src/worm.vala"
	_tmp1_ = gee_array_queue_get_is_empty (_tmp0_);
#line 463 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 463 "../src/worm.vala"
	_vala_return_if_fail (!_tmp2_, "!key_queue.is_empty");
#line 466 "../src/worm.vala"
	_tmp3_ = self->priv->key_queue;
#line 466 "../src/worm.vala"
	_tmp4_ = gee_abstract_queue_poll ((GeeAbstractQueue*) _tmp3_);
#line 466 "../src/worm.vala"
	worm_direction_set (self, (WormDirection) ((gintptr) _tmp4_));
#line 2545 "worm.c"
}

static gint
worm_ai_deadend (gint* board,
                 gint board_length1,
                 gint board_length2,
                 gint numworms,
                 Position* old_position,
                 gint length_left)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	gint result;
#line 489 "../src/worm.vala"
	g_return_val_if_fail (old_position != NULL, 0);
#line 491 "../src/worm.vala"
	_tmp0_ = board_length1;
#line 491 "../src/worm.vala"
	width = (guint8) _tmp0_;
#line 492 "../src/worm.vala"
	_tmp1_ = board_length2;
#line 492 "../src/worm.vala"
	height = (guint8) _tmp1_;
#line 494 "../src/worm.vala"
	if (length_left <= 0) {
#line 495 "../src/worm.vala"
		result = 0;
#line 495 "../src/worm.vala"
		return result;
#line 2577 "worm.c"
	}
	{
		gint dir = 0;
#line 497 "../src/worm.vala"
		dir = 4;
#line 2583 "worm.c"
		{
			gboolean _tmp2_ = FALSE;
#line 497 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 497 "../src/worm.vala"
			while (TRUE) {
#line 2590 "worm.c"
				Position new_position = {0};
				Position _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				Position _tmp7_;
				Position _tmp8_;
				gint _tmp9_;
#line 497 "../src/worm.vala"
				if (!_tmp2_) {
#line 2600 "worm.c"
					gint _tmp3_;
#line 497 "../src/worm.vala"
					_tmp3_ = dir;
#line 497 "../src/worm.vala"
					dir = _tmp3_ - 1;
#line 2606 "worm.c"
				}
#line 497 "../src/worm.vala"
				_tmp2_ = FALSE;
#line 497 "../src/worm.vala"
				if (!(dir > 0)) {
#line 497 "../src/worm.vala"
					break;
#line 2614 "worm.c"
				}
#line 499 "../src/worm.vala"
				_tmp4_ = *old_position;
#line 499 "../src/worm.vala"
				new_position = _tmp4_;
#line 500 "../src/worm.vala"
				position_move (&new_position, (WormDirection) dir, width, height);
#line 502 "../src/worm.vala"
				_tmp7_ = new_position;
#line 502 "../src/worm.vala"
				_tmp8_ = new_position;
#line 502 "../src/worm.vala"
				_tmp9_ = board[(_tmp7_.x * board_length2) + _tmp8_.y];
#line 502 "../src/worm.vala"
				if (_tmp9_ <= ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 502 "../src/worm.vala"
					_tmp6_ = TRUE;
#line 2632 "worm.c"
				} else {
					Position _tmp10_;
					Position _tmp11_;
					gint _tmp12_;
#line 503 "../src/worm.vala"
					_tmp10_ = *old_position;
#line 503 "../src/worm.vala"
					_tmp11_ = *old_position;
#line 503 "../src/worm.vala"
					_tmp12_ = board[(_tmp10_.x * board_length2) + _tmp11_.y];
#line 503 "../src/worm.vala"
					_tmp6_ = _tmp12_ >= ('z' + numworms);
#line 2645 "worm.c"
				}
#line 502 "../src/worm.vala"
				if (_tmp6_) {
#line 2649 "worm.c"
					guint* _tmp13_;
					gint _tmp13__length1;
					gint _tmp13__length2;
					Position _tmp14_;
					Position _tmp15_;
					guint _tmp16_;
#line 504 "../src/worm.vala"
					_tmp13_ = worm_deadend_board;
#line 504 "../src/worm.vala"
					_tmp13__length1 = worm_deadend_board_length1;
#line 504 "../src/worm.vala"
					_tmp13__length2 = worm_deadend_board_length2;
#line 504 "../src/worm.vala"
					_tmp14_ = new_position;
#line 504 "../src/worm.vala"
					_tmp15_ = new_position;
#line 504 "../src/worm.vala"
					_tmp16_ = _tmp13_[(_tmp14_.x * _tmp13__length2) + _tmp15_.y];
#line 504 "../src/worm.vala"
					_tmp5_ = _tmp16_ != worm_deadend_runnumber;
#line 2670 "worm.c"
				} else {
#line 502 "../src/worm.vala"
					_tmp5_ = FALSE;
#line 2674 "worm.c"
				}
#line 502 "../src/worm.vala"
				if (_tmp5_) {
#line 2678 "worm.c"
					guint* _tmp17_;
					gint _tmp17__length1;
					gint _tmp17__length2;
					Position _tmp18_;
					Position _tmp19_;
					Position _tmp20_;
#line 506 "../src/worm.vala"
					_tmp17_ = worm_deadend_board;
#line 506 "../src/worm.vala"
					_tmp17__length1 = worm_deadend_board_length1;
#line 506 "../src/worm.vala"
					_tmp17__length2 = worm_deadend_board_length2;
#line 506 "../src/worm.vala"
					_tmp18_ = new_position;
#line 506 "../src/worm.vala"
					_tmp19_ = new_position;
#line 506 "../src/worm.vala"
					_tmp17_[(_tmp18_.x * _tmp17__length2) + _tmp19_.y] = worm_deadend_runnumber;
#line 507 "../src/worm.vala"
					_tmp20_ = new_position;
#line 507 "../src/worm.vala"
					length_left = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp20_, length_left - 1);
#line 508 "../src/worm.vala"
					if (length_left <= 0) {
#line 509 "../src/worm.vala"
						result = 0;
#line 509 "../src/worm.vala"
						return result;
#line 2707 "worm.c"
					}
				}
			}
		}
	}
#line 513 "../src/worm.vala"
	result = length_left;
#line 513 "../src/worm.vala"
	return result;
#line 2717 "worm.c"
}

static gint
worm_ai_deadend_after (gint* board,
                       gint board_length1,
                       gint board_length2,
                       GeeLinkedList* worms,
                       gint numworms,
                       Position* old_position,
                       WormDirection direction,
                       gint length)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	Position _tmp3_;
	guint _tmp5_;
	Position new_position = {0};
	Position _tmp29_;
	guint* _tmp30_;
	gint _tmp30__length1;
	gint _tmp30__length2;
	Position _tmp31_;
	Position _tmp32_;
	guint* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	Position _tmp34_;
	Position _tmp35_;
	gint cl = 0;
	Position _tmp36_;
	gint result;
#line 525 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, 0);
#line 525 "../src/worm.vala"
	g_return_val_if_fail (old_position != NULL, 0);
#line 527 "../src/worm.vala"
	_tmp0_ = board_length1;
#line 527 "../src/worm.vala"
	width = (guint8) _tmp0_;
#line 528 "../src/worm.vala"
	_tmp1_ = board_length2;
#line 528 "../src/worm.vala"
	height = (guint8) _tmp1_;
#line 530 "../src/worm.vala"
	_tmp3_ = *old_position;
#line 530 "../src/worm.vala"
	if (_tmp3_.x >= width) {
#line 530 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 2770 "worm.c"
	} else {
		Position _tmp4_;
#line 531 "../src/worm.vala"
		_tmp4_ = *old_position;
#line 531 "../src/worm.vala"
		_tmp2_ = _tmp4_.y >= height;
#line 2777 "worm.c"
	}
#line 530 "../src/worm.vala"
	if (_tmp2_) {
#line 532 "../src/worm.vala"
		result = 0;
#line 532 "../src/worm.vala"
		return result;
#line 2785 "worm.c"
	}
#line 534 "../src/worm.vala"
	_tmp5_ = worm_deadend_runnumber;
#line 534 "../src/worm.vala"
	worm_deadend_runnumber = _tmp5_ + 1;
#line 2791 "worm.c"
	{
		gint i = 0;
#line 536 "../src/worm.vala"
		i = numworms - 1;
#line 2796 "worm.c"
		{
			gboolean _tmp6_ = FALSE;
#line 536 "../src/worm.vala"
			_tmp6_ = TRUE;
#line 536 "../src/worm.vala"
			while (TRUE) {
#line 2803 "worm.c"
				guint8 target_x = 0U;
				gpointer _tmp8_;
				Worm* _tmp9_;
				Position _tmp10_ = {0};
				Position _tmp11_;
				guint8 _tmp12_;
				guint8 target_y = 0U;
				gpointer _tmp13_;
				Worm* _tmp14_;
				Position _tmp15_ = {0};
				Position _tmp16_;
				guint8 _tmp17_;
				gboolean _tmp18_ = FALSE;
				Position _tmp19_;
#line 536 "../src/worm.vala"
				if (!_tmp6_) {
#line 2820 "worm.c"
					gint _tmp7_;
#line 536 "../src/worm.vala"
					_tmp7_ = i;
#line 536 "../src/worm.vala"
					i = _tmp7_ - 1;
#line 2826 "worm.c"
				}
#line 536 "../src/worm.vala"
				_tmp6_ = FALSE;
#line 536 "../src/worm.vala"
				if (!(i >= 0)) {
#line 536 "../src/worm.vala"
					break;
#line 2834 "worm.c"
				}
#line 538 "../src/worm.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 538 "../src/worm.vala"
				_tmp9_ = (Worm*) _tmp8_;
#line 538 "../src/worm.vala"
				worm_get_head (_tmp9_, &_tmp10_);
#line 538 "../src/worm.vala"
				_tmp11_ = _tmp10_;
#line 538 "../src/worm.vala"
				_tmp12_ = _tmp11_.x;
#line 538 "../src/worm.vala"
				_g_object_unref0 (_tmp9_);
#line 538 "../src/worm.vala"
				target_x = _tmp12_;
#line 539 "../src/worm.vala"
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 539 "../src/worm.vala"
				_tmp14_ = (Worm*) _tmp13_;
#line 539 "../src/worm.vala"
				worm_get_head (_tmp14_, &_tmp15_);
#line 539 "../src/worm.vala"
				_tmp16_ = _tmp15_;
#line 539 "../src/worm.vala"
				_tmp17_ = _tmp16_.y;
#line 539 "../src/worm.vala"
				_g_object_unref0 (_tmp14_);
#line 539 "../src/worm.vala"
				target_y = _tmp17_;
#line 540 "../src/worm.vala"
				_tmp19_ = *old_position;
#line 540 "../src/worm.vala"
				if (target_x == _tmp19_.x) {
#line 2868 "worm.c"
					Position _tmp20_;
#line 541 "../src/worm.vala"
					_tmp20_ = *old_position;
#line 541 "../src/worm.vala"
					_tmp18_ = target_y == _tmp20_.y;
#line 2874 "worm.c"
				} else {
#line 540 "../src/worm.vala"
					_tmp18_ = FALSE;
#line 2878 "worm.c"
				}
#line 540 "../src/worm.vala"
				if (_tmp18_) {
#line 542 "../src/worm.vala"
					continue;
#line 2884 "worm.c"
				}
#line 544 "../src/worm.vala"
				if (((gint) target_x) > 0) {
#line 2888 "worm.c"
					guint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp21__length2;
#line 544 "../src/worm.vala"
					_tmp21_ = worm_deadend_board;
#line 544 "../src/worm.vala"
					_tmp21__length1 = worm_deadend_board_length1;
#line 544 "../src/worm.vala"
					_tmp21__length2 = worm_deadend_board_length2;
#line 544 "../src/worm.vala"
					_tmp21_[((target_x - 1) * _tmp21__length2) + target_y] = worm_deadend_runnumber;
#line 2900 "worm.c"
				} else {
					guint* _tmp22_;
					gint _tmp22__length1;
					gint _tmp22__length2;
#line 545 "../src/worm.vala"
					_tmp22_ = worm_deadend_board;
#line 545 "../src/worm.vala"
					_tmp22__length1 = worm_deadend_board_length1;
#line 545 "../src/worm.vala"
					_tmp22__length2 = worm_deadend_board_length2;
#line 545 "../src/worm.vala"
					_tmp22_[((width - 1) * _tmp22__length2) + target_y] = worm_deadend_runnumber;
#line 2913 "worm.c"
				}
#line 546 "../src/worm.vala"
				if (((gint) target_y) > 0) {
#line 2917 "worm.c"
					guint* _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
#line 546 "../src/worm.vala"
					_tmp23_ = worm_deadend_board;
#line 546 "../src/worm.vala"
					_tmp23__length1 = worm_deadend_board_length1;
#line 546 "../src/worm.vala"
					_tmp23__length2 = worm_deadend_board_length2;
#line 546 "../src/worm.vala"
					_tmp23_[(target_x * _tmp23__length2) + (target_y - 1)] = worm_deadend_runnumber;
#line 2929 "worm.c"
				} else {
					guint* _tmp24_;
					gint _tmp24__length1;
					gint _tmp24__length2;
#line 547 "../src/worm.vala"
					_tmp24_ = worm_deadend_board;
#line 547 "../src/worm.vala"
					_tmp24__length1 = worm_deadend_board_length1;
#line 547 "../src/worm.vala"
					_tmp24__length2 = worm_deadend_board_length2;
#line 547 "../src/worm.vala"
					_tmp24_[(target_x * _tmp24__length2) + (height - 1)] = worm_deadend_runnumber;
#line 2942 "worm.c"
				}
#line 548 "../src/worm.vala"
				if (((gint) target_x) < (width - 1)) {
#line 2946 "worm.c"
					guint* _tmp25_;
					gint _tmp25__length1;
					gint _tmp25__length2;
#line 548 "../src/worm.vala"
					_tmp25_ = worm_deadend_board;
#line 548 "../src/worm.vala"
					_tmp25__length1 = worm_deadend_board_length1;
#line 548 "../src/worm.vala"
					_tmp25__length2 = worm_deadend_board_length2;
#line 548 "../src/worm.vala"
					_tmp25_[((target_x + 1) * _tmp25__length2) + target_y] = worm_deadend_runnumber;
#line 2958 "worm.c"
				} else {
					guint* _tmp26_;
					gint _tmp26__length1;
					gint _tmp26__length2;
#line 549 "../src/worm.vala"
					_tmp26_ = worm_deadend_board;
#line 549 "../src/worm.vala"
					_tmp26__length1 = worm_deadend_board_length1;
#line 549 "../src/worm.vala"
					_tmp26__length2 = worm_deadend_board_length2;
#line 549 "../src/worm.vala"
					_tmp26_[(0 * _tmp26__length2) + target_y] = worm_deadend_runnumber;
#line 2971 "worm.c"
				}
#line 550 "../src/worm.vala"
				if (((gint) target_y) < (height - 1)) {
#line 2975 "worm.c"
					guint* _tmp27_;
					gint _tmp27__length1;
					gint _tmp27__length2;
#line 550 "../src/worm.vala"
					_tmp27_ = worm_deadend_board;
#line 550 "../src/worm.vala"
					_tmp27__length1 = worm_deadend_board_length1;
#line 550 "../src/worm.vala"
					_tmp27__length2 = worm_deadend_board_length2;
#line 550 "../src/worm.vala"
					_tmp27_[(target_x * _tmp27__length2) + (target_y + 1)] = worm_deadend_runnumber;
#line 2987 "worm.c"
				} else {
					guint* _tmp28_;
					gint _tmp28__length1;
					gint _tmp28__length2;
#line 551 "../src/worm.vala"
					_tmp28_ = worm_deadend_board;
#line 551 "../src/worm.vala"
					_tmp28__length1 = worm_deadend_board_length1;
#line 551 "../src/worm.vala"
					_tmp28__length2 = worm_deadend_board_length2;
#line 551 "../src/worm.vala"
					_tmp28_[(target_x * _tmp28__length2) + 0] = worm_deadend_runnumber;
#line 3000 "worm.c"
				}
			}
		}
	}
#line 554 "../src/worm.vala"
	_tmp29_ = *old_position;
#line 554 "../src/worm.vala"
	new_position = _tmp29_;
#line 555 "../src/worm.vala"
	position_move (&new_position, direction, width, height);
#line 557 "../src/worm.vala"
	_tmp30_ = worm_deadend_board;
#line 557 "../src/worm.vala"
	_tmp30__length1 = worm_deadend_board_length1;
#line 557 "../src/worm.vala"
	_tmp30__length2 = worm_deadend_board_length2;
#line 557 "../src/worm.vala"
	_tmp31_ = *old_position;
#line 557 "../src/worm.vala"
	_tmp32_ = *old_position;
#line 557 "../src/worm.vala"
	_tmp30_[(_tmp31_.x * _tmp30__length2) + _tmp32_.y] = worm_deadend_runnumber;
#line 558 "../src/worm.vala"
	_tmp33_ = worm_deadend_board;
#line 558 "../src/worm.vala"
	_tmp33__length1 = worm_deadend_board_length1;
#line 558 "../src/worm.vala"
	_tmp33__length2 = worm_deadend_board_length2;
#line 558 "../src/worm.vala"
	_tmp34_ = new_position;
#line 558 "../src/worm.vala"
	_tmp35_ = new_position;
#line 558 "../src/worm.vala"
	_tmp33_[(_tmp34_.x * _tmp33__length2) + _tmp35_.y] = worm_deadend_runnumber;
#line 560 "../src/worm.vala"
	cl = (length * length) / 16;
#line 561 "../src/worm.vala"
	if (cl < ((gint) width)) {
#line 562 "../src/worm.vala"
		cl = (gint) width;
#line 3041 "worm.c"
	}
#line 563 "../src/worm.vala"
	_tmp36_ = new_position;
#line 563 "../src/worm.vala"
	result = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp36_, cl);
#line 563 "../src/worm.vala"
	return result;
#line 3049 "worm.c"
}

static inline gboolean
worm_ai_too_close (Worm* self,
                   GeeLinkedList* worms)
{
	gboolean result;
#line 570 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 570 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 3061 "worm.c"
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 572 "../src/worm.vala"
		_worm_list = worms;
#line 572 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 572 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 572 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 572 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 572 "../src/worm.vala"
		_worm_index = -1;
#line 572 "../src/worm.vala"
		while (TRUE) {
#line 3083 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			Worm* _tmp7_;
			gint16 dx = 0;
			Position _tmp8_ = {0};
			Position _tmp9_;
			Worm* _tmp10_;
			Position _tmp11_ = {0};
			Position _tmp12_;
			gint16 dy = 0;
			Position _tmp13_ = {0};
			Position _tmp14_;
			Worm* _tmp15_;
			Position _tmp16_ = {0};
			Position _tmp17_;
			WormDirection _tmp18_;
#line 572 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 572 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 572 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 572 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 572 "../src/worm.vala"
				break;
#line 3113 "worm.c"
			}
#line 572 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 572 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
#line 572 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 574 "../src/worm.vala"
			_tmp7_ = worm;
#line 574 "../src/worm.vala"
			if (_tmp7_ == self) {
#line 575 "../src/worm.vala"
				_g_object_unref0 (worm);
#line 575 "../src/worm.vala"
				continue;
#line 3129 "worm.c"
			}
#line 577 "../src/worm.vala"
			worm_get_head (self, &_tmp8_);
#line 577 "../src/worm.vala"
			_tmp9_ = _tmp8_;
#line 577 "../src/worm.vala"
			_tmp10_ = worm;
#line 577 "../src/worm.vala"
			worm_get_head (_tmp10_, &_tmp11_);
#line 577 "../src/worm.vala"
			_tmp12_ = _tmp11_;
#line 577 "../src/worm.vala"
			dx = ((gint16) _tmp9_.x) - ((gint16) _tmp12_.x);
#line 578 "../src/worm.vala"
			worm_get_head (self, &_tmp13_);
#line 578 "../src/worm.vala"
			_tmp14_ = _tmp13_;
#line 578 "../src/worm.vala"
			_tmp15_ = worm;
#line 578 "../src/worm.vala"
			worm_get_head (_tmp15_, &_tmp16_);
#line 578 "../src/worm.vala"
			_tmp17_ = _tmp16_;
#line 578 "../src/worm.vala"
			dy = ((gint16) _tmp14_.y) - ((gint16) _tmp17_.y);
#line 579 "../src/worm.vala"
			_tmp18_ = self->priv->_direction;
#line 579 "../src/worm.vala"
			switch (_tmp18_) {
#line 579 "../src/worm.vala"
				case WORM_DIRECTION_UP:
#line 3161 "worm.c"
				{
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
#line 582 "../src/worm.vala"
					if (((gint) dy) > 0) {
#line 582 "../src/worm.vala"
						_tmp21_ = ((gint) dy) <= 3;
#line 3170 "worm.c"
					} else {
#line 582 "../src/worm.vala"
						_tmp21_ = FALSE;
#line 3174 "worm.c"
					}
#line 582 "../src/worm.vala"
					if (_tmp21_) {
#line 582 "../src/worm.vala"
						_tmp20_ = ((gint) dx) >= -1;
#line 3180 "worm.c"
					} else {
#line 582 "../src/worm.vala"
						_tmp20_ = FALSE;
#line 3184 "worm.c"
					}
#line 582 "../src/worm.vala"
					if (_tmp20_) {
#line 582 "../src/worm.vala"
						_tmp19_ = ((gint) dx) <= 1;
#line 3190 "worm.c"
					} else {
#line 582 "../src/worm.vala"
						_tmp19_ = FALSE;
#line 3194 "worm.c"
					}
#line 582 "../src/worm.vala"
					if (_tmp19_) {
#line 583 "../src/worm.vala"
						result = TRUE;
#line 583 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 583 "../src/worm.vala"
						return result;
#line 3204 "worm.c"
					}
#line 584 "../src/worm.vala"
					break;
#line 3208 "worm.c"
				}
#line 579 "../src/worm.vala"
				case WORM_DIRECTION_DOWN:
#line 3212 "worm.c"
				{
					gboolean _tmp22_ = FALSE;
					gboolean _tmp23_ = FALSE;
					gboolean _tmp24_ = FALSE;
#line 587 "../src/worm.vala"
					if (((gint) dy) < 0) {
#line 587 "../src/worm.vala"
						_tmp24_ = ((gint) dy) >= -3;
#line 3221 "worm.c"
					} else {
#line 587 "../src/worm.vala"
						_tmp24_ = FALSE;
#line 3225 "worm.c"
					}
#line 587 "../src/worm.vala"
					if (_tmp24_) {
#line 587 "../src/worm.vala"
						_tmp23_ = ((gint) dx) >= -1;
#line 3231 "worm.c"
					} else {
#line 587 "../src/worm.vala"
						_tmp23_ = FALSE;
#line 3235 "worm.c"
					}
#line 587 "../src/worm.vala"
					if (_tmp23_) {
#line 587 "../src/worm.vala"
						_tmp22_ = ((gint) dx) <= 1;
#line 3241 "worm.c"
					} else {
#line 587 "../src/worm.vala"
						_tmp22_ = FALSE;
#line 3245 "worm.c"
					}
#line 587 "../src/worm.vala"
					if (_tmp22_) {
#line 588 "../src/worm.vala"
						result = TRUE;
#line 588 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 588 "../src/worm.vala"
						return result;
#line 3255 "worm.c"
					}
#line 589 "../src/worm.vala"
					break;
#line 3259 "worm.c"
				}
#line 579 "../src/worm.vala"
				case WORM_DIRECTION_LEFT:
#line 3263 "worm.c"
				{
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_ = FALSE;
					gboolean _tmp27_ = FALSE;
#line 592 "../src/worm.vala"
					if (((gint) dx) > 0) {
#line 592 "../src/worm.vala"
						_tmp27_ = ((gint) dx) <= 3;
#line 3272 "worm.c"
					} else {
#line 592 "../src/worm.vala"
						_tmp27_ = FALSE;
#line 3276 "worm.c"
					}
#line 592 "../src/worm.vala"
					if (_tmp27_) {
#line 592 "../src/worm.vala"
						_tmp26_ = ((gint) dy) >= -1;
#line 3282 "worm.c"
					} else {
#line 592 "../src/worm.vala"
						_tmp26_ = FALSE;
#line 3286 "worm.c"
					}
#line 592 "../src/worm.vala"
					if (_tmp26_) {
#line 592 "../src/worm.vala"
						_tmp25_ = ((gint) dy) <= 1;
#line 3292 "worm.c"
					} else {
#line 592 "../src/worm.vala"
						_tmp25_ = FALSE;
#line 3296 "worm.c"
					}
#line 592 "../src/worm.vala"
					if (_tmp25_) {
#line 593 "../src/worm.vala"
						result = TRUE;
#line 593 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 593 "../src/worm.vala"
						return result;
#line 3306 "worm.c"
					}
#line 594 "../src/worm.vala"
					break;
#line 3310 "worm.c"
				}
#line 579 "../src/worm.vala"
				case WORM_DIRECTION_RIGHT:
#line 3314 "worm.c"
				{
					gboolean _tmp28_ = FALSE;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_ = FALSE;
#line 597 "../src/worm.vala"
					if (((gint) dx) < 0) {
#line 597 "../src/worm.vala"
						_tmp30_ = ((gint) dx) >= -3;
#line 3323 "worm.c"
					} else {
#line 597 "../src/worm.vala"
						_tmp30_ = FALSE;
#line 3327 "worm.c"
					}
#line 597 "../src/worm.vala"
					if (_tmp30_) {
#line 597 "../src/worm.vala"
						_tmp29_ = ((gint) dy) >= -1;
#line 3333 "worm.c"
					} else {
#line 597 "../src/worm.vala"
						_tmp29_ = FALSE;
#line 3337 "worm.c"
					}
#line 597 "../src/worm.vala"
					if (_tmp29_) {
#line 597 "../src/worm.vala"
						_tmp28_ = ((gint) dy) <= 1;
#line 3343 "worm.c"
					} else {
#line 597 "../src/worm.vala"
						_tmp28_ = FALSE;
#line 3347 "worm.c"
					}
#line 597 "../src/worm.vala"
					if (_tmp28_) {
#line 598 "../src/worm.vala"
						result = TRUE;
#line 598 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 598 "../src/worm.vala"
						return result;
#line 3357 "worm.c"
					}
#line 599 "../src/worm.vala"
					break;
#line 3361 "worm.c"
				}
				default:
				{
#line 602 "../src/worm.vala"
					g_assert_not_reached ();
#line 3367 "worm.c"
				}
			}
#line 572 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 3372 "worm.c"
		}
	}
#line 605 "../src/worm.vala"
	result = FALSE;
#line 605 "../src/worm.vala"
	return result;
#line 3379 "worm.c"
}

static gboolean
worm_ai_wander (gint* board,
                gint board_length1,
                gint board_length2,
                gint numworms,
                Position* updated_position,
                WormDirection direction,
                Position* initial_position)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	Position _tmp2_;
	Position _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 608 "../src/worm.vala"
	g_return_val_if_fail (updated_position != NULL, FALSE);
#line 608 "../src/worm.vala"
	g_return_val_if_fail (initial_position != NULL, FALSE);
#line 610 "../src/worm.vala"
	_tmp0_ = board_length1;
#line 610 "../src/worm.vala"
	width = (guint8) _tmp0_;
#line 611 "../src/worm.vala"
	_tmp1_ = board_length2;
#line 611 "../src/worm.vala"
	height = (guint8) _tmp1_;
#line 613 "../src/worm.vala"
	position_move (updated_position, direction, width, height);
#line 615 "../src/worm.vala"
	_tmp2_ = *updated_position;
#line 615 "../src/worm.vala"
	_tmp3_ = *updated_position;
#line 615 "../src/worm.vala"
	_tmp4_ = board[(_tmp2_.x * board_length2) + _tmp3_.y];
#line 615 "../src/worm.vala"
	switch (_tmp4_ - 'A') {
#line 615 "../src/worm.vala"
		case BONUS_TYPE_REGULAR:
#line 3423 "worm.c"
		{
#line 618 "../src/worm.vala"
			result = TRUE;
#line 618 "../src/worm.vala"
			return result;
#line 3429 "worm.c"
		}
#line 615 "../src/worm.vala"
		case BONUS_TYPE_DOUBLE:
#line 3433 "worm.c"
		{
#line 620 "../src/worm.vala"
			result = TRUE;
#line 620 "../src/worm.vala"
			return result;
#line 3439 "worm.c"
		}
#line 615 "../src/worm.vala"
		case BONUS_TYPE_LIFE:
#line 3443 "worm.c"
		{
#line 622 "../src/worm.vala"
			result = TRUE;
#line 622 "../src/worm.vala"
			return result;
#line 3449 "worm.c"
		}
#line 615 "../src/worm.vala"
		case BONUS_TYPE_REVERSE:
#line 3453 "worm.c"
		{
#line 624 "../src/worm.vala"
			result = TRUE;
#line 624 "../src/worm.vala"
			return result;
#line 3459 "worm.c"
		}
#line 615 "../src/worm.vala"
		case BONUS_TYPE_HALF:
#line 3463 "worm.c"
		{
#line 626 "../src/worm.vala"
			result = FALSE;
#line 626 "../src/worm.vala"
			return result;
#line 3469 "worm.c"
		}
		default:
		{
			gboolean _tmp5_ = FALSE;
			Position _tmp6_;
			Position _tmp7_;
			gint _tmp8_;
			gboolean _tmp12_ = FALSE;
			Position _tmp13_;
			Position _tmp14_;
			Position _tmp17_;
			Position _tmp18_;
#line 628 "../src/worm.vala"
			_tmp6_ = *updated_position;
#line 628 "../src/worm.vala"
			_tmp7_ = *updated_position;
#line 628 "../src/worm.vala"
			_tmp8_ = board[(_tmp6_.x * board_length2) + _tmp7_.y];
#line 628 "../src/worm.vala"
			if (_tmp8_ > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 3490 "worm.c"
				Position _tmp9_;
				Position _tmp10_;
				gint _tmp11_;
#line 629 "../src/worm.vala"
				_tmp9_ = *updated_position;
#line 629 "../src/worm.vala"
				_tmp10_ = *updated_position;
#line 629 "../src/worm.vala"
				_tmp11_ = board[(_tmp9_.x * board_length2) + _tmp10_.y];
#line 629 "../src/worm.vala"
				_tmp5_ = _tmp11_ < ('z' + numworms);
#line 3502 "worm.c"
			} else {
#line 628 "../src/worm.vala"
				_tmp5_ = FALSE;
#line 3506 "worm.c"
			}
#line 628 "../src/worm.vala"
			if (_tmp5_) {
#line 630 "../src/worm.vala"
				result = FALSE;
#line 630 "../src/worm.vala"
				return result;
#line 3514 "worm.c"
			}
#line 631 "../src/worm.vala"
			_tmp13_ = *updated_position;
#line 631 "../src/worm.vala"
			_tmp14_ = *initial_position;
#line 631 "../src/worm.vala"
			if (_tmp13_.x == _tmp14_.x) {
#line 3522 "worm.c"
				Position _tmp15_;
				Position _tmp16_;
#line 632 "../src/worm.vala"
				_tmp15_ = *updated_position;
#line 632 "../src/worm.vala"
				_tmp16_ = *initial_position;
#line 632 "../src/worm.vala"
				_tmp12_ = _tmp15_.y == _tmp16_.y;
#line 3531 "worm.c"
			} else {
#line 631 "../src/worm.vala"
				_tmp12_ = FALSE;
#line 3535 "worm.c"
			}
#line 631 "../src/worm.vala"
			if (_tmp12_) {
#line 633 "../src/worm.vala"
				result = FALSE;
#line 633 "../src/worm.vala"
				return result;
#line 3543 "worm.c"
			}
#line 634 "../src/worm.vala"
			_tmp17_ = *updated_position;
#line 634 "../src/worm.vala"
			_tmp18_ = *initial_position;
#line 634 "../src/worm.vala"
			result = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp17_, direction, &_tmp18_);
#line 634 "../src/worm.vala"
			return result;
#line 3553 "worm.c"
		}
	}
}

void
worm_ai_move (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2,
              gint numworms,
              GeeLinkedList* worms)
{
	WormDirection opposite = 0;
	WormDirection _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
	WormDirection _tmp3_;
	Position _tmp4_ = {0};
	Position _tmp5_;
	WormDirection prev_dir = 0;
	WormDirection _tmp21_;
	WormDirection best_dir = 0;
	gint best_yet = 0;
	gint _tmp22_;
	gint this_len = 0;
#line 639 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 639 "../src/worm.vala"
	g_return_if_fail (worms != NULL);
#line 641 "../src/worm.vala"
	_tmp0_ = self->priv->_direction;
#line 641 "../src/worm.vala"
	opposite = worm_direction_opposite (_tmp0_);
#line 644 "../src/worm.vala"
	worm_get_head (self, &_tmp1_);
#line 644 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 644 "../src/worm.vala"
	_tmp3_ = self->priv->_direction;
#line 644 "../src/worm.vala"
	worm_get_head (self, &_tmp4_);
#line 644 "../src/worm.vala"
	_tmp5_ = _tmp4_;
#line 644 "../src/worm.vala"
	if (!worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp2_, _tmp3_, &_tmp5_)) {
#line 3599 "worm.c"
		Position _tmp6_ = {0};
		Position _tmp7_;
		WormDirection _tmp8_;
		Position _tmp9_ = {0};
		Position _tmp10_;
#line 649 "../src/worm.vala"
		worm_get_head (self, &_tmp6_);
#line 649 "../src/worm.vala"
		_tmp7_ = _tmp6_;
#line 649 "../src/worm.vala"
		_tmp8_ = self->priv->_direction;
#line 649 "../src/worm.vala"
		worm_get_head (self, &_tmp9_);
#line 649 "../src/worm.vala"
		_tmp10_ = _tmp9_;
#line 649 "../src/worm.vala"
		if (worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp7_, worm_direction_turn_left (_tmp8_), &_tmp10_)) {
#line 3617 "worm.c"
			WormDirection _tmp11_;
#line 650 "../src/worm.vala"
			_tmp11_ = self->priv->_direction;
#line 650 "../src/worm.vala"
			worm_set_direction (self, worm_direction_turn_left (_tmp11_));
#line 3623 "worm.c"
		} else {
			Position _tmp12_ = {0};
			Position _tmp13_;
			WormDirection _tmp14_;
			Position _tmp15_ = {0};
			Position _tmp16_;
#line 653 "../src/worm.vala"
			worm_get_head (self, &_tmp12_);
#line 653 "../src/worm.vala"
			_tmp13_ = _tmp12_;
#line 653 "../src/worm.vala"
			_tmp14_ = self->priv->_direction;
#line 653 "../src/worm.vala"
			worm_get_head (self, &_tmp15_);
#line 653 "../src/worm.vala"
			_tmp16_ = _tmp15_;
#line 653 "../src/worm.vala"
			if (worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp13_, worm_direction_turn_right (_tmp14_), &_tmp16_)) {
#line 3642 "worm.c"
				WormDirection _tmp17_;
#line 654 "../src/worm.vala"
				_tmp17_ = self->priv->_direction;
#line 654 "../src/worm.vala"
				worm_set_direction (self, worm_direction_turn_right (_tmp17_));
#line 3648 "worm.c"
			} else {
#line 657 "../src/worm.vala"
				if (g_random_int_range ((gint32) 0, (gint32) 30) == ((gint32) 1)) {
#line 3652 "worm.c"
					WormDirection _tmp18_ = 0;
#line 658 "../src/worm.vala"
					if (g_random_boolean ()) {
#line 3656 "worm.c"
						WormDirection _tmp19_;
#line 658 "../src/worm.vala"
						_tmp19_ = self->priv->_direction;
#line 658 "../src/worm.vala"
						_tmp18_ = worm_direction_turn_right (_tmp19_);
#line 3662 "worm.c"
					} else {
						WormDirection _tmp20_;
#line 658 "../src/worm.vala"
						_tmp20_ = self->priv->_direction;
#line 658 "../src/worm.vala"
						_tmp18_ = worm_direction_turn_left (_tmp20_);
#line 3669 "worm.c"
					}
#line 658 "../src/worm.vala"
					worm_set_direction (self, _tmp18_);
#line 3673 "worm.c"
				}
			}
		}
	}
#line 672 "../src/worm.vala"
	_tmp21_ = self->priv->_direction;
#line 672 "../src/worm.vala"
	prev_dir = _tmp21_;
#line 673 "../src/worm.vala"
	best_dir = WORM_DIRECTION_NONE;
#line 674 "../src/worm.vala"
	_tmp22_ = self->priv->_capacity;
#line 674 "../src/worm.vala"
	best_yet = _tmp22_ * 2;
#line 3688 "worm.c"
	{
		gint dir = 0;
#line 677 "../src/worm.vala"
		dir = 1;
#line 3693 "worm.c"
		{
			gboolean _tmp23_ = FALSE;
#line 677 "../src/worm.vala"
			_tmp23_ = TRUE;
#line 677 "../src/worm.vala"
			while (TRUE) {
#line 3700 "worm.c"
				WormDirection _tmp25_;
				Position _tmp26_ = {0};
				Position _tmp28_ = {0};
				Position _tmp29_;
				WormDirection _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gboolean _tmp34_ = FALSE;
				WormDirection _tmp35_;
#line 677 "../src/worm.vala"
				if (!_tmp23_) {
#line 3713 "worm.c"
					gint _tmp24_;
#line 677 "../src/worm.vala"
					_tmp24_ = dir;
#line 677 "../src/worm.vala"
					dir = _tmp24_ + 1;
#line 3719 "worm.c"
				}
#line 677 "../src/worm.vala"
				_tmp23_ = FALSE;
#line 677 "../src/worm.vala"
				if (!(dir <= 4)) {
#line 677 "../src/worm.vala"
					break;
#line 3727 "worm.c"
				}
#line 680 "../src/worm.vala"
				worm_set_direction (self, (WormDirection) dir);
#line 682 "../src/worm.vala"
				_tmp25_ = self->priv->_direction;
#line 682 "../src/worm.vala"
				if (_tmp25_ == opposite) {
#line 683 "../src/worm.vala"
					continue;
#line 3737 "worm.c"
				}
#line 684 "../src/worm.vala"
				this_len = 0;
#line 686 "../src/worm.vala"
				worm_position_move (self, &_tmp26_);
#line 686 "../src/worm.vala"
				if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms, &_tmp26_)) {
#line 3745 "worm.c"
					gint _tmp27_;
#line 687 "../src/worm.vala"
					_tmp27_ = self->priv->_capacity;
#line 687 "../src/worm.vala"
					this_len += _tmp27_;
#line 3751 "worm.c"
				}
#line 689 "../src/worm.vala"
				if (worm_ai_too_close (self, worms)) {
#line 690 "../src/worm.vala"
					this_len += 4;
#line 3757 "worm.c"
				}
#line 692 "../src/worm.vala"
				worm_get_head (self, &_tmp28_);
#line 692 "../src/worm.vala"
				_tmp29_ = _tmp28_;
#line 692 "../src/worm.vala"
				_tmp30_ = self->priv->_direction;
#line 692 "../src/worm.vala"
				_tmp31_ = worm_get_length (self);
#line 692 "../src/worm.vala"
				_tmp32_ = _tmp31_;
#line 692 "../src/worm.vala"
				_tmp33_ = self->priv->_change;
#line 692 "../src/worm.vala"
				this_len += worm_ai_deadend_after (board, (gint) board_length1, (gint) board_length2, worms, numworms, &_tmp29_, _tmp30_, _tmp32_ + _tmp33_);
#line 694 "../src/worm.vala"
				_tmp35_ = self->priv->_direction;
#line 694 "../src/worm.vala"
				if (_tmp35_ == prev_dir) {
#line 694 "../src/worm.vala"
					_tmp34_ = this_len <= 0;
#line 3779 "worm.c"
				} else {
#line 694 "../src/worm.vala"
					_tmp34_ = FALSE;
#line 3783 "worm.c"
				}
#line 694 "../src/worm.vala"
				if (_tmp34_) {
#line 695 "../src/worm.vala"
					this_len -= 100;
#line 3789 "worm.c"
				}
#line 702 "../src/worm.vala"
				if (this_len <= 0) {
#line 703 "../src/worm.vala"
					this_len -= (gint) g_random_int_range ((gint32) 0, (gint32) 100);
#line 3795 "worm.c"
				}
#line 704 "../src/worm.vala"
				if (this_len < best_yet) {
#line 3799 "worm.c"
					WormDirection _tmp36_;
#line 706 "../src/worm.vala"
					best_yet = this_len;
#line 707 "../src/worm.vala"
					_tmp36_ = self->priv->_direction;
#line 707 "../src/worm.vala"
					best_dir = _tmp36_;
#line 3807 "worm.c"
				}
			}
		}
	}
#line 711 "../src/worm.vala"
	if (best_dir == WORM_DIRECTION_NONE) {
#line 712 "../src/worm.vala"
		g_assert_not_reached ();
#line 3816 "worm.c"
	}
#line 714 "../src/worm.vala"
	worm_set_direction (self, best_dir);
#line 3820 "worm.c"
	{
		guint8 dir = 0U;
#line 719 "../src/worm.vala"
		dir = (guint8) 1;
#line 3825 "worm.c"
		{
			gboolean _tmp37_ = FALSE;
#line 719 "../src/worm.vala"
			_tmp37_ = TRUE;
#line 719 "../src/worm.vala"
			while (TRUE) {
#line 3832 "worm.c"
				Position _tmp39_ = {0};
#line 719 "../src/worm.vala"
				if (!_tmp37_) {
#line 3836 "worm.c"
					guint8 _tmp38_;
#line 719 "../src/worm.vala"
					_tmp38_ = dir;
#line 719 "../src/worm.vala"
					dir = _tmp38_ + 1;
#line 3842 "worm.c"
				}
#line 719 "../src/worm.vala"
				_tmp37_ = FALSE;
#line 719 "../src/worm.vala"
				if (!(((gint) dir) <= 4)) {
#line 719 "../src/worm.vala"
					break;
#line 3850 "worm.c"
				}
#line 721 "../src/worm.vala"
				if (opposite == ((WormDirection) dir)) {
#line 722 "../src/worm.vala"
					continue;
#line 3856 "worm.c"
				}
#line 724 "../src/worm.vala"
				worm_position_move (self, &_tmp39_);
#line 724 "../src/worm.vala"
				if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms, &_tmp39_)) {
#line 725 "../src/worm.vala"
					worm_set_direction (self, (WormDirection) dir);
#line 3864 "worm.c"
				}
			}
		}
	}
}

void
worm_get_starting_position (Worm* self,
                            Position * result)
{
	Position _tmp0_;
#line 127 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/worm.vala"
	_tmp0_ = self->priv->_starting_position;
#line 127 "../src/worm.vala"
	*result = _tmp0_;
#line 127 "../src/worm.vala"
	return;
#line 3884 "worm.c"
}

static gboolean
_position_equal (const Position * s1,
                 const Position * s2)
{
#line 127 "../src/worm.vala"
	if (s1 == s2) {
#line 127 "../src/worm.vala"
		return TRUE;
#line 3895 "worm.c"
	}
#line 127 "../src/worm.vala"
	if (s1 == NULL) {
#line 127 "../src/worm.vala"
		return FALSE;
#line 3901 "worm.c"
	}
#line 127 "../src/worm.vala"
	if (s2 == NULL) {
#line 127 "../src/worm.vala"
		return FALSE;
#line 3907 "worm.c"
	}
#line 127 "../src/worm.vala"
	if (s1->x != s2->x) {
#line 127 "../src/worm.vala"
		return FALSE;
#line 3913 "worm.c"
	}
#line 127 "../src/worm.vala"
	if (s1->y != s2->y) {
#line 127 "../src/worm.vala"
		return FALSE;
#line 3919 "worm.c"
	}
#line 127 "../src/worm.vala"
	return TRUE;
#line 3923 "worm.c"
}

static void
worm_set_starting_position (Worm* self,
                            Position * value)
{
	Position old_value;
#line 127 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/worm.vala"
	worm_get_starting_position (self, &old_value);
#line 127 "../src/worm.vala"
	if (_position_equal (value, &old_value) != TRUE) {
#line 3937 "worm.c"
		Position _tmp0_;
#line 127 "../src/worm.vala"
		_tmp0_ = *value;
#line 127 "../src/worm.vala"
		self->priv->_starting_position = _tmp0_;
#line 127 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_STARTING_POSITION_PROPERTY]);
#line 3945 "worm.c"
	}
}

gint
worm_get_id (Worm* self)
{
	gint result;
#line 129 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "../src/worm.vala"
	result = self->priv->_id;
#line 129 "../src/worm.vala"
	return result;
#line 3959 "worm.c"
}

static void
worm_set_id (Worm* self,
             gint value)
{
	gint old_value;
#line 129 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/worm.vala"
	old_value = worm_get_id (self);
#line 129 "../src/worm.vala"
	if (old_value != value) {
#line 129 "../src/worm.vala"
		self->priv->_id = value;
#line 129 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_ID_PROPERTY]);
#line 3977 "worm.c"
	}
}

gboolean
worm_get_is_materialized (Worm* self)
{
	gboolean result;
#line 134 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "../src/worm.vala"
	result = self->priv->_is_materialized;
#line 134 "../src/worm.vala"
	return result;
#line 3991 "worm.c"
}

static void
worm_set_is_materialized (Worm* self,
                          gboolean value)
{
	gboolean old_value;
#line 134 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/worm.vala"
	old_value = worm_get_is_materialized (self);
#line 134 "../src/worm.vala"
	if (old_value != value) {
#line 134 "../src/worm.vala"
		self->priv->_is_materialized = value;
#line 134 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_IS_MATERIALIZED_PROPERTY]);
#line 4009 "worm.c"
	}
}

guint8
worm_get_lives (Worm* self)
{
	guint8 result;
#line 137 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 137 "../src/worm.vala"
	result = self->priv->_lives;
#line 137 "../src/worm.vala"
	return result;
#line 4023 "worm.c"
}

void
worm_set_lives (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 137 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/worm.vala"
	old_value = worm_get_lives (self);
#line 137 "../src/worm.vala"
	if (old_value != value) {
#line 137 "../src/worm.vala"
		self->priv->_lives = value;
#line 137 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIVES_PROPERTY]);
#line 4041 "worm.c"
	}
}

gint
worm_get_change (Worm* self)
{
	gint result;
#line 138 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 138 "../src/worm.vala"
	result = self->priv->_change;
#line 138 "../src/worm.vala"
	return result;
#line 4055 "worm.c"
}

void
worm_set_change (Worm* self,
                 gint value)
{
	gint old_value;
#line 138 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/worm.vala"
	old_value = worm_get_change (self);
#line 138 "../src/worm.vala"
	if (old_value != value) {
#line 138 "../src/worm.vala"
		self->priv->_change = value;
#line 138 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CHANGE_PROPERTY]);
#line 4073 "worm.c"
	}
}

gint
worm_get_score (Worm* self)
{
	gint result;
#line 139 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 139 "../src/worm.vala"
	result = self->priv->_score;
#line 139 "../src/worm.vala"
	return result;
#line 4087 "worm.c"
}

void
worm_set_score (Worm* self,
                gint value)
{
	gint old_value;
#line 139 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/worm.vala"
	old_value = worm_get_score (self);
#line 139 "../src/worm.vala"
	if (old_value != value) {
#line 139 "../src/worm.vala"
		self->priv->_score = value;
#line 139 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_SCORE_PROPERTY]);
#line 4105 "worm.c"
	}
}

gint
worm_get_length (Worm* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 143 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 143 "../src/worm.vala"
	_tmp0_ = self->priv->_list;
#line 143 "../src/worm.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 143 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/worm.vala"
	result = _tmp2_;
#line 143 "../src/worm.vala"
	return result;
#line 4128 "worm.c"
}

void
worm_get_head (Worm* self,
               Position * result)
{
	Position head = {0};
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	Position* _tmp2_;
	Position _tmp3_;
	Position _tmp4_;
#line 148 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/worm.vala"
	_tmp0_ = self->priv->_list;
#line 150 "../src/worm.vala"
	_tmp1_ = gee_linked_list_first (_tmp0_);
#line 150 "../src/worm.vala"
	_tmp2_ = (Position*) _tmp1_;
#line 150 "../src/worm.vala"
	_tmp3_ = *_tmp2_;
#line 150 "../src/worm.vala"
	_position_free0 (_tmp2_);
#line 150 "../src/worm.vala"
	head = _tmp3_;
#line 151 "../src/worm.vala"
	_tmp4_ = head;
#line 151 "../src/worm.vala"
	*result = _tmp4_;
#line 151 "../src/worm.vala"
	return;
#line 4161 "worm.c"
}

static void
worm_set_head (Worm* self,
               Position * value)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_;
#line 153 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/worm.vala"
	_tmp0_ = self->priv->_list;
#line 155 "../src/worm.vala"
	_tmp1_ = *value;
#line 155 "../src/worm.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, 0, &_tmp1_);
#line 153 "../src/worm.vala"
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEAD_PROPERTY]);
#line 4180 "worm.c"
}

WormDirection
worm_get_direction (Worm* self)
{
	WormDirection result;
#line 159 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 159 "../src/worm.vala"
	result = self->priv->_direction;
#line 159 "../src/worm.vala"
	return result;
#line 4193 "worm.c"
}

static void
worm_set_direction (Worm* self,
                    WormDirection value)
{
	WormDirection old_value;
#line 159 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/worm.vala"
	old_value = worm_get_direction (self);
#line 159 "../src/worm.vala"
	if (old_value != value) {
#line 159 "../src/worm.vala"
		self->priv->_direction = value;
#line 159 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_DIRECTION_PROPERTY]);
#line 4211 "worm.c"
	}
}

GeeLinkedList*
worm_get_list (Worm* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 165 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 165 "../src/worm.vala"
	_tmp0_ = self->priv->_list;
#line 165 "../src/worm.vala"
	result = _tmp0_;
#line 165 "../src/worm.vala"
	return result;
#line 4228 "worm.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 165 "../src/worm.vala"
	return self ? g_object_ref (self) : NULL;
#line 4236 "worm.c"
}

static void
worm_set_list (Worm* self,
               GeeLinkedList* value)
{
	GeeLinkedList* old_value;
#line 165 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/worm.vala"
	old_value = worm_get_list (self);
#line 165 "../src/worm.vala"
	if (old_value != value) {
#line 4250 "worm.c"
		GeeLinkedList* _tmp0_;
#line 165 "../src/worm.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 165 "../src/worm.vala"
		_g_object_unref0 (self->priv->_list);
#line 165 "../src/worm.vala"
		self->priv->_list = _tmp0_;
#line 165 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIST_PROPERTY]);
#line 4260 "worm.c"
	}
}

static guint8
worm_get_width (Worm* self)
{
	guint8 result;
#line 177 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 177 "../src/worm.vala"
	result = self->priv->_width;
#line 177 "../src/worm.vala"
	return result;
#line 4274 "worm.c"
}

static void
worm_set_width (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 177 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/worm.vala"
	old_value = worm_get_width (self);
#line 177 "../src/worm.vala"
	if (old_value != value) {
#line 177 "../src/worm.vala"
		self->priv->_width = value;
#line 177 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_WIDTH_PROPERTY]);
#line 4292 "worm.c"
	}
}

static guint8
worm_get_height (Worm* self)
{
	guint8 result;
#line 178 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 178 "../src/worm.vala"
	result = self->priv->_height;
#line 178 "../src/worm.vala"
	return result;
#line 4306 "worm.c"
}

static void
worm_set_height (Worm* self,
                 guint8 value)
{
	guint8 old_value;
#line 178 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/worm.vala"
	old_value = worm_get_height (self);
#line 178 "../src/worm.vala"
	if (old_value != value) {
#line 178 "../src/worm.vala"
		self->priv->_height = value;
#line 178 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEIGHT_PROPERTY]);
#line 4324 "worm.c"
	}
}

static gint
worm_get_capacity (Worm* self)
{
	gint result;
#line 179 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 179 "../src/worm.vala"
	result = self->priv->_capacity;
#line 179 "../src/worm.vala"
	return result;
#line 4338 "worm.c"
}

static void
worm_set_capacity (Worm* self,
                   gint value)
{
	gint old_value;
#line 179 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/worm.vala"
	old_value = worm_get_capacity (self);
#line 179 "../src/worm.vala"
	if (old_value != value) {
#line 179 "../src/worm.vala"
		self->priv->_capacity = value;
#line 179 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CAPACITY_PROPERTY]);
#line 4356 "worm.c"
	}
}

static GObject *
worm_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Worm * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint* _tmp2_;
#line 181 "../src/worm.vala"
	parent_class = G_OBJECT_CLASS (worm_parent_class);
#line 181 "../src/worm.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 181 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 183 "../src/worm.vala"
	_tmp0_ = self->priv->_width;
#line 183 "../src/worm.vala"
	_tmp1_ = self->priv->_height;
#line 183 "../src/worm.vala"
	_tmp2_ = g_new0 (guint, _tmp0_ * _tmp1_);
#line 183 "../src/worm.vala"
	worm_deadend_board = (g_free (worm_deadend_board), NULL);
#line 183 "../src/worm.vala"
	worm_deadend_board = _tmp2_;
#line 183 "../src/worm.vala"
	worm_deadend_board_length1 = _tmp0_;
#line 183 "../src/worm.vala"
	worm_deadend_board_length2 = _tmp1_;
#line 181 "../src/worm.vala"
	return obj;
#line 4393 "worm.c"
}

static void
worm_class_init (WormClass * klass,
                 gpointer klass_data)
{
#line 119 "../src/worm.vala"
	worm_parent_class = g_type_class_peek_parent (klass);
#line 119 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &Worm_private_offset);
#line 119 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_get_property;
#line 119 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_set_property;
#line 119 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->constructor = worm_constructor;
#line 119 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_finalize;
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_STARTING_POSITION_PROPERTY, worm_properties[WORM_STARTING_POSITION_PROPERTY] = g_param_spec_boxed ("starting-position", "starting-position", "starting-position", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_ID_PROPERTY, worm_properties[WORM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_IS_MATERIALIZED_PROPERTY, worm_properties[WORM_IS_MATERIALIZED_PROPERTY] = g_param_spec_boolean ("is-materialized", "is-materialized", "is-materialized", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIVES_PROPERTY, worm_properties[WORM_LIVES_PROPERTY] = g_param_spec_uchar ("lives", "lives", "lives", 0, G_MAXUINT8, WORM_STARTING_LIVES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CHANGE_PROPERTY, worm_properties[WORM_CHANGE_PROPERTY] = g_param_spec_int ("change", "change", "change", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_SCORE_PROPERTY, worm_properties[WORM_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LENGTH_PROPERTY, worm_properties[WORM_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEAD_PROPERTY, worm_properties[WORM_HEAD_PROPERTY] = g_param_spec_boxed ("head", "head", "head", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_DIRECTION_PROPERTY, worm_properties[WORM_DIRECTION_PROPERTY] = g_param_spec_enum ("direction", "direction", "direction", TYPE_WORM_DIRECTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIST_PROPERTY, worm_properties[WORM_LIST_PROPERTY] = g_param_spec_object ("list", "list", "list", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_WIDTH_PROPERTY, worm_properties[WORM_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEIGHT_PROPERTY, worm_properties[WORM_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 119 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CAPACITY_PROPERTY, worm_properties[WORM_CAPACITY_PROPERTY] = g_param_spec_int ("capacity", "capacity", "capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 119 "../src/worm.vala"
	worm_signals[WORM_ADDED_SIGNAL] = g_signal_new ("added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 119 "../src/worm.vala"
	worm_signals[WORM_FINISH_ADDED_SIGNAL] = g_signal_new ("finish-added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 119 "../src/worm.vala"
	worm_signals[WORM_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 119 "../src/worm.vala"
	worm_signals[WORM_RESCALED_SIGNAL] = g_signal_new ("rescaled", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 119 "../src/worm.vala"
	worm_signals[WORM_DIED_SIGNAL] = g_signal_new ("died", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 119 "../src/worm.vala"
	worm_signals[WORM_TAIL_REDUCED_SIGNAL] = g_signal_new ("tail-reduced", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 119 "../src/worm.vala"
	worm_signals[WORM_REVERSED_SIGNAL] = g_signal_new ("reversed", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 119 "../src/worm.vala"
	worm_signals[WORM_BONUS_FOUND_SIGNAL] = g_signal_new ("bonus-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4454 "worm.c"
}

static void
worm_instance_init (Worm * self,
                    gpointer klass)
{
	GeeArrayQueue* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 119 "../src/worm.vala"
	self->priv = worm_get_instance_private (self);
#line 132 "../src/worm.vala"
	self->keypress = FALSE;
#line 133 "../src/worm.vala"
	self->is_stopped = FALSE;
#line 134 "../src/worm.vala"
	self->priv->_is_materialized = TRUE;
#line 137 "../src/worm.vala"
	self->priv->_lives = WORM_STARTING_LIVES;
#line 138 "../src/worm.vala"
	self->priv->_change = 0;
#line 139 "../src/worm.vala"
	self->priv->_score = 0;
#line 163 "../src/worm.vala"
	_tmp0_ = gee_array_queue_new (TYPE_WORM_DIRECTION, NULL, NULL, NULL, NULL, NULL);
#line 163 "../src/worm.vala"
	self->priv->key_queue = _tmp0_;
#line 165 "../src/worm.vala"
	_tmp1_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
#line 165 "../src/worm.vala"
	self->priv->_list = _tmp1_;
#line 4485 "worm.c"
}

static void
worm_finalize (GObject * obj)
{
	Worm * self;
#line 119 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 163 "../src/worm.vala"
	_g_object_unref0 (self->priv->key_queue);
#line 165 "../src/worm.vala"
	_g_object_unref0 (self->priv->_list);
#line 119 "../src/worm.vala"
	G_OBJECT_CLASS (worm_parent_class)->finalize (obj);
#line 4500 "worm.c"
}

static GType
worm_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Worm), 0, (GInstanceInitFunc) worm_instance_init, NULL };
	GType worm_type_id;
	worm_type_id = g_type_register_static (G_TYPE_OBJECT, "Worm", &g_define_type_info, 0);
	Worm_private_offset = g_type_add_instance_private (worm_type_id, sizeof (WormPrivate));
	return worm_type_id;
}

GType
worm_get_type (void)
{
	static volatile gsize worm_type_id__once = 0;
	if (g_once_init_enter (&worm_type_id__once)) {
		GType worm_type_id;
		worm_type_id = worm_get_type_once ();
		g_once_init_leave (&worm_type_id__once, worm_type_id);
	}
	return worm_type_id__once;
}

static void
_vala_worm_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 119 "../src/worm.vala"
	switch (property_id) {
#line 119 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 4537 "worm.c"
		{
			Position boxed;
#line 119 "../src/worm.vala"
			worm_get_starting_position (self, &boxed);
#line 119 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 4544 "worm.c"
		}
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_int (value, worm_get_id (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_IS_MATERIALIZED_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_boolean (value, worm_get_is_materialized (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_lives (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_int (value, worm_get_change (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_int (value, worm_get_score (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_LENGTH_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_int (value, worm_get_length (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 4586 "worm.c"
		{
			Position boxed;
#line 119 "../src/worm.vala"
			worm_get_head (self, &boxed);
#line 119 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 4593 "worm.c"
		}
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_enum (value, worm_get_direction (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_LIST_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_object (value, worm_get_list (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_width (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_height (self));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 119 "../src/worm.vala"
		g_value_set_int (value, worm_get_capacity (self));
#line 119 "../src/worm.vala"
		break;
#line 4627 "worm.c"
		default:
#line 119 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 119 "../src/worm.vala"
		break;
#line 4633 "worm.c"
	}
}

static void
_vala_worm_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 119 "../src/worm.vala"
	switch (property_id) {
#line 119 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_starting_position (self, g_value_get_boxed (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_id (self, g_value_get_int (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_IS_MATERIALIZED_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_is_materialized (self, g_value_get_boolean (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_lives (self, g_value_get_uchar (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_change (self, g_value_get_int (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_score (self, g_value_get_int (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_head (self, g_value_get_boxed (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_direction (self, g_value_get_enum (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_LIST_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_list (self, g_value_get_object (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_width (self, g_value_get_uchar (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_height (self, g_value_get_uchar (value));
#line 119 "../src/worm.vala"
		break;
#line 119 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 119 "../src/worm.vala"
		worm_set_capacity (self, g_value_get_int (value));
#line 119 "../src/worm.vala"
		break;
#line 4719 "worm.c"
		default:
#line 119 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 119 "../src/worm.vala"
		break;
#line 4725 "worm.c"
	}
}

