/* nibbles-game.c generated by valac 0.56.3, the Vala compiler
 * generated from nibbles-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_GAME_MAX_SPEED 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WORMCHAR 'w'
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_MAX_LEVEL 26
#define WORM_GROW_FACTOR 4
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GAME_STATUS_GAMEOVER,
	GAME_STATUS_VICTORY,
	GAME_STATUS_NEWROUND
} GameStatus;

#define TYPE_GAME_STATUS (game_status_get_type ())

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef struct _NibblesGamePrivate NibblesGamePrivate;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
enum  {
	NIBBLES_GAME_0_PROPERTY,
	NIBBLES_GAME_SKIP_SCORE_PROPERTY,
	NIBBLES_GAME_CURRENT_LEVEL_PROPERTY,
	NIBBLES_GAME_SPEED_PROPERTY,
	NIBBLES_GAME_GAMEDELAY_PROPERTY,
	NIBBLES_GAME_WIDTH_PROPERTY,
	NIBBLES_GAME_HEIGHT_PROPERTY,
	NIBBLES_GAME_NUMHUMANS_PROPERTY,
	NIBBLES_GAME_NUMAI_PROPERTY,
	NIBBLES_GAME_NUMWORMS_PROPERTY,
	NIBBLES_GAME_WORMS_PROPERTY,
	NIBBLES_GAME_WORM_PROPS_PROPERTY,
	NIBBLES_GAME_IS_RUNNING_PROPERTY,
	NIBBLES_GAME_IS_PAUSED_PROPERTY,
	NIBBLES_GAME_FAKES_PROPERTY,
	NIBBLES_GAME_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_properties[NIBBLES_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef struct _WormPrivate WormPrivate;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
enum  {
	NIBBLES_GAME_BONUS_APPLIED_SIGNAL,
	NIBBLES_GAME_LOG_SCORE_SIGNAL,
	NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL,
	NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL,
	NIBBLES_GAME_WARP_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_NUM_SIGNALS
};
static guint nibbles_game_signals[NIBBLES_GAME_NUM_SIGNALS] = {0};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint* board;
	gint board_length1;
	gint board_length2;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _NibblesGamePrivate {
	gboolean _skip_score;
	gint _current_level;
	gint _speed;
	gint _gamedelay;
	guint8 _width;
	guint8 _height;
	gint _numhumans;
	gint _numai;
	gint _numworms;
	GeeLinkedList* _worms;
	GeeHashMap* _worm_props;
	Boni* boni;
	WarpManager* warp_manager;
	gboolean _is_running;
	gboolean _is_paused;
	guint main_id;
	gboolean _fakes;
	guint8 bonus_cycle;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gboolean is_stopped;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _Position {
	guint8 x;
	guint8 y;
};

static gint NibblesGame_private_offset;
static gpointer nibbles_game_parent_class = NULL;

VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
VALA_EXTERN gboolean nibbles_game_load_board (NibblesGame* self,
                                  gchar** future_board,
                                  gint future_board_length1,
                                  guint8 regular_bonus);
VALA_EXTERN guint8 nibbles_game_get_height (NibblesGame* self);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN guint8 nibbles_game_get_width (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
static void nibbles_game_add_bonus (NibblesGame* self,
                             gboolean regular);
static void nibbles_game_set_is_running (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_gamedelay (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
static gboolean __lambda5_ (NibblesGame* self);
static gboolean nibbles_game_main_loop_cb (NibblesGame* self);
static gboolean ___lambda5__gsource_func (gpointer self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
VALA_EXTERN void nibbles_game_pause (NibblesGame* self);
static void nibbles_game_set_is_paused (NibblesGame* self,
                                 gboolean value);
VALA_EXTERN void nibbles_game_unpause (NibblesGame* self);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
VALA_EXTERN void nibbles_game_set_skip_score (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN void nibbles_game_set_current_level (NibblesGame* self,
                                     gint value);
static void nibbles_game_end (NibblesGame* self);
VALA_EXTERN GameStatus* nibbles_game_get_game_status (NibblesGame* self);
static gboolean _game_status_equal (const GameStatus * s1,
                             const GameStatus * s2);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN Worm* nibbles_game_get_winner (NibblesGame* self);
static void nibbles_game_move_worms (NibblesGame* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numai (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_game_set_numworms (NibblesGame* self,
                                gint value);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height);
static void nibbles_game_bonus_found_cb (NibblesGame* self,
                                  Worm* worm);
static void _nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                                    gpointer self);
static void nibbles_game_worm_dematerialization_request (NibblesGame* self,
                                                  Worm* worm);
static void _nibbles_game_worm_dematerialization_request_worm_finish_added (Worm* _sender,
                                                                     gpointer self);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         guint8* missed_bonuses_to_replace);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN GeeLinkedList* worm_get_list (Worm* self);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   gint numworms,
                   GeeLinkedList* worms);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           gint numworms,
                           Position* position);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void nibbles_game_reverse_worms (NibblesGame* self,
                                 Worm* worm);
VALA_EXTERN void worm_reverse (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint rounds,
                         gint gamedelay);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
static inline void _nibbles_game_add_bonus (NibblesGame* self,
                              guint8 x,
                              guint8 y,
                              BonusType bonus_type,
                              gboolean fake,
                              guint16 countdown);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         Bonus* bonus);
static void nibbles_game_apply_bonus (NibblesGame* self,
                               Bonus* bonus,
                               Worm* worm);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN gint worm_get_length (Worm* self);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       gint erase_size);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       guint8 x,
                       guint8 y);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        gint* board,
                        gint board_length1,
                        gint board_length2,
                        Bonus* bonus);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
static GameStatus* _game_status_dup (GameStatus* self);
VALA_EXTERN void nibbles_game_load_worm_properties (NibblesGame* self,
                                        GeeArrayList* worm_settings);
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_get_id (Worm* self);
static gboolean ____lambda6_ (GValue* prop_value,
                       GVariant* variant);
static inline gint nibbles_game_get_color_num (const gchar* color);
static gboolean _____lambda6__gsettings_bind_get_mapping (GValue* value,
                                                   GVariant* variant,
                                                   void* user_data);
static GVariant* ____lambda7_ (GValue* prop_value,
                        const GVariantType* variant_type);
static inline gchar* nibbles_game_get_color_string (gint color);
static GVariant* _____lambda7__gsettings_bind_set_mapping (GValue* value,
                                                    const GVariantType* expected_type,
                                                    void* user_data);
VALA_EXTERN gboolean nibbles_game_handle_keypress (NibblesGame* self,
                                       guint keyval);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keyval,
                               GeeHashMap* worm_props);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
static void nibbles_game_set_gamedelay (NibblesGame* self,
                                 gint value);
static void nibbles_game_set_width (NibblesGame* self,
                             guint8 value);
static void nibbles_game_set_height (NibblesGame* self,
                              guint8 value);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
VALA_EXTERN gboolean nibbles_game_get_is_paused (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * nibbles_game_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _nibbles_game___lambda8_ (NibblesGame* self,
                               Bonus* bonus);
static void __nibbles_game___lambda8__boni_bonus_removed (Boni* _sender,
                                                   Bonus* bonus,
                                                   gpointer self);
static void nibbles_game_finalize (GObject * obj);
static GType nibbles_game_get_type_once (void);
static void _vala_nibbles_game_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_nibbles_game_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static GType
game_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATUS_GAMEOVER, "GAME_STATUS_GAMEOVER", "gameover"}, {GAME_STATUS_VICTORY, "GAME_STATUS_VICTORY", "victory"}, {GAME_STATUS_NEWROUND, "GAME_STATUS_NEWROUND", "newround"}, {0, NULL, NULL}};
	GType game_status_type_id;
	game_status_type_id = g_enum_register_static ("GameStatus", values);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static volatile gsize game_status_type_id__once = 0;
	if (g_once_init_enter (&game_status_type_id__once)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__once, game_status_type_id);
	}
	return game_status_type_id__once;
}

static inline gpointer
nibbles_game_get_instance_private (NibblesGame* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGame_private_offset);
}

NibblesGame*
nibbles_game_construct (GType object_type,
                        gint start_level,
                        gint speed,
                        gint gamedelay,
                        gboolean fakes,
                        guint8 width,
                        guint8 height,
                        gboolean no_random)
{
	NibblesGame * self = NULL;
	guint32 _tmp0_ = 0U;
#line 89 "../src/nibbles-game.vala"
	self = (NibblesGame*) g_object_new (object_type, "skip-score", start_level != 1, "current-level", start_level, "speed", speed, "gamedelay", gamedelay, "fakes", fakes, "width", width, "height", height, NULL);
#line 91 "../src/nibbles-game.vala"
	if (no_random) {
#line 91 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) 42;
#line 570 "nibbles-game.c"
	} else {
		time_t _tmp1_;
#line 91 "../src/nibbles-game.vala"
		_tmp1_ = time (NULL);
#line 91 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) _tmp1_;
#line 577 "nibbles-game.c"
	}
#line 91 "../src/nibbles-game.vala"
	g_random_set_seed (_tmp0_);
#line 87 "../src/nibbles-game.vala"
	return self;
#line 583 "nibbles-game.c"
}

NibblesGame*
nibbles_game_new (gint start_level,
                  gint speed,
                  gint gamedelay,
                  gboolean fakes,
                  guint8 width,
                  guint8 height,
                  gboolean no_random)
{
#line 87 "../src/nibbles-game.vala"
	return nibbles_game_construct (TYPE_NIBBLES_GAME, start_level, speed, gamedelay, fakes, width, height, no_random);
#line 597 "nibbles-game.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 611 "nibbles-game.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result;
#line 1290 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1291 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1291 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1291 "glib-2.0.vapi"
	return result;
#line 628 "nibbles-game.c"
}

gboolean
nibbles_game_load_board (NibblesGame* self,
                         gchar** future_board,
                         gint future_board_length1,
                         guint8 regular_bonus)
{
	guint8 _tmp0_;
	Boni* _tmp1_;
	WarpManager* _tmp2_;
	gchar* tmpboard = NULL;
	gint count = 0;
	gboolean result;
#line 94 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_height;
#line 96 "../src/nibbles-game.vala"
	if (future_board_length1 != ((gint) _tmp0_)) {
#line 97 "../src/nibbles-game.vala"
		result = FALSE;
#line 97 "../src/nibbles-game.vala"
		return result;
#line 653 "nibbles-game.c"
	}
#line 99 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 99 "../src/nibbles-game.vala"
	boni_reset (_tmp1_, regular_bonus);
#line 100 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->warp_manager;
#line 100 "../src/nibbles-game.vala"
	warp_manager_clear_warps (_tmp2_);
#line 103 "../src/nibbles-game.vala"
	count = 0;
#line 665 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 104 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 670 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 104 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 104 "../src/nibbles-game.vala"
			while (TRUE) {
#line 677 "nibbles-game.c"
				guint8 _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint8 _tmp9_;
#line 104 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 685 "nibbles-game.c"
					guint8 _tmp4_;
#line 104 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 104 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 691 "nibbles-game.c"
				}
#line 104 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 104 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_height;
#line 104 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 104 "../src/nibbles-game.vala"
					break;
#line 701 "nibbles-game.c"
				}
#line 106 "../src/nibbles-game.vala"
				_tmp6_ = future_board[i];
#line 106 "../src/nibbles-game.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 106 "../src/nibbles-game.vala"
				_g_free0 (tmpboard);
#line 106 "../src/nibbles-game.vala"
				tmpboard = _tmp7_;
#line 107 "../src/nibbles-game.vala"
				_tmp8_ = tmpboard;
#line 107 "../src/nibbles-game.vala"
				_tmp9_ = self->priv->_width;
#line 107 "../src/nibbles-game.vala"
				if (g_utf8_strlen (_tmp8_, (gssize) -1) != ((gint) _tmp9_)) {
#line 108 "../src/nibbles-game.vala"
					result = FALSE;
#line 108 "../src/nibbles-game.vala"
					_g_free0 (tmpboard);
#line 108 "../src/nibbles-game.vala"
					return result;
#line 723 "nibbles-game.c"
				}
				{
					guint8 j = 0U;
#line 109 "../src/nibbles-game.vala"
					j = (guint8) 0;
#line 729 "nibbles-game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 109 "../src/nibbles-game.vala"
						_tmp10_ = TRUE;
#line 109 "../src/nibbles-game.vala"
						while (TRUE) {
#line 736 "nibbles-game.c"
							guint8 _tmp12_;
							gunichar char_value = 0U;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 109 "../src/nibbles-game.vala"
							if (!_tmp10_) {
#line 743 "nibbles-game.c"
								guint8 _tmp11_;
#line 109 "../src/nibbles-game.vala"
								_tmp11_ = j;
#line 109 "../src/nibbles-game.vala"
								j = _tmp11_ + 1;
#line 749 "nibbles-game.c"
							}
#line 109 "../src/nibbles-game.vala"
							_tmp10_ = FALSE;
#line 109 "../src/nibbles-game.vala"
							_tmp12_ = self->priv->_width;
#line 109 "../src/nibbles-game.vala"
							if (!(j < _tmp12_)) {
#line 109 "../src/nibbles-game.vala"
								break;
#line 759 "nibbles-game.c"
							}
#line 111 "../src/nibbles-game.vala"
							_tmp13_ = tmpboard;
#line 111 "../src/nibbles-game.vala"
							_tmp14_ = tmpboard;
#line 111 "../src/nibbles-game.vala"
							char_value = string_get_char (_tmp13_, (glong) string_index_of_nth_char (_tmp14_, (glong) j));
#line 112 "../src/nibbles-game.vala"
							switch (char_value) {
#line 112 "../src/nibbles-game.vala"
								case '.':
#line 112 "../src/nibbles-game.vala"
								case '+':
#line 773 "nibbles-game.c"
								{
									gint* _tmp15_;
									gint _tmp15__length1;
									gint _tmp15__length2;
#line 117 "../src/nibbles-game.vala"
									_tmp15_ = self->board;
#line 117 "../src/nibbles-game.vala"
									_tmp15__length1 = self->board_length1;
#line 117 "../src/nibbles-game.vala"
									_tmp15__length2 = self->board_length2;
#line 117 "../src/nibbles-game.vala"
									_tmp15_[(j * _tmp15__length2) + i] = (gint) 'a';
#line 118 "../src/nibbles-game.vala"
									break;
#line 788 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9475U:
#line 792 "nibbles-game.c"
								{
									gint* _tmp16_;
									gint _tmp16__length1;
									gint _tmp16__length2;
#line 122 "../src/nibbles-game.vala"
									_tmp16_ = self->board;
#line 122 "../src/nibbles-game.vala"
									_tmp16__length1 = self->board_length1;
#line 122 "../src/nibbles-game.vala"
									_tmp16__length2 = self->board_length2;
#line 122 "../src/nibbles-game.vala"
									_tmp16_[(j * _tmp16__length2) + i] = (gint) 'b';
#line 123 "../src/nibbles-game.vala"
									break;
#line 807 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9473U:
#line 811 "nibbles-game.c"
								{
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
#line 125 "../src/nibbles-game.vala"
									_tmp17_ = self->board;
#line 125 "../src/nibbles-game.vala"
									_tmp17__length1 = self->board_length1;
#line 125 "../src/nibbles-game.vala"
									_tmp17__length2 = self->board_length2;
#line 125 "../src/nibbles-game.vala"
									_tmp17_[(j * _tmp17__length2) + i] = (gint) 'c';
#line 126 "../src/nibbles-game.vala"
									break;
#line 826 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9495U:
#line 830 "nibbles-game.c"
								{
									gint* _tmp18_;
									gint _tmp18__length1;
									gint _tmp18__length2;
#line 128 "../src/nibbles-game.vala"
									_tmp18_ = self->board;
#line 128 "../src/nibbles-game.vala"
									_tmp18__length1 = self->board_length1;
#line 128 "../src/nibbles-game.vala"
									_tmp18__length2 = self->board_length2;
#line 128 "../src/nibbles-game.vala"
									_tmp18_[(j * _tmp18__length2) + i] = (gint) 'd';
#line 129 "../src/nibbles-game.vala"
									break;
#line 845 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9499U:
#line 849 "nibbles-game.c"
								{
									gint* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
#line 131 "../src/nibbles-game.vala"
									_tmp19_ = self->board;
#line 131 "../src/nibbles-game.vala"
									_tmp19__length1 = self->board_length1;
#line 131 "../src/nibbles-game.vala"
									_tmp19__length2 = self->board_length2;
#line 131 "../src/nibbles-game.vala"
									_tmp19_[(j * _tmp19__length2) + i] = (gint) 'e';
#line 132 "../src/nibbles-game.vala"
									break;
#line 864 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9487U:
#line 868 "nibbles-game.c"
								{
									gint* _tmp20_;
									gint _tmp20__length1;
									gint _tmp20__length2;
#line 134 "../src/nibbles-game.vala"
									_tmp20_ = self->board;
#line 134 "../src/nibbles-game.vala"
									_tmp20__length1 = self->board_length1;
#line 134 "../src/nibbles-game.vala"
									_tmp20__length2 = self->board_length2;
#line 134 "../src/nibbles-game.vala"
									_tmp20_[(j * _tmp20__length2) + i] = (gint) 'f';
#line 135 "../src/nibbles-game.vala"
									break;
#line 883 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9491U:
#line 887 "nibbles-game.c"
								{
									gint* _tmp21_;
									gint _tmp21__length1;
									gint _tmp21__length2;
#line 137 "../src/nibbles-game.vala"
									_tmp21_ = self->board;
#line 137 "../src/nibbles-game.vala"
									_tmp21__length1 = self->board_length1;
#line 137 "../src/nibbles-game.vala"
									_tmp21__length2 = self->board_length2;
#line 137 "../src/nibbles-game.vala"
									_tmp21_[(j * _tmp21__length2) + i] = (gint) 'g';
#line 138 "../src/nibbles-game.vala"
									break;
#line 902 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9531U:
#line 906 "nibbles-game.c"
								{
									gint* _tmp22_;
									gint _tmp22__length1;
									gint _tmp22__length2;
#line 140 "../src/nibbles-game.vala"
									_tmp22_ = self->board;
#line 140 "../src/nibbles-game.vala"
									_tmp22__length1 = self->board_length1;
#line 140 "../src/nibbles-game.vala"
									_tmp22__length2 = self->board_length2;
#line 140 "../src/nibbles-game.vala"
									_tmp22_[(j * _tmp22__length2) + i] = (gint) 'h';
#line 141 "../src/nibbles-game.vala"
									break;
#line 921 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9507U:
#line 925 "nibbles-game.c"
								{
									gint* _tmp23_;
									gint _tmp23__length1;
									gint _tmp23__length2;
#line 143 "../src/nibbles-game.vala"
									_tmp23_ = self->board;
#line 143 "../src/nibbles-game.vala"
									_tmp23__length1 = self->board_length1;
#line 143 "../src/nibbles-game.vala"
									_tmp23__length2 = self->board_length2;
#line 143 "../src/nibbles-game.vala"
									_tmp23_[(j * _tmp23__length2) + i] = (gint) 'i';
#line 144 "../src/nibbles-game.vala"
									break;
#line 940 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9515U:
#line 944 "nibbles-game.c"
								{
									gint* _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
#line 146 "../src/nibbles-game.vala"
									_tmp24_ = self->board;
#line 146 "../src/nibbles-game.vala"
									_tmp24__length1 = self->board_length1;
#line 146 "../src/nibbles-game.vala"
									_tmp24__length2 = self->board_length2;
#line 146 "../src/nibbles-game.vala"
									_tmp24_[(j * _tmp24__length2) + i] = (gint) 'j';
#line 147 "../src/nibbles-game.vala"
									break;
#line 959 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9523U:
#line 963 "nibbles-game.c"
								{
									gint* _tmp25_;
									gint _tmp25__length1;
									gint _tmp25__length2;
#line 149 "../src/nibbles-game.vala"
									_tmp25_ = self->board;
#line 149 "../src/nibbles-game.vala"
									_tmp25__length1 = self->board_length1;
#line 149 "../src/nibbles-game.vala"
									_tmp25__length2 = self->board_length2;
#line 149 "../src/nibbles-game.vala"
									_tmp25_[(j * _tmp25__length2) + i] = (gint) 'k';
#line 150 "../src/nibbles-game.vala"
									break;
#line 978 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9547U:
#line 982 "nibbles-game.c"
								{
									gint* _tmp26_;
									gint _tmp26__length1;
									gint _tmp26__length2;
#line 152 "../src/nibbles-game.vala"
									_tmp26_ = self->board;
#line 152 "../src/nibbles-game.vala"
									_tmp26__length1 = self->board_length1;
#line 152 "../src/nibbles-game.vala"
									_tmp26__length2 = self->board_length2;
#line 152 "../src/nibbles-game.vala"
									_tmp26_[(j * _tmp26__length2) + i] = (gint) 'l';
#line 153 "../src/nibbles-game.vala"
									break;
#line 997 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9650U:
#line 112 "../src/nibbles-game.vala"
								case 'm':
#line 1003 "nibbles-game.c"
								{
									gint* _tmp27_;
									gint _tmp27__length1;
									gint _tmp27__length2;
									gint _tmp28_;
#line 158 "../src/nibbles-game.vala"
									_tmp27_ = self->board;
#line 158 "../src/nibbles-game.vala"
									_tmp27__length1 = self->board_length1;
#line 158 "../src/nibbles-game.vala"
									_tmp27__length2 = self->board_length2;
#line 158 "../src/nibbles-game.vala"
									_tmp27_[(j * _tmp27__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 159 "../src/nibbles-game.vala"
									_tmp28_ = self->priv->_numworms;
#line 159 "../src/nibbles-game.vala"
									if (count < _tmp28_) {
#line 1021 "nibbles-game.c"
										GeeLinkedList* _tmp29_;
										gpointer _tmp30_;
										Worm* _tmp31_;
										gint _tmp32_;
#line 161 "../src/nibbles-game.vala"
										_tmp29_ = self->priv->_worms;
#line 161 "../src/nibbles-game.vala"
										_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, count);
#line 161 "../src/nibbles-game.vala"
										_tmp31_ = (Worm*) _tmp30_;
#line 161 "../src/nibbles-game.vala"
										worm_set_start (_tmp31_, j, i, WORM_DIRECTION_UP);
#line 161 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp31_);
#line 162 "../src/nibbles-game.vala"
										_tmp32_ = count;
#line 162 "../src/nibbles-game.vala"
										count = _tmp32_ + 1;
#line 1040 "nibbles-game.c"
									}
#line 164 "../src/nibbles-game.vala"
									break;
#line 1044 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9664U:
#line 112 "../src/nibbles-game.vala"
								case 'n':
#line 1050 "nibbles-game.c"
								{
									gint* _tmp33_;
									gint _tmp33__length1;
									gint _tmp33__length2;
									gint _tmp34_;
#line 167 "../src/nibbles-game.vala"
									_tmp33_ = self->board;
#line 167 "../src/nibbles-game.vala"
									_tmp33__length1 = self->board_length1;
#line 167 "../src/nibbles-game.vala"
									_tmp33__length2 = self->board_length2;
#line 167 "../src/nibbles-game.vala"
									_tmp33_[(j * _tmp33__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 168 "../src/nibbles-game.vala"
									_tmp34_ = self->priv->_numworms;
#line 168 "../src/nibbles-game.vala"
									if (count < _tmp34_) {
#line 1068 "nibbles-game.c"
										GeeLinkedList* _tmp35_;
										gpointer _tmp36_;
										Worm* _tmp37_;
										gint _tmp38_;
#line 170 "../src/nibbles-game.vala"
										_tmp35_ = self->priv->_worms;
#line 170 "../src/nibbles-game.vala"
										_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, count);
#line 170 "../src/nibbles-game.vala"
										_tmp37_ = (Worm*) _tmp36_;
#line 170 "../src/nibbles-game.vala"
										worm_set_start (_tmp37_, j, i, WORM_DIRECTION_LEFT);
#line 170 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp37_);
#line 171 "../src/nibbles-game.vala"
										_tmp38_ = count;
#line 171 "../src/nibbles-game.vala"
										count = _tmp38_ + 1;
#line 1087 "nibbles-game.c"
									}
#line 173 "../src/nibbles-game.vala"
									break;
#line 1091 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9660U:
#line 112 "../src/nibbles-game.vala"
								case 'o':
#line 1097 "nibbles-game.c"
								{
									gint* _tmp39_;
									gint _tmp39__length1;
									gint _tmp39__length2;
									gint _tmp40_;
#line 176 "../src/nibbles-game.vala"
									_tmp39_ = self->board;
#line 176 "../src/nibbles-game.vala"
									_tmp39__length1 = self->board_length1;
#line 176 "../src/nibbles-game.vala"
									_tmp39__length2 = self->board_length2;
#line 176 "../src/nibbles-game.vala"
									_tmp39_[(j * _tmp39__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 177 "../src/nibbles-game.vala"
									_tmp40_ = self->priv->_numworms;
#line 177 "../src/nibbles-game.vala"
									if (count < _tmp40_) {
#line 1115 "nibbles-game.c"
										GeeLinkedList* _tmp41_;
										gpointer _tmp42_;
										Worm* _tmp43_;
										gint _tmp44_;
#line 179 "../src/nibbles-game.vala"
										_tmp41_ = self->priv->_worms;
#line 179 "../src/nibbles-game.vala"
										_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, count);
#line 179 "../src/nibbles-game.vala"
										_tmp43_ = (Worm*) _tmp42_;
#line 179 "../src/nibbles-game.vala"
										worm_set_start (_tmp43_, j, i, WORM_DIRECTION_DOWN);
#line 179 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp43_);
#line 180 "../src/nibbles-game.vala"
										_tmp44_ = count;
#line 180 "../src/nibbles-game.vala"
										count = _tmp44_ + 1;
#line 1134 "nibbles-game.c"
									}
#line 182 "../src/nibbles-game.vala"
									break;
#line 1138 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 9654U:
#line 112 "../src/nibbles-game.vala"
								case 'p':
#line 1144 "nibbles-game.c"
								{
									gint* _tmp45_;
									gint _tmp45__length1;
									gint _tmp45__length2;
									gint _tmp46_;
#line 185 "../src/nibbles-game.vala"
									_tmp45_ = self->board;
#line 185 "../src/nibbles-game.vala"
									_tmp45__length1 = self->board_length1;
#line 185 "../src/nibbles-game.vala"
									_tmp45__length2 = self->board_length2;
#line 185 "../src/nibbles-game.vala"
									_tmp45_[(j * _tmp45__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 186 "../src/nibbles-game.vala"
									_tmp46_ = self->priv->_numworms;
#line 186 "../src/nibbles-game.vala"
									if (count < _tmp46_) {
#line 1162 "nibbles-game.c"
										GeeLinkedList* _tmp47_;
										gpointer _tmp48_;
										Worm* _tmp49_;
										gint _tmp50_;
#line 188 "../src/nibbles-game.vala"
										_tmp47_ = self->priv->_worms;
#line 188 "../src/nibbles-game.vala"
										_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, count);
#line 188 "../src/nibbles-game.vala"
										_tmp49_ = (Worm*) _tmp48_;
#line 188 "../src/nibbles-game.vala"
										worm_set_start (_tmp49_, j, i, WORM_DIRECTION_RIGHT);
#line 188 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp49_);
#line 189 "../src/nibbles-game.vala"
										_tmp50_ = count;
#line 189 "../src/nibbles-game.vala"
										count = _tmp50_ + 1;
#line 1181 "nibbles-game.c"
									}
#line 191 "../src/nibbles-game.vala"
									break;
#line 1185 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 'Q':
#line 112 "../src/nibbles-game.vala"
								case 'R':
#line 112 "../src/nibbles-game.vala"
								case 'S':
#line 112 "../src/nibbles-game.vala"
								case 'T':
#line 112 "../src/nibbles-game.vala"
								case 'U':
#line 112 "../src/nibbles-game.vala"
								case 'V':
#line 112 "../src/nibbles-game.vala"
								case 'W':
#line 112 "../src/nibbles-game.vala"
								case 'X':
#line 112 "../src/nibbles-game.vala"
								case 'Y':
#line 112 "../src/nibbles-game.vala"
								case 'Z':
#line 1207 "nibbles-game.c"
								{
									gboolean _tmp51_ = FALSE;
									gint* _tmp52_;
									gint _tmp52__length1;
									gint _tmp52__length2;
									WarpManager* _tmp53_;
									gint* _tmp54_;
									gint _tmp54__length1;
									gint _tmp54__length2;
									gint _tmp55_;
									gint* _tmp56_;
									gint _tmp56__length1;
									gint _tmp56__length2;
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint* _tmp58_;
									gint _tmp58__length1;
									gint _tmp58__length2;
									gint* _tmp59_;
									gint _tmp59__length1;
									gint _tmp59__length2;
#line 204 "../src/nibbles-game.vala"
									if (((gint) j) == 0) {
#line 204 "../src/nibbles-game.vala"
										_tmp51_ = TRUE;
#line 1234 "nibbles-game.c"
									} else {
#line 204 "../src/nibbles-game.vala"
										_tmp51_ = ((gint) i) == 0;
#line 1238 "nibbles-game.c"
									}
#line 204 "../src/nibbles-game.vala"
									if (_tmp51_) {
#line 205 "../src/nibbles-game.vala"
										result = FALSE;
#line 205 "../src/nibbles-game.vala"
										_g_free0 (tmpboard);
#line 205 "../src/nibbles-game.vala"
										return result;
#line 1248 "nibbles-game.c"
									}
#line 207 "../src/nibbles-game.vala"
									_tmp52_ = self->board;
#line 207 "../src/nibbles-game.vala"
									_tmp52__length1 = self->board_length1;
#line 207 "../src/nibbles-game.vala"
									_tmp52__length2 = self->board_length2;
#line 207 "../src/nibbles-game.vala"
									_tmp52_[(j * _tmp52__length2) + i] = (gint) char_value;
#line 208 "../src/nibbles-game.vala"
									_tmp53_ = self->priv->warp_manager;
#line 208 "../src/nibbles-game.vala"
									_tmp54_ = self->board;
#line 208 "../src/nibbles-game.vala"
									_tmp54__length1 = self->board_length1;
#line 208 "../src/nibbles-game.vala"
									_tmp54__length2 = self->board_length2;
#line 208 "../src/nibbles-game.vala"
									_tmp55_ = _tmp54_[(j * _tmp54__length2) + i];
#line 208 "../src/nibbles-game.vala"
									warp_manager_add_warp_source (_tmp53_, _tmp55_, (guint8) (j - 1), (guint8) (i - 1));
#line 210 "../src/nibbles-game.vala"
									_tmp56_ = self->board;
#line 210 "../src/nibbles-game.vala"
									_tmp56__length1 = self->board_length1;
#line 210 "../src/nibbles-game.vala"
									_tmp56__length2 = self->board_length2;
#line 210 "../src/nibbles-game.vala"
									_tmp56_[((j - 1) * _tmp56__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 211 "../src/nibbles-game.vala"
									_tmp57_ = self->board;
#line 211 "../src/nibbles-game.vala"
									_tmp57__length1 = self->board_length1;
#line 211 "../src/nibbles-game.vala"
									_tmp57__length2 = self->board_length2;
#line 211 "../src/nibbles-game.vala"
									_tmp57_[(j * _tmp57__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 212 "../src/nibbles-game.vala"
									_tmp58_ = self->board;
#line 212 "../src/nibbles-game.vala"
									_tmp58__length1 = self->board_length1;
#line 212 "../src/nibbles-game.vala"
									_tmp58__length2 = self->board_length2;
#line 212 "../src/nibbles-game.vala"
									_tmp58_[((j - 1) * _tmp58__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 213 "../src/nibbles-game.vala"
									_tmp59_ = self->board;
#line 213 "../src/nibbles-game.vala"
									_tmp59__length1 = self->board_length1;
#line 213 "../src/nibbles-game.vala"
									_tmp59__length2 = self->board_length2;
#line 213 "../src/nibbles-game.vala"
									_tmp59_[(j * _tmp59__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 215 "../src/nibbles-game.vala"
									g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL], 0, (guint8) (j - 1), (guint8) (i - 1));
#line 216 "../src/nibbles-game.vala"
									break;
#line 1306 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 'r':
#line 112 "../src/nibbles-game.vala"
								case 's':
#line 112 "../src/nibbles-game.vala"
								case 't':
#line 112 "../src/nibbles-game.vala"
								case 'u':
#line 112 "../src/nibbles-game.vala"
								case 'v':
#line 112 "../src/nibbles-game.vala"
								case 'w':
#line 112 "../src/nibbles-game.vala"
								case 'x':
#line 112 "../src/nibbles-game.vala"
								case 'y':
#line 112 "../src/nibbles-game.vala"
								case 'z':
#line 1326 "nibbles-game.c"
								{
									WarpManager* _tmp60_;
									gint* _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
#line 228 "../src/nibbles-game.vala"
									_tmp60_ = self->priv->warp_manager;
#line 228 "../src/nibbles-game.vala"
									warp_manager_add_warp_target (_tmp60_, (((gint) char_value) - ((gint) 'a')) + ((gint) 'A'), j, i);
#line 229 "../src/nibbles-game.vala"
									_tmp61_ = self->board;
#line 229 "../src/nibbles-game.vala"
									_tmp61__length1 = self->board_length1;
#line 229 "../src/nibbles-game.vala"
									_tmp61__length2 = self->board_length2;
#line 229 "../src/nibbles-game.vala"
									_tmp61_[(j * _tmp61__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 230 "../src/nibbles-game.vala"
									break;
#line 1346 "nibbles-game.c"
								}
#line 112 "../src/nibbles-game.vala"
								case 'a':
#line 112 "../src/nibbles-game.vala"
								case 'b':
#line 112 "../src/nibbles-game.vala"
								case 'c':
#line 112 "../src/nibbles-game.vala"
								case 'd':
#line 112 "../src/nibbles-game.vala"
								case 'e':
#line 112 "../src/nibbles-game.vala"
								case 'f':
#line 112 "../src/nibbles-game.vala"
								case 'g':
#line 112 "../src/nibbles-game.vala"
								case 'h':
#line 112 "../src/nibbles-game.vala"
								case 'i':
#line 112 "../src/nibbles-game.vala"
								case 'j':
#line 112 "../src/nibbles-game.vala"
								case 'k':
#line 112 "../src/nibbles-game.vala"
								case 'l':
#line 1372 "nibbles-game.c"
								{
									gint* _tmp62_;
									gint _tmp62__length1;
									gint _tmp62__length2;
#line 245 "../src/nibbles-game.vala"
									_tmp62_ = self->board;
#line 245 "../src/nibbles-game.vala"
									_tmp62__length1 = self->board_length1;
#line 245 "../src/nibbles-game.vala"
									_tmp62__length2 = self->board_length2;
#line 245 "../src/nibbles-game.vala"
									_tmp62_[(j * _tmp62__length2) + i] = (gint) char_value;
#line 246 "../src/nibbles-game.vala"
									break;
#line 1387 "nibbles-game.c"
								}
								default:
								{
#line 249 "../src/nibbles-game.vala"
									result = FALSE;
#line 249 "../src/nibbles-game.vala"
									_g_free0 (tmpboard);
#line 249 "../src/nibbles-game.vala"
									return result;
#line 1397 "nibbles-game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 253 "../src/nibbles-game.vala"
	result = TRUE;
#line 253 "../src/nibbles-game.vala"
	_g_free0 (tmpboard);
#line 253 "../src/nibbles-game.vala"
	return result;
#line 1412 "nibbles-game.c"
}

static gboolean
__lambda5_ (NibblesGame* self)
{
	gboolean result;
#line 269 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) ((self->priv->bonus_cycle + 1) % 3);
#line 270 "../src/nibbles-game.vala"
	if (((gint) self->priv->bonus_cycle) == 0) {
#line 271 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, FALSE);
#line 1425 "nibbles-game.c"
	}
#line 272 "../src/nibbles-game.vala"
	result = nibbles_game_main_loop_cb (self);
#line 272 "../src/nibbles-game.vala"
	return result;
#line 1431 "nibbles-game.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((NibblesGame*) self);
#line 268 "../src/nibbles-game.vala"
	return result;
#line 1441 "nibbles-game.c"
}

void
nibbles_game_start (NibblesGame* self,
                    gboolean add_initial_bonus)
{
	gint _tmp0_;
	gint _tmp1_;
#line 261 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/nibbles-game.vala"
	if (add_initial_bonus) {
#line 264 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 1456 "nibbles-game.c"
	}
#line 266 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, TRUE);
#line 268 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_gamedelay;
#line 268 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_speed;
#line 268 "../src/nibbles-game.vala"
	self->priv->main_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_tmp0_ * _tmp1_), ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 274 "../src/nibbles-game.vala"
	g_source_set_name_by_id (self->priv->main_id, "[Nibbles] main_loop_cb");
#line 1468 "nibbles-game.c"
}

void
nibbles_game_stop (NibblesGame* self)
{
#line 277 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, FALSE);
#line 281 "../src/nibbles-game.vala"
	if (self->priv->main_id == ((guint) 0)) {
#line 282 "../src/nibbles-game.vala"
		return;
#line 1482 "nibbles-game.c"
	}
#line 283 "../src/nibbles-game.vala"
	g_source_remove (self->priv->main_id);
#line 284 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 1488 "nibbles-game.c"
}

void
nibbles_game_pause (NibblesGame* self)
{
#line 287 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, TRUE);
#line 290 "../src/nibbles-game.vala"
	nibbles_game_stop (self);
#line 1500 "nibbles-game.c"
}

void
nibbles_game_unpause (NibblesGame* self)
{
#line 293 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, FALSE);
#line 296 "../src/nibbles-game.vala"
	nibbles_game_start (self, FALSE);
#line 1512 "nibbles-game.c"
}

inline void
nibbles_game_reset (NibblesGame* self,
                    gint start_level)
{
#line 299 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/nibbles-game.vala"
	nibbles_game_set_skip_score (self, start_level != 1);
#line 302 "../src/nibbles-game.vala"
	nibbles_game_set_current_level (self, start_level);
#line 303 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, FALSE);
#line 1527 "nibbles-game.c"
}

static void
nibbles_game_end (NibblesGame* self)
{
#line 306 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/nibbles-game.vala"
	nibbles_game_stop (self);
#line 309 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 1539 "nibbles-game.c"
}

static gboolean
_game_status_equal (const GameStatus * s1,
                    const GameStatus * s2)
{
#line 316 "../src/nibbles-game.vala"
	if (s1 == s2) {
#line 316 "../src/nibbles-game.vala"
		return TRUE;
#line 1550 "nibbles-game.c"
	}
#line 316 "../src/nibbles-game.vala"
	if (s1 == NULL) {
#line 316 "../src/nibbles-game.vala"
		return FALSE;
#line 1556 "nibbles-game.c"
	}
#line 316 "../src/nibbles-game.vala"
	if (s2 == NULL) {
#line 316 "../src/nibbles-game.vala"
		return FALSE;
#line 1562 "nibbles-game.c"
	}
#line 316 "../src/nibbles-game.vala"
	return (*s1) == (*s2);
#line 1566 "nibbles-game.c"
}

static gboolean
nibbles_game_main_loop_cb (NibblesGame* self)
{
	GameStatus* status = NULL;
	GameStatus* _tmp0_;
	GameStatus* _tmp1_;
	GameStatus _tmp2_;
	gboolean result;
#line 312 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 314 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_game_status (self);
#line 314 "../src/nibbles-game.vala"
	status = _tmp0_;
#line 316 "../src/nibbles-game.vala"
	_tmp1_ = status;
#line 316 "../src/nibbles-game.vala"
	_tmp2_ = GAME_STATUS_GAMEOVER;
#line 316 "../src/nibbles-game.vala"
	if (_game_status_equal (_tmp1_, &_tmp2_) == TRUE) {
#line 1589 "nibbles-game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 318 "../src/nibbles-game.vala"
		nibbles_game_end (self);
#line 320 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 320 "../src/nibbles-game.vala"
		_tmp4_ = gee_linked_list_first (_tmp3_);
#line 320 "../src/nibbles-game.vala"
		_tmp5_ = (Worm*) _tmp4_;
#line 320 "../src/nibbles-game.vala"
		_tmp6_ = worm_get_score (_tmp5_);
#line 320 "../src/nibbles-game.vala"
		_tmp7_ = _tmp6_;
#line 320 "../src/nibbles-game.vala"
		_tmp8_ = self->priv->_current_level;
#line 320 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp7_, _tmp8_);
#line 320 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp5_);
#line 322 "../src/nibbles-game.vala"
		result = G_SOURCE_REMOVE;
#line 322 "../src/nibbles-game.vala"
		_g_free0 (status);
#line 322 "../src/nibbles-game.vala"
		return result;
#line 1620 "nibbles-game.c"
	} else {
		GameStatus* _tmp9_;
		GameStatus _tmp10_;
#line 324 "../src/nibbles-game.vala"
		_tmp9_ = status;
#line 324 "../src/nibbles-game.vala"
		_tmp10_ = GAME_STATUS_VICTORY;
#line 324 "../src/nibbles-game.vala"
		if (_game_status_equal (_tmp9_, &_tmp10_) == TRUE) {
#line 1630 "nibbles-game.c"
			Worm* winner = NULL;
			Worm* _tmp11_;
			Worm* _tmp12_;
			Worm* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 326 "../src/nibbles-game.vala"
			nibbles_game_end (self);
#line 328 "../src/nibbles-game.vala"
			_tmp11_ = nibbles_game_get_winner (self);
#line 328 "../src/nibbles-game.vala"
			winner = _tmp11_;
#line 329 "../src/nibbles-game.vala"
			_tmp12_ = winner;
#line 329 "../src/nibbles-game.vala"
			if (_tmp12_ == NULL) {
#line 330 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 330 "../src/nibbles-game.vala"
				_g_object_unref0 (winner);
#line 330 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 330 "../src/nibbles-game.vala"
				return result;
#line 1656 "nibbles-game.c"
			}
#line 332 "../src/nibbles-game.vala"
			_tmp13_ = winner;
#line 332 "../src/nibbles-game.vala"
			_tmp14_ = worm_get_score (_tmp13_);
#line 332 "../src/nibbles-game.vala"
			_tmp15_ = _tmp14_;
#line 332 "../src/nibbles-game.vala"
			_tmp16_ = self->priv->_current_level;
#line 332 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp15_, _tmp16_);
#line 334 "../src/nibbles-game.vala"
			result = G_SOURCE_REMOVE;
#line 334 "../src/nibbles-game.vala"
			_g_object_unref0 (winner);
#line 334 "../src/nibbles-game.vala"
			_g_free0 (status);
#line 334 "../src/nibbles-game.vala"
			return result;
#line 1676 "nibbles-game.c"
		} else {
			GameStatus* _tmp17_;
			GameStatus _tmp18_;
#line 336 "../src/nibbles-game.vala"
			_tmp17_ = status;
#line 336 "../src/nibbles-game.vala"
			_tmp18_ = GAME_STATUS_NEWROUND;
#line 336 "../src/nibbles-game.vala"
			if (_game_status_equal (_tmp17_, &_tmp18_) == TRUE) {
#line 1686 "nibbles-game.c"
				gint _tmp19_;
				gint _tmp20_;
#line 338 "../src/nibbles-game.vala"
				nibbles_game_stop (self);
#line 340 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 341 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL], 0);
#line 343 "../src/nibbles-game.vala"
				_tmp19_ = self->priv->_current_level;
#line 343 "../src/nibbles-game.vala"
				nibbles_game_set_current_level (self, _tmp19_ + 1);
#line 345 "../src/nibbles-game.vala"
				_tmp20_ = self->priv->_current_level;
#line 345 "../src/nibbles-game.vala"
				if (_tmp20_ == (NIBBLES_GAME_MAX_LEVEL + 1)) {
#line 1703 "nibbles-game.c"
					GeeLinkedList* _tmp21_;
					gpointer _tmp22_;
					Worm* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
#line 346 "../src/nibbles-game.vala"
					_tmp21_ = self->priv->_worms;
#line 346 "../src/nibbles-game.vala"
					_tmp22_ = gee_linked_list_first (_tmp21_);
#line 346 "../src/nibbles-game.vala"
					_tmp23_ = (Worm*) _tmp22_;
#line 346 "../src/nibbles-game.vala"
					_tmp24_ = worm_get_score (_tmp23_);
#line 346 "../src/nibbles-game.vala"
					_tmp25_ = _tmp24_;
#line 346 "../src/nibbles-game.vala"
					_tmp26_ = self->priv->_current_level;
#line 346 "../src/nibbles-game.vala"
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp25_, _tmp26_);
#line 346 "../src/nibbles-game.vala"
					_g_object_unref0 (_tmp23_);
#line 1726 "nibbles-game.c"
				}
#line 348 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 348 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 348 "../src/nibbles-game.vala"
				return result;
#line 1734 "nibbles-game.c"
			}
		}
	}
#line 350 "../src/nibbles-game.vala"
	nibbles_game_move_worms (self);
#line 352 "../src/nibbles-game.vala"
	result = G_SOURCE_CONTINUE;
#line 352 "../src/nibbles-game.vala"
	_g_free0 (status);
#line 352 "../src/nibbles-game.vala"
	return result;
#line 1746 "nibbles-game.c"
}

static void
_nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                               gpointer self)
{
#line 367 "../src/nibbles-game.vala"
	nibbles_game_bonus_found_cb ((NibblesGame*) self, _sender);
#line 1755 "nibbles-game.c"
}

static void
_nibbles_game_worm_dematerialization_request_worm_finish_added (Worm* _sender,
                                                                gpointer self)
{
#line 368 "../src/nibbles-game.vala"
	nibbles_game_worm_dematerialization_request ((NibblesGame*) self, _sender);
#line 1764 "nibbles-game.c"
}

void
nibbles_game_create_worms (NibblesGame* self)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 359 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 361 "../src/nibbles-game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 363 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_numai;
#line 363 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->_numhumans;
#line 363 "../src/nibbles-game.vala"
	nibbles_game_set_numworms (self, _tmp1_ + _tmp2_);
#line 1785 "nibbles-game.c"
	{
		gint i = 0;
#line 364 "../src/nibbles-game.vala"
		i = 0;
#line 1790 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 364 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 364 "../src/nibbles-game.vala"
			while (TRUE) {
#line 1797 "nibbles-game.c"
				gint _tmp5_;
				Worm* worm = NULL;
				guint8 _tmp6_;
				guint8 _tmp7_;
				Worm* _tmp8_;
				Worm* _tmp9_;
				Worm* _tmp10_;
				Worm* _tmp11_;
				gint _tmp12_;
				GeeLinkedList* _tmp13_;
				Worm* _tmp14_;
#line 364 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 1811 "nibbles-game.c"
					gint _tmp4_;
#line 364 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 364 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 1817 "nibbles-game.c"
				}
#line 364 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 364 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_numworms;
#line 364 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 364 "../src/nibbles-game.vala"
					break;
#line 1827 "nibbles-game.c"
				}
#line 366 "../src/nibbles-game.vala"
				_tmp6_ = self->priv->_width;
#line 366 "../src/nibbles-game.vala"
				_tmp7_ = self->priv->_height;
#line 366 "../src/nibbles-game.vala"
				_tmp8_ = worm_new (i, _tmp6_, _tmp7_);
#line 366 "../src/nibbles-game.vala"
				worm = _tmp8_;
#line 367 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 367 "../src/nibbles-game.vala"
				g_signal_connect_object (_tmp9_, "bonus-found", (GCallback) _nibbles_game_bonus_found_cb_worm_bonus_found, self, 0);
#line 368 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 368 "../src/nibbles-game.vala"
				g_signal_connect_object (_tmp10_, "finish-added", (GCallback) _nibbles_game_worm_dematerialization_request_worm_finish_added, self, 0);
#line 369 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 369 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_numhumans;
#line 369 "../src/nibbles-game.vala"
				_tmp11_->is_human = i < _tmp12_;
#line 370 "../src/nibbles-game.vala"
				_tmp13_ = self->priv->_worms;
#line 370 "../src/nibbles-game.vala"
				_tmp14_ = worm;
#line 370 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 364 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 1859 "nibbles-game.c"
			}
		}
	}
}

void
nibbles_game_add_worms (NibblesGame* self)
{
#line 374 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 1870 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 376 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 376 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 376 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 376 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 376 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 376 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 376 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 376 "../src/nibbles-game.vala"
		while (TRUE) {
#line 1895 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			Worm* _tmp9_;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
#line 376 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 376 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 376 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 376 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 376 "../src/nibbles-game.vala"
				break;
#line 1916 "nibbles-game.c"
			}
#line 376 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 376 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 376 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 381 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 381 "../src/nibbles-game.vala"
			g_signal_emit_by_name (_tmp8_, "added");
#line 383 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 383 "../src/nibbles-game.vala"
			_tmp10_ = self->board;
#line 383 "../src/nibbles-game.vala"
			_tmp10__length1 = self->board_length1;
#line 383 "../src/nibbles-game.vala"
			_tmp10__length2 = self->board_length2;
#line 383 "../src/nibbles-game.vala"
			worm_spawn (_tmp9_, _tmp10_, (gint) _tmp10__length1, (gint) _tmp10__length2);
#line 376 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 1940 "nibbles-game.c"
		}
	}
}

static void
nibbles_game_move_worms (NibblesGame* self)
{
	Boni* _tmp0_;
	guint8 missed_bonuses_to_replace = 0U;
	Boni* _tmp15_;
	gint* _tmp16_;
	gint _tmp16__length1;
	gint _tmp16__length2;
	guint8 _tmp17_ = 0U;
	GeeLinkedList* dead_worms = NULL;
	GeeLinkedList* _tmp20_;
#line 387 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 389 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 389 "../src/nibbles-game.vala"
	if (boni_too_many_missed (_tmp0_)) {
#line 1963 "nibbles-game.c"
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp1_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _worm_index = 0;
#line 391 "../src/nibbles-game.vala"
			_tmp1_ = self->priv->_worms;
#line 391 "../src/nibbles-game.vala"
			_worm_list = _tmp1_;
#line 391 "../src/nibbles-game.vala"
			_tmp2_ = _worm_list;
#line 391 "../src/nibbles-game.vala"
			_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 391 "../src/nibbles-game.vala"
			_tmp4_ = _tmp3_;
#line 391 "../src/nibbles-game.vala"
			_worm_size = _tmp4_;
#line 391 "../src/nibbles-game.vala"
			_worm_index = -1;
#line 391 "../src/nibbles-game.vala"
			while (TRUE) {
#line 1988 "nibbles-game.c"
				gint _tmp5_;
				gint _tmp6_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp7_;
				gpointer _tmp8_;
				Worm* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 391 "../src/nibbles-game.vala"
				_worm_index = _worm_index + 1;
#line 391 "../src/nibbles-game.vala"
				_tmp5_ = _worm_index;
#line 391 "../src/nibbles-game.vala"
				_tmp6_ = _worm_size;
#line 391 "../src/nibbles-game.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 391 "../src/nibbles-game.vala"
					break;
#line 2007 "nibbles-game.c"
				}
#line 391 "../src/nibbles-game.vala"
				_tmp7_ = _worm_list;
#line 391 "../src/nibbles-game.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 391 "../src/nibbles-game.vala"
				worm = (Worm*) _tmp8_;
#line 393 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 393 "../src/nibbles-game.vala"
				_tmp10_ = worm_get_score (_tmp9_);
#line 393 "../src/nibbles-game.vala"
				_tmp11_ = _tmp10_;
#line 393 "../src/nibbles-game.vala"
				if (_tmp11_ > 0) {
#line 2023 "nibbles-game.c"
					Worm* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 394 "../src/nibbles-game.vala"
					_tmp12_ = worm;
#line 394 "../src/nibbles-game.vala"
					_tmp13_ = worm_get_score (_tmp12_);
#line 394 "../src/nibbles-game.vala"
					_tmp14_ = _tmp13_;
#line 394 "../src/nibbles-game.vala"
					worm_set_score (_tmp12_, _tmp14_ - 1);
#line 2035 "nibbles-game.c"
				}
#line 391 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2039 "nibbles-game.c"
			}
		}
	}
#line 399 "../src/nibbles-game.vala"
	_tmp15_ = self->priv->boni;
#line 399 "../src/nibbles-game.vala"
	_tmp16_ = self->board;
#line 399 "../src/nibbles-game.vala"
	_tmp16__length1 = self->board_length1;
#line 399 "../src/nibbles-game.vala"
	_tmp16__length2 = self->board_length2;
#line 399 "../src/nibbles-game.vala"
	boni_on_worms_move (_tmp15_, _tmp16_, (gint) _tmp16__length1, (gint) _tmp16__length2, &_tmp17_);
#line 399 "../src/nibbles-game.vala"
	missed_bonuses_to_replace = _tmp17_;
#line 2055 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 400 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 2060 "nibbles-game.c"
		{
			gboolean _tmp18_ = FALSE;
#line 400 "../src/nibbles-game.vala"
			_tmp18_ = TRUE;
#line 400 "../src/nibbles-game.vala"
			while (TRUE) {
#line 400 "../src/nibbles-game.vala"
				if (!_tmp18_) {
#line 2069 "nibbles-game.c"
					guint8 _tmp19_;
#line 400 "../src/nibbles-game.vala"
					_tmp19_ = i;
#line 400 "../src/nibbles-game.vala"
					i = _tmp19_ + 1;
#line 2075 "nibbles-game.c"
				}
#line 400 "../src/nibbles-game.vala"
				_tmp18_ = FALSE;
#line 400 "../src/nibbles-game.vala"
				if (!(i < missed_bonuses_to_replace)) {
#line 400 "../src/nibbles-game.vala"
					break;
#line 2083 "nibbles-game.c"
				}
#line 401 "../src/nibbles-game.vala"
				nibbles_game_add_bonus (self, TRUE);
#line 2087 "nibbles-game.c"
			}
		}
	}
#line 403 "../src/nibbles-game.vala"
	_tmp20_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 403 "../src/nibbles-game.vala"
	dead_worms = _tmp20_;
#line 2095 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp21_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _worm_index = 0;
#line 406 "../src/nibbles-game.vala"
		_tmp21_ = self->priv->_worms;
#line 406 "../src/nibbles-game.vala"
		_worm_list = _tmp21_;
#line 406 "../src/nibbles-game.vala"
		_tmp22_ = _worm_list;
#line 406 "../src/nibbles-game.vala"
		_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 406 "../src/nibbles-game.vala"
		_tmp24_ = _tmp23_;
#line 406 "../src/nibbles-game.vala"
		_worm_size = _tmp24_;
#line 406 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 406 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2120 "nibbles-game.c"
			gint _tmp25_;
			gint _tmp26_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp27_;
			gpointer _tmp28_;
			gboolean _tmp29_ = FALSE;
			Worm* _tmp30_;
			Worm* _tmp36_;
#line 406 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 406 "../src/nibbles-game.vala"
			_tmp25_ = _worm_index;
#line 406 "../src/nibbles-game.vala"
			_tmp26_ = _worm_size;
#line 406 "../src/nibbles-game.vala"
			if (!(_tmp25_ < _tmp26_)) {
#line 406 "../src/nibbles-game.vala"
				break;
#line 2139 "nibbles-game.c"
			}
#line 406 "../src/nibbles-game.vala"
			_tmp27_ = _worm_list;
#line 406 "../src/nibbles-game.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _worm_index);
#line 406 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp28_;
#line 408 "../src/nibbles-game.vala"
			_tmp30_ = worm;
#line 408 "../src/nibbles-game.vala"
			if (_tmp30_->is_stopped) {
#line 408 "../src/nibbles-game.vala"
				_tmp29_ = TRUE;
#line 2153 "nibbles-game.c"
			} else {
				Worm* _tmp31_;
				GeeLinkedList* _tmp32_;
				GeeLinkedList* _tmp33_;
				gboolean _tmp34_;
				gboolean _tmp35_;
#line 409 "../src/nibbles-game.vala"
				_tmp31_ = worm;
#line 409 "../src/nibbles-game.vala"
				_tmp32_ = worm_get_list (_tmp31_);
#line 409 "../src/nibbles-game.vala"
				_tmp33_ = _tmp32_;
#line 409 "../src/nibbles-game.vala"
				_tmp34_ = gee_collection_get_is_empty ((GeeCollection*) _tmp33_);
#line 409 "../src/nibbles-game.vala"
				_tmp35_ = _tmp34_;
#line 409 "../src/nibbles-game.vala"
				_tmp29_ = _tmp35_;
#line 2172 "nibbles-game.c"
			}
#line 408 "../src/nibbles-game.vala"
			if (_tmp29_) {
#line 410 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 410 "../src/nibbles-game.vala"
				continue;
#line 2180 "nibbles-game.c"
			}
#line 412 "../src/nibbles-game.vala"
			_tmp36_ = worm;
#line 412 "../src/nibbles-game.vala"
			if (!_tmp36_->is_human) {
#line 2186 "nibbles-game.c"
				Worm* _tmp37_;
				gint* _tmp38_;
				gint _tmp38__length1;
				gint _tmp38__length2;
				gint _tmp39_;
				GeeLinkedList* _tmp40_;
#line 413 "../src/nibbles-game.vala"
				_tmp37_ = worm;
#line 413 "../src/nibbles-game.vala"
				_tmp38_ = self->board;
#line 413 "../src/nibbles-game.vala"
				_tmp38__length1 = self->board_length1;
#line 413 "../src/nibbles-game.vala"
				_tmp38__length2 = self->board_length2;
#line 413 "../src/nibbles-game.vala"
				_tmp39_ = self->priv->_numworms;
#line 413 "../src/nibbles-game.vala"
				_tmp40_ = self->priv->_worms;
#line 413 "../src/nibbles-game.vala"
				worm_ai_move (_tmp37_, _tmp38_, (gint) _tmp38__length1, (gint) _tmp38__length2, _tmp39_, _tmp40_);
#line 2207 "nibbles-game.c"
			}
#line 406 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2211 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp41_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _worm_index = 0;
#line 417 "../src/nibbles-game.vala"
		_tmp41_ = self->priv->_worms;
#line 417 "../src/nibbles-game.vala"
		_worm_list = _tmp41_;
#line 417 "../src/nibbles-game.vala"
		_tmp42_ = _worm_list;
#line 417 "../src/nibbles-game.vala"
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 417 "../src/nibbles-game.vala"
		_tmp44_ = _tmp43_;
#line 417 "../src/nibbles-game.vala"
		_worm_size = _tmp44_;
#line 417 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 417 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2238 "nibbles-game.c"
			gint _tmp45_;
			gint _tmp46_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp47_;
			gpointer _tmp48_;
			gboolean _tmp49_ = FALSE;
			Worm* _tmp50_;
			Position position = {0};
			Worm* _tmp56_;
			Position _tmp57_ = {0};
			guint8 target_x = 0U;
			guint8 target_y = 0U;
			gboolean _tmp58_ = FALSE;
			Worm* _tmp59_;
			WormDirection _tmp60_;
			WormDirection _tmp61_;
			WarpManager* _tmp65_;
			Position _tmp66_;
			Position _tmp67_;
			guint8 _tmp68_ = 0U;
			guint8 _tmp69_ = 0U;
			gboolean _tmp70_;
			Worm* _tmp72_;
			gint* _tmp73_;
			gint _tmp73__length1;
			gint _tmp73__length2;
			gint _tmp74_;
			Position _tmp75_;
#line 417 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 417 "../src/nibbles-game.vala"
			_tmp45_ = _worm_index;
#line 417 "../src/nibbles-game.vala"
			_tmp46_ = _worm_size;
#line 417 "../src/nibbles-game.vala"
			if (!(_tmp45_ < _tmp46_)) {
#line 417 "../src/nibbles-game.vala"
				break;
#line 2277 "nibbles-game.c"
			}
#line 417 "../src/nibbles-game.vala"
			_tmp47_ = _worm_list;
#line 417 "../src/nibbles-game.vala"
			_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, _worm_index);
#line 417 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp48_;
#line 419 "../src/nibbles-game.vala"
			_tmp50_ = worm;
#line 419 "../src/nibbles-game.vala"
			if (_tmp50_->is_stopped) {
#line 419 "../src/nibbles-game.vala"
				_tmp49_ = TRUE;
#line 2291 "nibbles-game.c"
			} else {
				Worm* _tmp51_;
				GeeLinkedList* _tmp52_;
				GeeLinkedList* _tmp53_;
				gboolean _tmp54_;
				gboolean _tmp55_;
#line 420 "../src/nibbles-game.vala"
				_tmp51_ = worm;
#line 420 "../src/nibbles-game.vala"
				_tmp52_ = worm_get_list (_tmp51_);
#line 420 "../src/nibbles-game.vala"
				_tmp53_ = _tmp52_;
#line 420 "../src/nibbles-game.vala"
				_tmp54_ = gee_collection_get_is_empty ((GeeCollection*) _tmp53_);
#line 420 "../src/nibbles-game.vala"
				_tmp55_ = _tmp54_;
#line 420 "../src/nibbles-game.vala"
				_tmp49_ = _tmp55_;
#line 2310 "nibbles-game.c"
			}
#line 419 "../src/nibbles-game.vala"
			if (_tmp49_) {
#line 421 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 421 "../src/nibbles-game.vala"
				continue;
#line 2318 "nibbles-game.c"
			}
#line 423 "../src/nibbles-game.vala"
			_tmp56_ = worm;
#line 423 "../src/nibbles-game.vala"
			worm_position_move (_tmp56_, &_tmp57_);
#line 423 "../src/nibbles-game.vala"
			position = _tmp57_;
#line 427 "../src/nibbles-game.vala"
			_tmp59_ = worm;
#line 427 "../src/nibbles-game.vala"
			_tmp60_ = worm_get_direction (_tmp59_);
#line 427 "../src/nibbles-game.vala"
			_tmp61_ = _tmp60_;
#line 427 "../src/nibbles-game.vala"
			if (_tmp61_ == WORM_DIRECTION_LEFT) {
#line 427 "../src/nibbles-game.vala"
				_tmp58_ = TRUE;
#line 2336 "nibbles-game.c"
			} else {
				Worm* _tmp62_;
				WormDirection _tmp63_;
				WormDirection _tmp64_;
#line 427 "../src/nibbles-game.vala"
				_tmp62_ = worm;
#line 427 "../src/nibbles-game.vala"
				_tmp63_ = worm_get_direction (_tmp62_);
#line 427 "../src/nibbles-game.vala"
				_tmp64_ = _tmp63_;
#line 427 "../src/nibbles-game.vala"
				_tmp58_ = _tmp64_ == WORM_DIRECTION_RIGHT;
#line 2349 "nibbles-game.c"
			}
#line 426 "../src/nibbles-game.vala"
			_tmp65_ = self->priv->warp_manager;
#line 426 "../src/nibbles-game.vala"
			_tmp66_ = position;
#line 426 "../src/nibbles-game.vala"
			_tmp67_ = position;
#line 426 "../src/nibbles-game.vala"
			_tmp70_ = warp_manager_get_warp_target (_tmp65_, _tmp66_.x, _tmp67_.y, _tmp58_, &_tmp68_, &_tmp69_);
#line 426 "../src/nibbles-game.vala"
			target_x = _tmp68_;
#line 426 "../src/nibbles-game.vala"
			target_y = _tmp69_;
#line 426 "../src/nibbles-game.vala"
			if (_tmp70_) {
#line 2365 "nibbles-game.c"
				Position _tmp71_ = {0};
#line 429 "../src/nibbles-game.vala"
				memset (&_tmp71_, 0, sizeof (Position));
#line 429 "../src/nibbles-game.vala"
				_tmp71_.x = target_x;
#line 429 "../src/nibbles-game.vala"
				_tmp71_.y = target_y;
#line 429 "../src/nibbles-game.vala"
				position = _tmp71_;
#line 2375 "nibbles-game.c"
			}
#line 431 "../src/nibbles-game.vala"
			_tmp72_ = worm;
#line 431 "../src/nibbles-game.vala"
			_tmp73_ = self->board;
#line 431 "../src/nibbles-game.vala"
			_tmp73__length1 = self->board_length1;
#line 431 "../src/nibbles-game.vala"
			_tmp73__length2 = self->board_length2;
#line 431 "../src/nibbles-game.vala"
			_tmp74_ = self->priv->_numworms;
#line 431 "../src/nibbles-game.vala"
			_tmp75_ = position;
#line 431 "../src/nibbles-game.vala"
			if (!worm_can_move_to (_tmp72_, _tmp73_, (gint) _tmp73__length1, (gint) _tmp73__length2, _tmp74_, &_tmp75_)) {
#line 2391 "nibbles-game.c"
				GeeLinkedList* _tmp76_;
				Worm* _tmp77_;
#line 432 "../src/nibbles-game.vala"
				_tmp76_ = dead_worms;
#line 432 "../src/nibbles-game.vala"
				_tmp77_ = worm;
#line 432 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp76_, _tmp77_);
#line 2400 "nibbles-game.c"
			}
#line 417 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2404 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp78_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp79_;
		gint _tmp80_;
		gint _tmp81_;
		gint _worm_index = 0;
#line 436 "../src/nibbles-game.vala"
		_tmp78_ = self->priv->_worms;
#line 436 "../src/nibbles-game.vala"
		_worm_list = _tmp78_;
#line 436 "../src/nibbles-game.vala"
		_tmp79_ = _worm_list;
#line 436 "../src/nibbles-game.vala"
		_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp79_);
#line 436 "../src/nibbles-game.vala"
		_tmp81_ = _tmp80_;
#line 436 "../src/nibbles-game.vala"
		_worm_size = _tmp81_;
#line 436 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 436 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2431 "nibbles-game.c"
			gint _tmp82_;
			gint _tmp83_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp84_;
			gpointer _tmp85_;
			gboolean _tmp86_ = FALSE;
			gboolean _tmp87_ = FALSE;
			Worm* _tmp88_;
			Worm* _tmp96_;
			gint* _tmp97_;
			gint _tmp97__length1;
			gint _tmp97__length2;
			Worm* _tmp98_;
			Position _tmp99_ = {0};
			Position _tmp100_;
			Worm* _tmp101_;
			Position _tmp102_ = {0};
			Position _tmp103_;
			gint _tmp104_;
#line 436 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 436 "../src/nibbles-game.vala"
			_tmp82_ = _worm_index;
#line 436 "../src/nibbles-game.vala"
			_tmp83_ = _worm_size;
#line 436 "../src/nibbles-game.vala"
			if (!(_tmp82_ < _tmp83_)) {
#line 436 "../src/nibbles-game.vala"
				break;
#line 2461 "nibbles-game.c"
			}
#line 436 "../src/nibbles-game.vala"
			_tmp84_ = _worm_list;
#line 436 "../src/nibbles-game.vala"
			_tmp85_ = gee_abstract_list_get ((GeeAbstractList*) _tmp84_, _worm_index);
#line 436 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp85_;
#line 438 "../src/nibbles-game.vala"
			_tmp88_ = worm;
#line 438 "../src/nibbles-game.vala"
			if (_tmp88_->is_stopped) {
#line 438 "../src/nibbles-game.vala"
				_tmp87_ = TRUE;
#line 2475 "nibbles-game.c"
			} else {
				Worm* _tmp89_;
				GeeLinkedList* _tmp90_;
				GeeLinkedList* _tmp91_;
				gboolean _tmp92_;
				gboolean _tmp93_;
#line 439 "../src/nibbles-game.vala"
				_tmp89_ = worm;
#line 439 "../src/nibbles-game.vala"
				_tmp90_ = worm_get_list (_tmp89_);
#line 439 "../src/nibbles-game.vala"
				_tmp91_ = _tmp90_;
#line 439 "../src/nibbles-game.vala"
				_tmp92_ = gee_collection_get_is_empty ((GeeCollection*) _tmp91_);
#line 439 "../src/nibbles-game.vala"
				_tmp93_ = _tmp92_;
#line 439 "../src/nibbles-game.vala"
				_tmp87_ = _tmp93_;
#line 2494 "nibbles-game.c"
			}
#line 438 "../src/nibbles-game.vala"
			if (_tmp87_) {
#line 438 "../src/nibbles-game.vala"
				_tmp86_ = TRUE;
#line 2500 "nibbles-game.c"
			} else {
				GeeLinkedList* _tmp94_;
				Worm* _tmp95_;
#line 440 "../src/nibbles-game.vala"
				_tmp94_ = dead_worms;
#line 440 "../src/nibbles-game.vala"
				_tmp95_ = worm;
#line 440 "../src/nibbles-game.vala"
				_tmp86_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp94_, _tmp95_);
#line 2510 "nibbles-game.c"
			}
#line 438 "../src/nibbles-game.vala"
			if (_tmp86_) {
#line 441 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 441 "../src/nibbles-game.vala"
				continue;
#line 2518 "nibbles-game.c"
			}
#line 443 "../src/nibbles-game.vala"
			_tmp96_ = worm;
#line 443 "../src/nibbles-game.vala"
			worm_move_part_1 (_tmp96_);
#line 444 "../src/nibbles-game.vala"
			_tmp97_ = self->board;
#line 444 "../src/nibbles-game.vala"
			_tmp97__length1 = self->board_length1;
#line 444 "../src/nibbles-game.vala"
			_tmp97__length2 = self->board_length2;
#line 444 "../src/nibbles-game.vala"
			_tmp98_ = worm;
#line 444 "../src/nibbles-game.vala"
			worm_get_head (_tmp98_, &_tmp99_);
#line 444 "../src/nibbles-game.vala"
			_tmp100_ = _tmp99_;
#line 444 "../src/nibbles-game.vala"
			_tmp101_ = worm;
#line 444 "../src/nibbles-game.vala"
			worm_get_head (_tmp101_, &_tmp102_);
#line 444 "../src/nibbles-game.vala"
			_tmp103_ = _tmp102_;
#line 444 "../src/nibbles-game.vala"
			_tmp104_ = _tmp97_[(_tmp100_.x * _tmp97__length2) + _tmp103_.y];
#line 444 "../src/nibbles-game.vala"
			if (_tmp104_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 2546 "nibbles-game.c"
				guint8 target_x = 0U;
				guint8 target_y = 0U;
				gboolean _tmp105_ = FALSE;
				Worm* _tmp106_;
				WormDirection _tmp107_;
				WormDirection _tmp108_;
				WarpManager* _tmp112_;
				Worm* _tmp113_;
				Position _tmp114_ = {0};
				Position _tmp115_;
				Worm* _tmp116_;
				Position _tmp117_ = {0};
				Position _tmp118_;
				guint8 _tmp119_ = 0U;
				guint8 _tmp120_ = 0U;
				gboolean _tmp121_;
				Worm* _tmp122_;
				gint* _tmp123_;
				gint _tmp123__length1;
				gint _tmp123__length2;
				Position _tmp124_ = {0};
#line 449 "../src/nibbles-game.vala"
				_tmp106_ = worm;
#line 449 "../src/nibbles-game.vala"
				_tmp107_ = worm_get_direction (_tmp106_);
#line 449 "../src/nibbles-game.vala"
				_tmp108_ = _tmp107_;
#line 449 "../src/nibbles-game.vala"
				if (_tmp108_ == WORM_DIRECTION_LEFT) {
#line 449 "../src/nibbles-game.vala"
					_tmp105_ = TRUE;
#line 2578 "nibbles-game.c"
				} else {
					Worm* _tmp109_;
					WormDirection _tmp110_;
					WormDirection _tmp111_;
#line 449 "../src/nibbles-game.vala"
					_tmp109_ = worm;
#line 449 "../src/nibbles-game.vala"
					_tmp110_ = worm_get_direction (_tmp109_);
#line 449 "../src/nibbles-game.vala"
					_tmp111_ = _tmp110_;
#line 449 "../src/nibbles-game.vala"
					_tmp105_ = _tmp111_ == WORM_DIRECTION_RIGHT;
#line 2591 "nibbles-game.c"
				}
#line 448 "../src/nibbles-game.vala"
				_tmp112_ = self->priv->warp_manager;
#line 448 "../src/nibbles-game.vala"
				_tmp113_ = worm;
#line 448 "../src/nibbles-game.vala"
				worm_get_head (_tmp113_, &_tmp114_);
#line 448 "../src/nibbles-game.vala"
				_tmp115_ = _tmp114_;
#line 448 "../src/nibbles-game.vala"
				_tmp116_ = worm;
#line 448 "../src/nibbles-game.vala"
				worm_get_head (_tmp116_, &_tmp117_);
#line 448 "../src/nibbles-game.vala"
				_tmp118_ = _tmp117_;
#line 448 "../src/nibbles-game.vala"
				_tmp121_ = warp_manager_get_warp_target (_tmp112_, _tmp115_.x, _tmp118_.y, _tmp105_, &_tmp119_, &_tmp120_);
#line 448 "../src/nibbles-game.vala"
				target_x = _tmp119_;
#line 448 "../src/nibbles-game.vala"
				target_y = _tmp120_;
#line 448 "../src/nibbles-game.vala"
				if (!_tmp121_) {
#line 451 "../src/nibbles-game.vala"
					g_assert_not_reached ();
#line 2617 "nibbles-game.c"
				}
#line 453 "../src/nibbles-game.vala"
				_tmp122_ = worm;
#line 453 "../src/nibbles-game.vala"
				_tmp123_ = self->board;
#line 453 "../src/nibbles-game.vala"
				_tmp123__length1 = self->board_length1;
#line 453 "../src/nibbles-game.vala"
				_tmp123__length2 = self->board_length2;
#line 453 "../src/nibbles-game.vala"
				memset (&_tmp124_, 0, sizeof (Position));
#line 453 "../src/nibbles-game.vala"
				_tmp124_.x = target_x;
#line 453 "../src/nibbles-game.vala"
				_tmp124_.y = target_y;
#line 453 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp122_, _tmp123_, (gint) _tmp123__length1, (gint) _tmp123__length2, &_tmp124_);
#line 2635 "nibbles-game.c"
			} else {
				Worm* _tmp125_;
				gint* _tmp126_;
				gint _tmp126__length1;
				gint _tmp126__length2;
#line 456 "../src/nibbles-game.vala"
				_tmp125_ = worm;
#line 456 "../src/nibbles-game.vala"
				_tmp126_ = self->board;
#line 456 "../src/nibbles-game.vala"
				_tmp126__length1 = self->board_length1;
#line 456 "../src/nibbles-game.vala"
				_tmp126__length2 = self->board_length2;
#line 456 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp125_, _tmp126_, (gint) _tmp126__length1, (gint) _tmp126__length2, NULL);
#line 2651 "nibbles-game.c"
			}
			{
				GeeLinkedList* _other_worm_list = NULL;
				GeeLinkedList* _tmp127_;
				gint _other_worm_size = 0;
				GeeLinkedList* _tmp128_;
				gint _tmp129_;
				gint _tmp130_;
				gint _other_worm_index = 0;
#line 459 "../src/nibbles-game.vala"
				_tmp127_ = self->priv->_worms;
#line 459 "../src/nibbles-game.vala"
				_other_worm_list = _tmp127_;
#line 459 "../src/nibbles-game.vala"
				_tmp128_ = _other_worm_list;
#line 459 "../src/nibbles-game.vala"
				_tmp129_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp128_);
#line 459 "../src/nibbles-game.vala"
				_tmp130_ = _tmp129_;
#line 459 "../src/nibbles-game.vala"
				_other_worm_size = _tmp130_;
#line 459 "../src/nibbles-game.vala"
				_other_worm_index = -1;
#line 459 "../src/nibbles-game.vala"
				while (TRUE) {
#line 2677 "nibbles-game.c"
					gint _tmp131_;
					gint _tmp132_;
					Worm* other_worm = NULL;
					GeeLinkedList* _tmp133_;
					gpointer _tmp134_;
					gboolean _tmp135_ = FALSE;
					gboolean _tmp136_ = FALSE;
					gboolean _tmp137_ = FALSE;
					gboolean _tmp138_ = FALSE;
					Worm* _tmp139_;
					Worm* _tmp140_;
#line 459 "../src/nibbles-game.vala"
					_other_worm_index = _other_worm_index + 1;
#line 459 "../src/nibbles-game.vala"
					_tmp131_ = _other_worm_index;
#line 459 "../src/nibbles-game.vala"
					_tmp132_ = _other_worm_size;
#line 459 "../src/nibbles-game.vala"
					if (!(_tmp131_ < _tmp132_)) {
#line 459 "../src/nibbles-game.vala"
						break;
#line 2699 "nibbles-game.c"
					}
#line 459 "../src/nibbles-game.vala"
					_tmp133_ = _other_worm_list;
#line 459 "../src/nibbles-game.vala"
					_tmp134_ = gee_abstract_list_get ((GeeAbstractList*) _tmp133_, _other_worm_index);
#line 459 "../src/nibbles-game.vala"
					other_worm = (Worm*) _tmp134_;
#line 461 "../src/nibbles-game.vala"
					_tmp139_ = worm;
#line 461 "../src/nibbles-game.vala"
					_tmp140_ = other_worm;
#line 461 "../src/nibbles-game.vala"
					if (_tmp139_ != _tmp140_) {
#line 2713 "nibbles-game.c"
						Worm* _tmp141_;
#line 462 "../src/nibbles-game.vala"
						_tmp141_ = other_worm;
#line 462 "../src/nibbles-game.vala"
						_tmp138_ = !_tmp141_->is_stopped;
#line 2719 "nibbles-game.c"
					} else {
#line 461 "../src/nibbles-game.vala"
						_tmp138_ = FALSE;
#line 2723 "nibbles-game.c"
					}
#line 461 "../src/nibbles-game.vala"
					if (_tmp138_) {
#line 2727 "nibbles-game.c"
						Worm* _tmp142_;
						GeeLinkedList* _tmp143_;
						GeeLinkedList* _tmp144_;
						gboolean _tmp145_;
						gboolean _tmp146_;
#line 463 "../src/nibbles-game.vala"
						_tmp142_ = other_worm;
#line 463 "../src/nibbles-game.vala"
						_tmp143_ = worm_get_list (_tmp142_);
#line 463 "../src/nibbles-game.vala"
						_tmp144_ = _tmp143_;
#line 463 "../src/nibbles-game.vala"
						_tmp145_ = gee_collection_get_is_empty ((GeeCollection*) _tmp144_);
#line 463 "../src/nibbles-game.vala"
						_tmp146_ = _tmp145_;
#line 463 "../src/nibbles-game.vala"
						_tmp137_ = !_tmp146_;
#line 2745 "nibbles-game.c"
					} else {
#line 461 "../src/nibbles-game.vala"
						_tmp137_ = FALSE;
#line 2749 "nibbles-game.c"
					}
#line 461 "../src/nibbles-game.vala"
					if (_tmp137_) {
#line 2753 "nibbles-game.c"
						Worm* _tmp147_;
						Position _tmp148_ = {0};
						Position _tmp149_;
						Worm* _tmp150_;
						Position _tmp151_ = {0};
						Position _tmp152_;
#line 464 "../src/nibbles-game.vala"
						_tmp147_ = worm;
#line 464 "../src/nibbles-game.vala"
						worm_get_head (_tmp147_, &_tmp148_);
#line 464 "../src/nibbles-game.vala"
						_tmp149_ = _tmp148_;
#line 464 "../src/nibbles-game.vala"
						_tmp150_ = other_worm;
#line 464 "../src/nibbles-game.vala"
						worm_get_head (_tmp150_, &_tmp151_);
#line 464 "../src/nibbles-game.vala"
						_tmp152_ = _tmp151_;
#line 464 "../src/nibbles-game.vala"
						_tmp136_ = _tmp149_.x == _tmp152_.x;
#line 2774 "nibbles-game.c"
					} else {
#line 461 "../src/nibbles-game.vala"
						_tmp136_ = FALSE;
#line 2778 "nibbles-game.c"
					}
#line 461 "../src/nibbles-game.vala"
					if (_tmp136_) {
#line 2782 "nibbles-game.c"
						Worm* _tmp153_;
						Position _tmp154_ = {0};
						Position _tmp155_;
						Worm* _tmp156_;
						Position _tmp157_ = {0};
						Position _tmp158_;
#line 465 "../src/nibbles-game.vala"
						_tmp153_ = worm;
#line 465 "../src/nibbles-game.vala"
						worm_get_head (_tmp153_, &_tmp154_);
#line 465 "../src/nibbles-game.vala"
						_tmp155_ = _tmp154_;
#line 465 "../src/nibbles-game.vala"
						_tmp156_ = other_worm;
#line 465 "../src/nibbles-game.vala"
						worm_get_head (_tmp156_, &_tmp157_);
#line 465 "../src/nibbles-game.vala"
						_tmp158_ = _tmp157_;
#line 465 "../src/nibbles-game.vala"
						_tmp135_ = _tmp155_.y == _tmp158_.y;
#line 2803 "nibbles-game.c"
					} else {
#line 461 "../src/nibbles-game.vala"
						_tmp135_ = FALSE;
#line 2807 "nibbles-game.c"
					}
#line 461 "../src/nibbles-game.vala"
					if (_tmp135_) {
#line 2811 "nibbles-game.c"
						GeeLinkedList* _tmp159_;
						Worm* _tmp160_;
						GeeLinkedList* _tmp163_;
						Worm* _tmp164_;
#line 467 "../src/nibbles-game.vala"
						_tmp159_ = dead_worms;
#line 467 "../src/nibbles-game.vala"
						_tmp160_ = worm;
#line 467 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp159_, _tmp160_)) {
#line 2822 "nibbles-game.c"
							GeeLinkedList* _tmp161_;
							Worm* _tmp162_;
#line 468 "../src/nibbles-game.vala"
							_tmp161_ = dead_worms;
#line 468 "../src/nibbles-game.vala"
							_tmp162_ = worm;
#line 468 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, _tmp162_);
#line 2831 "nibbles-game.c"
						}
#line 469 "../src/nibbles-game.vala"
						_tmp163_ = dead_worms;
#line 469 "../src/nibbles-game.vala"
						_tmp164_ = other_worm;
#line 469 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp163_, _tmp164_)) {
#line 2839 "nibbles-game.c"
							GeeLinkedList* _tmp165_;
							Worm* _tmp166_;
#line 470 "../src/nibbles-game.vala"
							_tmp165_ = dead_worms;
#line 470 "../src/nibbles-game.vala"
							_tmp166_ = other_worm;
#line 470 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp165_, _tmp166_);
#line 2848 "nibbles-game.c"
						}
					}
#line 459 "../src/nibbles-game.vala"
					_g_object_unref0 (other_worm);
#line 2853 "nibbles-game.c"
				}
			}
#line 436 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2858 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp167_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp168_;
		gint _tmp169_;
		gint _tmp170_;
		gint _worm_index = 0;
#line 476 "../src/nibbles-game.vala"
		_tmp167_ = dead_worms;
#line 476 "../src/nibbles-game.vala"
		_worm_list = _tmp167_;
#line 476 "../src/nibbles-game.vala"
		_tmp168_ = _worm_list;
#line 476 "../src/nibbles-game.vala"
		_tmp169_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp168_);
#line 476 "../src/nibbles-game.vala"
		_tmp170_ = _tmp169_;
#line 476 "../src/nibbles-game.vala"
		_worm_size = _tmp170_;
#line 476 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 476 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2885 "nibbles-game.c"
			gint _tmp171_;
			gint _tmp172_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp173_;
			gpointer _tmp174_;
			gint _tmp175_;
			Worm* _tmp180_;
			guint8 _tmp181_;
			guint8 _tmp182_;
#line 476 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 476 "../src/nibbles-game.vala"
			_tmp171_ = _worm_index;
#line 476 "../src/nibbles-game.vala"
			_tmp172_ = _worm_size;
#line 476 "../src/nibbles-game.vala"
			if (!(_tmp171_ < _tmp172_)) {
#line 476 "../src/nibbles-game.vala"
				break;
#line 2905 "nibbles-game.c"
			}
#line 476 "../src/nibbles-game.vala"
			_tmp173_ = _worm_list;
#line 476 "../src/nibbles-game.vala"
			_tmp174_ = gee_abstract_list_get ((GeeAbstractList*) _tmp173_, _worm_index);
#line 476 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp174_;
#line 478 "../src/nibbles-game.vala"
			_tmp175_ = self->priv->_numworms;
#line 478 "../src/nibbles-game.vala"
			if (_tmp175_ > 1) {
#line 2917 "nibbles-game.c"
				Worm* _tmp176_;
				Worm* _tmp177_;
				gint _tmp178_;
				gint _tmp179_;
#line 479 "../src/nibbles-game.vala"
				_tmp176_ = worm;
#line 479 "../src/nibbles-game.vala"
				_tmp177_ = worm;
#line 479 "../src/nibbles-game.vala"
				_tmp178_ = worm_get_score (_tmp177_);
#line 479 "../src/nibbles-game.vala"
				_tmp179_ = _tmp178_;
#line 479 "../src/nibbles-game.vala"
				worm_set_score (_tmp176_, (_tmp179_ * 7) / 10);
#line 2932 "nibbles-game.c"
			}
#line 481 "../src/nibbles-game.vala"
			_tmp180_ = worm;
#line 481 "../src/nibbles-game.vala"
			_tmp181_ = worm_get_lives (_tmp180_);
#line 481 "../src/nibbles-game.vala"
			_tmp182_ = _tmp181_;
#line 481 "../src/nibbles-game.vala"
			if (((gint) _tmp182_) > 0) {
#line 2942 "nibbles-game.c"
				Worm* _tmp183_;
				gint* _tmp184_;
				gint _tmp184__length1;
				gint _tmp184__length2;
#line 482 "../src/nibbles-game.vala"
				_tmp183_ = worm;
#line 482 "../src/nibbles-game.vala"
				_tmp184_ = self->board;
#line 482 "../src/nibbles-game.vala"
				_tmp184__length1 = self->board_length1;
#line 482 "../src/nibbles-game.vala"
				_tmp184__length2 = self->board_length2;
#line 482 "../src/nibbles-game.vala"
				worm_reset (_tmp183_, _tmp184_, (gint) _tmp184__length1, (gint) _tmp184__length2);
#line 2957 "nibbles-game.c"
			}
#line 476 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2961 "nibbles-game.c"
		}
	}
#line 387 "../src/nibbles-game.vala"
	_g_object_unref0 (dead_worms);
#line 2966 "nibbles-game.c"
}

static void
nibbles_game_reverse_worms (NibblesGame* self,
                            Worm* worm)
{
#line 486 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 2977 "nibbles-game.c"
	{
		GeeLinkedList* _other_worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _other_worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _other_worm_index = 0;
#line 488 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 488 "../src/nibbles-game.vala"
		_other_worm_list = _tmp0_;
#line 488 "../src/nibbles-game.vala"
		_tmp1_ = _other_worm_list;
#line 488 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 488 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 488 "../src/nibbles-game.vala"
		_other_worm_size = _tmp3_;
#line 488 "../src/nibbles-game.vala"
		_other_worm_index = -1;
#line 488 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3002 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* other_worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
#line 488 "../src/nibbles-game.vala"
			_other_worm_index = _other_worm_index + 1;
#line 488 "../src/nibbles-game.vala"
			_tmp4_ = _other_worm_index;
#line 488 "../src/nibbles-game.vala"
			_tmp5_ = _other_worm_size;
#line 488 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 488 "../src/nibbles-game.vala"
				break;
#line 3019 "nibbles-game.c"
			}
#line 488 "../src/nibbles-game.vala"
			_tmp6_ = _other_worm_list;
#line 488 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _other_worm_index);
#line 488 "../src/nibbles-game.vala"
			other_worm = (Worm*) _tmp7_;
#line 489 "../src/nibbles-game.vala"
			_tmp8_ = other_worm;
#line 489 "../src/nibbles-game.vala"
			if (worm != _tmp8_) {
#line 3031 "nibbles-game.c"
				Worm* _tmp9_;
				gint* _tmp10_;
				gint _tmp10__length1;
				gint _tmp10__length2;
#line 490 "../src/nibbles-game.vala"
				_tmp9_ = other_worm;
#line 490 "../src/nibbles-game.vala"
				_tmp10_ = self->board;
#line 490 "../src/nibbles-game.vala"
				_tmp10__length1 = self->board_length1;
#line 490 "../src/nibbles-game.vala"
				_tmp10__length2 = self->board_length2;
#line 490 "../src/nibbles-game.vala"
				worm_reverse (_tmp9_, _tmp10_, (gint) _tmp10__length1, (gint) _tmp10__length2);
#line 3046 "nibbles-game.c"
			}
#line 488 "../src/nibbles-game.vala"
			_g_object_unref0 (other_worm);
#line 3050 "nibbles-game.c"
		}
	}
}

static void
nibbles_game_worm_dematerialization_request (NibblesGame* self,
                                             Worm* worm)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 493 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 495 "../src/nibbles-game.vala"
	_tmp0_ = self->board;
#line 495 "../src/nibbles-game.vala"
	_tmp0__length1 = self->board_length1;
#line 495 "../src/nibbles-game.vala"
	_tmp0__length2 = self->board_length2;
#line 495 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_gamedelay;
#line 495 "../src/nibbles-game.vala"
	worm_dematerialize (worm, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, 3, _tmp1_);
#line 3077 "nibbles-game.c"
}

static void
nibbles_game_add_bonus (NibblesGame* self,
                        gboolean regular)
{
	gboolean good = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
#line 502 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/nibbles-game.vala"
	good = FALSE;
#line 505 "../src/nibbles-game.vala"
	x = (guint8) 0;
#line 506 "../src/nibbles-game.vala"
	y = (guint8) 0;
#line 508 "../src/nibbles-game.vala"
	if (!regular) {
#line 510 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 50) != ((gint32) 0)) {
#line 511 "../src/nibbles-game.vala"
			return;
#line 3101 "nibbles-game.c"
		}
	}
	{
		gboolean _tmp0_ = FALSE;
#line 514 "../src/nibbles-game.vala"
		_tmp0_ = TRUE;
#line 514 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3110 "nibbles-game.c"
			guint8 _tmp1_;
			guint8 _tmp2_;
			gint* _tmp3_;
			gint _tmp3__length1;
			gint _tmp3__length2;
			gint _tmp4_;
			gint* _tmp5_;
			gint _tmp5__length1;
			gint _tmp5__length2;
			gint _tmp6_;
			gint* _tmp7_;
			gint _tmp7__length1;
			gint _tmp7__length2;
			gint _tmp8_;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
#line 514 "../src/nibbles-game.vala"
			if (!_tmp0_) {
#line 525 "../src/nibbles-game.vala"
				if (!(!good)) {
#line 525 "../src/nibbles-game.vala"
					break;
#line 3135 "nibbles-game.c"
				}
			}
#line 514 "../src/nibbles-game.vala"
			_tmp0_ = FALSE;
#line 516 "../src/nibbles-game.vala"
			good = TRUE;
#line 518 "../src/nibbles-game.vala"
			_tmp1_ = self->priv->_width;
#line 518 "../src/nibbles-game.vala"
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp1_ - 1));
#line 519 "../src/nibbles-game.vala"
			_tmp2_ = self->priv->_height;
#line 519 "../src/nibbles-game.vala"
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp2_ - 1));
#line 521 "../src/nibbles-game.vala"
			_tmp3_ = self->board;
#line 521 "../src/nibbles-game.vala"
			_tmp3__length1 = self->board_length1;
#line 521 "../src/nibbles-game.vala"
			_tmp3__length2 = self->board_length2;
#line 521 "../src/nibbles-game.vala"
			_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
#line 521 "../src/nibbles-game.vala"
			if (_tmp4_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 521 "../src/nibbles-game.vala"
				good = FALSE;
#line 521 "../src/nibbles-game.vala"
				continue;
#line 3164 "nibbles-game.c"
			}
#line 522 "../src/nibbles-game.vala"
			_tmp5_ = self->board;
#line 522 "../src/nibbles-game.vala"
			_tmp5__length1 = self->board_length1;
#line 522 "../src/nibbles-game.vala"
			_tmp5__length2 = self->board_length2;
#line 522 "../src/nibbles-game.vala"
			_tmp6_ = _tmp5_[((x + 1) * _tmp5__length2) + (y + 1)];
#line 522 "../src/nibbles-game.vala"
			if (_tmp6_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 522 "../src/nibbles-game.vala"
				good = FALSE;
#line 522 "../src/nibbles-game.vala"
				continue;
#line 3180 "nibbles-game.c"
			}
#line 523 "../src/nibbles-game.vala"
			_tmp7_ = self->board;
#line 523 "../src/nibbles-game.vala"
			_tmp7__length1 = self->board_length1;
#line 523 "../src/nibbles-game.vala"
			_tmp7__length2 = self->board_length2;
#line 523 "../src/nibbles-game.vala"
			_tmp8_ = _tmp7_[((x + 1) * _tmp7__length2) + y];
#line 523 "../src/nibbles-game.vala"
			if (_tmp8_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 523 "../src/nibbles-game.vala"
				good = FALSE;
#line 523 "../src/nibbles-game.vala"
				continue;
#line 3196 "nibbles-game.c"
			}
#line 524 "../src/nibbles-game.vala"
			_tmp9_ = self->board;
#line 524 "../src/nibbles-game.vala"
			_tmp9__length1 = self->board_length1;
#line 524 "../src/nibbles-game.vala"
			_tmp9__length2 = self->board_length2;
#line 524 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + (y + 1)];
#line 524 "../src/nibbles-game.vala"
			if (_tmp10_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 524 "../src/nibbles-game.vala"
				good = FALSE;
#line 524 "../src/nibbles-game.vala"
				continue;
#line 3212 "nibbles-game.c"
			}
		}
	}
#line 527 "../src/nibbles-game.vala"
	if (regular) {
#line 3218 "nibbles-game.c"
		gboolean _tmp11_ = FALSE;
#line 529 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 7) == ((gint32) 0)) {
#line 3222 "nibbles-game.c"
			gboolean _tmp12_;
#line 529 "../src/nibbles-game.vala"
			_tmp12_ = self->priv->_fakes;
#line 529 "../src/nibbles-game.vala"
			_tmp11_ = _tmp12_;
#line 3228 "nibbles-game.c"
		} else {
#line 529 "../src/nibbles-game.vala"
			_tmp11_ = FALSE;
#line 3232 "nibbles-game.c"
		}
#line 529 "../src/nibbles-game.vala"
		if (_tmp11_) {
#line 530 "../src/nibbles-game.vala"
			_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, TRUE, (guint16) 300);
#line 3238 "nibbles-game.c"
		}
#line 532 "../src/nibbles-game.vala"
		good = FALSE;
#line 533 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3244 "nibbles-game.c"
			guint8 _tmp13_;
			guint8 _tmp14_;
			gint* _tmp15_;
			gint _tmp15__length1;
			gint _tmp15__length2;
			gint _tmp16_;
			gint* _tmp17_;
			gint _tmp17__length1;
			gint _tmp17__length2;
			gint _tmp18_;
			gint* _tmp19_;
			gint _tmp19__length1;
			gint _tmp19__length2;
			gint _tmp20_;
			gint* _tmp21_;
			gint _tmp21__length1;
			gint _tmp21__length2;
			gint _tmp22_;
#line 533 "../src/nibbles-game.vala"
			if (!(!good)) {
#line 533 "../src/nibbles-game.vala"
				break;
#line 3267 "nibbles-game.c"
			}
#line 535 "../src/nibbles-game.vala"
			good = TRUE;
#line 537 "../src/nibbles-game.vala"
			_tmp13_ = self->priv->_width;
#line 537 "../src/nibbles-game.vala"
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp13_ - 1));
#line 538 "../src/nibbles-game.vala"
			_tmp14_ = self->priv->_height;
#line 538 "../src/nibbles-game.vala"
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp14_ - 1));
#line 540 "../src/nibbles-game.vala"
			_tmp15_ = self->board;
#line 540 "../src/nibbles-game.vala"
			_tmp15__length1 = self->board_length1;
#line 540 "../src/nibbles-game.vala"
			_tmp15__length2 = self->board_length2;
#line 540 "../src/nibbles-game.vala"
			_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
#line 540 "../src/nibbles-game.vala"
			if (_tmp16_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 540 "../src/nibbles-game.vala"
				good = FALSE;
#line 540 "../src/nibbles-game.vala"
				continue;
#line 3293 "nibbles-game.c"
			}
#line 541 "../src/nibbles-game.vala"
			_tmp17_ = self->board;
#line 541 "../src/nibbles-game.vala"
			_tmp17__length1 = self->board_length1;
#line 541 "../src/nibbles-game.vala"
			_tmp17__length2 = self->board_length2;
#line 541 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_[((x + 1) * _tmp17__length2) + (y + 1)];
#line 541 "../src/nibbles-game.vala"
			if (_tmp18_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 541 "../src/nibbles-game.vala"
				good = FALSE;
#line 541 "../src/nibbles-game.vala"
				continue;
#line 3309 "nibbles-game.c"
			}
#line 542 "../src/nibbles-game.vala"
			_tmp19_ = self->board;
#line 542 "../src/nibbles-game.vala"
			_tmp19__length1 = self->board_length1;
#line 542 "../src/nibbles-game.vala"
			_tmp19__length2 = self->board_length2;
#line 542 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_[((x + 1) * _tmp19__length2) + y];
#line 542 "../src/nibbles-game.vala"
			if (_tmp20_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 542 "../src/nibbles-game.vala"
				good = FALSE;
#line 542 "../src/nibbles-game.vala"
				continue;
#line 3325 "nibbles-game.c"
			}
#line 543 "../src/nibbles-game.vala"
			_tmp21_ = self->board;
#line 543 "../src/nibbles-game.vala"
			_tmp21__length1 = self->board_length1;
#line 543 "../src/nibbles-game.vala"
			_tmp21__length2 = self->board_length2;
#line 543 "../src/nibbles-game.vala"
			_tmp22_ = _tmp21_[(x * _tmp21__length2) + (y + 1)];
#line 543 "../src/nibbles-game.vala"
			if (_tmp22_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 543 "../src/nibbles-game.vala"
				good = FALSE;
#line 543 "../src/nibbles-game.vala"
				continue;
#line 3341 "nibbles-game.c"
			}
		}
#line 545 "../src/nibbles-game.vala"
		_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, FALSE, (guint16) 300);
#line 3346 "nibbles-game.c"
	} else {
		Boni* _tmp23_;
#line 547 "../src/nibbles-game.vala"
		_tmp23_ = self->priv->boni;
#line 547 "../src/nibbles-game.vala"
		if (!boni_too_many_missed (_tmp23_)) {
#line 3353 "nibbles-game.c"
			gboolean _tmp24_ = FALSE;
#line 549 "../src/nibbles-game.vala"
			if (g_random_int_range ((gint32) 0, (gint32) 7) != ((gint32) 0)) {
#line 550 "../src/nibbles-game.vala"
				good = FALSE;
#line 3359 "nibbles-game.c"
			} else {
#line 552 "../src/nibbles-game.vala"
				good = TRUE;
#line 3363 "nibbles-game.c"
			}
#line 554 "../src/nibbles-game.vala"
			if (good) {
#line 3367 "nibbles-game.c"
				gboolean _tmp25_;
#line 554 "../src/nibbles-game.vala"
				_tmp25_ = self->priv->_fakes;
#line 554 "../src/nibbles-game.vala"
				_tmp24_ = !_tmp25_;
#line 3373 "nibbles-game.c"
			} else {
#line 554 "../src/nibbles-game.vala"
				_tmp24_ = FALSE;
#line 3377 "nibbles-game.c"
			}
#line 554 "../src/nibbles-game.vala"
			if (_tmp24_) {
#line 555 "../src/nibbles-game.vala"
				return;
#line 3383 "nibbles-game.c"
			}
#line 557 "../src/nibbles-game.vala"
			switch (g_random_int_range ((gint32) 0, (gint32) 21)) {
#line 557 "../src/nibbles-game.vala"
				case 0:
#line 557 "../src/nibbles-game.vala"
				case 1:
#line 557 "../src/nibbles-game.vala"
				case 2:
#line 557 "../src/nibbles-game.vala"
				case 3:
#line 557 "../src/nibbles-game.vala"
				case 4:
#line 557 "../src/nibbles-game.vala"
				case 5:
#line 557 "../src/nibbles-game.vala"
				case 6:
#line 557 "../src/nibbles-game.vala"
				case 7:
#line 557 "../src/nibbles-game.vala"
				case 8:
#line 557 "../src/nibbles-game.vala"
				case 9:
#line 3407 "nibbles-game.c"
				{
#line 569 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_HALF, good, (guint16) 200);
#line 570 "../src/nibbles-game.vala"
					break;
#line 3413 "nibbles-game.c"
				}
#line 557 "../src/nibbles-game.vala"
				case 10:
#line 557 "../src/nibbles-game.vala"
				case 11:
#line 557 "../src/nibbles-game.vala"
				case 12:
#line 557 "../src/nibbles-game.vala"
				case 13:
#line 557 "../src/nibbles-game.vala"
				case 14:
#line 3425 "nibbles-game.c"
				{
#line 576 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_DOUBLE, good, (guint16) 150);
#line 577 "../src/nibbles-game.vala"
					break;
#line 3431 "nibbles-game.c"
				}
#line 557 "../src/nibbles-game.vala"
				case 15:
#line 3435 "nibbles-game.c"
				{
#line 579 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_LIFE, good, (guint16) 100);
#line 580 "../src/nibbles-game.vala"
					break;
#line 3441 "nibbles-game.c"
				}
#line 557 "../src/nibbles-game.vala"
				case 16:
#line 557 "../src/nibbles-game.vala"
				case 17:
#line 557 "../src/nibbles-game.vala"
				case 18:
#line 557 "../src/nibbles-game.vala"
				case 19:
#line 557 "../src/nibbles-game.vala"
				case 20:
#line 3453 "nibbles-game.c"
				{
					gint _tmp26_;
#line 586 "../src/nibbles-game.vala"
					_tmp26_ = self->priv->_numworms;
#line 586 "../src/nibbles-game.vala"
					if (_tmp26_ > 1) {
#line 587 "../src/nibbles-game.vala"
						_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REVERSE, good, (guint16) 150);
#line 3462 "nibbles-game.c"
					}
#line 588 "../src/nibbles-game.vala"
					break;
#line 3466 "nibbles-game.c"
				}
				default:
#line 557 "../src/nibbles-game.vala"
				break;
#line 3471 "nibbles-game.c"
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 595 "../src/nibbles-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 3482 "nibbles-game.c"
}

static inline void
_nibbles_game_add_bonus (NibblesGame* self,
                         guint8 x,
                         guint8 y,
                         BonusType bonus_type,
                         gboolean fake,
                         guint16 countdown)
{
	Bonus* bonus = NULL;
	Bonus* _tmp0_;
	Boni* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Bonus* _tmp3_;
	Bonus* _tmp4_;
#line 592 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 594 "../src/nibbles-game.vala"
	_tmp0_ = bonus_new (x, y, bonus_type, fake, countdown);
#line 594 "../src/nibbles-game.vala"
	bonus = _tmp0_;
#line 595 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 595 "../src/nibbles-game.vala"
	_tmp2_ = self->board;
#line 595 "../src/nibbles-game.vala"
	_tmp2__length1 = self->board_length1;
#line 595 "../src/nibbles-game.vala"
	_tmp2__length2 = self->board_length2;
#line 595 "../src/nibbles-game.vala"
	_tmp3_ = bonus;
#line 595 "../src/nibbles-game.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 595 "../src/nibbles-game.vala"
	if (boni_add_bonus (_tmp1_, _tmp2_, (gint) _tmp2__length1, (gint) _tmp2__length2, _tmp4_)) {
#line 3521 "nibbles-game.c"
		Bonus* _tmp5_;
#line 596 "../src/nibbles-game.vala"
		_tmp5_ = bonus;
#line 596 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL], 0, _tmp5_);
#line 3527 "nibbles-game.c"
	}
#line 592 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 3531 "nibbles-game.c"
}

static void
nibbles_game_apply_bonus (NibblesGame* self,
                          Bonus* bonus,
                          Worm* worm)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Position _tmp4_ = {0};
	Position _tmp5_;
	Position _tmp6_ = {0};
	Position _tmp7_;
	gint _tmp8_;
#line 599 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 599 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 599 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 601 "../src/nibbles-game.vala"
	_tmp0_ = bonus_get_fake (bonus);
#line 601 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 601 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 3561 "nibbles-game.c"
		gint* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
#line 603 "../src/nibbles-game.vala"
		_tmp2_ = self->board;
#line 603 "../src/nibbles-game.vala"
		_tmp2__length1 = self->board_length1;
#line 603 "../src/nibbles-game.vala"
		_tmp2__length2 = self->board_length2;
#line 603 "../src/nibbles-game.vala"
		worm_reverse (worm, _tmp2_, (gint) _tmp2__length1, (gint) _tmp2__length2);
#line 605 "../src/nibbles-game.vala"
		return;
#line 3575 "nibbles-game.c"
	}
#line 608 "../src/nibbles-game.vala"
	_tmp3_ = self->board;
#line 608 "../src/nibbles-game.vala"
	_tmp3__length1 = self->board_length1;
#line 608 "../src/nibbles-game.vala"
	_tmp3__length2 = self->board_length2;
#line 608 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp4_);
#line 608 "../src/nibbles-game.vala"
	_tmp5_ = _tmp4_;
#line 608 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp6_);
#line 608 "../src/nibbles-game.vala"
	_tmp7_ = _tmp6_;
#line 608 "../src/nibbles-game.vala"
	_tmp8_ = _tmp3_[(_tmp5_.x * _tmp3__length2) + _tmp7_.y];
#line 608 "../src/nibbles-game.vala"
	switch (_tmp8_ - 'A') {
#line 608 "../src/nibbles-game.vala"
		case BONUS_TYPE_REGULAR:
#line 3597 "nibbles-game.c"
		{
			guint8 nth_bonus = 0U;
			Boni* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 611 "../src/nibbles-game.vala"
			_tmp9_ = self->priv->boni;
#line 611 "../src/nibbles-game.vala"
			nth_bonus = boni_new_regular_bonus_eaten (_tmp9_);
#line 612 "../src/nibbles-game.vala"
			_tmp10_ = worm_get_change (worm);
#line 612 "../src/nibbles-game.vala"
			_tmp11_ = _tmp10_;
#line 612 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp11_ + (((gint) nth_bonus) * WORM_GROW_FACTOR));
#line 613 "../src/nibbles-game.vala"
			_tmp12_ = worm_get_score (worm);
#line 613 "../src/nibbles-game.vala"
			_tmp13_ = _tmp12_;
#line 613 "../src/nibbles-game.vala"
			_tmp14_ = self->priv->_current_level;
#line 613 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp13_ + (((gint) nth_bonus) * _tmp14_));
#line 614 "../src/nibbles-game.vala"
			break;
#line 3626 "nibbles-game.c"
		}
#line 608 "../src/nibbles-game.vala"
		case BONUS_TYPE_DOUBLE:
#line 3630 "nibbles-game.c"
		{
			gint _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
#line 616 "../src/nibbles-game.vala"
			_tmp15_ = worm_get_score (worm);
#line 616 "../src/nibbles-game.vala"
			_tmp16_ = _tmp15_;
#line 616 "../src/nibbles-game.vala"
			_tmp17_ = worm_get_length (worm);
#line 616 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_;
#line 616 "../src/nibbles-game.vala"
			_tmp19_ = worm_get_change (worm);
#line 616 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_;
#line 616 "../src/nibbles-game.vala"
			_tmp21_ = self->priv->_current_level;
#line 616 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp16_ + ((_tmp18_ + _tmp20_) * _tmp21_));
#line 617 "../src/nibbles-game.vala"
			_tmp22_ = worm_get_change (worm);
#line 617 "../src/nibbles-game.vala"
			_tmp23_ = _tmp22_;
#line 617 "../src/nibbles-game.vala"
			_tmp24_ = worm_get_length (worm);
#line 617 "../src/nibbles-game.vala"
			_tmp25_ = _tmp24_;
#line 617 "../src/nibbles-game.vala"
			_tmp26_ = worm_get_change (worm);
#line 617 "../src/nibbles-game.vala"
			_tmp27_ = _tmp26_;
#line 617 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp23_ + (_tmp25_ + _tmp27_));
#line 618 "../src/nibbles-game.vala"
			break;
#line 3677 "nibbles-game.c"
		}
#line 608 "../src/nibbles-game.vala"
		case BONUS_TYPE_HALF:
#line 3681 "nibbles-game.c"
		{
			gint _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 620 "../src/nibbles-game.vala"
			_tmp28_ = worm_get_length (worm);
#line 620 "../src/nibbles-game.vala"
			_tmp29_ = _tmp28_;
#line 620 "../src/nibbles-game.vala"
			_tmp30_ = worm_get_change (worm);
#line 620 "../src/nibbles-game.vala"
			_tmp31_ = _tmp30_;
#line 620 "../src/nibbles-game.vala"
			if ((_tmp29_ + _tmp31_) > 2) {
#line 3697 "nibbles-game.c"
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint* _tmp39_;
				gint _tmp39__length1;
				gint _tmp39__length2;
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
#line 622 "../src/nibbles-game.vala"
				_tmp32_ = worm_get_score (worm);
#line 622 "../src/nibbles-game.vala"
				_tmp33_ = _tmp32_;
#line 622 "../src/nibbles-game.vala"
				_tmp34_ = worm_get_length (worm);
#line 622 "../src/nibbles-game.vala"
				_tmp35_ = _tmp34_;
#line 622 "../src/nibbles-game.vala"
				_tmp36_ = worm_get_change (worm);
#line 622 "../src/nibbles-game.vala"
				_tmp37_ = _tmp36_;
#line 622 "../src/nibbles-game.vala"
				_tmp38_ = self->priv->_current_level;
#line 622 "../src/nibbles-game.vala"
				worm_set_score (worm, _tmp33_ + ((_tmp35_ + (_tmp37_ / 2)) * _tmp38_));
#line 623 "../src/nibbles-game.vala"
				_tmp39_ = self->board;
#line 623 "../src/nibbles-game.vala"
				_tmp39__length1 = self->board_length1;
#line 623 "../src/nibbles-game.vala"
				_tmp39__length2 = self->board_length2;
#line 623 "../src/nibbles-game.vala"
				_tmp40_ = worm_get_length (worm);
#line 623 "../src/nibbles-game.vala"
				_tmp41_ = _tmp40_;
#line 623 "../src/nibbles-game.vala"
				worm_reduce_tail (worm, _tmp39_, (gint) _tmp39__length1, (gint) _tmp39__length2, _tmp41_ / 2);
#line 624 "../src/nibbles-game.vala"
				_tmp42_ = worm_get_change (worm);
#line 624 "../src/nibbles-game.vala"
				_tmp43_ = _tmp42_;
#line 624 "../src/nibbles-game.vala"
				_tmp44_ = worm_get_length (worm);
#line 624 "../src/nibbles-game.vala"
				_tmp45_ = _tmp44_;
#line 624 "../src/nibbles-game.vala"
				_tmp46_ = worm_get_change (worm);
#line 624 "../src/nibbles-game.vala"
				_tmp47_ = _tmp46_;
#line 624 "../src/nibbles-game.vala"
				worm_set_change (worm, _tmp43_ - ((_tmp45_ + _tmp47_) / 2));
#line 3758 "nibbles-game.c"
			}
#line 626 "../src/nibbles-game.vala"
			break;
#line 3762 "nibbles-game.c"
		}
#line 608 "../src/nibbles-game.vala"
		case BONUS_TYPE_LIFE:
#line 3766 "nibbles-game.c"
		{
#line 628 "../src/nibbles-game.vala"
			worm_add_life (worm);
#line 629 "../src/nibbles-game.vala"
			break;
#line 3772 "nibbles-game.c"
		}
#line 608 "../src/nibbles-game.vala"
		case BONUS_TYPE_REVERSE:
#line 3776 "nibbles-game.c"
		{
#line 631 "../src/nibbles-game.vala"
			nibbles_game_reverse_worms (self, worm);
#line 632 "../src/nibbles-game.vala"
			break;
#line 3782 "nibbles-game.c"
		}
		default:
#line 608 "../src/nibbles-game.vala"
		break;
#line 3787 "nibbles-game.c"
	}
}

static void
nibbles_game_bonus_found_cb (NibblesGame* self,
                             Worm* worm)
{
	Bonus* bonus = NULL;
	Boni* _tmp0_;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Position _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_ = {0};
	Position _tmp5_;
	Bonus* _tmp6_;
	Bonus* _tmp7_;
	Bonus* _tmp8_;
	Bonus* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	Position _tmp12_ = {0};
	Position _tmp13_;
	Position _tmp14_ = {0};
	Position _tmp15_;
	gint _tmp16_;
	gboolean real_bonus = FALSE;
	Boni* _tmp20_;
	gint* _tmp21_;
	gint _tmp21__length1;
	gint _tmp21__length2;
	Bonus* _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 636 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 636 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 638 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 638 "../src/nibbles-game.vala"
	_tmp1_ = self->board;
#line 638 "../src/nibbles-game.vala"
	_tmp1__length1 = self->board_length1;
#line 638 "../src/nibbles-game.vala"
	_tmp1__length2 = self->board_length2;
#line 638 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp2_);
#line 638 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 638 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp4_);
#line 638 "../src/nibbles-game.vala"
	_tmp5_ = _tmp4_;
#line 638 "../src/nibbles-game.vala"
	_tmp6_ = boni_get_bonus (_tmp0_, _tmp1_, (gint) _tmp1__length1, (gint) _tmp1__length2, _tmp3_.x, _tmp5_.y);
#line 638 "../src/nibbles-game.vala"
	bonus = _tmp6_;
#line 639 "../src/nibbles-game.vala"
	_tmp7_ = bonus;
#line 639 "../src/nibbles-game.vala"
	if (_tmp7_ == NULL) {
#line 640 "../src/nibbles-game.vala"
		_g_object_unref0 (bonus);
#line 640 "../src/nibbles-game.vala"
		return;
#line 3856 "nibbles-game.c"
	}
#line 641 "../src/nibbles-game.vala"
	_tmp8_ = bonus;
#line 641 "../src/nibbles-game.vala"
	nibbles_game_apply_bonus (self, _tmp8_, worm);
#line 642 "../src/nibbles-game.vala"
	_tmp9_ = bonus;
#line 642 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL], 0, _tmp9_, worm);
#line 644 "../src/nibbles-game.vala"
	_tmp11_ = self->board;
#line 644 "../src/nibbles-game.vala"
	_tmp11__length1 = self->board_length1;
#line 644 "../src/nibbles-game.vala"
	_tmp11__length2 = self->board_length2;
#line 644 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp12_);
#line 644 "../src/nibbles-game.vala"
	_tmp13_ = _tmp12_;
#line 644 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp14_);
#line 644 "../src/nibbles-game.vala"
	_tmp15_ = _tmp14_;
#line 644 "../src/nibbles-game.vala"
	_tmp16_ = _tmp11_[(_tmp13_.x * _tmp11__length2) + _tmp15_.y];
#line 644 "../src/nibbles-game.vala"
	if (_tmp16_ == ((gint) (BONUS_TYPE_REGULAR + 'A'))) {
#line 3884 "nibbles-game.c"
		Bonus* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
#line 645 "../src/nibbles-game.vala"
		_tmp17_ = bonus;
#line 645 "../src/nibbles-game.vala"
		_tmp18_ = bonus_get_fake (_tmp17_);
#line 645 "../src/nibbles-game.vala"
		_tmp19_ = _tmp18_;
#line 645 "../src/nibbles-game.vala"
		_tmp10_ = !_tmp19_;
#line 3896 "nibbles-game.c"
	} else {
#line 644 "../src/nibbles-game.vala"
		_tmp10_ = FALSE;
#line 3900 "nibbles-game.c"
	}
#line 644 "../src/nibbles-game.vala"
	real_bonus = _tmp10_;
#line 647 "../src/nibbles-game.vala"
	_tmp20_ = self->priv->boni;
#line 647 "../src/nibbles-game.vala"
	_tmp21_ = self->board;
#line 647 "../src/nibbles-game.vala"
	_tmp21__length1 = self->board_length1;
#line 647 "../src/nibbles-game.vala"
	_tmp21__length2 = self->board_length2;
#line 647 "../src/nibbles-game.vala"
	_tmp22_ = bonus;
#line 647 "../src/nibbles-game.vala"
	boni_remove_bonus (_tmp20_, _tmp21_, (gint) _tmp21__length1, (gint) _tmp21__length2, _tmp22_);
#line 649 "../src/nibbles-game.vala"
	if (real_bonus) {
#line 3918 "nibbles-game.c"
		Boni* _tmp24_;
#line 649 "../src/nibbles-game.vala"
		_tmp24_ = self->priv->boni;
#line 649 "../src/nibbles-game.vala"
		_tmp23_ = !boni_last_regular_bonus (_tmp24_);
#line 3924 "nibbles-game.c"
	} else {
#line 649 "../src/nibbles-game.vala"
		_tmp23_ = FALSE;
#line 3928 "nibbles-game.c"
	}
#line 649 "../src/nibbles-game.vala"
	if (_tmp23_) {
#line 650 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 3934 "nibbles-game.c"
	}
#line 636 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 3938 "nibbles-game.c"
}

static GameStatus*
_game_status_dup (GameStatus* self)
{
	GameStatus* dup;
#line 661 "../src/nibbles-game.vala"
	dup = g_new0 (GameStatus, 1);
#line 661 "../src/nibbles-game.vala"
	memcpy (dup, self, sizeof (GameStatus));
#line 661 "../src/nibbles-game.vala"
	return dup;
#line 3951 "nibbles-game.c"
}

static gpointer
__game_status_dup0 (gpointer self)
{
#line 661 "../src/nibbles-game.vala"
	return self ? _game_status_dup (self) : NULL;
#line 3959 "nibbles-game.c"
}

GameStatus*
nibbles_game_get_game_status (NibblesGame* self)
{
	gint worms_left = 0;
	gboolean _tmp25_ = FALSE;
	Boni* _tmp31_;
	GameStatus* result;
#line 653 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 655 "../src/nibbles-game.vala"
	worms_left = 0;
#line 3973 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 656 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 656 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 656 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 656 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 656 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 656 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 656 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 656 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3998 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 656 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 656 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 656 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 656 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 656 "../src/nibbles-game.vala"
				break;
#line 4017 "nibbles-game.c"
			}
#line 656 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 656 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 656 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 658 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 658 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 658 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 658 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 659 "../src/nibbles-game.vala"
				worms_left += 1;
#line 4035 "nibbles-game.c"
			} else {
				gboolean _tmp11_ = FALSE;
				Worm* _tmp12_;
#line 660 "../src/nibbles-game.vala"
				_tmp12_ = worm;
#line 660 "../src/nibbles-game.vala"
				if (_tmp12_->is_human) {
#line 4043 "nibbles-game.c"
					Worm* _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
#line 660 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 660 "../src/nibbles-game.vala"
					_tmp14_ = worm_get_lives (_tmp13_);
#line 660 "../src/nibbles-game.vala"
					_tmp15_ = _tmp14_;
#line 660 "../src/nibbles-game.vala"
					_tmp11_ = ((gint) _tmp15_) == 0;
#line 4055 "nibbles-game.c"
				} else {
#line 660 "../src/nibbles-game.vala"
					_tmp11_ = FALSE;
#line 4059 "nibbles-game.c"
				}
#line 660 "../src/nibbles-game.vala"
				if (_tmp11_) {
#line 4063 "nibbles-game.c"
					GameStatus _tmp16_;
					GameStatus* _tmp17_;
#line 661 "../src/nibbles-game.vala"
					_tmp16_ = GAME_STATUS_GAMEOVER;
#line 661 "../src/nibbles-game.vala"
					_tmp17_ = __game_status_dup0 (&_tmp16_);
#line 661 "../src/nibbles-game.vala"
					result = _tmp17_;
#line 661 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 661 "../src/nibbles-game.vala"
					return result;
#line 4076 "nibbles-game.c"
				} else {
					gboolean _tmp18_ = FALSE;
					gint _tmp19_;
#line 662 "../src/nibbles-game.vala"
					_tmp19_ = self->priv->_numhumans;
#line 662 "../src/nibbles-game.vala"
					if (_tmp19_ == 0) {
#line 4084 "nibbles-game.c"
						Worm* _tmp20_;
						guint8 _tmp21_;
						guint8 _tmp22_;
#line 662 "../src/nibbles-game.vala"
						_tmp20_ = worm;
#line 662 "../src/nibbles-game.vala"
						_tmp21_ = worm_get_lives (_tmp20_);
#line 662 "../src/nibbles-game.vala"
						_tmp22_ = _tmp21_;
#line 662 "../src/nibbles-game.vala"
						_tmp18_ = ((gint) _tmp22_) == 0;
#line 4096 "nibbles-game.c"
					} else {
#line 662 "../src/nibbles-game.vala"
						_tmp18_ = FALSE;
#line 4100 "nibbles-game.c"
					}
#line 662 "../src/nibbles-game.vala"
					if (_tmp18_) {
#line 4104 "nibbles-game.c"
						GameStatus _tmp23_;
						GameStatus* _tmp24_;
#line 663 "../src/nibbles-game.vala"
						_tmp23_ = GAME_STATUS_GAMEOVER;
#line 663 "../src/nibbles-game.vala"
						_tmp24_ = __game_status_dup0 (&_tmp23_);
#line 663 "../src/nibbles-game.vala"
						result = _tmp24_;
#line 663 "../src/nibbles-game.vala"
						_g_object_unref0 (worm);
#line 663 "../src/nibbles-game.vala"
						return result;
#line 4117 "nibbles-game.c"
					}
				}
			}
#line 656 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4123 "nibbles-game.c"
		}
	}
#line 666 "../src/nibbles-game.vala"
	if (worms_left == 1) {
#line 4128 "nibbles-game.c"
		gint _tmp26_;
#line 666 "../src/nibbles-game.vala"
		_tmp26_ = self->priv->_numworms;
#line 666 "../src/nibbles-game.vala"
		_tmp25_ = _tmp26_ > 1;
#line 4134 "nibbles-game.c"
	} else {
#line 666 "../src/nibbles-game.vala"
		_tmp25_ = FALSE;
#line 4138 "nibbles-game.c"
	}
#line 666 "../src/nibbles-game.vala"
	if (_tmp25_) {
#line 4142 "nibbles-game.c"
		GameStatus _tmp27_;
		GameStatus* _tmp28_;
#line 669 "../src/nibbles-game.vala"
		_tmp27_ = GAME_STATUS_VICTORY;
#line 669 "../src/nibbles-game.vala"
		_tmp28_ = __game_status_dup0 (&_tmp27_);
#line 669 "../src/nibbles-game.vala"
		result = _tmp28_;
#line 669 "../src/nibbles-game.vala"
		return result;
#line 4153 "nibbles-game.c"
	} else {
#line 671 "../src/nibbles-game.vala"
		if (worms_left == 0) {
#line 4157 "nibbles-game.c"
			GameStatus _tmp29_;
			GameStatus* _tmp30_;
#line 674 "../src/nibbles-game.vala"
			_tmp29_ = GAME_STATUS_GAMEOVER;
#line 674 "../src/nibbles-game.vala"
			_tmp30_ = __game_status_dup0 (&_tmp29_);
#line 674 "../src/nibbles-game.vala"
			result = _tmp30_;
#line 674 "../src/nibbles-game.vala"
			return result;
#line 4168 "nibbles-game.c"
		}
	}
#line 677 "../src/nibbles-game.vala"
	_tmp31_ = self->priv->boni;
#line 677 "../src/nibbles-game.vala"
	if (boni_last_regular_bonus (_tmp31_)) {
#line 4175 "nibbles-game.c"
		GameStatus _tmp32_;
		GameStatus* _tmp33_;
#line 678 "../src/nibbles-game.vala"
		_tmp32_ = GAME_STATUS_NEWROUND;
#line 678 "../src/nibbles-game.vala"
		_tmp33_ = __game_status_dup0 (&_tmp32_);
#line 678 "../src/nibbles-game.vala"
		result = _tmp33_;
#line 678 "../src/nibbles-game.vala"
		return result;
#line 4186 "nibbles-game.c"
	}
#line 680 "../src/nibbles-game.vala"
	result = NULL;
#line 680 "../src/nibbles-game.vala"
	return result;
#line 4192 "nibbles-game.c"
}

Worm*
nibbles_game_get_winner (NibblesGame* self)
{
	Worm* result;
#line 683 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4201 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 685 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 685 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 685 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 685 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 685 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 685 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 685 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 685 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4226 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 685 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 685 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 685 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 685 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 685 "../src/nibbles-game.vala"
				break;
#line 4245 "nibbles-game.c"
			}
#line 685 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 685 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 685 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 687 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 687 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 687 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 687 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 688 "../src/nibbles-game.vala"
				result = worm;
#line 688 "../src/nibbles-game.vala"
				return result;
#line 4265 "nibbles-game.c"
			}
#line 685 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4269 "nibbles-game.c"
		}
	}
#line 691 "../src/nibbles-game.vala"
	result = NULL;
#line 691 "../src/nibbles-game.vala"
	return result;
#line 4276 "nibbles-game.c"
}

static gboolean
____lambda6_ (GValue* prop_value,
              GVariant* variant)
{
	const gchar* _tmp0_;
	gboolean result;
#line 706 "../src/nibbles-game.vala"
	g_return_val_if_fail (prop_value != NULL, FALSE);
#line 706 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 706 "../src/nibbles-game.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 706 "../src/nibbles-game.vala"
	g_value_set_int (prop_value, nibbles_game_get_color_num (_tmp0_));
#line 707 "../src/nibbles-game.vala"
	result = TRUE;
#line 707 "../src/nibbles-game.vala"
	return result;
#line 4297 "nibbles-game.c"
}

static gboolean
_____lambda6__gsettings_bind_get_mapping (GValue* value,
                                          GVariant* variant,
                                          void* user_data)
{
	gboolean result;
	result = ____lambda6_ (value, variant);
#line 705 "../src/nibbles-game.vala"
	return result;
#line 4309 "nibbles-game.c"
}

static GVariant*
____lambda7_ (GValue* prop_value,
              const GVariantType* variant_type)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 708 "../src/nibbles-game.vala"
	g_return_val_if_fail (prop_value != NULL, NULL);
#line 708 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant_type != NULL, NULL);
#line 708 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_color_string (g_value_get_int (prop_value));
#line 708 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 708 "../src/nibbles-game.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 708 "../src/nibbles-game.vala"
	g_variant_ref_sink (_tmp2_);
#line 708 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 708 "../src/nibbles-game.vala"
	_g_free0 (_tmp1_);
#line 708 "../src/nibbles-game.vala"
	result = _tmp3_;
#line 708 "../src/nibbles-game.vala"
	return result;
#line 4341 "nibbles-game.c"
}

static GVariant*
_____lambda7__gsettings_bind_set_mapping (GValue* value,
                                          const GVariantType* expected_type,
                                          void* user_data)
{
	GVariant* result;
	result = ____lambda7_ (value, expected_type);
#line 705 "../src/nibbles-game.vala"
	return result;
#line 4353 "nibbles-game.c"
}

void
nibbles_game_load_worm_properties (NibblesGame* self,
                                   GeeArrayList* worm_settings)
{
	GeeHashMap* _tmp0_;
#line 698 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 698 "../src/nibbles-game.vala"
	g_return_if_fail (worm_settings != NULL);
#line 700 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 700 "../src/nibbles-game.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 4369 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 701 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 701 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 701 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 701 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 701 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 701 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 701 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 701 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4394 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			WormProperties* properties = NULL;
			WormProperties* _tmp9_;
			Worm* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GSettings* _tmp14_;
			WormProperties* _tmp15_;
			Worm* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			GSettings* _tmp20_;
			WormProperties* _tmp21_;
			Worm* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gpointer _tmp25_;
			GSettings* _tmp26_;
			WormProperties* _tmp27_;
			Worm* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gpointer _tmp31_;
			GSettings* _tmp32_;
			WormProperties* _tmp33_;
			Worm* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			gpointer _tmp37_;
			GSettings* _tmp38_;
			WormProperties* _tmp39_;
			GeeHashMap* _tmp40_;
			Worm* _tmp41_;
			WormProperties* _tmp42_;
#line 701 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 701 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 701 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 701 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 701 "../src/nibbles-game.vala"
				break;
#line 4445 "nibbles-game.c"
			}
#line 701 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 701 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 701 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 703 "../src/nibbles-game.vala"
			_tmp9_ = worm_properties_new ();
#line 703 "../src/nibbles-game.vala"
			properties = _tmp9_;
#line 705 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 705 "../src/nibbles-game.vala"
			_tmp11_ = worm_get_id (_tmp10_);
#line 705 "../src/nibbles-game.vala"
			_tmp12_ = _tmp11_;
#line 705 "../src/nibbles-game.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp12_);
#line 705 "../src/nibbles-game.vala"
			_tmp14_ = (GSettings*) _tmp13_;
#line 705 "../src/nibbles-game.vala"
			_tmp15_ = properties;
#line 705 "../src/nibbles-game.vala"
			g_settings_bind_with_mapping (_tmp14_, "color", (GObject*) _tmp15_, "color", G_SETTINGS_BIND_DEFAULT, _____lambda6__gsettings_bind_get_mapping, _____lambda7__gsettings_bind_set_mapping, NULL, NULL);
#line 705 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp14_);
#line 711 "../src/nibbles-game.vala"
			_tmp16_ = worm;
#line 711 "../src/nibbles-game.vala"
			_tmp17_ = worm_get_id (_tmp16_);
#line 711 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_;
#line 711 "../src/nibbles-game.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp18_);
#line 711 "../src/nibbles-game.vala"
			_tmp20_ = (GSettings*) _tmp19_;
#line 711 "../src/nibbles-game.vala"
			_tmp21_ = properties;
#line 711 "../src/nibbles-game.vala"
			g_settings_bind (_tmp20_, "key-up", (GObject*) _tmp21_, "up", G_SETTINGS_BIND_DEFAULT);
#line 711 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp20_);
#line 712 "../src/nibbles-game.vala"
			_tmp22_ = worm;
#line 712 "../src/nibbles-game.vala"
			_tmp23_ = worm_get_id (_tmp22_);
#line 712 "../src/nibbles-game.vala"
			_tmp24_ = _tmp23_;
#line 712 "../src/nibbles-game.vala"
			_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp24_);
#line 712 "../src/nibbles-game.vala"
			_tmp26_ = (GSettings*) _tmp25_;
#line 712 "../src/nibbles-game.vala"
			_tmp27_ = properties;
#line 712 "../src/nibbles-game.vala"
			g_settings_bind (_tmp26_, "key-down", (GObject*) _tmp27_, "down", G_SETTINGS_BIND_DEFAULT);
#line 712 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp26_);
#line 713 "../src/nibbles-game.vala"
			_tmp28_ = worm;
#line 713 "../src/nibbles-game.vala"
			_tmp29_ = worm_get_id (_tmp28_);
#line 713 "../src/nibbles-game.vala"
			_tmp30_ = _tmp29_;
#line 713 "../src/nibbles-game.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp30_);
#line 713 "../src/nibbles-game.vala"
			_tmp32_ = (GSettings*) _tmp31_;
#line 713 "../src/nibbles-game.vala"
			_tmp33_ = properties;
#line 713 "../src/nibbles-game.vala"
			g_settings_bind (_tmp32_, "key-left", (GObject*) _tmp33_, "left", G_SETTINGS_BIND_DEFAULT);
#line 713 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp32_);
#line 714 "../src/nibbles-game.vala"
			_tmp34_ = worm;
#line 714 "../src/nibbles-game.vala"
			_tmp35_ = worm_get_id (_tmp34_);
#line 714 "../src/nibbles-game.vala"
			_tmp36_ = _tmp35_;
#line 714 "../src/nibbles-game.vala"
			_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp36_);
#line 714 "../src/nibbles-game.vala"
			_tmp38_ = (GSettings*) _tmp37_;
#line 714 "../src/nibbles-game.vala"
			_tmp39_ = properties;
#line 714 "../src/nibbles-game.vala"
			g_settings_bind (_tmp38_, "key-right", (GObject*) _tmp39_, "right", G_SETTINGS_BIND_DEFAULT);
#line 714 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp38_);
#line 716 "../src/nibbles-game.vala"
			_tmp40_ = self->priv->_worm_props;
#line 716 "../src/nibbles-game.vala"
			_tmp41_ = worm;
#line 716 "../src/nibbles-game.vala"
			_tmp42_ = properties;
#line 716 "../src/nibbles-game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp40_, _tmp41_, _tmp42_);
#line 701 "../src/nibbles-game.vala"
			_g_object_unref0 (properties);
#line 701 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4549 "nibbles-game.c"
		}
	}
}

static inline gchar*
nibbles_game_get_color_string (gint color)
{
	gchar* result;
#line 721 "../src/nibbles-game.vala"
	switch (color) {
#line 721 "../src/nibbles-game.vala"
		case 0:
#line 4562 "nibbles-game.c"
		{
			gchar* _tmp0_;
#line 723 "../src/nibbles-game.vala"
			_tmp0_ = g_strdup ("red");
#line 723 "../src/nibbles-game.vala"
			result = _tmp0_;
#line 723 "../src/nibbles-game.vala"
			return result;
#line 4571 "nibbles-game.c"
		}
#line 721 "../src/nibbles-game.vala"
		case 1:
#line 4575 "nibbles-game.c"
		{
			gchar* _tmp1_;
#line 724 "../src/nibbles-game.vala"
			_tmp1_ = g_strdup ("green");
#line 724 "../src/nibbles-game.vala"
			result = _tmp1_;
#line 724 "../src/nibbles-game.vala"
			return result;
#line 4584 "nibbles-game.c"
		}
#line 721 "../src/nibbles-game.vala"
		case 2:
#line 4588 "nibbles-game.c"
		{
			gchar* _tmp2_;
#line 725 "../src/nibbles-game.vala"
			_tmp2_ = g_strdup ("blue");
#line 725 "../src/nibbles-game.vala"
			result = _tmp2_;
#line 725 "../src/nibbles-game.vala"
			return result;
#line 4597 "nibbles-game.c"
		}
#line 721 "../src/nibbles-game.vala"
		case 3:
#line 4601 "nibbles-game.c"
		{
			gchar* _tmp3_;
#line 726 "../src/nibbles-game.vala"
			_tmp3_ = g_strdup ("yellow");
#line 726 "../src/nibbles-game.vala"
			result = _tmp3_;
#line 726 "../src/nibbles-game.vala"
			return result;
#line 4610 "nibbles-game.c"
		}
#line 721 "../src/nibbles-game.vala"
		case 4:
#line 4614 "nibbles-game.c"
		{
			gchar* _tmp4_;
#line 727 "../src/nibbles-game.vala"
			_tmp4_ = g_strdup ("cyan");
#line 727 "../src/nibbles-game.vala"
			result = _tmp4_;
#line 727 "../src/nibbles-game.vala"
			return result;
#line 4623 "nibbles-game.c"
		}
#line 721 "../src/nibbles-game.vala"
		case 5:
#line 4627 "nibbles-game.c"
		{
			gchar* _tmp5_;
#line 728 "../src/nibbles-game.vala"
			_tmp5_ = g_strdup ("purple");
#line 728 "../src/nibbles-game.vala"
			result = _tmp5_;
#line 728 "../src/nibbles-game.vala"
			return result;
#line 4636 "nibbles-game.c"
		}
		default:
		{
#line 729 "../src/nibbles-game.vala"
			g_assert_not_reached ();
#line 4642 "nibbles-game.c"
		}
	}
}

static inline gint
nibbles_game_get_color_num (const gchar* color)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label0 = 0;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label1 = 0;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label2 = 0;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label3 = 0;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label4 = 0;
#line 734 "../src/nibbles-game.vala"
	static GQuark _tmp1_label5 = 0;
#line 4664 "nibbles-game.c"
	gint result;
#line 732 "../src/nibbles-game.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 734 "../src/nibbles-game.vala"
	_tmp0_ = color;
#line 734 "../src/nibbles-game.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 734 "../src/nibbles-game.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("red")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4676 "nibbles-game.c"
			default:
			{
#line 736 "../src/nibbles-game.vala"
				result = 0;
#line 736 "../src/nibbles-game.vala"
				return result;
#line 4683 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("green")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4689 "nibbles-game.c"
			default:
			{
#line 737 "../src/nibbles-game.vala"
				result = 1;
#line 737 "../src/nibbles-game.vala"
				return result;
#line 4696 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("blue")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4702 "nibbles-game.c"
			default:
			{
#line 738 "../src/nibbles-game.vala"
				result = 2;
#line 738 "../src/nibbles-game.vala"
				return result;
#line 4709 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("yellow")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4715 "nibbles-game.c"
			default:
			{
#line 739 "../src/nibbles-game.vala"
				result = 3;
#line 739 "../src/nibbles-game.vala"
				return result;
#line 4722 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("cyan")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4728 "nibbles-game.c"
			default:
			{
#line 740 "../src/nibbles-game.vala"
				result = 4;
#line 740 "../src/nibbles-game.vala"
				return result;
#line 4735 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("purple")))) {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4741 "nibbles-game.c"
			default:
			{
#line 741 "../src/nibbles-game.vala"
				result = 5;
#line 741 "../src/nibbles-game.vala"
				return result;
#line 4748 "nibbles-game.c"
			}
		}
	} else {
#line 734 "../src/nibbles-game.vala"
		switch (0) {
#line 4754 "nibbles-game.c"
			default:
			{
#line 742 "../src/nibbles-game.vala"
				g_assert_not_reached ();
#line 4759 "nibbles-game.c"
			}
		}
	}
}

gboolean
nibbles_game_handle_keypress (NibblesGame* self,
                              guint keyval)
{
	gboolean _tmp0_;
	gboolean result;
#line 746 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 748 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_running;
#line 748 "../src/nibbles-game.vala"
	if (!_tmp0_) {
#line 749 "../src/nibbles-game.vala"
		result = FALSE;
#line 749 "../src/nibbles-game.vala"
		return result;
#line 4781 "nibbles-game.c"
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 751 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 751 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 751 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 751 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 751 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 751 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 751 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 751 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4807 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 751 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 751 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 751 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 751 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 751 "../src/nibbles-game.vala"
				break;
#line 4824 "nibbles-game.c"
			}
#line 751 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 751 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 751 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 753 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 753 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 4836 "nibbles-game.c"
				Worm* _tmp10_;
				GeeHashMap* _tmp11_;
#line 755 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 755 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_worm_props;
#line 755 "../src/nibbles-game.vala"
				if (worm_handle_keypress (_tmp10_, keyval, _tmp11_)) {
#line 756 "../src/nibbles-game.vala"
					result = TRUE;
#line 756 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 756 "../src/nibbles-game.vala"
					return result;
#line 4851 "nibbles-game.c"
				}
			}
#line 751 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4856 "nibbles-game.c"
		}
	}
#line 760 "../src/nibbles-game.vala"
	result = FALSE;
#line 760 "../src/nibbles-game.vala"
	return result;
#line 4863 "nibbles-game.c"
}

gboolean
nibbles_game_get_skip_score (NibblesGame* self)
{
	gboolean result;
#line 42 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/nibbles-game.vala"
	result = self->priv->_skip_score;
#line 42 "../src/nibbles-game.vala"
	return result;
#line 4876 "nibbles-game.c"
}

void
nibbles_game_set_skip_score (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_skip_score (self);
#line 42 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 42 "../src/nibbles-game.vala"
		self->priv->_skip_score = value;
#line 42 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY]);
#line 4894 "nibbles-game.c"
	}
}

gint
nibbles_game_get_current_level (NibblesGame* self)
{
	gint result;
#line 43 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/nibbles-game.vala"
	result = self->priv->_current_level;
#line 43 "../src/nibbles-game.vala"
	return result;
#line 4908 "nibbles-game.c"
}

void
nibbles_game_set_current_level (NibblesGame* self,
                                gint value)
{
	gint old_value;
#line 43 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_current_level (self);
#line 43 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 43 "../src/nibbles-game.vala"
		self->priv->_current_level = value;
#line 43 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY]);
#line 4926 "nibbles-game.c"
	}
}

gint
nibbles_game_get_speed (NibblesGame* self)
{
	gint result;
#line 44 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/nibbles-game.vala"
	result = self->priv->_speed;
#line 44 "../src/nibbles-game.vala"
	return result;
#line 4940 "nibbles-game.c"
}

void
nibbles_game_set_speed (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 44 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_speed (self);
#line 44 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 44 "../src/nibbles-game.vala"
		self->priv->_speed = value;
#line 44 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY]);
#line 4958 "nibbles-game.c"
	}
}

gint
nibbles_game_get_gamedelay (NibblesGame* self)
{
	gint result;
#line 45 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/nibbles-game.vala"
	result = self->priv->_gamedelay;
#line 45 "../src/nibbles-game.vala"
	return result;
#line 4972 "nibbles-game.c"
}

static void
nibbles_game_set_gamedelay (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 45 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_gamedelay (self);
#line 45 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 45 "../src/nibbles-game.vala"
		self->priv->_gamedelay = value;
#line 45 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY]);
#line 4990 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_width (NibblesGame* self)
{
	guint8 result;
#line 50 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 50 "../src/nibbles-game.vala"
	result = self->priv->_width;
#line 50 "../src/nibbles-game.vala"
	return result;
#line 5004 "nibbles-game.c"
}

static void
nibbles_game_set_width (NibblesGame* self,
                        guint8 value)
{
	guint8 old_value;
#line 50 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_width (self);
#line 50 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 50 "../src/nibbles-game.vala"
		self->priv->_width = value;
#line 50 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY]);
#line 5022 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_height (NibblesGame* self)
{
	guint8 result;
#line 51 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 51 "../src/nibbles-game.vala"
	result = self->priv->_height;
#line 51 "../src/nibbles-game.vala"
	return result;
#line 5036 "nibbles-game.c"
}

static void
nibbles_game_set_height (NibblesGame* self,
                         guint8 value)
{
	guint8 old_value;
#line 51 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_height (self);
#line 51 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 51 "../src/nibbles-game.vala"
		self->priv->_height = value;
#line 51 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY]);
#line 5054 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numhumans (NibblesGame* self)
{
	gint result;
#line 54 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 54 "../src/nibbles-game.vala"
	result = self->priv->_numhumans;
#line 54 "../src/nibbles-game.vala"
	return result;
#line 5068 "nibbles-game.c"
}

void
nibbles_game_set_numhumans (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 54 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numhumans (self);
#line 54 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 54 "../src/nibbles-game.vala"
		self->priv->_numhumans = value;
#line 54 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY]);
#line 5086 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numai (NibblesGame* self)
{
	gint result;
#line 55 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 55 "../src/nibbles-game.vala"
	result = self->priv->_numai;
#line 55 "../src/nibbles-game.vala"
	return result;
#line 5100 "nibbles-game.c"
}

void
nibbles_game_set_numai (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 55 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numai (self);
#line 55 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 55 "../src/nibbles-game.vala"
		self->priv->_numai = value;
#line 55 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY]);
#line 5118 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numworms (NibblesGame* self)
{
	gint result;
#line 56 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../src/nibbles-game.vala"
	result = self->priv->_numworms;
#line 56 "../src/nibbles-game.vala"
	return result;
#line 5132 "nibbles-game.c"
}

static void
nibbles_game_set_numworms (NibblesGame* self,
                           gint value)
{
	gint old_value;
#line 56 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numworms (self);
#line 56 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 56 "../src/nibbles-game.vala"
		self->priv->_numworms = value;
#line 56 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY]);
#line 5150 "nibbles-game.c"
	}
}

GeeLinkedList*
nibbles_game_get_worms (NibblesGame* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 59 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 59 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 59 "../src/nibbles-game.vala"
	return result;
#line 5167 "nibbles-game.c"
}

GeeHashMap*
nibbles_game_get_worm_props (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 60 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 60 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 60 "../src/nibbles-game.vala"
	return result;
#line 5183 "nibbles-game.c"
}

gboolean
nibbles_game_get_is_running (NibblesGame* self)
{
	gboolean result;
#line 66 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "../src/nibbles-game.vala"
	result = self->priv->_is_running;
#line 66 "../src/nibbles-game.vala"
	return result;
#line 5196 "nibbles-game.c"
}

static void
nibbles_game_set_is_running (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 66 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_is_running (self);
#line 66 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 66 "../src/nibbles-game.vala"
		self->priv->_is_running = value;
#line 66 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY]);
#line 5214 "nibbles-game.c"
	}
}

gboolean
nibbles_game_get_is_paused (NibblesGame* self)
{
	gboolean result;
#line 67 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../src/nibbles-game.vala"
	result = self->priv->_is_paused;
#line 67 "../src/nibbles-game.vala"
	return result;
#line 5228 "nibbles-game.c"
}

static void
nibbles_game_set_is_paused (NibblesGame* self,
                            gboolean value)
{
	gboolean old_value;
#line 67 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_is_paused (self);
#line 67 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 67 "../src/nibbles-game.vala"
		self->priv->_is_paused = value;
#line 67 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_PAUSED_PROPERTY]);
#line 5246 "nibbles-game.c"
	}
}

gboolean
nibbles_game_get_fakes (NibblesGame* self)
{
	gboolean result;
#line 71 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/nibbles-game.vala"
	result = self->priv->_fakes;
#line 71 "../src/nibbles-game.vala"
	return result;
#line 5260 "nibbles-game.c"
}

void
nibbles_game_set_fakes (NibblesGame* self,
                        gboolean value)
{
	gboolean old_value;
#line 71 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_fakes (self);
#line 71 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 71 "../src/nibbles-game.vala"
		self->priv->_fakes = value;
#line 71 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY]);
#line 5278 "nibbles-game.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 29 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 5304 "nibbles-game.c"
	} else {
#line 29 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 5310 "nibbles-game.c"
	}
#line 29 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/nibbles-game.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 5316 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 29 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 5341 "nibbles-game.c"
	} else {
#line 29 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 5347 "nibbles-game.c"
	}
#line 29 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/nibbles-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 5353 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 29 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 5378 "nibbles-game.c"
	} else {
#line 29 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 5384 "nibbles-game.c"
	}
#line 29 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/nibbles-game.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 5390 "nibbles-game.c"
}

static void
_nibbles_game___lambda8_ (NibblesGame* self,
                          Bonus* bonus)
{
#line 84 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 84 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 5401 "nibbles-game.c"
}

static void
__nibbles_game___lambda8__boni_bonus_removed (Boni* _sender,
                                              Bonus* bonus,
                                              gpointer self)
{
#line 84 "../src/nibbles-game.vala"
	_nibbles_game___lambda8_ ((NibblesGame*) self, bonus);
#line 5411 "nibbles-game.c"
}

static GObject *
nibbles_game_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesGame * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint* _tmp2_;
	Boni* _tmp3_;
#line 81 "../src/nibbles-game.vala"
	parent_class = G_OBJECT_CLASS (nibbles_game_parent_class);
#line 81 "../src/nibbles-game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 81 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 83 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 83 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 83 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 83 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 83 "../src/nibbles-game.vala"
	self->board = _tmp2_;
#line 83 "../src/nibbles-game.vala"
	self->board_length1 = _tmp0_;
#line 83 "../src/nibbles-game.vala"
	self->board_length2 = _tmp1_;
#line 84 "../src/nibbles-game.vala"
	_tmp3_ = self->priv->boni;
#line 84 "../src/nibbles-game.vala"
	g_signal_connect_object (_tmp3_, "bonus-removed", (GCallback) __nibbles_game___lambda8__boni_bonus_removed, self, 0);
#line 81 "../src/nibbles-game.vala"
	return obj;
#line 5452 "nibbles-game.c"
}

static void
nibbles_game_class_init (NibblesGameClass * klass,
                         gpointer klass_data)
{
#line 29 "../src/nibbles-game.vala"
	nibbles_game_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGame_private_offset);
#line 29 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_get_property;
#line 29 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_set_property;
#line 29 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->constructor = nibbles_game_constructor;
#line 29 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_finalize;
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SKIP_SCORE_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY] = g_param_spec_boolean ("skip-score", "skip-score", "skip-score", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_CURRENT_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY] = g_param_spec_int ("current-level", "current-level", "current-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SPEED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY] = g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_GAMEDELAY_PROPERTY, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY] = g_param_spec_int ("gamedelay", "gamedelay", "gamedelay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WIDTH_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_HEIGHT_PROPERTY, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMHUMANS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY] = g_param_spec_int ("numhumans", "numhumans", "numhumans", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMAI_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY] = g_param_spec_int ("numai", "numai", "numai", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMWORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY] = g_param_spec_int ("numworms", "numworms", "numworms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORMS_PROPERTY] = g_param_spec_object ("worms", "worms", "worms", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORM_PROPS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORM_PROPS_PROPERTY] = g_param_spec_object ("worm-props", "worm-props", "worm-props", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_RUNNING_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_PAUSED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_PAUSED_PROPERTY] = g_param_spec_boolean ("is-paused", "is-paused", "is-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_FAKES_PROPERTY, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY] = g_param_spec_boolean ("fakes", "fakes", "fakes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL] = g_signal_new ("bonus-applied", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_BONUS, TYPE_WORM);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL] = g_signal_new ("log-score", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL] = g_signal_new ("animate-end-game", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL] = g_signal_new ("level-completed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL] = g_signal_new ("bonus-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 29 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 5513 "nibbles-game.c"
}

static void
nibbles_game_instance_init (NibblesGame * self,
                            gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeHashMap* _tmp1_;
	Boni* _tmp2_;
	WarpManager* _tmp3_;
#line 29 "../src/nibbles-game.vala"
	self->priv = nibbles_game_get_instance_private (self);
#line 59 "../src/nibbles-game.vala"
	_tmp0_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 59 "../src/nibbles-game.vala"
	self->priv->_worms = _tmp0_;
#line 60 "../src/nibbles-game.vala"
	_tmp1_ = gee_hash_map_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM_PROPERTIES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 60 "../src/nibbles-game.vala"
	self->priv->_worm_props = _tmp1_;
#line 62 "../src/nibbles-game.vala"
	_tmp2_ = boni_new ();
#line 62 "../src/nibbles-game.vala"
	self->priv->boni = _tmp2_;
#line 63 "../src/nibbles-game.vala"
	_tmp3_ = warp_manager_new ();
#line 63 "../src/nibbles-game.vala"
	self->priv->warp_manager = _tmp3_;
#line 66 "../src/nibbles-game.vala"
	self->priv->_is_running = FALSE;
#line 67 "../src/nibbles-game.vala"
	self->priv->_is_paused = FALSE;
#line 69 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 260 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) 0;
#line 5550 "nibbles-game.c"
}

static void
nibbles_game_finalize (GObject * obj)
{
	NibblesGame * self;
#line 29 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 48 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 59 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worms);
#line 60 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worm_props);
#line 62 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->boni);
#line 63 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->warp_manager);
#line 29 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_parent_class)->finalize (obj);
#line 5571 "nibbles-game.c"
}

static GType
nibbles_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGame), 0, (GInstanceInitFunc) nibbles_game_instance_init, NULL };
	GType nibbles_game_type_id;
	nibbles_game_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGame", &g_define_type_info, 0);
	NibblesGame_private_offset = g_type_add_instance_private (nibbles_game_type_id, sizeof (NibblesGamePrivate));
	return nibbles_game_type_id;
}

GType
nibbles_game_get_type (void)
{
	static volatile gsize nibbles_game_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_type_id__once)) {
		GType nibbles_game_type_id;
		nibbles_game_type_id = nibbles_game_get_type_once ();
		g_once_init_leave (&nibbles_game_type_id__once, nibbles_game_type_id);
	}
	return nibbles_game_type_id__once;
}

static void
_vala_nibbles_game_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 29 "../src/nibbles-game.vala"
	switch (property_id) {
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_skip_score (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_current_level (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_speed (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_gamedelay (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_width (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_height (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numhumans (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numai (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numworms (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORMS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worms (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORM_PROPS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worm_props (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_is_running (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_PAUSED_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_is_paused (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_fakes (self));
#line 29 "../src/nibbles-game.vala"
		break;
#line 5690 "nibbles-game.c"
		default:
#line 29 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/nibbles-game.vala"
		break;
#line 5696 "nibbles-game.c"
	}
}

static void
_vala_nibbles_game_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 29 "../src/nibbles-game.vala"
	switch (property_id) {
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_skip_score (self, g_value_get_boolean (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_speed (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_gamedelay (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_width (self, g_value_get_uchar (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_height (self, g_value_get_uchar (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_numhumans (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_numai (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_numworms (self, g_value_get_int (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_is_running (self, g_value_get_boolean (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_PAUSED_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_is_paused (self, g_value_get_boolean (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 29 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 29 "../src/nibbles-game.vala"
		nibbles_game_set_fakes (self, g_value_get_boolean (value));
#line 29 "../src/nibbles-game.vala"
		break;
#line 5782 "nibbles-game.c"
		default:
#line 29 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/nibbles-game.vala"
		break;
#line 5788 "nibbles-game.c"
	}
}

